<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/* Latest STABLE version
define('URL_LATEST_RELEASE', 'http://www.puntal.fr/latest_version'); 
//*/

//* Latest DEV version
define('URL_LATEST_RELEASE', 'http://www.puntal.fr/dev_version'); 
//*/

# Load a plugin file
if (!empty($_GET['pf'])) {
	require dirname(__FILE__).'/../inc/load_plugin_file.php';
	exit;
}

require dirname(__FILE__).'/../inc/admin/prepend.php';

# Mise  jour automatique de puntal
if (compare_version(pt_version,PT_VERSION) == '-1')
{
	require dirname(__FILE__).'/../inc/admin/upgrade.php';
	
	if (puntalUpgrade::perform())
	{
		header('Location: index.php?upgraded=1');
		exit;
	}
}

$action = isset($_GET['action']) ? $_GET['action'] : NULL;

# Show phpinfo() output
if ($action == 'phpinfo' && $puntal->user['g_id'] == PUN_ADMIN)
{
	# Is phpinfo() a disabled function?
	if (strpos(strtolower((string)@ini_get('disable_functions')), 'phpinfo') !== false)
	{
		$common_error = __('The phpinfo() function of PHP is disable on this server.');
	}
	else {
		phpinfo();
		exit;
	}
}

# Modification notes admin
if (!empty($_POST['formPost']) && $puntal->checkToken())
{
	$pt_settings->setNamespace('puntal');
	
	$notes = trim($_POST['notes']);
	
	$res = true;
	$res &= $pt_settings->put('pt_admin_notes', $notes);

	$pt_settings->setNamespace('');

	if ($res)
	{
		logit('Edit admin notes', 0);
		header('Location: index.php?updated=1');
		exit;
	}
}


# Check for upgrade
#

# explicit check
if ($action == 'check_upgrade')
	$latest_version = updateCacheLatestRelease(URL_LATEST_RELEASE,'puntal');

# automatic check
elseif (pt_auto_search_updates)
{
	# get the latest release number
	if (pt_auto_search_updates && (!file_exists(PT_CACHE_PATH.'latest_versions/puntal')
		|| (time()-@filemtime(PT_CACHE_PATH.'latest_version/puntal')) > 86400))
		$latest_version = updateCacheLatestRelease(URL_LATEST_RELEASE,'puntal');
	else
		$latest_version = trim(@file_get_contents(PT_CACHE_PATH.'latest_versions/puntal'));
}
# si y'a un fichier cache
elseif (file_exists(PT_CACHE_PATH.'latest_versions/puntal'))
	$latest_version = trim(@file_get_contents(PT_CACHE_PATH.'latest_versions/puntal'));
# sinon on sais pas
else
	$latest_version = '';

# compare versions
$version_info = '<img src="style/img/check_off.png" alt="" class="icon" /> '.__('Unavailable');
if ($latest_version)
{
	if (compare_version(pt_version,$latest_version) == '-1')
	{
		$version_info = '<img src="style/img/check_wrn.png" alt="" class="icon" /> <strong>'.__('A new version of Puntal is available! You can download this last version on the <a href="http://www.puntal.com/">Puntal website</a>.').'</strong>';
		
		if ($action == 'check_upgrade')
			$common_warning = __('A new version of Puntal is available! You can download this last version on the <a href="http://www.puntal.com/">Puntal website</a>.');
	}
	else{
		$version_info = '<img src="style/img/check_on.png" alt="" class="icon" /> '.__('You use the last version of Puntal.');
		
		if ($action == 'check_upgrade')
			$common_message = __('You use the last version of Puntal.');
	}
}

# Get the server load averages (if possible)
if (@file_exists('/proc/loadavg') && is_readable('/proc/loadavg'))
{
	# We use @ just in case
	$fh = @fopen('/proc/loadavg', 'r');
	$load_averages = @fread($fh, 64);
	@fclose($fh);

	$load_averages = @explode(' ', $load_averages);
	$server_load = isset($load_averages[2]) ? $load_averages[0].' '.$load_averages[1].' '.$load_averages[2] : 'Indisponible';
}
else if (!in_array(PHP_OS, array('WINNT', 'WIN32')) && preg_match('/averages?: ([0-9\.]+),[\s]+([0-9\.]+),[\s]+([0-9\.]+)/i', @exec('uptime'), $load_averages))
	$server_load = $load_averages[1].' '.$load_averages[2].' '.$load_averages[3];
else
	$server_load = __('Unavailable');


# Get number of current visitors
$result = $con->select('SELECT COUNT(user_id) AS num_online FROM '.DB_PREFIX.'online WHERE idle=0') or $puntal->err->fatalError($con->error());
$num_online = $result->f('num_online');

# Get the database system version
$result = $con->select('SELECT VERSION() as db_version') or $puntal->err->fatalError($con->error());
$mysql_version = $result->f('db_version');

# Collect some additional info about MySQL
$mysql_version = 'MySQL '.$mysql_version;

# Calculate total db size/row count
$mysql_status = $con->select('SHOW TABLE STATUS FROM `'.$db_name.'`') or $puntal->err->fatalError($con->error());

$total_records = $total_size = 0;
while ($mysql_status->fetch())
{
	$total_records += $mysql_status->f('Rows');
	$total_size += $mysql_status->f('Data_length') + $mysql_status->f('Index_length');
}

$total_size = $total_size / 1024;

if ($total_size > 1024)
	$total_size = round($total_size / 1024, 2).' MB';
else
	$total_size = round($total_size, 2).' KB';


# See if MMCache or PHPA is loaded
if (function_exists('mmcache'))
	$php_accelerator = '<a href="http://turck-mmcache.sourceforge.net/">Turck MMCache</a>';
else if (isset($_PHPA))
	$php_accelerator = '<a href="http://www.php-accelerator.co.uk/">ionCube PHP Accelerator</a>';
else
	$php_accelerator = 'N/A';


# message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

if (!empty($_GET['upgraded']))
	$common_message = __('Puntal has been upgraded');

# Set token
$puntal->setToken();

# Affichage
adminPage::open(__('Puntal administration'),
adminPage::jsLoad('js/home.js'));
?>
		<h2 class="first"><img src="style/img/ico_admin.png" alt="" class="icon" /> <?php echo __('Puntal administration'); ?></h2>
		<p><?php echo __('Welcom admin text'); ?></p>
	
		<?php # --BEHAVIOR-- adminIndexHTML
		$puntal->callBehavior('adminIndexHTML'); ?>
	
		<h3><img src="style/img/ico_note.png" alt="" class="icon" /> <?php echo __('Notes'); ?></h3>
		<?php
		require_once PT_INC_PATH."libs/punbb_parser.php"; 
		echo parse_message(pt_admin_notes,0); 
		?>
		
		<form method="post" action="index.php" id="form-notes">
			<p class="field clearb"><label for="notes"><?php echo __('Notes') ?></label></p>
			<p class="area"><?php echo form::textarea('notes', 55, 10, html::escapeHTML(pt_admin_notes)) ?></p>
			<?php 
			require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
			$ptb = new puntoolbarSmilies($puntal);
			echo $ptb->generatePtb('notes');
			?>			
			<p><?php echo form::hidden(array('ptkn'),$puntal->getToken()) ?>
			<input class="submit" type="submit" name="formPost" id="formPost" value="<?php echo __('Save'); ?>" /></p>			
		</form>
		
		<p><a href="#" id="form-notes-control" class="imglink"><img src="style/img/plus.png" alt="" class="icon" id="form-notes-img" /> <?php echo __('Edit the notes'); ?></a></p>
		
		<h3><span><img src="style/img/ico_stats.png" alt="" class="icon" /> <?php echo __('Statistics'); ?></span></h3>
		<dl>
			<dt><?php echo __('Puntal version'); ?></dt>
			<dd>
				Puntal <?php echo pt_version.' '.__('on PunBB').' '.$puntal->pun_config['o_cur_version'] ?> - <a href="index.php?action=check_upgrade"><?php echo __('Check Puntal version') ?></a>
			</dd>
			<dd><?php echo $version_info ?></dd>
			<dt><?php echo __('Execution server') ?></dt>
			<dd>
				<?php echo $server_load ?> (<?php printf(__('%s user(s) online'),$num_online) ?>)
			</dd>
	<?php if ($puntal->user['g_id'] == PUN_ADMIN): ?>					<dt><?php echo __('Environment') ?></dt>
			<dd>
				<?php echo __('Operating system:') .' '. PHP_OS ?><br />
				PHP&#160;: <?php echo phpversion() ?> - <a href="index.php?action=phpinfo"><?php echo __('Show infos') ?></a><br />
				<?php echo __('PHP accelerator:').' '.$php_accelerator."\n" ?>
			</dd>
			<dt><?php echo __('Database') ?></dt>
			<dd>
				<?php echo $mysql_version."\n" ?>
	<?php if (isset($total_records) && isset($total_size)): ?>						<br /><?php echo __('Lines:').' '.$total_records."\n" ?>
				<br /><?php echo __('Size:').' '.$total_size."\n" ?>
	<?php endif; endif; ?>					</dd>
		</dl>
	
<?php
adminPage::close();
?>
