<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

require dirname(__FILE__).'/../inc/admin/prepend.php';

if ($puntal->user['g_id'] != PUN_ADMIN)
	adminPage::fatalErrorPage(__('You do not have permission to access this page.'));

# Liste des groupes
$groups = punbb::getGroups();

# Si le formulaire est envoy
if (isset($_POST['form_sent']) && $puntal->checkToken())
{
	$form = array();
	while ($groups->fetch())
	{
		if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
		{
			$form[$groups->f('g_id')] = array();
			
			if (!empty($_POST['form'][$groups->f('g_id')]))
			{
				$form[$groups->f('g_id')] = array_map('trim', $_POST['form'][$groups->f('g_id')]);
				$form[$groups->f('g_id')] = array_map('intval', $_POST['form'][$groups->f('g_id')]);
			}		
			
			$form[$groups->f('g_id')] = array_keys($form[$groups->f('g_id')]);
		}
	}

	$pt_perms = serialize($form);

	$pt_settings->setNamespace('puntal');
	
	$res = true;
	$res &= $pt_settings->put('pt_perms',$pt_perms);

	$pt_settings->setNamespace('');

	if ($res)
	{
		logIt('Edit Puntal permissions', 2);
		header('Location: permissions.php?updated=1');
		exit;
	}
}

# message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# Load all tools locales
foreach ($valide_tools as $t)
{
	l10n::set(dirname(__FILE__).'/tools/'.$t.'/locales/'.$puntal->user['language'].'/main');
}

# Set token
$puntal->setToken();

# debut de page
adminPage::open(__('Permissions'),
adminPage::jsPageTabs("admin-menu")
);
?>

<h2 class="first"><img src="style/img/ico_permissions.png" alt="" class="icon" /> <?php echo __('Permissions'); ?></h2>
<p><?php echo __('Choose which parts of Puntal the groups can manage. The administrators have all the permissions, the guests none.'); ?></p>
<form action="permissions.php" method="post">

	<div id="admin-menu" class="multi-part" title="<?php echo __('Admin menu'); ?>">
	<fieldset>
		<legend><?php echo __('Admin menu') ?></legend>
		
		<table class="perms" cellpadding="0" cellspacing="0">
			<tr>
				<td class="perm_name">&nbsp;</td>
		<?php 
		while ($groups->fetch()) 
		{
			if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
				echo "\t\t\t\t".'<th scope="col" class="perm_group">'.html::escapeHTML($groups->f('g_title')).'</th>'."\n";
		}
		?>
			</tr>
			<tr>
				<th scope="row" class="perm_name even"><?php echo __('Puntal configuration') ?></th>
				<?php 
				while ($groups->fetch())
				{
					if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
					{
						$checked = (!empty($pt_perms[$groups->f('g_id')]) && 
									in_array('puntal_config',$pt_perms[$groups->f('g_id')])) ? true : false;
						
						echo "\t\t\t\t".'<td class="perm_group even">'.
							 form::checkbox(array('form['.$groups->f('g_id').'][puntal_config]'),'1',$checked, 'checkbox').
							 "</td>\n";
					}
				}
				?>
			</tr>
			<tr>
				<th scope="row" class="perm_name odd"><?php echo __('Modules') ?></th>
				<?php 
				while ($groups->fetch())
				{
					if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
					{
						$checked = (!empty($pt_perms[$groups->f('g_id')]) && 
									in_array('manage_modules',$pt_perms[$groups->f('g_id')])) ? true : false;
						
						echo "\t\t\t\t".'<td class="perm_group odd">'.
							 form::checkbox(array('form['.$groups->f('g_id').'][manage_modules]'),'1',$checked, 'checkbox').
							 "</td>\n";
					}
				}
				?>
			</tr>
			<tr>
				<th scope="row" class="perm_name even"><?php echo __('Tools') ?></th>
				<?php 
				while ($groups->fetch())
				{
					if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
					{
						$checked = (!empty($pt_perms[$groups->f('g_id')]) && 
									in_array('manage_tools',$pt_perms[$groups->f('g_id')])) ? true : false;
						
						echo "\t\t\t\t".'<td class="perm_group even">'.
							 form::checkbox(array('form['.$groups->f('g_id').'][manage_tools]'),'1',$checked, 'checkbox').
							 "</td>\n";
					}
				}
				?>
			</tr>
		</table>
	</fieldset>
	</div>

	<div id="tools" class="multi-part" title="<?php echo __('Tools'); ?>">
	<fieldset>
		<legend><?php echo __('Tools') ?></legend>
		
		<table class="perms" cellpadding="0" cellspacing="0">
			<tr>
				<td class="perm_name">&nbsp;</td>
		<?php 
		while ($groups->fetch()) 
		{
			if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
				echo "\t\t\t\t".'<th scope="col" class="perm_group">'.html::escapeHTML($groups->f('g_title')).'</th>'."\n";
		}
		?>
			</tr>
			<tr>
				<th scope="row" class="perm_name even"><?php echo __('Files manager') ?></th>
				<?php 
				while ($groups->fetch())
				{
					if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
					{
						$checked = (!empty($pt_perms[$groups->f('g_id')]) && 
									in_array('filemanager',$pt_perms[$groups->f('g_id')])) ? true : false;
						
						echo "\t\t\t\t".'<td class="perm_group even">'.
							 form::checkbox(array('form['.$groups->f('g_id').'][filemanager]'),'1',$checked, 'checkbox').
							 "</td>\n";
					}
				}
				?>
			</tr>
			<tr>
				<th scope="row" class="perm_name odd"><?php echo __('Users languages and styles') ?></th>
				<?php 
				while ($groups->fetch())
				{
					if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
					{
						$checked = (!empty($pt_perms[$groups->f('g_id')]) && 
									in_array('languages_and_styles',$pt_perms[$groups->f('g_id')])) ? true : false;
						
						echo "\t\t\t\t".'<td class="perm_group odd">'.
							 form::checkbox(array('form['.$groups->f('g_id').'][languages_and_styles]'),'1',$checked, 'checkbox').
							 "</td>\n";
					}
				}
				?>
			</tr>
		</table>
	</fieldset>
	</div>
	
	<div id="modules" class="multi-part" title="<?php echo __('Modules') ?>">
	<fieldset>
		<legend><?php echo __('Modules') ?></legend>
		<table class="perms" cellpadding="0" cellspacing="0">
			<tr>
				<td class="perm_name">&nbsp;</td>
		<?php 
		while ($groups->fetch()) 
		{
			if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
				echo "\t\t\t\t".'<th scope="col" class="perm_group">'.html::escapeHTML($groups->f('g_title')).'</th>'."\n";
		}
		?>
			</tr>
<?php 
$i = 0;
foreach ($puntal->modules->modules as $m) : 
	$class = ($i%2 == 0) ? 'even' : 'odd';
?>
			<tr>
				<th scope="row" class="perm_name <?php echo $class ?>"><?php echo __($m['name']) ?></th>
				<?php 
				while ($groups->fetch())
				{
					if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
					{
						$checked = (!empty($pt_perms[$groups->f('g_id')]) && 
									in_array('mod_'.$m['id'],$pt_perms[$groups->f('g_id')])) ? true : false;
									
						echo "\t\t\t\t".'<td class="perm_group '.$class.'">'.
							 form::checkbox(array('form['.$groups->f('g_id').'][mod_'.$m['id'].']'),'1',$checked, 'checkbox').
							 "</td>\n";
					}
				}
				?>
			</tr>
<?php $i++;
endforeach; ?>		
			</tr>
		</table>
	</fieldset>
	</div>
	
	<div id="blocks" class="multi-part" title="<?php echo __('Blocks') ?>">
	<fieldset>
		<legend><?php echo __('Blocks') ?></legend>
		<table class="perms" cellpadding="0" cellspacing="0">
			<tr>
				<td class="perm_name">&nbsp;</td>
		<?php 
		while ($groups->fetch()) 
		{
			if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
				echo "\t\t\t\t".'<th scope="col" class="perm_group">'.html::escapeHTML($groups->f('g_title')).'</th>'."\n";
		}
		?>
			</tr>
			<tr>
				<th scope="row" class="perm_name odd"><?php echo __('Blocks positions') ?></th>
				<?php 
				while ($groups->fetch())
				{
					if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
					{
						$checked = (!empty($pt_perms[$groups->f('g_id')]) && 
									in_array('manage_blocs',$pt_perms[$groups->f('g_id')])) ? true : false;
						
						echo "\t\t\t\t".'<td class="perm_group odd">'.
							 form::checkbox(array('form['.$groups->f('g_id').'][manage_blocs]'),'1',$checked, 'checkbox').
							 "</td>\n";
					}
				}
				?>
			</tr>
<?php 
$i = 0;
foreach ($puntal->blocks->blocks as $id=>$infos) : 
	if (is_callable($puntal->blocks->getAdminBlock($id))) :
		$class = ($i%2 == 0) ? 'even' : 'odd';
?>
			<tr>
				<th scope="row" class="perm_name <?php echo $class ?>"><?php echo __('bloc_'.$id) ?></th>
				<?php 
				while ($groups->fetch())
				{
					if ($groups->f('g_id') != PUN_ADMIN && $groups->f('g_id') != PUN_GUEST)
					{
						$checked = (!empty($pt_perms[$groups->f('g_id')]) && 
									in_array('bloc_'.$id,$pt_perms[$groups->f('g_id')])) ? true : false;
									
						echo "\t\t\t\t".'<td class="perm_group '.$class.'">'.
							 form::checkbox(array('form['.$groups->f('g_id').'][bloc_'.$id.']'),'1',$checked, 'checkbox').
							 "</td>\n";
					}
				}
				?>
			</tr>
<?php $i++;
	endif;
endforeach; ?>		
			</tr>
		</table>		
	</fieldset>
	</div>
	
	<p><?php echo form::hidden('form_sent', '1')."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input type="submit" class="submit" value="<?php echo __('Save'); ?>" /></p>
</form>

<?php adminPage::close(); ?>