<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


/************************************************************************\
	Configuration des limites / Limits configuration
\************************************************************************/

$smilies_config_image_size = 10240;	// max upload image size in bytes
$smilies_config_image_width = 20;	// max upload image width in pixels
$smilies_config_image_height = 20;	// max upload image height in pixels


/************************************************************************\
	Ne pas modifier ci-dessous / Do not edit bellow
\************************************************************************/


require dirname(__FILE__).'/../inc/admin/prepend.php';

if (!checkPerm('manage_modules'))
	adminPage::fatalErrorPage(__('You do not have permission to access this page.'));


# Modification de la configuration
if (!empty($_POST['reord']) && $puntal->checkToken()) {
	$smilies_order = $_POST['smilies_order'];
	
	$result = $puntal->con->select('SELECT id FROM '.DB_PREFIX.'pt_smilies ORDER BY disp_position') or $puntal->err->fatalError($puntal->con->error());
	
	while ($result->fetch())
	{
		if (!preg_match('#^\d+$#', $smilies_order[$result->f('id')]))
			$puntal->err->setError(__('Must int'));
		$sql = 'UPDATE '.DB_PREFIX.'pt_smilies SET disp_position='.$smilies_order[$result->f('id')].' WHERE id='.$result->f('id');			
		$puntal->con->execute($sql) or $puntal->err->fatalError($puntal->con->error());		
	}

	require_once PT_INC_PATH.'libs/puntoolbar_smilies.php';
	$cache = new puntoolbarSmilies();
	$cache->generate_smiley_cache();
	
	header('Location: smilies.php?reordered=1');		
}

// Retirer des smileys
elseif (isset($_POST['remove']) && $puntal->checkToken())
{
	$rem_smilies = array_map('trim', $_POST['rem_smilies']);
	
	foreach (array_keys($rem_smilies) as $id)
		$puntal->con->execute('DELETE FROM '.DB_PREFIX."pt_smilies WHERE id = '".$id."'") or $puntal->err->fatalError($puntal->con->error());

	require_once PT_INC_PATH.'libs/puntoolbar_smilies.php';
	$cache = new puntoolbarSmilies();	
	$cache->generate_smiley_cache();
	
	header('Location: smilies.php?removed=1');		
		
}


// Supprimer des images
elseif (isset($_POST['delete']) && $puntal->checkToken())
{
	$del_smilies = array_map('trim', $_POST['del_smilies']);
	
	$to_delete = array();
	$images_affected = array();
	$not_deleted = array();
	
	foreach (array_keys($del_smilies) as $img)
	{
		if (!in_array($img, $smiley_img))
			$to_delete[] = $img;
		else
			$images_affected[] = $img;
	}
	
	if (!empty($images_affected))
		$puntal->err->setError(__(sprintf(__('Images affected'), implode(', ', $images_affected))));

	else {
		foreach ($to_delete as $img)
		{
			if (!@unlink(PT_THEMES_PATH.'img/smilies/'.$img))
				$not_deleted[] = $img;
		}
	}
		
	if (!empty($not_deleted))
		$message = sprintf(__('Images not deleted'), implode(', ', $not_deleted));
	else 
		$message = __('Images deleted');

	header('Location: smilies.php?deleted=1');
}

// Ajouter une image
elseif (isset($_POST['add_image']) && $puntal->checkToken())
{
	if (!isset($_FILES['req_file']))
		$puntal->err->setError(__('No file'));
			
	$uploaded_file = $_FILES['req_file'];

	// Make sure the upload went smooth
	if (isset($uploaded_file['error']))
	{
		switch ($uploaded_file['error'])
		{
			case 1:	// UPLOAD_ERR_INI_SIZE
			case 2:	// UPLOAD_ERR_FORM_SIZE
				$puntal->err->setError(__('Too large ini'));
				break;
	
			case 3:	// UPLOAD_ERR_PARTIAL
				$puntal->err->setError(__('Partial upload'));
				break;
	
			case 4:	// UPLOAD_ERR_NO_FILE
				$puntal->err->setError(__('No file'));
				break;
	
			case 6:	// UPLOAD_ERR_NO_TMP_DIR
				$puntal->setError(__('No tmp directory'));
				break;
	
			default:
				// No error occured, but was something actually uploaded?
				if ($uploaded_file['size'] == 0)
					$puntal->err->setError(__('No file'));
				break;
		}
	}
	
	if (is_uploaded_file($uploaded_file['tmp_name']))
	{
		$filename = substr($uploaded_file['name'], 0, strpos($uploaded_file['name'], '.'));
		
		$allowed_types = array('image/gif', 'image/jpeg', 'image/pjpeg', 'image/png', 'image/x-png');
		if (!in_array($uploaded_file['type'], $allowed_types))
			$puntal->err->setError(__('Bad type'));

		// Make sure the file isn't too big
		if ($uploaded_file['size'] > $smilies_config_image_size)
			$puntal->err->setError(__('Too large').' '.$smilies_config_image_size.' '.__('bytes').'.');

		// Determine type
		$extensions = null;
		if ($uploaded_file['type'] == 'image/gif')
			$extensions = array('.gif', '.jpg', '.png');
		else if ($uploaded_file['type'] == 'image/jpeg' || $uploaded_file['type'] == 'image/pjpeg')
			$extensions = array('.jpg', '.gif', '.png');
		else
			$extensions = array('.png', '.gif', '.jpg');

		// Move the file to the avatar directory. We do this before checking the width/height to circumvent open_basedir restrictions.
		if (!@move_uploaded_file($uploaded_file['tmp_name'], PT_THEMES_PATH.'img/smilies/'.$filename.'.tmp'))
			$puntal->err->setError(__('Move failed'));

		// Now check the width/height
		list($width, $height, $type,) = getimagesize(PT_THEMES_PATH.'img/smilies/'.$filename.'.tmp');
		if (empty($width) || empty($height) || $width > $smilies_config_image_width || $height > $smilies_config_image_height)
		{
			@unlink(PT_THEMES_PATH.'img/smilies/'.$filename.'.tmp');
			$puntal->err->setError(__('Too wide or high').' '.$smilies_config_image_width.'x'.$smilies_config_image_height.' '.__('pixels').'.');
		}
		else if ($type == 1 && $uploaded_file['type'] != 'image/gif')	// Prevent dodgy uploads
		{
			@unlink(PT_THEMES_PATH.'img/smilies/'.$filename.'.tmp');
			$puntal->err->setError(__('Bad type'));
		}			

		// Delete any old avatars and put the new one in place
		@unlink(PT_THEMES_PATH.'img/smilies/'.$filename.$extensions[0]);
		@unlink(PT_THEMES_PATH.'img/smilies/'.$filename.$extensions[1]);
		@unlink(PT_THEMES_PATH.'img/smilies/'.$filename.$extensions[2]);
		@rename(PT_THEMES_PATH.'img/smilies/'.$filename.'.tmp', PT_THEMES_PATH.'img/smilies/'.$filename.$extensions[0]);
		@chmod(PT_THEMES_PATH.'img/smilies/'.$filename.$extensions[0], 0644);
	}
	else
		$puntal->err->setError(__('Unknown failure'));	
			
	header('Location: smilies.php?successful_uploaded=1');
	
}

// Ajouter un smiley � la liste
elseif (isset($_POST['add_smiley']) && $puntal->checkToken())
{
	$smiley_code = trim($_POST['smiley_code']);
	$smiley_image = trim($_POST['smiley_image']);
	
	if ($smiley_code == '')
		$puntal->err->setError(__('Create Smiley Code None'));

	if ($smiley_image == '')
		$puntal->err->setError(__('Create Smiley Image None'));
	
	$result = $puntal->con->select("SELECT text FROM ".DB_PREFIX."pt_smilies WHERE text = '".$smiley_code."'");
				
	if ($result->nbRow())
		$puntal->err->setError(__('Code already exists'));
	
	$puntal->con->execute('INSERT INTO '.DB_PREFIX."pt_smilies (image, text) VALUES ('".$smiley_image."', '".$puntal->con->escapeStr($smiley_code)."')") or $puntal->err->fatalError($puntal->con->error());
	
	require_once PT_INC_PATH.'libs/puntoolbar_smilies.php';
	$cache = new puntoolbarSmilies();	
	$cache->generate_smiley_cache();
	
	header('Location: smilies.php?added=1');
}

# message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

if (!empty($_GET['added']))
	$common_message = __('Smilies added');
	
if (!empty($_GET['removed']))
	$common_message = __('Smilies removed');

if (!empty($_GET['deleted']))
	$common_message = __('Smilies deleted');
	
if (!empty($_GET['successful_uploaded']))
	$common_message = __('Successful Upload');	
	
# Set token
$puntal->setToken();

#Affichage 
adminPage::open(__('Smilies Manager'));
?>
	<div class="block">
		<h2><span><?php echo __('Smilies');?></span></h2>
		<div class="box">
			<div class="inbox">
				<p><?php echo __('Smilies Description') ?></p>
			</div>
		</div>
	</div>

	<div class="blockform">
	
		<h2 class="block2"><span><?php echo __('Current Smilies') ?></span></h2>
		<div class="box">
	<?php
	$db_smilies = $puntal->con->select('SELECT * FROM '.DB_PREFIX.'pt_smilies ORDER BY disp_position') or $puntal->err->fatalError($puntal->con->error());
	
	$num_db_smilies = $db_smilies->nbRow();
	
	if ($num_db_smilies > 0) : ?>
			<form method="post" action="smilies.php">
				<div class="inform">
					<fieldset>
						<legend><?php echo __('List Current Smilies') ?></legend>
						<div class="infldset">
						<table>
							<thead>
							<tr>
								<th scope="row"><?php echo __('Position'); ?></th>
								<th scope="row"><?php echo __('Image Filename'); ?></th>
								<th scope="row"><?php echo __('Code'); ?></th>
								<th scope="row"><?php echo __('Image'); ?></th>
								<th scope="row"><?php echo __('Remove'); ?></th>
							</tr>
							</thead>
							<tbody>
		<?php while ($db_smilies->fetch()) : ?>
							<tr>
								<td><input type="text" name="smilies_order[<?php echo $db_smilies->f('id'); ?>]" value="<?php echo $db_smilies->f('disp_position'); ?>" size="3" maxlength="3" /></td>
								<td><?php echo $db_smilies->f('image'); ?></td>
								<td><?php echo $db_smilies->f('text'); ?></td>
								<td><img src="<?php echo PT_THEMES_URL; ?>img/smilies/<?php echo $db_smilies->f('image'); ?>" alt="<?php echo $db_smilies->f('text'); ?>" /></td>
								<td><input name="rem_smilies[<?php echo $db_smilies->f('id'); ?>]" type="checkbox" value="1" /></td>
							</tr>
		<?php endwhile; ?>
							</tbody>
						</table>
						</div>
					</fieldset>
				</div>
				<p class="submitend"><?php echo form::hidden('form_sent',1)."\n".form::hidden(array('ptkn'),$puntal->getToken()); ?>				
				<input name="reord" class="submit" type="submit" value="<?php echo __('Change position'); ?>" /> <input name="remove" class="submit" type="submit" value="<?php echo __('Remove Selected'); ?>" /></p>
			</form>
	<?php else : ?>
			<div class="fakeform">
				<div class="inbox">
					<p><?php echo __('No smiley'); ?></p>
				</div>
			</div>
	<?php endif; ?>
			
			<form method="post" action="smilies.php">
				<div class="inform">
					<fieldset>
						<legend><?php echo __('Submit New Smiley') ?></legend>
						<div class="infldset">
						<table class="aligntop" cellspacing="0">
							<tr>
								<th scope="row"><?php echo __('Smiley Code') ?></th>
								<td>
									<input type="text" name="smiley_code" size="25" tabindex="1" />
									<span><?php echo __('Smiley Code Description') ?></span>
								</td>
							</tr>
							<tr>
								<th scope="row"><?php echo __('Smiley Image') ?></th>
								<td>
									<input type="text" name="smiley_image" size="25" tabindex="1" />
									<span><?php echo __('Smiley Image Description') ?></span>
								</td>
							</tr>
						</table>
						</div>
					</fieldset>
				</div>
				<p class="submitend"><?php echo form::hidden('form_sent',1)."\n".form::hidden(array('ptkn'),$puntal->getToken()); ?>				
				<input type="submit" class="submit" name="add_smiley" value="<?php echo __('Submit Smiley') ?>" /></p>
			</form>
		</div>		
		
		<h2 class="block2"><span>Liste des images actuellement disponibles</span></h2>
		<div class="box">
			<form method="post" action="smilies.php">
				<div class="inform">
					<fieldset>
						<legend><?php echo __('List Images Smilies') ?></legend>
						<div class="infldset">
	<?php
	$img_smilies = array();
	$d = dir(PT_THEMES_PATH.'img/smilies');
	while (($entry = $d->read()) !== false)
	{
		if ($entry != '.' && $entry != '..' && $entry != 'index.html')
			$img_smilies[] = $entry;
	}
	$d->close();
	@natsort($img_smilies);
	?>
						<table>
							<thead>
							<tr>
								<th scope="row"><?php echo __('Image Filename'); ?></th>
								<th scope="row"><?php echo __('Image'); ?></th>
								<th scope="row"><?php echo __('Delete'); ?></th>
							</tr>
							</thead>
							<tbody>
<?php
$i = 0;
foreach ($img_smilies as $img) :
?>
							<tr>
								<td><?php echo $img; ?></td>
								<td><img src="<?php echo PT_THEMES_URL ?>img/smilies/<?php echo $img; ?>" alt="" /></td>
								<td><input name="del_smilies[<?php echo $img; ?>]" type="checkbox" value="1" /></td>
							</tr>
<?php
$i++;
endforeach;
?>
							</tbody>
						</table>
						</div>
					</fieldset>
				</div>
				<p class="submitend"><?php echo form::hidden('form_sent',1)."\n".form::hidden(array('ptkn'),$puntal->getToken()); ?>				
				<input name="delete" class="submit" type="submit" value="<?php echo __('Delete Selected'); ?>" /></p>
			</form>
			
			<form method="post" enctype="multipart/form-data"  action="smilies.php">
				<div class="inform">
					<fieldset>
						<legend><?php echo __('Add Images Smilies') ?></legend>
						<div class="infldset">
							<label><?php echo __('Images file') ?><br /><input name="req_file" type="file" size="40" /><br /></label>
						</div>
					</fieldset>
				</div>
				
		<p class="clearb"><?php echo form::hidden('form_sent',1)."\n".
		form::hidden(array('ptkn'),$puntal->getToken()); ?>
		<input class="submit" type="submit" value=" <?php echo __('Upload Smilies') ?> " /></p>
			</form>

		</div>
	</div>


<?php
#Affichage 
adminPage::close();?>