<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/*
	Based on  Connor Dunn (Connorhd@mypunbb.com) PunBB plugin
*/

# languages array
$languages = array();
$d = dir(PUN_ROOT.'lang');
while (($entry = $d->read()) !== false)
{
	if ($entry != '.' && $entry != '..' && is_dir(PUN_ROOT.'lang/'.$entry))
		$languages[$entry] = $entry;
}
$d->close();

# styles array
$styles = array();
$d = dir(PUN_ROOT.'style');
while (($entry = $d->read()) !== false)
{
	if (substr($entry, strlen($entry)-4) == '.css')
	{
		$style_name = substr($entry, 0, strlen($entry)-4);
		$styles[$style_name] = $style_name;
	}	
}
$d->close();

# what are we doing ?
$action = !empty($_POST['action']) ? html::escapeHTML($_POST['action']) : NULL;

# init lang for all users
if ($action == 'init_all_lang' && $puntal->checkToken())
{
	$neo_lang = isset($_POST['all_language']) ? $_POST['all_language'] : NULL;
	
	if (!in_array($neo_lang,$languages))
	{
		$common_error = __('Bad request. The link you followed is incorrect or outdated.');
	}
	else {
		$con->execute('UPDATE '.DB_PREFIX.'users SET language=\''.$neo_lang.'\' WHERE id>1') or $puntal->err->fatalError('Unable to set lang settings', $con->error());
		
		logIt("Init all users languages", 2);
		header('Location: tools.php?t=languages_and_styles&lang_reseted=1');
		exit;
	}
}

# init from x lang to y lang
elseif ($action == 'init_from_to_lang' && $puntal->checkToken())
{
	$from_lang = isset($_POST['from_language']) ? $_POST['from_language'] : NULL;
	$to_lang = isset($_POST['to_language']) ? $_POST['to_language'] : NULL;
	
	if (!in_array($from_lang,$languages) || !in_array($to_lang,$languages))
	{
		$common_error = __('Bad request. The link you followed is incorrect or outdated.');
	}
	else {
		$con->execute('UPDATE '.DB_PREFIX.'users SET language=\''.$to_lang.'\' WHERE language=\''.$from_lang.'\'') or $puntal->err->fatalError('Unable to set lang settings', $con->error());
		
		logIt('Init language from '.$from_lang.' to '.$to_lang, 2);
		header('Location: tools.php?t=languages_and_styles&lang_reseted=1');
		exit;
	}
}

# init style for all users
elseif ($action == 'init_all_style' && $puntal->checkToken())
{
	$neo_style = isset($_POST['all_style']) ? $_POST['all_style'] : NULL;
	
	if (!in_array($neo_style,$styles))
	{
		$common_error = __('Bad request. The link you followed is incorrect or outdated.');
	}
	else {
		$con->execute('UPDATE '.DB_PREFIX.'users SET style=\''.$neo_style.'\' WHERE id>1') or $puntal->err->fatalError('Unable to set style settings', $con->error());
		
		logIt("Init all users styles", 2);
		header('Location: tools.php?t=languages_and_styles&style_reseted=1');
		exit;
	}
}

# init from x style to y style
elseif ($action == 'init_from_to_style' && $puntal->checkToken())
{
	$from_style = isset($_POST['from_style']) ? $_POST['from_style'] : NULL;
	$to_style = isset($_POST['to_style']) ? $_POST['to_style'] : NULL;
	
	if (!in_array($from_style,$styles) || !in_array($to_style,$styles))
	{
		$common_error = __('Bad request. The link you followed is incorrect or outdated.');
	}
	else {
		$con->execute('UPDATE '.DB_PREFIX.'users SET style=\''.$to_style.'\' WHERE style=\''.$from_style.'\'') or $puntal->err->fatalError('Unable to set style settings', $con->error());
		
		logIt('Init style from '.$from_style.' to '.$to_style, 2);
		header('Location: tools.php?t=languages_and_styles&style_reseted=1');
		exit;
	}
}

# messages
if (!empty($_GET['lang_reseted']))
	$common_message = __('Languages reseted');

if (!empty($_GET['style_reseted']))
	$common_message = __('Styles reseted');

# Set token
$puntal->setToken();

# Affichage
$rs = $con->select('SELECT COUNT(id) AS num_user FROM '.DB_PREFIX.'users WHERE id > 1');
$num_user = $rs->f('num_user');

adminPage::open(__('Users languages and styles'));
?>
<h2 class="first"><img src="style/img/ico_tools.png" alt="" class="icon" /> <?php echo __('Tools') ?></h2>
<p><?php echo __('This tool makes it possible to see the adjustments of styles and languages of the users and initialize them.') ?></p>

<h3><img src="style/img/ico_lang.png" alt="" class="icon" /> <?php echo __('Languages') ?></h3>

<h4><?php echo __('Languages usage') ?></h4>
<ul>
<?php
$cur_lang = $con->select('SELECT language, count(*) as number FROM '.DB_PREFIX.'users WHERE id > 1 GROUP BY language  ORDER BY number') or $puntal->err->fatalError('Unable to fetch lang settings', $con->error());

while ($cur_lang->fetch())
{
	$percent = ceil($cur_lang->f('number') / $num_user * 100);
	echo 
	'<li>'.str_replace('_',' ',$cur_lang->f('language')).' '.$percent.'% '.
	'<div class="percent_bar_ext"><div class="percent_bar_int" style="width:'.$percent.'px;"><!-- --></div></div>'.
	'</li>';
}
?>
</ul>	

<h4><?php echo __('Initialization of the languages') ?></h4>
<form method="post" action="tools.php">
	<fieldset>
		<legend><?php echo __('Global initialization') ?></legend>
		
		<p class="field"><label for="all_language"><?php echo __('Language') ?></label>
		<?php echo form::combo('all_language', $languages) ?>
		<span class="desc"><?php echo __('All the languages of users will be reset to this option.') ?></span></p>
		
		<p><?php echo form::hidden('t','languages_and_styles')."\n".
		form::hidden(array('ptkn'),$puntal->getToken())."\n".
		form::hidden('action','init_all_lang') ?>
		<input type="submit" class="submit" value="<?php echo __('Reset') ?>" /></p>
	</fieldset>
</form>

<form method="post" action="tools.php">
	<fieldset>
		<legend><?php echo __('Targeted initialization') ?></legend>
		
		<p class="field"><label for="from_language"><?php echo __('When the users use') ?></label>
		<?php echo form::combo('from_language', $languages) ?></p>
		
		<p class="field"><label for="to_language"><?php echo __('Change to use') ?></label>
		<?php echo form::combo('to_language', $languages) ?></p>
		
		<p><?php echo form::hidden('t','languages_and_styles')."\n".
		form::hidden(array('ptkn'),$puntal->getToken())."\n".
		form::hidden('action','init_from_to_lang') ?>
		<input type="submit" class="submit" value="<?php echo __('Change') ?>" /></p>
	</fieldset>
</form>
		
<h3><img src="style/img/ico_style.png" alt="" class="icon" /> <?php echo __('Styles') ?></h3>

<h4><?php echo __('Styles usage') ?></h4>
<ul>
<?php
$cur_style = $con->select('SELECT style, COUNT(*) AS number FROM '.DB_PREFIX.'users WHERE id > 1 GROUP BY style ORDER BY number') or $puntal->err->fatalError('Unable to fetch style settings', $con->error());

while ($cur_style->fetch())
{
	$percent = ceil($cur_style->f('number') / $num_user * 100);
	echo 
	'<li>'.str_replace('_',' ',$cur_style->f('style')).' '.$percent.'% '.
	'<div class="percent_bar_ext"><div class="percent_bar_int" style="width:'.$percent.'px;"><!-- --></div></div>'.
	'</li>';
}
?>
</ul>

<h4><?php echo __('Initialization of the styles') ?></h4>
<form method="post" action="tools.php">
	<fieldset>
		<legend><?php echo __('Global initialization') ?></legend>
		
		<p class="field"><label for="all_style"><?php echo __('Style') ?></label>
		<?php echo form::combo('all_style', $styles) ?>
		<span class="desc"><?php echo __('All the styles of users will be reset to this option.') ?></span></p>
		
		<p><?php echo form::hidden('t','languages_and_styles')."\n".
		form::hidden(array('ptkn'),$puntal->getToken())."\n".
		form::hidden('action','init_all_style') ?>
		<input type="submit" class="submit" value="<?php echo __('Reset') ?>" /></p>
	</fieldset>
</form>

<form method="post" action="tools.php">
	<fieldset>
		<legend><?php echo __('Targeted initialization') ?></legend>
		
		<p class="field"><label for="from_style"><?php echo __('When the users use') ?></label>
		<?php echo form::combo('from_style', $styles) ?></p>
		
		<p class="field"><label for="to_style"><?php echo __('Change to use') ?></label>
		<?php echo form::combo('to_style', $styles) ?></p>
		
		<p><?php echo form::hidden('t','languages_and_styles')."\n".
		form::hidden(array('ptkn'),$puntal->getToken())."\n".
		form::hidden('action','init_from_to_style') ?>
		<input type="submit" class="submit" value="<?php echo __('Change') ?>" /></p>
	</fieldset>
</form>

<?php
adminPage::close();
?>