<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

class error
{
	var $error;
	
	/**
	@function error
	
	"Constructeur". Cette mthode initialise l'objet error.

	*/
	function error()
	{
		$this->resetError();
	}

	/**
	@function resetError
	
	Remet les erreurs  zro.
	*/
	function resetError()
	{
		$this->error = array();
	}

	/**
	@function hasError
	
	Retourne vrai si il y a des erreurs.
	*/
	function hasError()
	{
		if (!empty($this->error))
			return true;
		
		return false;
	}

	/**
	@function setError
	
	Ajoute une erreur dans la pile des erreurs.
	
	@param	string	msg			Message
	*/
	function setError($message,$db_error='')
	{
		$this->error[] = array($message,$db_error);
	}

	/**
	@function getError
	
	Rcupre les erreurs et renvoie une chane ou ''false'' si aucune erreur.
	
	Le paramtre $html indique si l'on souhaite obtenir les erreurs au format
	HTML
	
	@param	boolean	html	Au format HTML (true)
	@return	string
	*/
	function getError($html=true)
	{
		$nb_err = count($this->error);
		if ($nb_err > 0)
		{
			if (!$html)
				return $this->error;
			else {
				if ($nb_err > 1)
				{
					$res = '<ul>'."\n";
					foreach($this->error as $v)
					{
						$res .= "\t".'<li><span class="errmsg">'.$v[0].'</span>'.
								($v[1] != '' ? '<br /><span class="errsql">'.$v[1].'</span>' : '').
								'</li>'."\n";
					}
					$res .= "</ul>\n";
					
					return $res;
				}
				else {
					return '<p class="errmsg">'.$this->error[0][0].'</p>'."\n".
							($this->error[0][1] != '' ? '<p class="errsql">'.$this->error[0][1].'</p>'."\n" : '');
				}
			}
		}
		else
			return '';
	}

	/**
	@function fatalError
	
	Affiche une erreur fatale
	
	@param	string	message				Message de redirection
	*/
	function fatalError($message='',$db_error='')
	{
		if ($message != '')
			$this->setError($message,$db_error);
		
		$error = $this->getError();
		
		if (defined('PT_THEMES_PATH'))
			require PT_THEMES_PATH.'/fatal_error.php';
		else 
			echo $this->getError();
		
		# Close connexion
		if (isset($GLOBALS['con'])) $GLOBALS['con']->close();
		
		exit;
	}

	/**
	@function fatalNotice
	
	Affiche une notification fatale
	
	@param	string	message				Message de redirection
	*/
	function fatalNotice($message='',$db_error='')
	{
		if ($message != '')
			$this->setError($message,$db_error);
		
		$error = $this->getError();
		
		if (file_exists(PT_THEMES_PATH.pt_theme.'/error.php'))
			require PT_THEMES_PATH.pt_theme.'/error.php';
		else
			require PT_THEMES_PATH.PT_DEFAULT_THEME.'/error.php';

		# Close connexion
		if (isset($GLOBALS['con'])) $GLOBALS['con']->close();
		
		exit;
	}
}

?>