<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

require dirname(__FILE__).'/../prepend.php';
require dirname(__FILE__).'/tpl_functions.php';

# scan des URLs
require dirname(__FILE__).'/url_scan.php';

$extra_header = '';

# Loading modules
$puntal->modules->loadModules(PT_MODULES_PATH,'public',$puntal->user['language']);

# Load the prepend theme file
if (file_exists(PT_THEMES_PATH.pt_theme.'/__prepend.php'))
	require PT_THEMES_PATH.pt_theme.'/__prepend.php';
else
	require PT_THEMES_PATH.PT_DEFAULT_THEME.'/__prepend.php';

# Module par dfaut
$pt_current_module =  pt_default_module;
	
# Les blocs de "navigation"
require_once PT_MODULES_PATH."blocks/_public.php";
$blocs_nav = array();
$tmp = unserialize(pt_nav_sidebar);
foreach ($tmp as $k=>$bloc)
{
	$func = $GLOBALS['puntal']->blocks->getPublicBlock($bloc);

	if (is_callable($func))
		$blocs_nav[$bloc] = $func;
}
unset($tmp);

# Les blocs "extra"
$blocs_extra = array();
$tmp = unserialize(pt_extra_sidebar);
foreach ($tmp as $k=>$bloc)
{
	$func = $GLOBALS['puntal']->blocks->getPublicBlock($bloc);

	if (is_callable($func))
		$blocs_extra[$bloc] = $func;
}
unset($tmp);

# If we want to switch lang (from lang_switcher block)
if (isset($_POST['change_lang']) && !$puntal->user['is_guest'])
{	
	$con->execute('UPDATE '.DB_PREFIX.'users SET language=\''.$con->escapeStr($_POST['language']).'\' WHERE id='.$puntal->user['id']) or $puntal->err->fatalError('Impossible de mettre  jour le profil', $con->error());
	
	$puntal->redirect((!empty($_POST['redirect_url']) ? $_POST['redirect_url'] : pt_portal_url), __('Lang redirect'));
}

# If we want to switch style (from style_switcher block)
if (isset($_POST['change_style']) && !$puntal->user['is_guest'])
{	
	$con->execute('UPDATE '.DB_PREFIX.'users SET style=\''.$con->escapeStr($_POST['style']).'\' WHERE id='.$puntal->user['id']) or $puntal->err->fatalError('Impossible de mettre  jour le profil', $con->error());
	
	$puntal->redirect((!empty($_POST['redirect_url']) ? $_POST['redirect_url'] : pt_portal_url), __('Style redirect'));
}

# Login
if (isset($_POST['login']) && $puntal->user['is_guest'])
{
	if ($puntal->login() === true)
		$puntal->redirect((!empty($_POST['redirect_url']) ? $_POST['redirect_url'] : pt_portal_url), __('Login redirect'));
	else
		$puntal->err->fatalNotice();
}

# Si nous avons des arguments dans l'URL
if (isset($pt_args[0]))
{
	# soit c'est un module  afficher
	if ($puntal->modules->moduleInstalled($pt_args[0]))
		$pt_current_module = $pt_args[0];
	
	# soit c'est une dconnexion
	elseif ($pt_args[0] == 'logout' && !$puntal->user['is_guest'])
	{
		$puntal->logout();
		$puntal->redirect(pt_portal_url, __('Logout redirect'));
	}
}

# Le module  afficher
if (constant('pt_mod_'.$pt_current_module))
	require PT_MODULES_PATH.$pt_current_module.'/public.php';
else
	$puntal->err->fatalNotice( sprintf( __('Module %s is disable'),__($pt_current_module) ) );


?>