<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/**
	Fonctions template gnrales
*/
class tpl
{
	/**
	@function bloc
	
	Affiche un bloc
	
	@param	string	bloc		Identifiant du bloc  afficher
	*/
	function bloc($bloc)
	{
		$func = $GLOBALS['puntal']->blocks->getPublicBlock($bloc);
		if (is_callable($func))
			call_user_func($func);
	}
	
	/**
	@function blocsNav
	
	Affiche les blocs placs dans nav
	*/
	function blocsNav()
	{
		foreach ($GLOBALS['blocs_nav'] as $id=>$func)
			call_user_func($func);
	}
	
	/**
	@function blocsExtra
	
	Affiche les blocs placs dans extra
	*/
	function blocsExtra()
	{
		foreach ($GLOBALS['blocs_extra'] as $id=>$func)
			call_user_func($func);
	}
	
	/**
	@function redirect
	
	Affiche l'URL de redirection
	*/
	function redirect()
	{
		echo str_replace(array('<', '>', '"'), array('&lt;', '&gt;', '&quot;'), $GLOBALS['redirect_url']);
	}

	/**
	@function redirectMessage
	
	Affiche le message de redirection
	*/
	function redirectMessage()
	{
		echo $GLOBALS['redirect_message'];
	}

	/**
	@function top
	
	debut de page commun contenu dans le fichier _top.php
	*/
	function top()
	{
	  global $puntal;
	  
    $puntal->callBehavior('publicBeforeLoadTopHTML');
    
		if (file_exists(PT_THEMES_PATH.pt_theme.'/_top.php'))
			require PT_THEMES_PATH.pt_theme.'/_top.php';
		else
			require PT_THEMES_PATH.'puntal/_top.php';
		
    $puntal->callBehavior('publicAfterLoadTopHTML');
	}

	/**
	@function bottom
	
	Fin de page commun contenu dans le fichier _bottom.php
	*/
	function bottom()
	{
	  global $puntal;
	  
    $puntal->callBehavior('publicBeforeLoadBottomHTML');
    
		if (file_exists(PT_THEMES_PATH.pt_theme.'/_bottom.php'))
			require PT_THEMES_PATH.pt_theme.'/_bottom.php';
		else
			require PT_THEMES_PATH.PT_DEFAULT_THEME.'/_bottom.php';
		
    $puntal->callBehavior('publicAfterLoadBottomHTML');
  }
	
	function callBehavior($behavior_name)
	{
		$GLOBALS['puntal']->callBehavior($behavior_name);
	}
  	
	/**
	@function url
	
	Affiche une URL en fonction de l'argument.
	
	@param	string	url		Argument dsignant l'URL a afficher.
	*/
	function url($url='')
	{
		switch ($url)
		{
			case 'forums':
				echo pt_forum_url;
				break;
			
			case 'themes':
				echo PT_THEMES_URL;
				break;
			
			case 'template':
				echo PT_THEMES_URL.pt_theme.'/';
				break;
				
			case 'puntal':
			default :
				echo pt_portal_url;
				break;
		}
	}
	
	/**
	@function url
	
	Affiche une URL d'un fichier de template en fonction 
	de l'argument et de ceux disponibles dans le thme.
	
	@param	string	file		Argument dsignant l'URL a afficher.
	*/
	function urlFile($file)
	{
		if (file_exists(PT_THEMES_PATH.pt_theme.'/'.$file))
			echo PT_THEMES_URL.pt_theme.'/'.$file;
		else
			echo PT_THEMES_URL.PT_DEFAULT_THEME.'/'.$file;
	}
	
	/**
	@function infos
	
	Affiche une informations en fonction de l'argument.
	
	@param	string	what		Argument dsignant l'info a afficher.
	*/
	function infos($what='')
	{
		switch ($what)
		{
			case 'desc':
				echo pt_portal_desc;
				break;
						
			case 'title':
			default :
				echo pt_portal_title;
				break;
		}
	}
	
	/**
	@function user
	
	Affiche une des donnes contenue dans le tableau $puntal->user en fonction de l'index donn.	
	
	@param	string	idx			Index de la valeur du tableau  retourner
	@param	boolean	return		Permet de retourner la valeur au lieu de l'afficher ('false')
	*/
	function user($idx,$return=false)
	{
		if ($return)
			return $GLOBALS['puntal']->user[$idx];
		
		if ($idx == 'username')
			echo html::escapeHTML($GLOBALS['puntal']->user['username']);
		elseif ($idx == 'last_visit')
			echo $GLOBALS['puntal']->format_time($GLOBALS['puntal']->user['last_visit']);
		else
			echo $GLOBALS['puntal']->user[$idx];
	}
	
	/**
	@function user
	
	Affiche une des donnes contenue dans le tableau $puntal->lang en fonction de l'index donn.
	
	@param	string	idx			Index de la valeur du tableau  retourner
	@param	boolean	return		Permet de retourner la valeur au lieu de l'afficher ('false')
	*/
	function lang($idx,$return=false)
	{
		if ($return)
			return __($idx);
		
		echo __($idx);
	}
	
	/**
	@function pun_config
	
	Affiche une des donnes contenue dans le tableau $puntal->pun_config en fonction de l'index donn.
	
	@param	string	idx			Index de la valeur du tableau  retourner
	@param	boolean	return		Permet de retourner la valeur au lieu de l'afficher ('false')
	*/
	function pun_config($idx,$return=false)
	{
		if ($return)
			return $GLOBALS['puntal']->pun_config[$idx];
		
		echo $GLOBALS['puntal']->pun_config[$idx];
	}
	
	/**
	@function headTitlePage
	
	Titre de la page dans l'en-tte.
	*/
	function headTitlePage($sep=' - ')
	{
		global $pt_custom_title_page;
		
		if (!empty($pt_custom_title_page))
		{
			echo html::escapeHTML(implode($sep, array_reverse($pt_custom_title_page)).$sep);
		}
		
		echo html::escapeHTML(pt_portal_title);
	}
	
	/**
	@function headExtra
	
	Affiche les donnes extra d'en-tte HTML si il y en as de dfinies.
	*/
	function headExtra()
	{
		if ($GLOBALS['extra_header'] != '')
			echo $GLOBALS['extra_header'];
	}
	
	/**
	@function title
	
	Affiche le titre du portail.
	*/
	function title()
	{
		echo html::escapeHTML(pt_portal_title);
	}
	
	/**
	@function desc
	
	Affiche la description du portail.
	*/
	function desc($s='<p><span>%s</span></p>')
	{
		if (pt_portal_desc != '')
			printf($s,pt_portal_desc);
	}
	
	/**
	@function navLinks
	
	Affiche la barre de liens principale.
	*/
	function navLinks()
	{
		global $puntal;
	
		// Index and Userlist should always be displayed
		$links[] = '<li id="navindex"><a href="'.pt_forum_url.'index.php">'.__('Forums').'</a>';
		$links[] = '<li id="navuserlist"><a href="'.pt_forum_url.'userlist.php">'.__('User list').'</a>';
	
		if ($puntal->pun_config['o_rules'] == '1')
			$links[] = '<li id="navrules"><a href="'.pt_forum_url.'misc.php?action=rules">'.__('Rules').'</a>';
	
		if ($puntal->user['is_guest'])
		{
			if ($puntal->user['g_search'] == '1')
				$links[] = '<li id="navsearch"><a href="'.pt_forum_url.'search.php">'.__('Search').'</a>';
	
			$links[] = '<li id="navregister"><a href="'.pt_forum_url.'register.php">'.__('Register').'</a>';
			$links[] = '<li id="navlogin"><a href="'.pt_forum_url.'login.php">'.__('Login').'</a>';
	
		}
		else {
			if ($puntal->user['g_id'] < PUN_MOD || $puntal->user['g_search'] == '1')
				$links[] = '<li id="navsearch"><a href="'.pt_forum_url.'search.php">'.__('Search').'</a>';

			$links[] = '<li id="navprofile"><a href="'.pt_forum_url.'profile.php?id='.$puntal->user['id'].'">'.__('Profile').'</a>';
			
			if ($puntal->user['g_id'] == PUN_ADMIN || !empty($GLOBALS['pt_perms'][$puntal->user['g_id']]) )
				$links[] = '<li id="navadmin"><a href="'.pt_portal_path.'admin/index.php">'.__('Puntal administration').'</a>';

			$links[] = '<li id="navlogout"><a href="'.pt_portal_url.'logout/">'.__('Logout').'</a>';
		}
	
		// Are there any additional navlinks we should insert into the array before imploding it?
		if (pt_additional_navlinks != '')
		{
			if (preg_match_all('#([0-9]+)\s*=\s*(.*?)\n#s', pt_additional_navlinks."\n", $extra_links))
			{
				// Insert any additional links into the $links array (at the correct index)
				for ($i = 0; $i < count($extra_links[1]); ++$i)
					array_splice($links, $extra_links[1][$i], 0, array('<li id="navextra'.($i + 1).'">'.$extra_links[2][$i]));
			}
		}
	
		echo '<ul>'."\n\t\t\t\t".implode(__('Link separator').'</li>'."\n\t\t\t\t", $links).'</li>'."\n\t\t\t".'</ul>';
	}
	
	/**
	@function reportsLink
	
	Affiche le lien de signalement.
	*/
	function reportsLink($block='<li>%s</li>',$text='Il y a de nouveaux signalements')
	{
		global $puntal;
		
		$result_header = $puntal->con->select('SELECT COUNT(id) FROM '.DB_PREFIX.'reports WHERE zapped IS NULL') or $puntal->err->fatalError('Unable to fetch reports info', $puntal->con->error());

		if ($result_header->f(0) > 0)
			printf($block, '<a href="'.pt_forum_url.'admin_reports.php">'.$text.'</a>');
	}
	
	/**
	@function maintenanceLink
	
	Affiche le lien de forum en maintenance.
	*/
	function maintenanceLink($block='<li>%s</li>',$text='Il y a de nouveaux signalements')
	{
		if ($GLOBALS['puntal']->pun_config['o_maintenance'] == '1')
			printf($block, '<a href="'.pt_forum_url.'admin_options.php#maintenance">'.$text.'</a>');
	}
	
	/**
	@function annoucement
	
	Retourne si nous avons ou non l'annonce des forums 
	 afficher.
	*/
	function annoucement()
	{
		if ($GLOBALS['puntal']->pun_config['o_announcement'] == '1' && pt_announcement)
			return true;
		
		return false;
	}
	
	/**
	@function annoucementMessage
	
	Affiche l'annonce des forums.
	*/
	function annoucementMessage()
	{
		echo $GLOBALS['puntal']->pun_config['o_announcement_message'];
	}
		
	/**
	@function error
	
	Affiche le message d'erreur global.
	*/
	function error()
	{
		echo $GLOBALS['puntal']->err->getError();
	}
	
	/**
	@function debugTime
	
	Affiche le temps de gnration de la page
	
	@param	string	s		Masque de formatage du bloc
	*/
	function debugTime($s='<p class="conr">[ %s - %s ]</p>')
	{
		if (DEBUG > 0)
		{
			list($usec, $sec) = explode(' ', microtime());
			$pt_time_diff = sprintf('%.3f', ((float)$usec + (float)$sec) - $GLOBALS['pt_start']);
			printf($s, sprintf(__('Generated in'), $pt_time_diff),sprintf(__('%s queries executed'),$GLOBALS['puntal']->con->nb_q()));
		}
	}
	
	/**
	@function debugQueries
	
	Affiche la liste des requtes excutes
	
	@param	string	s		Masque de formatage du bloc
	*/
	function debugQueries($s='<p>%s</p>')
	{
		if (DEBUG > 1)
		{
			foreach ($GLOBALS['puntal']->con->queries as $q)
				printf($s, $q);
		}
	}
		
	function jsToolBar()
	{
		$res = "\n".
		'<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.'common/style/jsToolBar/jsToolBar.css" />'.
		'<script type="text/javascript" src="'.PT_THEMES_URL.'common/js/jsToolBar/jsToolBar.js"></script>'.
		'<script type="text/javascript" src="'.PT_THEMES_URL.'common/js/jsToolBar/jsToolBar.wysiwyg.js"></script>'.
		'<script type="text/javascript">'."\n".
		"//<![CDATA[\n".
		"jsToolBar.prototype.dialog_url = 'popup.php'; ".
		"jsToolBar.prototype.iframe_css = '".
			'body{'.
				'font: x-small/1.5em Verdana,Geneva,sans-serif;'.
				'color : #000;'.
				'background: #f9f9f9;'.
				'margin: 0;'.
				'padding : 2px;'.
				'border: none;'.
			'}'.
			'pre, code, kbd, samp {'.
				'font-family:"Courier New",Courier,monospace;'.
				'font-size : 1.1em;'.
			'}'.
			'code {'.
				'color : #666;'.
				'font-weight : bold;'.
			'}'.
			'body > p:first-child {'.
				'margin-top: 0;'.
			'}'.
		"'; ".
		"jsToolBar.prototype.base_url = '".puntal::getHost()."'; ".
		"jsToolBar.prototype.switcher_visual_title = '".html::escapeJS(__('visual'))."'; ".
		"jsToolBar.prototype.switcher_source_title = '".html::escapeJS(__('source'))."'; ".
		"jsToolBar.prototype.legend_msg = '".html::escapeJS(__('You can use the following shortcuts to format your text.'))."'; ".
		"jsToolBar.prototype.elements.strong.title = '".html::escapeJS(__('Strong emphasis'))."'; ".
		"jsToolBar.prototype.elements.em.title = '".html::escapeJS(__('Emphasis'))."'; ".
		"jsToolBar.prototype.elements.ins.title = '".html::escapeJS(__('Inserted'))."'; ".
		"jsToolBar.prototype.elements.del.title = '".html::escapeJS(__('Deleted'))."'; ".
		"jsToolBar.prototype.elements.quote.title = '".html::escapeJS(__('Inline quote'))."'; ".
		"jsToolBar.prototype.elements.code.title = '".html::escapeJS(__('Code'))."'; ".
		"jsToolBar.prototype.elements.br.title = '".html::escapeJS(__('Line break'))."'; ".
		"jsToolBar.prototype.elements.blockquote.title = '".html::escapeJS(__('Blockquote'))."'; ".
		"jsToolBar.prototype.elements.pre.title = '".html::escapeJS(__('Preformated text'))."'; ".
		"jsToolBar.prototype.elements.ul.title = '".html::escapeJS(__('Unordered list'))."'; ".
		"jsToolBar.prototype.elements.ol.title = '".html::escapeJS(__('Ordered list'))."'; ".
		
		"jsToolBar.prototype.elements.link.title = '".html::escapeJS(__('Link'))."'; ".
		"jsToolBar.prototype.elements.link.href_prompt = '".html::escapeJS(__('URL?'))."'; ".
		"jsToolBar.prototype.elements.link.hreflang_prompt = '".html::escapeJS(__('Language?'))."'; ".
		
		"jsToolBar.prototype.elements.img.title = '".html::escapeJS(__('External image'))."'; ".
		"jsToolBar.prototype.elements.img.src_prompt = '".html::escapeJS(__('URL?'))."'; ".
		
		"\n//]]>\n".
		"</script>\n";
		
		echo $res;
	}
	
	function jsDatePicker()
	{
		$res = "\n".
		tpl::jsLoad(PT_THEMES_URL.'common/js/date-picker.js').
		'<script type="text/javascript">'."\n".
		"//<![CDATA[\n".
		
		"datePicker.prototype.months[0] = '".html::escapeJS(__('January'))."'; ".
		"datePicker.prototype.months[1] = '".html::escapeJS(__('February'))."'; ".
		"datePicker.prototype.months[2] = '".html::escapeJS(__('March'))."'; ".
		"datePicker.prototype.months[3] = '".html::escapeJS(__('April'))."'; ".
		"datePicker.prototype.months[4] = '".html::escapeJS(__('May'))."'; ".
		"datePicker.prototype.months[5] = '".html::escapeJS(__('June'))."'; ".
		"datePicker.prototype.months[6] = '".html::escapeJS(__('July'))."'; ".
		"datePicker.prototype.months[7] = '".html::escapeJS(__('August'))."'; ".
		"datePicker.prototype.months[8] = '".html::escapeJS(__('September'))."'; ".
		"datePicker.prototype.months[9] = '".html::escapeJS(__('October'))."'; ".
		"datePicker.prototype.months[10] = '".html::escapeJS(__('November'))."'; ".
		"datePicker.prototype.months[11] = '".html::escapeJS(__('December'))."'; ".
	
		"datePicker.prototype.days[0] = '".html::escapeJS(__('Monday'))."'; ".
		"datePicker.prototype.days[1] = '".html::escapeJS(__('Tuesday'))."'; ".
		"datePicker.prototype.days[2] = '".html::escapeJS(__('Wednesday'))."'; ".
		"datePicker.prototype.days[3] = '".html::escapeJS(__('Thursday'))."'; ".
		"datePicker.prototype.days[4] = '".html::escapeJS(__('Friday'))."'; ".
		"datePicker.prototype.days[5] = '".html::escapeJS(__('Saturday'))."'; ".
		"datePicker.prototype.days[6] = '".html::escapeJS(__('Sunday'))."'; ".
		
		"datePicker.prototype.img_src = '".PT_THEMES_URL."common/style/img/ico_calendar.png'; ".
		
		"datePicker.prototype.close_msg = '".html::escapeJS(__('Close'))."'; ".
		"datePicker.prototype.now_msg = '".html::escapeJS(__('Now'))."'; ".
		
		"\n//]]>\n".
		"</script>\n";
		echo $res;
	}
	
	function jsLoad($src)
	{
		return '<script type="text/javascript" src="'.html::escapeHTML($src).'"></script>'."\n";
	}
	
	
	/**
	@function truncate_html
	
	Smarty truncate_tagsafe modifier plugin
	
	Type:		 modifier<br>
	Name:		truncate_tagsafe<br>
	Purpose:  	Truncate a string to a certain length if necessary,
				optionally splitting in the middle of a word, and
				appending the $etc string or inserting $etc into the middle.
				Makes sure no tags are left half-open or half-closed
				(e.g. "Banana in a <a...")
	
	@author   Monte Ohrt <monte at ohrt dot com>, modified by Amos Robinson
	<amos dot robinson at gmail dot com>
	
	@param string
	@param integer
	@param string
	@param boolean
	@param boolean
	@return string
	*/
	function truncate_html($string,$length=80,$etc='...',$break_words=false,$return=false)
	{
		if ($length == 0)
			return '';
			
		$ret = '';
	
		if (strlen($string) > $length)
		{
			$length -= strlen($etc);
			if (!$break_words)
			{
				$string = preg_replace('/\s+?(\S+)?$/', '', substr($string, 0, $length+1));
				$string = preg_replace('/<[^>]*$/', '', $string);
				$string = tpl::smarty_modifier_close_tags($string);
			}
			$ret = $string.$etc;
		}
		else
			$ret = $string;
		
		if ($return)
			return $ret;
		
		echo $ret;
	}
	
	/**
	 * Smarty close all unclosed xhtml tags
	 *
	 * Type:   modifier<br>
	 * Name:   close_tags<br>
	 *
	 * @param  string
	 * @return string
	 */
	function smarty_modifier_close_tags($string)
	{
		// match opened tags
		if(preg_match_all('/<([a-z\:\-]+)[ >]/', $string, $start_tags))
		{
			$start_tags = $start_tags[1];
			
			// match closed tags
			if(preg_match_all('/<\/([a-z]+)>/', $string, $end_tags))
			{
				$complete_tags = array();
				$end_tags = $end_tags[1];
				
				foreach($start_tags as $key => $val)
				{   
					$posb = array_search($val, $end_tags);
					if(is_integer($posb))
						unset($end_tags[$posb]);
					else
						$complete_tags[] = $val;
				}
			}
			else
				$complete_tags = $start_tags;
				
			$complete_tags = array_reverse($complete_tags);
			for($i = 0; $i < count($complete_tags); $i++)
				$string .= '</' . $complete_tags[$i] . '>';
		}
		return $string;
	}
	
	/**
	 * @function pTkn
	 * this function get the value of the token
	 * generated by a $puntal->setToken();
	 * 
	 * @return int	the token
	 */
	function pTkn()
	{
		#get the Token setted up just before
		global $puntal;
		return $puntal->getToken();		 
	}
}

?>
