<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

define('CHECK_CONFIG',true);

define('STEP',2);

require dirname(__FILE__).'/prepend.php';
require dirname(__FILE__).'/../inc/classes/checklist.php';

$php_check = new checkList();

# Vrification de la version PHP
$php_check->addItem(
	'php',
	version_compare(phpversion(),'4.3','>='),
	sprintf(__('The version of PHP is %s.'),phpversion()),
	sprintf(__('The version of PHP is %s. Version 4.3 or greater is required.'),phpversion())
);

# Vrification de la prsence des fonctions MySQL
$php_check->addItem(
	'mysql',
	function_exists('mysql_connect'),
	sprintf(__('%s module is present.'),'MySQL'),
	sprintf(__('%s module is not present.'),'MySQL')
);

# Vrification de la prsence du module XML
$php_check->addItem(
	'xml',
	function_exists('xml_parser_create'),
	sprintf(__('%s module is present.'),'XML'),
	sprintf(__('%s module is not present.'),'XML')
);


$files_check = new checkList();

# Vrification des droits sur /conf
$files_check->addItem(
	'cache',
	is_writable(dirname(__FILE__).'/../cache/'),
	sprintf(__('%s is writable.'),'cache/'),
	sprintf(__('%s is not writable. Please change its permissions to install.'),'cache/')
);


if ($php_check->checkAll() && $files_check->checkAll())
	$ses->reg('step',3);

# Affichage
require dirname(__FILE__).'/header.php'; 

echo '<h2 class="first">'.__('Checks').'</h2>';

echo $php_check->getHTML($img_chk_on,$img_chk_off,$img_chk_wrn);
echo $files_check->getHTML($img_chk_on,$img_chk_off,$img_chk_wrn);

if ($php_check->checkAll() && $files_check->checkAll())
{
?>
	<p><?php echo __('You can install Puntal on your system.') ?></p>
	
	<form action="config.php" method="post">
	<p><input type="submit" class="submit" value="<?php echo __('Next') ?> &#187;" /></p>
	</form>
<?php
}
else
	echo '<p>'.__('You cannot install Puntal on your system.').'</p>';

require dirname(__FILE__).'/footer.php'; ?>