<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

define('CHECK_CONFIG',true);

$supported_languages = array(
	'Franais'=>'French',
	'English'=>'English'
);

# On tente de dterminer la premire langue
$dlang = '';
if (!empty($_SERVER['HTTP_ACCEPT_LANGUAGE']))
{
	$acclang = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
	$L = explode(';', $acclang[0]);
	$dlang = substr(trim($L[0]),0,2);
	
	if (strtolower($dlang) == 'fr')
		$dlang = 'French';
	elseif (strtolower($dlang) == 'en')
		$dlang = 'English';
	else
		$dlang = 'English';
}

require dirname(__FILE__).'/prepend.php';

$ses->reg('step',2);

# Affichage
require dirname(__FILE__).'/header.php'; 

echo 
'<h2 class="first">'.__('Welcome on the installation of Puntal').'</h2>'.
'<p>'.__('You are about to install Puntal. Please choose your language.').'</p>';

?>

	<form action="checks.php" method="post">
	<p class="field"><label for="lang"><?php echo __('Language') ?></label>
	<select name="lang" id="lang">
	<?php 
	foreach ($supported_languages as $lang_name=>$lang)
		echo  '<option value="'.$lang.'"'.(($dlang == $lang) ? ' selected="selected"' : '').'>'.$lang_name.'</option>';
	?>
	</select></p>
	<p><input type="submit" class="submit" value="<?php echo __('Next') ?> &#187;" /></p>
	</form>


<?php require dirname(__FILE__).'/footer.php'; ?>