<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

define('STEP',7);

require dirname(__FILE__).'/prepend.php';
require dirname(__FILE__).'/../inc/classes/modules.php';
require dirname(__FILE__).'/../inc/classes/checklist.php';
require dirname(__FILE__).'/../inc/libs/files.php';
require dirname(__FILE__).'/../inc/classes/module.install.php';

l10n::set(dirname(__FILE__).'/../locales/'.$ses->f('lang').'/admin');

define('DB_PREFIX', $ses->f('db_prefix'));
define('PUNTAL', 1);

$error = new error();
$con = new connection($ses->f('db_username'),$ses->f('db_password'),$ses->f('db_host'),$ses->f('db_name'));
$pt_settings = new settings($con, $ses->f('db_prefix').'pt_setting');
$modules = new modules;
$modules->loadModules(PT_MODULES_PATH,'admin',$ses->f('lang'));

$res = true;

if ($modules->moduleExists('blocks') && $modules->moduleExists('news'))
{
	# Installation du module blocks
	$blocks = $modules->getModules('blocks');
	if (file_exists($blocks['root'].'/inc/install/install.php'))
	{
		require $blocks['root'].'/inc/install/install.php';
		if (function_exists('install_'.$blocks['id']))
		{
			$install_module = new installModule($con,$error,$pt_settings,$blocks);
			call_user_func('install_'.$blocks['id']);
			$blocks_check_html = $install_module->check->getHTML($img_chk_on,$img_chk_off,$img_chk_wrn);
			$res &= $install_module->check->checkAll();
			unset($install_module);
		}
		else {
			$error->setError(sprintf(__('The module %s does not have a valid installation process'),__($blocks['name'])));
			$res &= false;
		}
	}
	else {
		$error->setError(sprintf(__('The module %s does not have an installation file'),__($blocks['name'])));
		$res &= false;
	}
	
	# Installation du module news
	$news = $modules->getModules('news');
	if (file_exists($news['root'].'/inc/install/install.php'))
	{
		require $news['root'].'/inc/install/install.php';
		if (function_exists('install_'.$news['id']))
		{
			$install_module = new installModule($con,$error,$pt_settings,$news);
			call_user_func('install_'.$news['id']);	
			$news_check_html = $install_module->check->getHTML($img_chk_on,$img_chk_off,$img_chk_wrn);
			$res &= $install_module->check->checkAll();
			unset($install_module);
		}
		else {
			$error->setError(sprintf(__('The module %s does not have a valid installation process'),__($news['name'])));
			$res &= false;
		}
	}
	else {
		$error->setError(sprintf(__('The module %s does not have an installation file'),__($news['name'])));
		$res &= false;
	}
}
else {
	$error->setError(sprintf(__('Modules %s and/or %s are not present'),__($blocks['name']),__($news['name'])));
	$res &= false;
}

if ($res)
	$ses->reg('step',8);


# Affichage
require dirname(__FILE__).'/header.php'; 

echo '<h2 class="first">'.__('Default modules').'</h2>';

if ($error->hasError())
{
	echo '<p><img src="'.$img_chk_off.'" alt="error" class="icon" /> '.$error->getError().'</p>';
}
else {
	echo '<h3>'.__($blocks['name']).'</h3>';
	echo $blocks_check_html;
	
	echo '<h3>'.__($news['name']).'</h3>';
	echo $news_check_html;
}

if ($res)
{
?>
	<form action="end.php" method="post">
	<p><input type="submit" class="submit" value="<?php echo __('Next') ?> &#187;" /></p>
	</form>
<?php
}

require dirname(__FILE__).'/footer.php'; ?>