<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


# FR - Signalisation article  valider
# EN - Warn that an article is to validate
$GLOBALS['puntal']->addBehavior('adminIndexHTML', array('articlesBehavior','getValidateArticles'));

# FR - Recherche sur les articles
# EN - Search on the articles
$GLOBALS['puntal']->addBehavior('searchPerform', array('articlesBehavior','performSearch'));
	
# FR - Rsultats de recherche
# EN - Result of the search
$GLOBALS['puntal']->addBehavior('searchResults', array('articlesBehavior','searchResults'));

# FR - Affiche le nombre de Rsultats de recherche
# EN - Display the number of results of the search
$GLOBALS['puntal']->addBehavior('searchResultsTtl', array('articlesBehavior','searchResultsTtl'));

/**
 articlesBehavior <br/>
 	@brief behavior class
 	
 	<strong>FR</strong> cette classe gere des comportements prdfinis<br/>
 	<strong>EN</strong> this class manage the predefined behaviors 
 */
class articlesBehavior
{
	/**
	 getValidateArticles<br/>
	 
	  	<strong>FR</strong> affiche le nombre d'article  valider<br/>
	 	<strong>EN</strong> display the number of article to validate 

	 */
	function getValidateArticles()
	{
		global $puntal;
		
		$sql = 
		'SELECT COUNT(id) AS num_post '.
		'FROM '.DB_PREFIX.'pt_articles '.
		'WHERE status=3';
		
		$rs = $puntal->con->select($sql) or $puntal->err->fatalError($puntal->con->error());
		
		if ($rs->f('num_post') > 0)
		{
			echo 
			'<div class="warningbox"><h2>'.__('Articles').'</h2>'.
			'<p><a href="module.php?id=articles&amp;action=1&amp;status=3">'.
			sprintf(__('There are %s article(s) on standby of validation.'), $rs->f('num_post')).
			'</a></p></div>';
		}
	}

	/**
		performSearch<br/>
	 
	  	<strong>FR</strong> effetue une recherche<br/>
	 	<strong>EN</strong> process a search 
 
	 */
	function performSearch()
	{
		global $puntal;
		
		if (file_exists(PT_THEMES_PATH.pt_theme.'/articles/articles.css'))
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.pt_theme.'/articles/articles.css'.'" />';
		else
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.PT_DEFAULT_THEME.'/articles/articles.css'.'" />';
				
		require dirname(__FILE__).'/inc/articles.class.php';
		$articles = new articlesManager($puntal);
		
		#la recherche est-elle vide ?
		if (strlen(trim($_GET['q'])) > 2 ) 			
			$GLOBALS['article_list'] = $articles->searchEntry($_GET['q'], pt_mod_search_num_per_page );			
	}
	
	
	/**
		searchResults<br/>
	 
	  	<strong>FR</strong> affiche le resultat de la recherche<br/>
	 	<strong>EN</strong> display the result of the search 
 
	 */
	function searchResults()
	{
		global $article_list;
		
		#on teste que $article_list existe ET qu'il n'est pas vide 
		if ($article_list and !$article_list->isEmpty())
		{		
			require dirname(__FILE__).'/inc/tpl_functions.php';
			
			if (file_exists(PT_THEMES_PATH.pt_theme.'/articles/search_results.php'))
				require PT_THEMES_PATH.pt_theme.'/articles/search_results.php';
			else
				require PT_THEMES_PATH.PT_DEFAULT_THEME.'/articles/search_results.php';
		}
	}

	/**
		searchResultsTtl<br/>
	 
	  	<strong>FR</strong> affiche le nombre total d'articles trouvs<br/>
	 	<strong>EN</strong> display the total number of found articles.
 
	 */	
	function searchResultsTtl() {
		global $article_list;
		if ($article_list and !$article_list->isEmpty())
		{		
			$GLOBALS['search_ttl'] += $article_list->nbRow();
			return $GLOBALS['search_ttl'];
		}		
	}	
}

?>