<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

# FR - ID Valide  ?
# EN - Valide ID ?
$cat_id = !empty($_REQUEST['cid']) ? intval($_REQUEST['cid']) : null;
if ($cat_id === null || $cat_id < 1)
	adminPage::fatalErrorPage(__('Bad request. The link you followed is incorrect or outdated.'));

# FR - La catgorie
# EN - the category
$cat = $articles->getCat($cat_id);
$cat_name = $cat->f('cat_name');
$cat_url = $cat->f('cat_url');
$cat_desc = $cat->f('cat_desc');

# FR - Formulaire envoy
# EN - Submitted Form
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	$cat_name = trim($_POST['cat_name']);
	$cat_url = !empty($_POST['cat_url']) ? trim($_POST['cat_url']) : $cat_url;
	$cat_desc = trim($_POST['cat_desc']);
	
	if ($articles->setCat($cat_name,$cat_url,$cat_desc,$cat_id))
	{
		header('Location: module.php?id=articles&action=4&edited=1');
		exit;
	}
}

# Set token
$puntal->setToken();

# FR - Affichage
# EN - Display
adminPage::open(__('Edit category').' - '.__('Articles'),
	'<script type="text/javascript" src="index.php?pf=articles/js/cat.js"></script>'
);

?>
<h2 class="first"><img src="style/img/ico_cat_edit.png" alt="" class="icon" /> <?php echo __('Edit category') ?></h2>

<form action="module.php" method="post">

	<div class="lockable">
		<p class="field"><label for="cat_name"><?php echo __('Category title') ?></label>
		<?php echo form::field('cat_name', 40, 255, html::escapeHTML($cat_name),'lockable-from') ?></p>
		
		<p class="field"><label for="cat_url"><?php echo __('Category URL title') ?></label>
		<?php echo form::field('cat_url', 40, 255, html::escapeHTML($cat_url),'lockable-in') ?></p>
	</div>
			
	<p class="field"><label for="cat_desc"><?php echo __('Category description') ?></label></p>
	<p class="area"><?php echo form::textarea('cat_desc', 55, 5, html::escapeHTML($cat_desc)) ?></p>
	<?php 
	require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
	$ptb = new puntoolbarSmilies($puntal);
	echo $ptb->generatePtb('cat_desc');
	?>		
	<p><?php echo form::hidden('form_sent','1')."\n".
	form::hidden(array('id'),'articles')."\n".
	form::hidden(array('action'),3)."\n".
	form::hidden(array('cid'),$cat_id)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Edit') ?>" /></p>
</form>

<?php adminPage::close() ?>