<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$num_home 	= pt_mod_articles_num_home;
$groups 	= unserialize(pt_mod_articles_groups);
$forum_id 	= pt_mod_articles_forum_id;
$p_mode 	= pt_mod_articles_mode;

# FR - Formulaire envoy
# EN - Submitted Form

if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	$p_mode = intval(trim($_POST['p_mode']));
	$num_home = intval(trim($_POST['num_home']));
	$groups = (!empty($_POST['groups']) ? array_map('intval',array_map('trim',$_POST['groups'])) : array());
	$forum_id = intval(trim($_POST['forum_id']));

	# Mise  jour de la configuration
	$pt_settings->setNamespace('mod_articles');    
	
	$res = true;
	$res &= $pt_settings->put('pt_mod_articles_num_home', $num_home);
	$res &= $pt_settings->put('pt_mod_articles_groups', serialize($groups));
	$res &= $pt_settings->put('pt_mod_articles_forum_id', $forum_id);
	$res &= $pt_settings->put('pt_mod_articles_mode', $p_mode);

	$pt_settings->setNamespace('');
	
	if ($res)
	{
		logIt('Articles module : edit config', 1);
		header('Location: module.php?id=articles&action=5&updated=1');
		exit;
	}
}

# FR - Messages de confirmation
# EN - Confirmation Messages
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# FR - Liste des forums
# EN - List of forums
$forums_array = array();
$forums_array['&nbsp;'] = 0;

$forums = punbb::getForums();
while ($forums->fetch())
	$forums_array[html::escapeHTML($forums->f('cat_name'))][html::escapeHTML($forums->f('forum_name'))] = $forums->f('fid');

# Set token
$puntal->setToken();

# FR - Liste des groupes
# EN - List of groups
$groups_list = punbb::getGroups();

# FR - Affichage
# EN - Display
adminPage::open(__('Configuration').' - '.__('Articles'),	
'<script type="text/javascript">'."\n".
"//<![CDATA[\n".
"$(function() {
	$('.checkboxes-helpers').each(function() {
		puntal.checkboxesHelpers(this);
	});
});".
"//]]>\n".
"</script>"."\n");
?>

<h2 class="first"><img src="index.php?pf=articles/img/ico_articles_config.png" alt="" class="icon" /> <?php echo __('Articles configuration') ?></h2>
<form method="post" action="module.php">

	<fieldset>
		<legend><?php echo __('Articles configuration'); ?></legend>

		<p><span class="fakelabel"><?php echo __('Mode') ?></span>
		<label><?php echo form::radio(array('p_mode'), 1, ($p_mode == 1), 'radio').__('Dynamics') ?></label>
		<label><?php echo form::radio(array('p_mode'), 0, ($p_mode == 0), 'radio').__('Statics') ?></label>
		<span class="desc"><?php echo __('The static mode makes it possible to generate cache files, each time you publish an article you must generate the articles. The dynamic mode generates the articles on each page displayin, this mode is greedier in resources server and run much more queries to the database.') ?></span></p>
		
		<p class="field"><label for="num_home"><?php echo __('Articles number on home') ?></label>
		<?php echo form::field('num_home', 2, 5, $num_home) ?>
		<span class="desc"><?php echo __('Indicate the number of articles to be posted on the home page of the module.') ?></span></p>
	
		<p><span class="fakelabel"><?php echo __('Allowed groups') ?></span>
		<span class="desc"><?php echo __('The groups which can submit articles.') ?></span></p>
		<ul class="checklist">
<?php
while ($groups_list->fetch()) 
{
	if ($groups_list->f('g_id') != PUN_ADMIN)
		echo '<li><label>'.form::checkbox(array('groups[]'),$groups_list->f('g_id'),in_array($groups_list->f('g_id'),$groups),'checkbox').html::escapeHTML($groups_list->f('g_title')).'</label></li>';
}
?>
		</ul>
		<p><span class="desc checkboxes-helpers"></span></p>
		
		<p class="field"><label for="forum_id"><?php echo __('Forum') ?></label>
		<?php echo form::combo('forum_id', $forums_array, $forum_id) ?>
		<span class="desc"><?php echo __('The forum in which a new topic will be started for each new article. Leave it blank to not start topic, the comments will then not be possible.') ?></span></p>
	</fieldset>
	<p><?php echo 
	form::hidden(array('form_sent'),'1')."\n".
	form::hidden(array('id'),'articles')."\n".
	form::hidden(array('action'),5)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
</form>
<?php adminPage::close() ?>