<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

# FR - Formulaire envoy
# EN - Form sent
if (isset($_REQUEST['gen_articles']))
{
	require_once PT_INC_PATH.'/libs/punbb_parser.php';

	if (file_exists(PT_THEMES_PATH.pt_theme.'/articles/articles_static.tpl'))
		$tpl_file = PT_THEMES_PATH.pt_theme.'/articles/articles_static.tpl';
	else
		$tpl_file = PT_THEMES_PATH.PT_DEFAULT_THEME.'/articles/articles_static.tpl';
		
	$articles = new articlesManager($puntal);	
		
	$articles_tpl = file_get_contents($tpl_file) or $puntal->err->fatalError(__('unable_to_open_tpl'));

	$articles_list = $articles->getArticles('','',2);
	$article_title = '';
	$article_date = '';
	$article_content = '';
	
	while ($articles_list->fetch())
	{
		$article_title = '';
		$article_date = '';
		$article_content = '';
		$article_link_forum = '';
				
		$fh = @fopen(PT_CACHE_PATH.'/articles/articles-'.$articles_list->f('id').'.html', 'wb');
		
		if (!$fh)
			$puntal->err->fatalError(__('unable_to_write_articles'));
		
		$article_title = html::escapeHTML($articles_list->f('title'));
	
		$article_content = parse_message($articles_list->f('content'),false);
		$article_date = $articles_list->f('date');

		if (pt_mod_articles_forum_id > 0 and $articles_list->f('tid') > 0 ) 
			$article_link_forum = '<p class="addLinkBottom"><a href="'. pt_forum_url .'post.php?tid='.$articles_list->f('tid').'">'.__('Write a comment') .'</a></p>';


		$str = __('Vote to estimate this article') . '<br/>';
		$vote = $articles->getVote($articles_list->f('id'));
		if 	($vote->f('ttl') > 0) {
			$ttl = $vote->f('ttl');
			$rate = $vote->f('ttl_level')/$vote->f('ttl');		
			$str .=  $ttl . ' ' . __('Ratings') . '<br/>';
			$str .= __('Rate :').$rate;
		}

		$one  = '<a href="'.pt_portal_url.'/articles/'.$articles_list->f('id').'-'.$articles_list->f('url').'/vote/1" title="'.__('Interesting').'">'.__('Interesting').'</a>';
		$two  = '<a href="'.pt_portal_url.'/articles/'.$articles_list->f('id').'-'.$articles_list->f('url').'/vote/2"  title="'.__('Very Interesting').'">'.__('Very Interesting').'</a>';
		$three= '<a href="'.pt_portal_url.'/articles/'.$articles_list->f('id').'-'.$articles_list->f('url').'/vote/3"  title="'.__('Good').'">'.__('Good').'</a>';				
		$four = '<a href="'.pt_portal_url.'/articles/'.$articles_list->f('id').'-'.$articles_list->f('url').'/vote/4"  title="'.__('Very Good').'">'.__('Very Good').'</a>';		
		$five = '<a href="'.pt_portal_url.'/articles/'.$articles_list->f('id').'-'.$articles_list->f('url').'/vote/5"  title="'.__('A Must Have').'">'.__('A Must Have').'</a>';		
							
		$search = array(
            '<articleTitle>',
            '<PublishedOn>',
            '<articleDate>',
            '<articleContent>',
            '<articleVoteLabel>',
            '<articleStar1>',
            '<articleStar2>',
            '<articleStar3>',
            '<articleStar4>',
            '<articleStar5>',
            '<articleLinkForum>'
			);
			
		$replace = array(            
			$article_title,
			__('Published on'),
			dt::str(pt_date_format, strtotime($article_date)),
			$article_content,
			$str,
			$one,
			$two,
			$three,
			$four,
			$five,
			$article_link_forum
			);

		fwrite($fh, str_replace($search, $replace, $articles_tpl));
		fclose($fh);
	}

	
	if ($puntal->err->hasError())
		adminPage::fatalErrorPage($puntal->err->getError());
	else {
		logIt("Articles module : generate article");
		
		if (isset($_REQUEST['from_post']))
		{
			header('Location: module.php?id=articles&action=1&addgen=1');
			exit;
		}
		else {
			header('Location: module.php?id=articles&action=6&generated=1');
			exit;
		}
	}
}

# FR - Messages de confirmation
# EN - Confirmation Messages
if (!empty($_GET['addgen']))
	$common_message = __('Articles added').' '.__('Generated articles');
	
if (!empty($_GET['generated']))
	$common_message = __('Generated articles');

# FR - Affichage
# EN - Display
adminPage::open(__('Generate articles').' - '.__('Articles'));
?>

<h2 class="first"><img src="index.php?pf=articles/img/ico_articles_generate.png" alt="" class="icon" /> <?php echo __('Generate articles') ?></h2>
<form method="post" action="module.php">
					
	<p><?php echo __('Puntal generates static contents in order not to systematically launch requests at the data base to recover contents which change only seldom. To generate the articles, click on the button below.'); ?></p>
	
	<p><input type="hidden" name="gen_articles" value="1" />
	<input type="hidden" name="id" value="articles" />
	<input type="hidden" name="action" value="6" />
	<input class="submit" type="submit" value="<?php echo __('Generate') ?>" /></p>

</form>
<?php adminPage::close() ?>