<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$cat_id = '';
$status = '';
$order = '';
$show_filters = false;

if (!empty($_REQUEST['cat_id']))
{
	$cat_id = intval($_REQUEST['cat_id']);
	$show_filters = true;
}

if (!empty($_REQUEST['status']))
{
	$status = intval($_REQUEST['status']);
	$show_filters = true;
}

if (!empty($_REQUEST['order']))
{
	$order = $_REQUEST['order'];
	$show_filters = true;
}

switch ($order)
{
	case 'cat' :
		$order_by = 'C.cat_name DESC';
		break;
		
	case 'status' :
		$order_by = 'P.status DESC';
		break;
		
	case 'date' :
	default:
		$order_by = 'P.date DESC';
		break;
}

/************************************************************************/

// Fonction d'affichage des lignes d'articles
function articles_line($data,$i)
{
	$title = html::escapeHTML($data['title']);
	
	if ($data['status'] == 3)
		$cur_status = '<img src="style/img/ico_bell.png" class="icon" alt="'.__('Validate').'" />';	
	elseif ($data['status'] == 2)
		$cur_status = '<a href="module.php?id=articles&amp;action=1&amp;offline='.$data['id'].'" title="'.sprintf(__('Put %s offline'),$title).'"><img src="style/img/on.png" class="icon" alt="'.__('Online').'" /></a>';
	else
		$cur_status = '<a href="module.php?id=articles&amp;action=1&amp;online='.$data['id'].'" title="'.sprintf(__('Put %s online'),$title).'"><img src="style/img/off.png" class="icon" alt="'.__('Offline').'" /></a>';
	
	if ($data['tid'] > 0)
	{	
		$numComment = $data['num_replies'];
		
		if ($numComment == 0)
			$comments = __('No comment');
		elseif ($numComment == 1)
			$comments = '<a href="module.php?id=articles&amp;action=2&amp;pid='.$data['id'].'#comments">'.__('One comment').'</a>';
		else
			$comments = '<a href="module.php?id=articles&amp;action=2&amp;pid='.$data['id'].'#comments">'.sprintf(__('%s comments'), $numComment).'</a>';
	}
	else
		$comments = __('No discuss');
	
	return
	"\t\t".'<tr class="line" id="c_'.$data['id'].'">'."\n".
	"\t\t\t".'<td scope="row">'.form::checkbox(array('selarticles[]'),$data['id'],0,'checkbox').'</td>'."\n".
	"\t\t\t".'<td class="maximal"><a href="module.php?id=articles&amp;action=2&amp;pid='.$data['id'].'">'.$title.'</a></td>'."\n".
	"\t\t\t".'<td class="nowrap left">'.$comments.'</td>'."\n\n".
	"\t\t\t".'<td class="nowrap left">'.html::escapeHTML($data['cat_name']).'</td>'."\n\n".
	"\t\t\t".'<td class="nowrap left">'.dt::str(pt_date_format,strtotime($data['date'])).'</td>'."\n\n".
	"\t\t\t".'<td class="center">'.$cur_status.'</td>'."\n\n".
	"\t\t".'</tr>'."\n\n";
}


/* Traitements
-------------------------------------------------------- */

# Mise en ligne d'un article
if (!empty($_GET['online']))
{
	$article_id = intval($_GET['online']);
	
	$articles->statusArticle($article_id,2);
	logIt('Articles module : put online article '.$article_id, 2);
	header('Location: module.php?id=articles&action=1&cat_id='.$cat_id.'&status='.$status.'&order='.$order.'&onlined=1');
	exit;
}

# Mise hors ligne d'un article
if (!empty($_GET['offline']))
{
	$article_id = intval($_GET['offline']);
	
	$articles->statusArticle($article_id,1);
	logIt('Articles module : put offline article '.$article_id, 2);
	header('Location: module.php?id=articles&action=1&cat_id='.$cat_id.'&status='.$status.'&order='.$order.'&offlined=1');
	exit;
}

# Modifications d'un lot d'articles
if (!empty($_POST['lot']) && !empty($_POST['selarticles']) && is_array($_POST['selarticles']))
{
	# Mise en ligne
	if ($_POST['lot'] == 'online' && $puntal->checkToken())
	{
		foreach ($_POST['selarticles'] as $v)
			$articles->statusArticle($v,2);
		
		if (!$puntal->err->hasError())
		{
			logIt('Articles module : put online articles '.implode(', ', $_POST['selarticles']), 2);
			header('Location: module.php?id=articles&action=1&cat_id='.$cat_id.'&status='.$status.'&order='.$order.'&onlined=1');
			exit;
		}
	}
	
	# Mise hors ligne
	if ($_POST['lot'] == 'offline' && $puntal->checkToken())
	{
		foreach ($_POST['selarticles'] as $v)
			$articles->statusArticle($v,1);
		
		if (!$puntal->err->hasError())
		{
			logIt('Articles module : put offline articles '.implode(', ', $_POST['selarticles']), 2);
			header('Location: module.php?id=articles&action=1&cat_id='.$cat_id.'&status='.$status.'&order='.$order.'&offlined=1');
			exit;
		}
	}
	
	# Suppression
	if ($_POST['lot'] == 'delete' && $puntal->checkToken())
	{
		foreach ($_POST['selarticles'] as $v)
			$articles->delArticle($v);
		
		if (!$puntal->err->hasError())
		{
			logIt('Articles module : Delete articles '.implode(', ', $_POST['selarticles']), 3);
			header('Location: module.php?id=articles&action=1&deleted=1');
			exit;
		}
	}

}

# Messages de confirmation
if (!empty($_GET['addgen']))
	$common_message = __('Article generated');


# Messages de confirmation
if (!empty($_GET['onlined']))
	$common_message = __('Articles put online');

if (!empty($_GET['offlined']))
	$common_message = __('Articles put offline');

if (!empty($_GET['deleted']))
	$common_message = __('Articles deleted');


/* Affichage
-------------------------------------------------------- */

# Set token
$puntal->setToken();

# Liste des catgories
$cats = $articles->getCat();
$cats_array = array();
$cats_array['&nbsp;'] = '';
while ($cats->fetch())
	$cats_array[$cats->f('cat_name')] = $cats->f('cat_id');
	
# Liste des articles sur plusieurs pages
require PT_INC_PATH.'/classes/multipage.php';

$nb_per_page = 20;
$nb_articles = $articles->getTotalAllArticles($cat_id,$status);
$max_pages = ceil($nb_articles/$nb_per_page);

$env = (!empty($_GET['env']) && $_GET['env'] <= $max_pages) ? $_GET['env'] : 1;

$rs = $articles->getArticles('',$cat_id,$status,$order_by,(($env-1)*$nb_per_page).','.$nb_per_page);

$lum = new multipage($env, 'articles_line', $rs->getData(), $nb_articles, $nb_per_page);

$lum->setOption('html_block', 
	'<form class="clearb" action="module.php" method="post" id="form-articles-list" onsubmit="return submitArticlesForm(this,\''.html::escapeJS(__('Are you sure you want to delete the selected articles?')).'\');">
	<table>
		<thead>
			<tr>
				<th colspan="2" class="nowrap left" scope="col">'.__('Article title').'</th>
				<th class="nowrap left" scope="col">'.__('Discuss').'</th>
				<th class="nowrap left" scope="col">'.__('Category').'</th>
				<th class="nowrap left" scope="col">'.__('Date').'</th>
				<th class="nowrap center" scope="col">'.__('Status').'</th>
			</tr>
		</thead>
		<tbody>%s</tbody>
	</table>
	<div class="two-cols">
		<p class="col checkboxes-helpers"></p>

		<p class="col right">'.
			form::hidden(array('id'),'articles')."\n".
			form::hidden(array('action'),1)."\n".
			form::hidden(array('cat_id'),$cat_id)."\n".
			form::hidden(array('status'),$status)."\n".
			form::hidden(array('order'),$order)."\n".
			form::hidden(array('ptkn'),$puntal->getToken()).
			'<label for="lot">'.__('For the selected articles:').'</label> '.
			form::combo('lot', array(__('Online')=>'online',__('Offline')=>'offline',__('Delete')=>'delete')).
			'<input class="submit" type="submit" value="'.__('ok').'" />
		</p>
	</div>
</form>'
);

$lum->setOption('html_row','%s');
$lum->setOption('html_cell','%s');

$lum->setOption('html_links','<p>'.__('Page(s):').' %s</p>');
$lum->setOption('html_cur_page','<strong>%s</strong>');

$lum->setOption('html_prev','&lt; '.__('Previous'));
$lum->setOption('html_next',__('Next').' &gt;');
$lum->setOption('html_prev_grp','...');
$lum->setOption('html_next_grp','...');

$lum->setOption('html_empty','');

# JS
$head = 
'<script type="text/javascript">'."\n".
"//<![CDATA[\n".
"function submitArticlesForm(F,msg)
{
	var inputs = F.elements;
	var articles_ids = new Array();
	var action;
	
	var i = 0;
	for (i=0; i<inputs.length; i++)
	{
		if (inputs[i].name == 'selarticles[]') {
			articles_ids.push(inputs[i]);
		}
		
		if (inputs[i].name == 'lot') {
			action = inputs[i].value;
		}
	}
	
	var selectfields = 0;
	for (i=0; i<articles_ids.length; i++) {
		selectfields += articles_ids[i].checked;
	}
	
	if (selectfields == 0) {
		return false;
	}
	
	if (action == 'delete') {
		return window.confirm(msg);
	}
	
	return true;
}

$(function() {
	$('.checkboxes-helpers').each(function() {
		puntal.checkboxesHelpers(this);
	});
});

//]]>
</script>";

if (!$show_filters)
	$head .= adminPage::jsLoad('js/filter-controls.js');

# Start page
adminPage::open(__('Articles list').' - '.__('Articles'),$head);

?>
<h2 class="first"><img src="index.php?pf=articles/img/ico_articles.png" alt="" class="icon" /> <?php echo __('Articles list') ?></h2>

<?php # Filtres
if (!$show_filters)
	echo '<p><a id="filter-control" class="form-control" href="#">'.__('Filters').'</a></p>';
?>	

<form action="module.php" method="get" id="filters-form">
	<fieldset>
		<legend><?php echo __('Filters') ?></legend>
		<div class="two-cols">
			<p class="col">
				<label for="cat_id"><?php echo __('Category') ?></label>
				<?php echo form::combo('cat_id', $cats_array,$cat_id) ?>
			</p>
			<p class="col">
				<label for="status"><?php echo __('Status') ?></label>
				<?php echo form::combo('status', array('&nbsp;'=>0, __('Offline')=>1, __('Online')=>2,__('Standby of validation')=>3),$status) ?>
			</p>
		</div>
		<div class="two-cols">
			<p class="col">
				<label for="status"><?php echo __('Sort by') ?></label>
				<?php echo form::combo('order', array(__('Date')=>'date', __('Status')=>'status', __('Category')=>'cat'),$order) ?>
			</p>
			<p class="col">
				<?php echo 
				form::hidden(array('id'),'articles')."\n".
				form::hidden(array('action'),1); ?>
				<input class="submit" type="submit" value="<?php echo __('Display') ?>" />
			</p>
		</div>
	</fieldset>
</form>

<?php if ($rs->isEmpty()) : 
	echo '<p class="clearb">'.__('No article').'</p>';
else : ?>

	<div class="clearb"></div>
	<?php echo $lum->getLinks(); ?>
	<?php echo $lum->getPage(); ?>
	<?php echo $lum->getLinks(); ?>
	
<?php endif;

adminPage::close() ?>