<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$p_id = (!empty($_REQUEST['pid']) && intval($_REQUEST['pid']) > 0) ? intval($_REQUEST['pid']) : '';

require_once PT_INC_PATH."libs/punbb_parser.php";

# FR - Nouvel article
# EN - New article
if ($p_id == '')
{
	$p_title 	= '';
	$p_url 		= '';
	$p_cat 		= '';
	$p_status 	= 1;
	$p_content 	= '';
	$p_date 	= '';
	$p_topic_id = 0;
	$p_post_id 	= 0;
	
	$t_infos = array('tid' => 0, 'pid' => 0);
	
	$title = __('New article');
	$buton = __('Add');
}

# FR - Modification d'un article
# EN - Article Modification
else {
	$article = $articles->getArticles($p_id);
	
	$p_title 	= $article->f('title');
	$p_url 		= $article->f('url');
	$p_cat 		= $article->f('cat_id');
	$p_status 	= $article->f('status');
	$p_content 	= $article->f('content');
	$p_date 	= date('Y-m-d H:i',strtotime($article->f('date')));
	$p_topic_id = $article->f('tid');
	$p_post_id 	= $article->f('pid');	
	
	$t_infos = array('tid' => $p_topic_id, 'pid' => $p_post_id);
	
	$title = __('Edit article');
	$buton = __('Edit');
}

# FR - Formulaire envoy
# EN - Submitted Form

if (!empty($_POST['publish']) || !empty($_POST['preview']) && $puntal->checkToken())
{
	
	$p_title 	= trim($_POST['p_title']);
	$p_content 	= $puntal->linebreaks(trim($_POST['p_content']));
	$p_content 	= preparse_bbcode($p_content, false);
	$p_date 	= trim($_POST['p_date']);
	$p_cat 		= intval($_POST['p_cat']);
	$p_url 		= !empty($_POST['p_url']) ? trim($_POST['p_url']) : '';
	$p_status 	= intval($_POST['p_status']);
	$p_post_topic = (!empty($_POST['p_post_topic']) && intval($_POST['p_post_topic']) == 1) ? true : false;
	$p_silent 	= (!empty($_POST['p_silent']) && intval($_POST['p_silent']) == 1) ? true : false;
	
	$p_id 		= intval($_POST['pid']);
	$p_topic_id = intval($_POST['p_tid']);
	$p_post_id 	= intval($_POST['p_pid']);

	
	if (empty($p_date))
		$p_date = date('Y-m-d');
	
	if (empty($p_title))
		$puntal->err->setError(__('You must give a title for the article.'));
	
	if (empty($p_content))
		$puntal->err->setError(__('You must give a content for the article.'));

	
	# FR - Pas d'erreur et publication
	# EN - No error and publishing
	if (!$puntal->err->hasError() && !empty($_POST['publish']))
	{
		
		if ( ( $ret_id = $articles->setArticle($p_title,$p_cat,$p_content,$p_date,$p_status,$p_url,$p_id,$p_topic_id,$p_post_id))  !== false)
		{
		
			# FR - Discussion sur les forums
			# EN - Discussion on forums
			if ( $p_status == '2' && $p_post_topic && pt_mod_articles_forum_id > 0)
			{
				$t_infos = array('tid' => 0, 'pid' => 0);
								
				# FR - Cration topic
				# EN - Topic Creation
				if ($p_id == 0) {
					$t_infos = punbb::newTopic(pt_mod_articles_forum_id,$p_title,$p_content,true,false,false,'','',true);
					$articles->setArticle($p_title,$p_cat,$p_content,$p_date,$p_status,$p_url,$ret_id,$t_infos['tid'],$t_infos['pid']);					
				}
				# FR - Modification post
				# EN - Post Modification
				else {
				/**
				 * 
				 * on verifie que le topic existe dj, si par mgarde le post avait t supprim entre temps ...				
				 */
					
					if ( punbb::checkPostTopic($p_post_id,$p_topic_id) === true) {
						/**
						 * [fr] on le met  jour
						 * [en] we update it
						 */
						punbb::editPost($p_post_id,$p_content,$p_title,false,$p_silent);
						$articles->setArticle($p_title,$p_cat,$p_content,$p_date,$p_status,$p_url,$p_id,$p_topic_id,$p_topic_id);
					} else {
						/**
						 * [fr] on recree le post disparu
						 * [en] we rebuild the removed post
						*/

						$t_infos = punbb::newTopic(pt_mod_articles_forum_id,$p_title,$p_content,true,false,false,'','',true);
						$articles->setArticle($p_title,$p_cat,$p_content,$p_date,$p_status,$p_url,$p_id,$t_infos['tid'],$t_infos['pid']);
					}
				}				
			}

			if (pt_mod_articles_mode == 0)
			{
				logIt("Articles module : added articles");
				header('Location: module.php?id=articles&action=6&gen_articles=1&from_post=1');
				exit;
			}
			else {
				logIt("Articles module : added article");
				header('Location: module.php?id=articles&action=2&pid='.$ret_id.'&'.($p_id == '' ? 'added' : 'edited').'=1');
				exit;
			}			

		}

	}
}

# FR - Commentaires
# EN - Comments
$neo_comment = '';

# FR - Ajout d'un commentaire
# EN - add a comment  
if (!empty($_POST['add_comment']) && $p_topic_id > 0 && $p_post_id > 0 && $puntal->checkToken())
{
	$neo_comment = $puntal->linebreaks(trim($_POST['neo_comment']));
	
	if ($neo_comment == '')
		$puntal->err->setError(__('You must give a comment'));
	
	else {
		
		$neo_comment = preparse_bbcode($neo_comment, false);
		
		if (punbb::newPost($p_topic_id,$neo_comment)) 
		{
		header('Location: module.php?id=articles&action=2&pid='.$p_id.'&comment_added=1');
		exit;
		}
	}
}


# FR - Message de confirmation
# EN - Confirmation Message
if (!empty($_GET['edited']))
	$common_message = __('Article edited');

if (!empty($_GET['added']))
	$common_message  = __('Article added');

if (!empty($_GET['comment_added']))
	$common_message  = __('Comment added');


# FR - Liste des commentaires
# EN - Comments List
if ($p_topic_id > 0 && $p_post_id > 0)
{
	if (($comments = punbb::getTopicPosts($p_topic_id,'',$p_post_id)) === false)
		$puntal->err->fatalError();
	
}
# FR - Liste des catgories
# EN - Categories List
$cats = $articles->getCat();

if (!$cats->isEmpty())
{
	$cats_array = array();
	while ($cats->fetch())
		$cats_array[$cats->f('cat_name')] = $cats->f('cat_id');
		
	$head =
	adminPage::jsDatePicker().
	'<script type="text/javascript">'."\n".
	"//<![CDATA[\n".
	"chainHandler(window,'onload',function() {
		if (!document.getElementById) { return; }
		
		puntal.hideLockable();			
		var post_dtPick = new datePicker(document.getElementById('p_date'));
		post_dtPick.img_top = '1.8em';
		post_dtPick.draw();
	});
	//]]>
	</script>";

}
else
	$head = '';

# Set token
$puntal->setToken();

# FR - Affichage
# EN - Display
adminPage::open($title.' - '.__('Articles'),$head);
?>
<h2 class="first"><img src="index.php?pf=articles/img/ico_articles_edit.png" alt="" class="icon" /> <?php echo $title ?></h2>

<?php 
# FR - Nous voulons au moins une catgorie
# EN - We want at least one category
if ($cats->isEmpty()) :
	echo '<p><a href="module.php?id=articles&amp;action=4">'.__('No category').'</a></p>';
else : ?>

<?php 
# FR - Prvisualisation
# EN - Preview
if (!empty($p_title) && !empty($p_content))
{
	
	echo 
	'<div id="previewbox">'.
	'<h3>'.html::escapeHTML($p_title).'</h3>'.
	parse_message($p_content,0).'</div>';
}

require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
$ptb = new puntoolbarSmilies($puntal);
?>

<form action="module.php" method="post">
	
	<div class="lockable">
	<p class="field"><label for="p_title"><?php echo __('Article title') ?></label>
	<?php echo form::field('p_title', 50, 255, html::escapeHTML($p_title),'lockable-from') ?></p>
	
	<?php if ($p_id != '') : ?>
		<p class="field"><label for="p_url"><?php echo __('Article URL title') ?></label>
		<?php echo form::field('p_url', 50, 255, html::escapeHTML($p_url),'lockable-in') ?></p>
	<?php endif; ?>
	</div>

	<div class="two-cols">
		<p class="field col"><label for="p_cat"><?php echo __('Article category') ?></label>
		<?php echo form::combo('p_cat', $cats_array, $p_cat) ?></p>
		
		<p class="field col"><label for="p_status"><?php echo __('Article status') ?></label>
		<?php echo form::combo('p_status', array(__('Offline')=>1,__('Online')=>2,__('Standby of validation')=>3), $p_status) ?></p>
	</div>

	<div class="two-cols">
		<p class="field col"><label for="p_date"><?php echo __('Article date') ?></label>
		<?php echo form::field('p_date', 10, 10, html::escapeHTML($p_date)) ?></p>
		
		<?php if ($p_topic_id > 0 && $p_post_id > 0) : ?>
			<div class="col">
				<ul class="checklist">
					<li><label><?php echo form::checkbox('p_post_topic', 1, true, 'checkbox').' '.__('Edit post of the topic') ?></label></li>
					<li><label><?php echo form::checkbox('p_silent', 1, true, 'checkbox').' '.__('Silent edit (don\'t display "Edited by ..." in topic view)') ?></label></li>
				</ul>
			</div>
		<?php elseif (pt_mod_articles_forum_id > 0) : ?>
			<p class="col"><label><?php echo form::checkbox('p_post_topic', 1, true, 'checkbox').' '.__('Post topic') ?></label></p>
		<?php endif; ?>
	</div>

	<p class="field clearb"><label for="p_content"><?php echo __('Article content') ?></label></p>
	<p class="area"><?php echo form::textarea('p_content', 55, 10, html::escapeHTML($p_content)) ?></p>
	<?php // Generate the PunToolBar 
	echo $ptb->generatePtb('p_content');
	?>	
		
	<p><?php echo 
	form::hidden('id','articles')."\n".
	form::hidden('action',2)."\n".
	form::hidden('pid',$p_id)."\n".
	form::hidden('p_tid',$p_topic_id)."\n".
	form::hidden('p_pid',$p_post_id)."\n".	
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" id="publish" name="publish" value="<?php echo $buton ?>" />
	<input class="submit" type="submit" id="preview" name="preview" value="<?php echo __('Preview') ?>" /></p>
</form>

<?php 
# FR - Si il y a une discussion pour cet article
# EN - If there is one discussion for this article
if ($p_topic_id > 0 && $p_post_id > 0) : ?>

<h2 id="comments"><img src="style/img/ico_comments.png" alt="" class="icon" /> <?php echo __('Comments') ?></h2>
	
	<?php # Et si il y a des commentaires on les affiches
	if (!$comments->isEmpty()) : ?>
		<?php # Boucle sur les commentaires
		while ($comments->fetch()) : 
		$cid = $comments->f('id');
		$comment_author = html::escapeHTML($comments->f('username'));
		?>
	<div class="comment">
	
		<h3 class="comment_info"><?php echo __('Comment by').' <a href="'.pt_forum_url.'profile.php?id='.$comments->f('poster_id').'" title="'.__('See profile of').' '.$comment_author.'">'.$comment_author.'</a> - <a href="'.pt_forum_url.'viewtopic.php?pid='.$cid.'#p'.$cid.'">'.$puntal->format_time($comments->f('posted')); ?></a></h3>
		
		<?php echo parse_message($comments->f('message'), $comments->f('hide_smilies')); ?>
		
	</div>
		<?php endwhile; ?>
	<?php 
	# FR - Pas de commentaire
	# EN - No comment
	else : ?>
	<p><strong><?php echo __('No comment') ?></strong></p>
	<?php endif; ?>
	
	<h3><img src="style/img/ico_comment_add.png" alt="" class="icon" /> <label for="neo_comment"><?php echo __('Write a comment') ?></label></h3>
	<form method="post" action="module.php">
		
		<p class="area"><?php echo form::textarea('neo_comment', 55, 5, $neo_comment) ?></p>
		<?php 
		# FR - Puntoolbar 
		# EN - Generate the PunToolBar 
		echo $ptb->generatePtb('noe_comment');
		?>
		<p><?php echo form::hidden('add_comment','1')."\n".
		form::hidden('id','articles')."\n".
		form::hidden('action',2)."\n".
		form::hidden('pid',$p_id)."\n".
		form::hidden('p_tid',$p_topic_id)."\n".
		form::hidden('p_pid',$p_post_id)."\n".		
		form::hidden(array('ptkn'),$puntal->getToken()) ?>
		<input class="submit" type="submit" value="<?php echo __('Add'); ?>" /></p>
	</form>

<?php endif; ?>

<?php endif;
adminPage::close() ?>