<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
update_articles<br/>

<strong>FR</strong> La fonction charge de la mise  jour du module articles.<br/>
<strong>EN</strong> the function in charge of the update of the article module.
*/
function update_articles()
{
	global $puntal;
	
	$res = true;
	
	# mise  jour 1.0
	if (compare_version(pt_mod_articles_version,'1.0') == '-1')
		$res &= articles_up_to_to_1_0();
	# mise  jour 1.1
	if (compare_version(pt_mod_articles_version,'1.1') == '-1')
		$res &= articles_up_to_to_1_1();	
	# mise  jour 1.2
	if (compare_version(pt_mod_articles_version,'1.2') == '-1')
		$res &= articles_up_to_to_1_2();
	# mise  jour 1.3
	if (compare_version(pt_mod_articles_version,'1.3') == '-1')
		$res &= articles_up_to_to_1_3();
	# mise  jour 2.0
	if (compare_version(pt_mod_articles_version,'2.0') == '-1')
		$res &= articles_up_to_to_2_0();
		
	return $res;
}

/**
articles_up_to_to_1_0<br/>

<strong>FR</strong> Mise  jour du module  la version 1.0<br/>
<strong>EN</strong> Update to the version 1.0 of the module
*/
function articles_up_to_to_1_0()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_articles_date_format'
	);
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
}

/**
articles_up_to_to_1_1<br/>

<strong>FR</strong> Mise  jour du module  la version 1.1<br/>
<strong>EN</strong> Update to the version 1.1 of the module
*/
function articles_up_to_to_1_1()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	$db_scheme[] = array(
		'action' 	=> 'update',
		'table' 	=> DB_PREFIX.'pt_articles',
		'query' 	=> 'ALTER TABLE '.DB_PREFIX.'pt_articles ADD INDEX idx_articles_cat_id (cat_id);'
	);
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
}


/**
articles_up_to_to_1_2<br/>

<strong>FR</strong> Mise  jour du module  la version 1.2<br/>
<strong>EN</strong> Update to the version 1.2 of the module
*/
function articles_up_to_to_1_2() {
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
		
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
	
}


/**
articles_up_to_to_1_3<br/>

<strong>FR</strong> Mise  jour du module  la version 1.3<br/>
<strong>EN</strong> Update to the version 1.3 of the module
*/
function articles_up_to_to_1_3() {
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
		
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();

	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_articles_mode',
		'type'		=> 'integer',
		'init'		=> 1
	);
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
	
}

/**
articles_up_to_to_2_0<br/>

<strong>FR</strong> Mise  jour du module  la version 2.0<br/>
<strong>EN</strong> Update to the version 2.0 of the module
*/
function articles_up_to_to_2_0() {
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
		
	# Structure de la table 'pt_articles_vote'
	$db_scheme[] = array(
		'action' 	=> 'add',
		'table' 	=> DB_PREFIX.'pt_articles_vote',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_articles_vote (	
		`id_article` INT NOT NULL ,
		`id_user` INT NOT NULL ,
		level INT NOT NULL ,
		INDEX ( `id_article` ),
		INDEX ( `id_user` )
		) ENGINE = MYISAM ;"
	);
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
	
}
?>