<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/**
 * 
	@brief articles template class
	
*/
class articles
{	
	/**
	mainMenu<br/>
	
	<strong>FR</strong> Affiche le menu des articles<br/>
	<strong>EN</strong> Display the menu of the articles<br/>
	
	@param bloc	<strong>string</strong>	formatting mask of the list of the bloc
	@param item	<strong>string</strong>	formatting mask  of an item of the list
	@param current <strong>string</strong> formatting mask of an active item
	*/
	function mainMenu($bloc='<ul>%s</ul>', $item='<li>%s</li>', $current='<li class="current">%s</li>')
	{
		global $cats, $cat_id, $articles_mode;
		
		$rs = '';
			
		$rs .= sprintf(($articles_mode == 'home' ? $current : $item), '<a href="'.$GLOBALS['puntal']->url('articles').'">'.__('Articles').'</a>');
		
		while ($cats->fetch())
		{
			if ($cats->f('nb_articles') > 0)
			{
				$rs .= sprintf((($cat_id == $cats->f('cat_id') || $cat_id == $cats->f('cat_url')) ? $current : $item), '<a href="'.$GLOBALS['puntal']->url('articles').$cats->f('cat_url').'">'.html::escapeHTML($cats->f('cat_name')).'</a>');
			}
		}
		
		if ($GLOBALS['allowed_to_submit'])
			$rs .= sprintf(($articles_mode == 'submit' ? $current : $item), '<a href="'.$GLOBALS['puntal']->url('articles_submit').'">'.__('Submit an article').'</a>');
		
		printf($bloc, $rs);
	}
	
	/**
	articlesOpenComment<br/>
	
	<strong>FR</strong>Indique si les commentaires sont possibles,	si il y a un forum affect aux articles.
	<strong>EN</strong>Tell if comments are enable,	if a dedicated forum exists
	
	@return <strong>boolean</strong>
	*/
	function articlesOpenComment()
	{
		if (pt_mod_articles_forum_id)
			return true;
		
		return false;
	}
	
	/***********************************************************************\
		Des infos pour le fil RSS
	\***********************************************************************/
	
	/**
	headRss<br/>
	 
	<strong>FR</strong> Affiche le lien d'entte vers le fil RSS.<br/>
	<strong>EN</strong> Display the link of the RSS Feeds
	
	*/
	function headRss()
	{
		echo '<link rel="alternate" type="application/rss+xml" href="'.$GLOBALS['puntal']->url('articles_rss').'" title="'.__('RSS feed of articles').'" />'."\n";
	}
	
	/**
	articlesUrl<br/>
	
	<strong>FR</strong> Affiche l'URL des articles.<br/>
	<strong>EN</strong> Display the URL of articles.
	
	*/
	function articlesUrl()
	{
		echo puntal::getHost().$GLOBALS['puntal']->url('articles');
	}
	
	/**
	articleRssTitle<br/>
	
	<strong>FR</strong> Affiche le titre d'un article dans le contexte d'une boucle
	sur une liste d'articles pour le fil RSS.<br/>
	<strong>EN</strong> Display the title of an article in loop 'article context' for the RSS feeds
	*/
	function articleRssTitle()
	{
		echo html::escapeHTML($GLOBALS['article_list']->f('title'));
	}
	
	/**
	articleRssUrl<br/>
	
	<strong>FR</strong> Affiche l'URL d'un article dans le contexte d'une boucle
	sur une liste d'articles pour le fil RSS.<br/>
	<strong>EN</strong> Display the URL of an article in loop 'article context' for the RSS feeds
	*/
	function articleRssUrl()
	{
		echo puntal::getHost().$GLOBALS['puntal']->url('articles').$GLOBALS['article_list']->f('id').'-'.html::escapeHTML($GLOBALS['article_list']->f('url'));
	}
	
	/***********************************************************************\
		Une catgorie
	\***********************************************************************/
	/**
	 catName<br/>
	 <strong>FR</strong> Affiche le nom de la categorie<br/>
	 <strong>EN</strong> Display the name of the category
	 */
	function catName()
	{
		if ($GLOBALS['cat_id'] != '')
			echo html::escapeHTML($GLOBALS['cat']->f('cat_name'));
	}
	
	/**
	catDesc<br/>
	
	 <strong>FR</strong> Affiche la description de la categorie<br/>
	 <strong>EN</strong> Display the description of the category

	*/
	function catDesc()
	{
		if ($GLOBALS['cat_id'] != '')
			echo $GLOBALS['cat']->f('cat_desc');
	}
	
	/***********************************************************************\
		Une liste d'articles
	\***********************************************************************/
		
	/**
	articlesList<br/>
	
	<strong>FR</strong> Affiche une liste d'articles<br/>
	<strong>EN</strong> Display the list of articles
	
	@param bloc <strong>string</strong>		formatting mask of list bloc
	@param item <strong>string</strong>		formatting mask of list item
	*/
	function articlesList($bloc='<ul>%s</ul>', $item='<li>%s</li>')
	{
		global $article_list, $articles_mode;
		
		$rs = '';
		
		if ($article_list->isEmpty())
			return;
		
		while ($article_list->fetch())
		{
			$rs .= sprintf($item, '<a href="'.$GLOBALS['puntal']->url('articles').$article_list->f('id').'-'.html::escapeHTML($article_list->f('url')).'">'.html::escapeHTML($article_list->f('title')).'</a>');
		}
		
		printf($bloc, $rs);
	}
	
	/**
	listUrl<br/>
	
	<strong>FR</strong> Affiche l'URL d'un article dans le contexte d'une boucle sur une liste d'articles.<br/>
	<strong>EN</strong> Display the URL of an article in loop 'article context' for the list of article
	*/
	function listUrl($return=false)
	{
		$url = $GLOBALS['puntal']->url('articles').$GLOBALS['article_list']->f('id').'-'.html::escapeHTML($GLOBALS['article_list']->f('url'));
		
		if ($return)
			return $url;
		
		echo $url;
	}	
	
	/**
	listTitle<br/>
	
	<strong>FR</strong> Affiche le titre d'un article dans le contexte d'une boucle sur une liste d'articles.<br/>
	<strong>EN</strong> Display the title of an article in loop 'article context' for the list of article
	*/
	function listTitle()
	{
		echo html::escapeHTML($GLOBALS['article_list']->f('title'));
	}
		
	/**
	@function listCatName
	
	Affiche le titre d'un article dans le contexte 
	d'une boucle sur une liste d'articles.
	*/
	function listCatName()
	{
		echo html::escapeHTML($GLOBALS['article_list']->f('cat_name'));
	}
		
	/**
	listDate<br/>
	
	<strong>FR</strong> Affiche la date d'un article dans le contexte d'une boucle sur une liste d'articles.<br/>
	<strong>EN</strong> Display the date of an article in loop 'article context' for the list of article
	*/
	function listDate($format='')
	{
		if ($format != '')
			echo dt::str($format, strtotime($GLOBALS['article_list']->f('date')));
		else
			echo dt::str(pt_date_format, strtotime($GLOBALS['article_list']->f('date')));
	}
	
	/**
	listTid<br/>
	
	<strong>FR</strong> Affiche l'identifiant du topic de l'article dans le contexte d'une boucle sur une liste d'articles.<br/>
	<strong>EN</strong> Display the ID of the Topic of an article in loop 'article context' for the list of article
	*/
	function listTid()
	{
		echo $GLOBALS['article_list']->f('tid');
	}
	
	/**
	listContent<br/>
	
	<strong>FR</strong> Affiche le contenu d'un article dans le contexte d'une boucle sur une liste d'articles.<br/>
	<strong>EN</strong> Display the content of an article in loop 'article context' for the list of article	
	*/
	function listContent($return=false)

	{
		require_once PT_INC_PATH."libs/punbb_parser.php";
		if ($return)
			return parse_message($GLOBALS['article_list']->f('content'),false);

		
        echo parse_message($GLOBALS['article_list']->f('content'),false);
	}
		
	/**
	listNumComment<br/>
	
	<strong>FR</strong> Affiche le nombre de commentaires d'un article dans le contexte	d'une boucle sur une liste d'articles.<br/>
	<strong>EN</strong> Display the comment of an article in loop 'article context' for the list of article	
	*/
	function listNumComment()
	{
		if ($GLOBALS['article_list']->f('tid') > 0)
		{
			$numComment = $GLOBALS['article_list']->f('num_replies');
			
			if ($numComment == 0)
				echo __('No comment');
			elseif ($numComment == 1)
				echo __('One comment');
			else
				printf(__('%s comments'), $numComment);
		}
		else {
			echo __('No discuss');
		}
	}
	
	/**
	listOpenComments<br/>
	
	<strong>FR</strong> Indique si il les commentaires pour un article sont ouverts (i.e. si il y a un topic)<br/>
	<strong>EN</strong> Tell if the comments for one article are opened (test if there is an existing topic)
	*/
	function listOpenComments()
	{
		if ($GLOBALS['article_list']->f('tid') > 0)
			return true;
		
		return false;
	}

	/***********************************************************************\
		Un article
	\***********************************************************************/
	
	/**
	articleTitle<br/>
	
	<strong>FR</strong> Affiche le titre d'un article<br/>
	<strong>EN</strong> Display the title of an article 
	*/
	function articleTitle()
	{
		echo html::escapeHTML($GLOBALS['article']->f('title'));
	}
		
	/**
	articleContent
	
	<strong>FR</strong> Affiche le contenu d'un article<br/>
	<strong>EN</strong> Display the content of an article  
	*/
	function articleContent()
	{
		
		require_once PT_INC_PATH."libs/punbb_parser.php";
		echo parse_message($GLOBALS['article']->f('content'),0);
		
	}
		
	/**
	articleDate<br/>
	
	<strong>FR</strong> Affiche la date d'un article dans le contexte d'une boucle sur une liste d'articles.<br/>
	<strong>EN</strong> Display the date of an article in loop 'article context' for the list of article  
	*/
	function articleDate($format='')
	{
		if ($format != '')
			echo dt::str($format, strtotime($GLOBALS['article']->f('date')));
		else
			echo dt::str(pt_date_format, strtotime($GLOBALS['article']->f('date')));
	}
	
	/**
	articleTid<br/>
	
	<strong>FR</strong> Affiche l'identifiant du topic de l'article<br/>
	<strong>EN</strong> Display the topic ID of the article
	*/
	function articleTid()
	{
		echo $GLOBALS['article']->f('tid');
	}
	
	/**
	articleNumComment<br/>
	
	<strong>FR</strong> Affiche le nombre de commentaires de l'article<br/>
	<strong>EN</strong> Display the number of comments of the article
	*/
	function articleNumComment()
	{
		$numComment = $GLOBALS['article']->f('num_replies');
		
		if ($numComment == 0)
			echo __('No comment');
		elseif ($numComment == 1)
			echo __('One comment');
		else
			printf(__('%s comments'), $numComment);
	}
	
	/**
	articleOpenComments<br/>
	
	<strong>FR</strong> Indique si il les commentaires pour un article sont ouvert (i.e. si il y a un topic)<br/>
	<strong>EN</strong> Tell if the comments are opened for an article (if the topic id exists)
	*/
	function articleOpenComments()
	{
		if ($GLOBALS['article']->f('tid') > 0)
			return true;
		
		return false;
	}
		
	/***********************************************************************\
		Commentaires d'un article
	\***********************************************************************/
	
	/**
	hasComments<br/>
	
	<strong>FR</strong> Indique si il y a ou non des commentaires pour un article<br/>
	<strong>EN</strong> Test if there are existing comments for the article
	
	@return <strong>boolean</strong>
	
	*/
	function hasComments()
	{
		if ($GLOBALS['comments']->isEmpty())
			return false;
		
		return true;
	}
	
	/**
	commentMessage<br/>
	
	<strong>FR</strong> Messages dans la boucle de commentaires<br/>
	<strong>EN</strong> Mmessages in a loop of comments
	*/
	function commentMessage()
	{
		echo parse_message($GLOBALS['comments']->f('message'), $GLOBALS['comments']->f('hide_smilies'));
	}
	
	/**
	uid<br/>
	
	<strong>FR</strong> Affiche l'identifiant de l'auteur de la news<br/>
	<strong>EN</strong> Display the ID of th Author of the news
	*/
	function commentUid()
	{
		echo $GLOBALS['comments']->f('poster_id');
	}
	
	/**
	commentDate<br/>
	
	<strong>FR</strong> Affiche la date de la news
	<strong>EN</strong> Display the date of the news
	*/
	function commentDate()
	{
		echo $GLOBALS['puntal']->format_time($GLOBALS['comments']->f('posted'));
	}
	
	/**
	author<br/>
	
	<strong>FR</strong> Affiche le nom d'utilisateur de l'auteur de la news<br/>
	<strong>EN</strong> Display the username of the author of the news
	*/
	function commentAuthor()
	{
		echo html::escapeHTML($GLOBALS['comments']->f('username'));
	}
	
	
		
	/***********************************************************************\
		Soumission d'un article
	\***********************************************************************/
	
	/**
	submitUrl<br/>
	
	<strong>FR</strong> Affiche l'URL de soumission des articles<br/>
	<strong>EN</strong> Display the URL of submission of articles
	*/
	function submitUrl()
	{
		echo $GLOBALS['puntal']->url('articles_submit');
	}
	
	/**
	errors<br/>
	
	<strong>FR</strong> Affiche une liste d'erreurs<br/>
	<strong>EN</strong> Display a list of errors 
	*/
	function errors($block='<ul>%s</ul>',$item='<li>%s</li>')
	{
		$items = '';
		foreach ($GLOBALS['errors'] as $err)
			$items .= sprintf($item,$err);
		
		printf($block, $items);
	}
	
	/**
	formValue<br/>
	
	<strong>FR</strong> Affiche un des champs du formulaire.<br/>
	<strong>EN</strong> Display one of the field of the form
	
	@param	var <strong>string</strong	Variable name to be displayed
	*/
	function formValue($var='')
	{
		if ($var == '')
			return;
		
		echo html::escapeHTML($GLOBALS[$var]);
	}
	
	/**
	selectCat<br/>
	
	<strong>FR</strong> Cette fonction affiche le menu d�roulant de choix des catgorie	sur la page de soumission.<br/>
	<strong>EN</strong> this function display the dropdown list of categories on the submission page
	
	@param name <strong>string</strong> name of the 'select' 
	*/
	function selectCat($name='p_cat')
	{
		global $cats;
		
		$rs = '<select name="'.$name.'" id="'.$name.'">';
		while ($cats->fetch())
		{
			if ($cats->f('cat_id') == $GLOBALS[$name])
				$rs .= '<option value="'.$cats->f('cat_id').'" selected=selected">'.html::escapeHTML($cats->f('cat_name')).'</option>'."\n";
			else
				$rs .= '<option value="'.$cats->f('cat_id').'">'.html::escapeHTML($cats->f('cat_name')).'</option>'."\n";
		}
		$rs .= '</select>';
		
		echo $rs;
	}

	/**
	 otherArticles<br/>
	 
	 <strong>FR</strong> Affiche le libell<br/>
	 <strong>EN</strong> Display the label 
	 */
	function otherArticles() {
		echo __('Articles in the same category:');
	}

	/**
	 getStaticArticles<br/>
	 
	 <strong>FR</strong> Affiche le cache des articles <br/>
	 <strong>EN</strong> Display the cache of the articles
	 
	  @param no_article <strong>string</strong> formatting the cache 
	 */	
	function getStaticArticles($no_article='<p>%s</p>')
	{
		if (file_exists(PT_CACHE_PATH.'/articles/articles-'.$GLOBALS['article_id'].'.html'))
			require PT_CACHE_PATH.'/articles/articles-'.$GLOBALS['article_id'].'.html';
		else
			printf($no_article, __('No article to be displayed'));
			
	}

	/**
	 articleVoteLabel<br/>
	 
	 <strong>FR</strong> Affiche les votes des articles <br/>
	 <strong>EN</strong> Display the ratings of the articles
	  
	 */		
	function articleVoteLabel() {
		global $vote;
		$ttl = 0;
		$rate = 0;
		
		echo __('Vote to estimate this article') . '<br/>';
		
		if 	($vote->f('ttl') > 0) {
			$ttl = $vote->f('ttl');
			$rate = $vote->f('ttl_level')/$vote->f('ttl');		
			echo $ttl . ' ' . __('Ratings') . '<br/>';
			echo __('Rate :').$rate;
		}
	}	

	/**
	 articleVote<br/>
	 
	 <strong>FR</strong> Affiche les liens pour voter<br/>
	 <strong>EN</strong> Display the links to rate

	  @param line <strong>string</strong> formatting the display of the vote 	  
	 */	
	function articleVote($line = '<span class="star1">%s</span> <span class="star2">%s</span> <span class="star3">%s</span> <span class="star4">%s</span> <span class="star5">%s</span>') {
		global $article_list;
				
		$one  = '<a href="'.sprintf($GLOBALS['puntal']->url('articles_vote'), $article_list->f('id'),html::escapeHTML($article_list->f('url')),1).'" title="'.__('Interesting').'">'.__('Interesting').'</a>';
		$two  = '<a href="'.sprintf($GLOBALS['puntal']->url('articles_vote'), $article_list->f('id'),html::escapeHTML($article_list->f('url')),2).'" title="'.__('Very Interesting').'">'.__('Very Interesting').'</a>';
		$three= '<a href="'.sprintf($GLOBALS['puntal']->url('articles_vote'), $article_list->f('id'),html::escapeHTML($article_list->f('url')),3).'" title="'.__('Good').'">'.__('Good').'</a>';				
		$four = '<a href="'.sprintf($GLOBALS['puntal']->url('articles_vote'), $article_list->f('id'),html::escapeHTML($article_list->f('url')),4).'" title="'.__('Very Good').'">'.__('Very Good').'</a>';		
		$five = '<a href="'.sprintf($GLOBALS['puntal']->url('articles_vote'), $article_list->f('id'),html::escapeHTML($article_list->f('url')),5).'" title="'.__('A Must Have').'">'.__('A Must Have').'</a>';
		
		echo sprintf($line,$one,$two,$three,$four,$five);
	}
	
}
?>