<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

# Menu blocs
if (pt_mod_blocks && checkPerm('mod_blocks'))
{
	$on_block = ($current_page == 'bloc.php' && !empty($block_id)) ? true : false;
	foreach ($puntal->blocks->getBlocks() as $b=>$infos)
	{
		$menu->addItem('blocs',__('bloc_'.$b),'bloc.php?id='.$b,($on_block && $block_id == $b),(is_callable($puntal->blocks->getAdminBlock($b)) && checkPerm('bloc_'.$b)));
	}
}


/**
	
	@brief adminBlocks module class
	
	<strong>FR</strong> La classe de gestion des blocs publiques<br/>	
	<strong>EN</strong> The class of the management of the publics blocks
*/
class adminBlocks
{
	/**
	active_topics<br/>
	
	<strong>FR</strong> Gestion du bloc des discussion actives<br/>
	<strong>EN</strong> Management of the bloc of active topics
	*/	
	function active_topics()
	{
		global $puntal, $pt_settings;
		
		$bloc_active = pt_bloc_active_topics;
		
		$p_topics_num = pt_bloc_active_topics_num;
		$p_max_len = pt_bloc_active_topics_max_len;
		$p_fids = explode(',',pt_bloc_active_topics_fid);
		
		# Formulaire envoy
		if (!empty($_POST['form_sent']))
		{
			$p_fids = !empty($_POST['p_fids']) ? array_map('intval', $_POST['p_fids']) : array();
			$p_max_len = intval(trim($_POST['p_max_len']));
			$bloc_active = intval(trim($_POST['bloc_active_topics']));
			
			$p_topics_num = intval(trim($_POST['p_topics_num']));
			if ($p_topics_num < 1 || $p_topics_num > 50)
				$p_topics_num = 15;	
		
			$pt_settings->setNamespace('mod_blocks');
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_active_topics_num', $p_topics_num);
			$res &= $pt_settings->put('pt_bloc_active_topics_max_len', $p_max_len);
			$res &= $pt_settings->put('pt_bloc_active_topics_fid', implode(',', $p_fids));
			$res &= $pt_settings->put('pt_bloc_active_topics', $bloc_active);
		
			$pt_settings->setNamespace('');
			
			if ( file_exists(PT_CACHE_PATH.'blocks/active_topics.html') ) 
				@unlink(PT_CACHE_PATH.'blocks/active_topics.html');
		
			if ($res)
			{
				logIt("Config active_topics block", 1);
				header('Location: bloc.php?id=active_topics&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
						
		# Affichage
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_active_topics')),	
		'<script type="text/javascript">'."\n".
		"//<![CDATA[\n".
		"$(function() {
			$('.checkboxes-helpers').each(function() {
				puntal.checkboxesHelpers(this);
			});
		});".
		"//]]>\n".
		"</script>"."\n");
?>
	<h2 class="first"><img src="style/img/ico_comment.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_active_topics')); ?></h2>
	
	<form method="post" action="bloc.php" id="form-bloc-active-topics-config">
		<fieldset>
			<legend><?php echo __('bloc_active_topics') ?></legend>
			
			<p class="field"><label for="bloc_active_topics"><?php echo __('Activate ?') ?></label>
			<label><?php echo form::radio(array('bloc_active_topics'),1,$bloc_active, 'radio').__('Yes') ?></label>
			<label><?php echo form::radio(array('bloc_active_topics'),0,!$bloc_active, 'radio').__('No') ?></label>
			</p>			
						
			<p class="field"><label for="p_num_topics"><?php echo __('Number of topics') ?></label>
			<?php echo form::field('p_topics_num', 2, 5, html::escapeHTML($p_topics_num)) ?>
			<span class="desc"><?php echo __('The number of topics to display on this block (between 1 and 50).') ?></span></p>
			
			<p class="field"><label for="p_max_len"><?php echo __('Truncat title') ?></label>
			<?php echo form::field('p_max_len', 2, 5, html::escapeHTML($p_max_len)) ?>
			<span class="desc"><?php echo __('The number of character to which the titles of the topics will be truncated (0 to disable).') ?></span></p>
			
			<p><span class="fakelabel"><?php echo __('Forums') ?></span>
			<span class="desc"><?php echo __('Choose the forums of which you wish to list the discussions. If been left blank, the topics of all the forums readable by the guests will be recovered.') ?></span></p>
<?php
// Get all the categories and forums
$forums = punbb::getForums();

$cur_category = 0;
while ($forums->fetch()) :
	if ($forums->f('cid') != $cur_category)	// A new category since last iteration?
	{
		if ($cur_category != 0)
			echo "\t\t\t".'</ul>'."\n";
?>
			<p><?php echo html::escapeHTML($forums->f('cat_name')) ?></p>
			<ul class="checklist">
<?php
		$cur_category = $forums->f('cid');
	}
?>
				<li><label><?php echo form::checkbox(array('p_fids[]'), $forums->f('fid'), in_array($forums->f('fid'),$p_fids), 'checkbox').html::escapeHTML($forums->f('forum_name')); ?></label></li>
<?php endwhile; ?>
			</ul>
			<p><span class="desc checkboxes-helpers"></span></p>
		</fieldset>
		
		<p><?php echo 
		form::hidden('form_sent', '1')."\n".
		form::hidden('id', 'active_topics'); ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	</form>
<?php
		adminPage::close();
	}
	
	#--------------------------------------------------
	
	/**
	custom_bloc<br/>
	
	<strong>FR</strong> Gestion du bloc personnalis<br/>
	<strong>EN</strong> Management of the content of the custom bloc
	*/	
	function custom_bloc()
	{
		global $puntal, $pt_settings;
		require_once PT_INC_PATH."libs/punbb_parser.php";
		$bloc_active = pt_bloc_custom_bloc;
		$p_title = pt_bloc_custom_bloc_title;
		$p_content = pt_bloc_custom_bloc_content;
		
		# Formulaire envoy
		if (!empty($_POST['form_sent']))
		{
			$p_title = trim($_POST['p_title']);
			
			$p_content = $puntal->linebreaks(trim($_POST['p_content']));
			$p_content = preparse_bbcode($p_content, false);
						
			$bloc_active = intval(trim($_POST['bloc_custom_bloc']));
									
			$pt_settings->setNamespace('mod_blocks');
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_custom_bloc_title', $p_title);
			$res &= $pt_settings->put('pt_bloc_custom_bloc_content', $p_content);
			$res &= $pt_settings->put('pt_bloc_custom_bloc', $bloc_active);			
			
			$pt_settings->setNamespace('');
		
			if ($res)
			{
				logIt("Config custom block", 1);
				header('Location: bloc.php?id=custom_bloc&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
	
		$head='';

		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_custom_bloc')),$head);
?>
	<h2 class="first"><img src="style/img/ico_custom_block.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_custom_bloc')); ?></h2>
	
	<form method="post" action="bloc.php">
		<fieldset>
			<legend><?php echo __('bloc_custom_bloc') ?></legend>

			<p class="field"><label for="bloc_custom_bloc"><?php echo __('Activate ?') ?></label>
			<label><?php echo form::radio(array('bloc_custom_bloc'),1,$bloc_active, 'radio').__('Yes') ?></label>
			<label><?php echo form::radio(array('bloc_custom_bloc'),0,!$bloc_active, 'radio').__('No') ?></label>
			</p>			
			
			<p class="field"><label for="p_title"><?php echo __('Block title'); ?></label>
			<?php echo form::field('p_title', 50, 255, html::escapeHTML($p_title)) ?>
			<span class="desc"><?php echo __('The title of the block. This field <strong>cannot</strong> contain <acronym title="HyperText Markup Language">HTML</acronym>.'); ?></span></p>
			
			<p class="field"><label for="p_content"><?php echo __('Block content'); ?></label>
			<span class="desc"><?php echo __('Give the <acronym title="HyperText Markup Language">HTML</acronym> content of the block.'); ?></span></p>
			<p class="area"><?php echo form::textarea('p_content', 55, 10, html::escapeHTML($p_content)) ?></p>
			<?php 
			require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
			$ptb = new puntoolbarSmilies($puntal);
			echo $ptb->generatePtb('p_content');
			?>			
		</fieldset>
		
		<p><?php echo
		form::hidden('form_sent', '1')."\n".
		form::hidden('id', 'custom_bloc'); ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	</form>
<?php	
		echo 
		'<div id="previewbox">'.
		'<h3>'.html::escapeHTML($p_title).'</h3>'.
		parse_message($p_content,false).'</div>';

		adminPage::close();
	}
	
	#--------------------------------------------------
	
	/**
	custom_bloc_bis<br/>
	
	<strong>FR</strong> Gestion du contenu du bloc personnalis 2<br/>
	<strong>EN</strong> Management of the content of the custom bloc 2
	*/	
	function custom_bloc_bis()
	{
		global $puntal, $pt_settings;
		
		require_once PT_INC_PATH."libs/punbb_parser.php";
		
		$bloc_active = pt_bloc_custom_bloc_bis;
		$p_title = pt_bloc_custom_bloc_bis_title;
		$p_content = pt_bloc_custom_bloc_bis_content;
		
		# Formulaire envoy
		if (!empty($_POST['form_sent']))
		{
			$p_title = trim($_POST['p_title']);
			
			$p_content = $puntal->linebreaks(trim($_POST['p_content']));
			$p_content = preparse_bbcode($p_content, false);
			
			$bloc_active = intval(trim($_POST['bloc_custom_bloc_bis']));
										
			$pt_settings->setNamespace('mod_blocks');
			$res = true;
			$res &= $pt_settings->put('pt_bloc_custom_bloc_bis_title', $p_title);
			$res &= $pt_settings->put('pt_bloc_custom_bloc_bis_content', $p_content);
			$res &= $pt_settings->put('pt_bloc_custom_bloc_bis', $bloc_active);	
						
			$pt_settings->setNamespace('');
		
			if ($res)
			{
				logIt("Config custom block bis", 1);
				header('Location: bloc.php?id=custom_bloc_bis&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
		
		# Affichage
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_custom_bloc_bis')));
?>
	<h2 class="first"><span><img src="style/img/ico_custom_block.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_custom_bloc_bis')); ?></span></h2>
	
	<form method="post" action="bloc.php">
		<fieldset>
			<legend><?php echo __('bloc_custom_bloc_bis') ?></legend>

			<p class="field"><label for="bloc_custom_bloc_bis"><?php echo __('Activate ?') ?></label>
			<label><?php echo form::radio(array('bloc_custom_bloc_bis'),1,$bloc_active, 'radio').__('Yes') ?></label>
			<label><?php echo form::radio(array('bloc_custom_bloc_bis'),0,!$bloc_active, 'radio').__('No') ?></label>
			</p>			
			
			<p class="field"><label for="p_title"><?php echo __('Block title'); ?></label>
			<?php echo form::field('p_title', 50, 255, html::escapeHTML($p_title)) ?>
			<span class="desc"><?php echo __('The title of the block. This field <strong>cannot</strong> contain <acronym title="HyperText Markup Language">HTML</acronym>.'); ?></span></p>
			
			<p class="field"><label for="p_content"><?php echo __('Block content'); ?></label>
			<span class="desc"><?php echo __('Give the <acronym title="HyperText Markup Language">HTML</acronym> content of the block.'); ?></span></p>
			<p class="area"><?php echo form::textarea('p_content', 55, 10, html::escapeHTML($p_content)) ?></p>
			<?php 
			require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
			$ptb = new puntoolbarSmilies($puntal);
			echo $ptb->generatePtb('p_content');
			?>			
		</fieldset>
		
		<p><?php echo
		form::hidden('form_sent', '1')."\n".
		form::hidden('id', 'custom_bloc_bis'); ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	</form>
<?php	
		echo 
		'<div id="previewbox">'.
		'<h3>'.html::escapeHTML($p_title).'</h3>'.
		parse_message($p_content,false).'</div>';

		adminPage::close();
	}
	
	#--------------------------------------------------
	
	/**
	custom_menu<br/>
	
	<strong>FR</strong> Geston du contenu du menu personnalis<br/>
	<strong>EN</strong> Management of the content of the custom menu
	*/
	function custom_menu()
	{
		global $puntal, $pt_settings;
		
		$bloc_active = pt_bloc_custom_menu;
		$p_title = pt_bloc_custom_menu_title;
		$p_links_array = unserialize(pt_bloc_custom_menu_content);
		$n_title = '';
		$n_url = '';
		$n_html = '';
		
		if (isset($_POST['config_bloc_custom_menu']))
		{
			$p_title = trim($_POST['p_title']);
			$l_title = array_map('trim', $_POST['title']);
			$l_url = array_map('trim', $_POST['url']);
			$l_html = array_map('trim', $_POST['html']);
			$bloc_active = intval(trim($_POST['bloc_custom_menu']));
			
			$i=0;
			foreach ($p_links_array as $link)
			{
				if (!empty($l_title[$i]))
				{
					
				
					if ( strpos($l_title[$i],'<img') === false or strpos($l_title[$i],'<img') > 1 ) {
						$l_title[$i] = html::escapeHTML($l_title[$i]);
					}
								
					$neo_html = !empty($l_html[$i]) ? ' '.$l_html[$i] : '';

					if (empty($l_url[$i]))
						$neo_links_array[] = '<span'.$neo_html.'>'.$l_title[$i].'</span>';
					else
						$neo_links_array[] = '<a href="'.$l_url[$i].'"'.$neo_html.'>'.$l_title[$i].'</a>';
					
				}
				$i++;
			}
			
			$pt_settings->setNamespace('mod_blocks');
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_custom_menu_title', $p_title);
			$res &= $pt_settings->put('pt_bloc_custom_menu_content', serialize($neo_links_array));
			$res &= $pt_settings->put('pt_bloc_custom_menu', $bloc_active);	
			
			$pt_settings->setNamespace('');
		
			if ($res)
			{
				logIt("Config custom menu block", 1);
				header('Location: bloc.php?id=custom_menu&updated=1');
				exit;
			}
		}
		
		else if (isset($_POST['add_in_bloc_custom_menu']))
		{
			$n_title = trim($_POST['n_title']);
			$n_url = trim($_POST['n_url']);
			$n_html = trim($_POST['n_html']);
					
			if (!empty($n_title))
			{
				$neo_html = !empty($n_html) ? ' '.$n_html : '';
			
				if (empty($n_url))
					$p_links_array[] = '<span'.$neo_html.'>'.$n_title.'</span>';
				else
					$p_links_array[] = '<a href="'.$n_url.'"'.$neo_html.'>'.$n_title.'</a>';
				
				$pt_settings->setNamespace('mod_blocks');
				
				$res = true;
				$res &= $pt_settings->put('pt_bloc_custom_menu_content', serialize($p_links_array));
				
				$pt_settings->setNamespace('');
			
				if ($res)
				{
					logIt("Add item in custom menu block", 1);
					header('Location: bloc.php?id=custom_menu&updated=1');
					exit;
				}
			}
			else 
				$puntal->err->setError(__('You must give at least a title.'));
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
		
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_custom_menu')));
?>
		<h2 class="first"><img src="style/img/ico_custom_menu.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_custom_menu')) ?></h2>
		
		<form method="post" action="bloc.php">	
			<fieldset>
				<legend><?php echo __('bloc_custom_menu') ?></legend>
				
				<p class="field"><label for="bloc_custom_menu"><?php echo __('Activate ?') ?></label>
				<label><?php echo form::radio(array('bloc_custom_menu'),1,$bloc_active, 'radio').__('Yes') ?></label>
				<label><?php echo form::radio(array('bloc_custom_menu'),0,!$bloc_active, 'radio').__('No') ?></label>
				</p>			
				
				<p class="field"><label for="p_title"><?php echo __('Block title') ?></label>
				<?php echo form::field('p_title', 50, 255, html::escapeHTML($p_title)) ?>
				<span class="desc"><?php echo __('The title of the block. This field <strong>cannot</strong> contain <acronym title="HyperText Markup Language">HTML</acronym>.') ?></span></p>
				
<?php
		for ($i=0; $i<count($p_links_array); ++$i)
		{
			preg_match('#<a href="(.*?)"(.*?)>(.*?)</a>#', $p_links_array[$i], $l_matches);
			preg_match('#<span(.*?)>(.*?)</span>#', $p_links_array[$i], $s_matches);
			
						
			$title_value = isset($l_matches[3]) ? $l_matches[3] : $s_matches[2];
			$url_value = isset($l_matches[1]) ? $l_matches[1] : '';
			$html_value = isset($l_matches[2]) ? trim($l_matches[2]) : trim($s_matches[1]);

			if ( strpos($title_value,'<img') !== false ) 
						$title_value = html::escapeHTML($title_value);
			
			echo 
			'<p class="field"><span class="fakelabel">'.$p_links_array[$i].'</span>'.
			'<label class="inline">'.__('Title').'<br />'.
			form::field(array('title['.$i.']'), 20, 255, $title_value).'</label>'.
			'<label class="inline">'.__('<acronym title="Uniform Resource Locator">URL</acronym>').'<br />'.
			form::field(array('url['.$i.']'), 20, 255, $url_value).'</label>'.
			'<label class="inline">'.__('<acronym title="HyperText Markup Language">HTML</acronym>').'<br />'.
			form::field(array('html['.$i.']'), 20, 255, html::escapeHTML($html_value)).'</label>'.
			'<span class="desc clearb">'.html::escapeHTML($p_links_array[$i]).'</span></p>';
		}
?>			
			</fieldset>
			<p><?php echo 
			form::hidden('config_bloc_custom_menu','1')."\n".
			form::hidden('id','custom_menu'); ?>
			<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
		</form>
		
		<form method="post" action="bloc.php">	
			<fieldset>
				<legend><?php echo __('Add'); ?></legend>
				<div class="three-cols">
					<p class="field col"><label><?php echo __('Title') ?><br />
					<?php echo form::field('n_title', 20, 255, html::escapeHTML($n_title)) ?></label></p>
					
					<p class="field col"><label><?php echo __('<acronym title="Uniform Resource Locator">URL</acronym>') ?><br />
					<?php echo form::field('n_url', 20, 255, html::escapeHTML($n_url)) ?></label></p>
	
					<p class="field col"><label><?php echo __('<acronym title="HyperText Markup Language">HTML</acronym>') ?><br />
					<?php echo form::field('n_html', 20, 255, html::escapeHTML($n_html)) ?></label></p>
				</div>
			</fieldset>
			
			<p><?php echo 
			form::hidden('add_in_bloc_custom_menu','1')."\n".
			form::hidden('id','custom_menu'); ?>
			<input class="submit" type="submit" value="<?php echo __('Add'); ?>" /></p>
		</form>
<?php
		adminPage::close();
	}
	
	#--------------------------------------------------
	
	/**
	custom_menu_bis<br/>
	
	<strong>FR</strong> Geston du contenu du menu personnalis 2<br/>
	<strong>EN</strong> Management of the content of the custom menu 2
	*/	
	function custom_menu_bis()
	{
		global $puntal, $pt_settings;
		
		$neo_links_array = array();
		
		$p_title = pt_bloc_custom_menu_bis_title;
		$p_links_array = unserialize(pt_bloc_custom_menu_bis_content);
		$n_title = '';
		$n_url = '';
		$n_html = '';
		$bloc_active = pt_bloc_custom_menu_bis;
		
		if (isset($_POST['config_bloc_custom_menu_bis']))
		{
			$p_title = trim($_POST['p_title']);
			$l_title = array_map('trim', $_POST['title']);
			$l_url = array_map('trim', $_POST['url']);
			$l_html = array_map('trim', $_POST['html']);
			$bloc_active = intval(trim($_POST['bloc_custom_menu_bis']));
								
			$i=0;
			foreach ($p_links_array as $link)
			{
				if (!empty($l_title[$i]))
				{
					
					if ( strpos($l_title[$i],'<img') === false or strpos($l_title[$i],'<img') > 1 ) {
						$l_title[$i] = html::escapeHTML($l_title[$i]);
					}

					$neo_html = !empty($l_html[$i]) ? ' '.$l_html[$i] : '';
														
					if (empty($l_url[$i]))
						$neo_links_array[] = '<span'.$neo_html.'>'.$l_title[$i].'</span>';
					else
						$neo_links_array[] = '<a href="'.$l_url[$i].'"'.$neo_html.'>'.$l_title[$i].'</a>';
				}
				$i++;
			}
			
			$pt_settings->setNamespace('mod_blocks');
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_custom_menu_bis_title', $p_title);
			$res &= $pt_settings->put('pt_bloc_custom_menu_bis_content', serialize($neo_links_array));
			$res &= $pt_settings->put('pt_bloc_custom_menu_bis', $bloc_active);	
			
			$pt_settings->setNamespace('');
		
			if ($res)
			{
				logIt("Config custom menu bis block", 1);
				header('Location: bloc.php?id=custom_menu_bis&updated=1');
				exit;
			}
		}
		
		else if (isset($_POST['add_in_bloc_custom_menu_bis']))
		{
			$n_title = trim($_POST['n_title']);
			$n_url = trim($_POST['n_url']);
			$n_html = trim($_POST['n_html']);
			
			if (!empty($n_title))
			{
				$neo_html = !empty($n_html) ? ' '.$n_html : '';
				
				if (empty($n_url))
					$p_links_array[] = '<span'.$neo_html.'>'.$n_title.'</span>';
				else
					$p_links_array[] = '<a href="'.$n_url.'"'.$neo_html.'>'.$n_title.'</a>';
				
				$pt_settings->setNamespace('mod_blocks');
				
				$res = true;
				$res &= $pt_settings->put('pt_bloc_custom_menu_bis_content', serialize($p_links_array));
				
				$pt_settings->setNamespace('');
			
				if ($res)
				{
					logIt("Add item in custom menu bis block", 1);
					header('Location: bloc.php?id=custom_menu_bis&updated=1');
					exit;
				}
			}
			else {
				$puntal->err->setError(__('You must give at least a title.'));
			}
		}

		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
					
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_custom_menu_bis')));
?>
		<h2 class="first"><img src="style/img/ico_custom_menu.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_custom_menu_bis')) ?></h2>
		
		<form method="post" action="bloc.php">	
			<fieldset>
				<legend><?php echo __('bloc_custom_menu_bis') ?></legend>
				
				<p class="field"><label for="bloc_custom_menu_bis"><?php echo __('Activate ?') ?></label>
				<label><?php echo form::radio(array('bloc_custom_menu_bis'),1,$bloc_active, 'radio').__('Yes') ?></label>
				<label><?php echo form::radio(array('bloc_custom_menu_bis'),0,!$bloc_active, 'radio').__('No') ?></label>
				</p>			
				
				<p class="field"><label for="p_title"><?php echo __('Block title') ?></label>
				<?php echo form::field('p_title', 50, 255, html::escapeHTML($p_title)) ?>
				<span class="desc"><?php echo __('The title of the block. This field <strong>cannot</strong> contain <acronym title="HyperText Markup Language">HTML</acronym>.') ?></span></p>
				
<?php
		for ($i=0; $i<count($p_links_array); ++$i)
		{
			preg_match('#<a href="(.*?)"(.*?)>(.*?)</a>#', $p_links_array[$i], $l_matches);
			preg_match('#<span(.*?)>(.*?)</span>#', $p_links_array[$i], $s_matches);

			$title_value = isset($l_matches[3]) ? $l_matches[3] : $s_matches[2];
			$url_value = isset($l_matches[1]) ? $l_matches[1] : '';
			$html_value = isset($l_matches[2]) ? trim($l_matches[2]) : trim($s_matches[1]);

			if ( strpos($title_value,'<img') !== false )
						$title_value = html::escapeHTML($title_value);
									
			echo 
			'<p class="field"><span class="fakelabel">'.$p_links_array[$i].'</span>'.
			'<label class="inline">'.__('Title').'<br />'.
			form::field(array('title['.$i.']'), 20, 255, $title_value).'</label>'.
			'<label class="inline">'.__('<acronym title="Uniform Resource Locator">URL</acronym>').'<br />'.
			form::field(array('url['.$i.']'), 20, 255, $url_value).'</label>'.
			'<label class="inline">'.__('<acronym title="HyperText Markup Language">HTML</acronym>').'<br />'.
			form::field(array('html['.$i.']'), 20, 255, html::escapeHTML($html_value)).'</label>'.
			'<span class="desc clearb">'.html::escapeHTML($p_links_array[$i]).'</span></p>';
		}
?>			
			</fieldset>
			
			<p><?php echo 
			form::hidden('config_bloc_custom_menu_bis','1')."\n".
			form::hidden('id','custom_menu_bis'); ?>
			<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
		</form>
		
		<form method="post" action="bloc.php">	
			<fieldset>
				<legend><?php echo __('Add'); ?></legend>
				<div class="three-cols">
					<p class="field col"><label><?php echo __('Title') ?><br />
					<?php echo form::field('n_title', 20, 255, html::escapeHTML($n_title)) ?></label></p>
					
					<p class="field col"><label><?php echo __('<acronym title="Uniform Resource Locator">URL</acronym>') ?><br />
					<?php echo form::field('n_url', 20, 255, html::escapeHTML($n_url)) ?></label></p>
	
					<p class="field col"><label><?php echo __('<acronym title="HyperText Markup Language">HTML</acronym>') ?><br />
					<?php echo form::field('n_html', 20, 255, html::escapeHTML($n_html)) ?></label></p>
				</div>
			</fieldset>
			
			<p><?php echo 
			form::hidden('add_in_bloc_custom_menu_bis','1')."\n".
			form::hidden('id','custom_menu_bis'); ?>
			<input class="submit" type="submit" value="<?php echo __('Add'); ?>" /></p>
		</form>

<?php
		adminPage::close();
	}
	
	#--------------------------------------------------
	
	/**
	edit<br/>
	
	<strong>FR</strong> Geston du contenu de l'edito<br/>
	<strong>EN</strong> Management of the content of edito
	*/
	function edito()
	{
		global $puntal, $pt_settings;
		require_once PT_INC_PATH."libs/punbb_parser.php";
		$p_title = pt_bloc_edito_titre;
		$p_content = pt_bloc_edito_message;
		$bloc_active = pt_bloc_edito;
	
		if (!empty($_POST['form_sent']))
		{
			
			$p_title = trim($_POST['p_title']);
			
			$p_content = $puntal->linebreaks(trim($_POST['p_content']));
			$p_content = preparse_bbcode($p_content, false);
							
			$bloc_active = intval(trim($_POST['bloc_edito']));
			
			$pt_settings->setNamespace('mod_blocks');
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_edito_titre', $p_title);
			$res &= $pt_settings->put('pt_bloc_edito_message', $p_content);
			$res &= $pt_settings->put('pt_bloc_edito', $bloc_active);
			
			$pt_settings->setNamespace('');
		
			if ($res)
			{
				logIt("Config edito block", 1);
				header('Location: bloc.php?id=edito&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
		
		# Affichage
		$head ='';
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_edito')),$head);
?>
	<h2 class="first"><img src="style/img/ico_edito.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_edito')); ?></h2>
	
	<form method="post" action="bloc.php">
		<fieldset>
			<legend><?php echo __('bloc_edito') ?></legend>

			<p class="field"><label for="bloc_edito"><?php echo __('Activate ?') ?></label>
				<label><?php echo form::radio(array('bloc_edito'),1,$bloc_active, 'radio').__('Yes') ?></label>
				<label><?php echo form::radio(array('bloc_edito'),0,!$bloc_active, 'radio').__('No') ?></label>
			</p>			
			
			<p class="field"><label for="p_title"><?php echo __('Edito title'); ?></label>
			<?php echo form::field('p_title', 50, 255, html::escapeHTML($p_title)) ?>
			<span class="desc"><?php echo __('The title of the block. This field <strong>cannot</strong> contain <acronym title="HyperText Markup Language">HTML</acronym>.'); ?></span></p>
			
			<p class="field"><label for="p_content"><?php echo __('Edito content'); ?></label></p>
			<p class="area"><?php echo form::textarea('p_content', 55, 10, html::escapeHTML($p_content)) ?></p>
			<?php 
			require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
			$ptb = new puntoolbarSmilies($puntal);
			echo $ptb->generatePtb('p_content');
			?>		
		</fieldset>
		
		<p><?php echo 
		form::hidden('form_sent','1')."\n".
		form::hidden('id','edito'); ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	
	</form>
<?php	
		
		echo 
		'<div id="previewbox">'.
		'<h3>'.html::escapeHTML($p_title).'</h3>'.
		parse_message($p_content,false).'</div>';

		adminPage::close();
	}
	
	#--------------------------------------------------
	
	/**
	recent_topics<br/>
	
	<strong>FR</strong> Gestion le bloc discussions rcentes<br/>
	<strong>EN</strong> Management of the bloc of the recent topics
	*/	
	function recent_topics()
	{
		global $puntal, $pt_settings;
		
		$p_num_topics = pt_bloc_recent_topics_num;
		$p_max_len = pt_bloc_recent_topics_max_len;
		$p_fid = explode(',',pt_bloc_recent_topics_fid);
		$bloc_active = pt_bloc_recent_topics;
		
		if (!empty($_POST['form_sent']))
		{
			$p_num_topics = intval(trim($_POST['p_num_topics']));
			if ($p_num_topics < 1 || $p_num_topics > 50)
				$p_num_topics = 15;	
			
			$p_max_len = intval(trim($_POST['p_max_len']));
			$p_fid = !empty($_POST['p_fid']) ? array_map('intval', $_POST['p_fid']) : array();
			$bloc_active = intval(trim($_POST['bloc_recent_topics']));
					
			$pt_settings->setNamespace('mod_blocks');
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_recent_topics_num', $p_num_topics);
			$res &= $pt_settings->put('pt_bloc_recent_topics_max_len', $p_max_len);
			$res &= $pt_settings->put('pt_bloc_recent_topics_fid', implode(',', $p_fid));
			$res &= $pt_settings->put('pt_bloc_recent_topics', $bloc_active);
					
			$pt_settings->setNamespace('');

			if ( file_exists(PT_CACHE_PATH.'blocks/recent_topics.html') ) 
				@unlink(PT_CACHE_PATH.'blocks/recent_topics.html');
		
			if ($res)
			{
				logIt("Config recent topics block", 1);
				header('Location: bloc.php?id=recent_topics&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
		
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_recent_topics')),	
		'<script type="text/javascript">'."\n".
		"//<![CDATA[\n".
		"$(function() {
			$('.checkboxes-helpers').each(function() {
				puntal.checkboxesHelpers(this);
			});
		});".
		"//]]>\n".
		"</script>"."\n");
?>
	<h2 class="first"><img src="style/img/ico_comment.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_recent_topics')); ?></h2>
	
	<form method="post" action="bloc.php" id="form-bloc-recent-topics-config">
		<fieldset>
			<legend><?php echo __('bloc_recent_topics') ?></legend>
			
			<p class="field"><label for="bloc_recent_topics"><?php echo __('Activate ?') ?></label>
				<label><?php echo form::radio(array('bloc_recent_topics'),1,$bloc_active, 'radio').__('Yes') ?></label>
				<label><?php echo form::radio(array('bloc_recent_topics'),0,!$bloc_active, 'radio').__('No') ?></label>
			</p>						
			<p class="field"><label for="p_num_topics"><?php echo __('Number of topics') ?></label>
			<?php echo form::field('p_num_topics', 2, 5, html::escapeHTML($p_num_topics)) ?>
			<span class="desc"><?php echo __('The number of topics to display on this block (between 1 and 50).') ?></span></p>
			
			<p class="field"><label for="p_max_len"><?php echo __('Truncat title') ?></label>
			<?php echo form::field('p_max_len', 2, 5, html::escapeHTML($p_max_len)) ?>
			<span class="desc"><?php echo __('The number of character to which the titles of the topics will be truncated (0 to disable).') ?></span></p>
			
			<p><span class="fakelabel"><?php echo __('Forums') ?></span>
			<span class="desc"><?php echo __('Choose the forums of which you wish to list the discussions. If been left blank, the topics of all the forums readable by the guests will be recovered.') ?></span></p>
<?php
// Get all the categories and forums
$forums = punbb::getForums();

$cur_category = 0;
while ($forums->fetch()) :
	if ($forums->f('cid') != $cur_category)	// A new category since last iteration?
	{
		if ($cur_category != 0)
			echo "\t\t\t".'</ul>'."\n";
?>
			<p><?php echo html::escapeHTML($forums->f('cat_name')) ?></p>
			<ul class="checklist">
<?php
		$cur_category = $forums->f('cid');
	}
?>
				<li><label><?php echo form::checkbox(array('p_fid[]'), $forums->f('fid'), in_array($forums->f('fid'),$p_fid), 'checkbox').html::escapeHTML($forums->f('forum_name')); ?></label></li>
<?php endwhile; ?>
			</ul>		
			<p><span class="desc checkboxes-helpers"></span></p>
		</fieldset>
		
		<p><?php echo 
		form::hidden('form_sent','1')."\n".
		form::hidden('id','recent_topics'); ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
		
	</form>
<?php
		adminPage::close();
	}
	
	#--------------------------------------------------
	
	/**
	modules_list<br/>
	
	<strong>FR</strong> Gestion le bloc de la liste des modules<br/>
	<strong>EN</strong> Management of the bloc of the list of the modules
	*/		
	function modules_list()
	{
		global $puntal, $pt_settings;
		
		$p_title = pt_bloc_modules_list_title;
		$bloc_active = pt_bloc_modules_list;
		
		if (!empty($_POST['form_sent']))
		{
			$p_title = trim($_POST['p_title']);
					
			$pt_settings->setNamespace('mod_blocks');
			$bloc_active = intval(trim($_POST['bloc_modules_list']));
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_modules_list_title', $p_title);
			$res &= $pt_settings->put('pt_bloc_modules_list', $bloc_active);
			
			$pt_settings->setNamespace('');
		
			if ($res)
			{
				logIt("Config modules list block", 1);
				header('Location: bloc.php?id=modules_list&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
		
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_modules_list')));
?>
	<h2 class="first"><img src="style/img/ico_module.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_modules_list')) ?></h2>
	
	<form method="post" action="bloc.php">
		<fieldset>
			<legend><?php echo __('bloc_modules_list') ?></legend>
			
			<p class="field"><label for="bloc_modules_list"><?php echo __('Activate ?') ?></label>
				<label><?php echo form::radio(array('bloc_modules_list'),1,$bloc_active, 'radio').__('Yes') ?></label>
				<label><?php echo form::radio(array('bloc_modules_list'),0,!$bloc_active, 'radio').__('No') ?></label>
			</p>			
			<p class="field"><label for="p_title"><?php echo __('Block title'); ?></label>
			<?php echo form::field('p_title', 50, 255, html::escapeHTML($p_title)) ?>
			<span class="desc"><?php echo __('The title of the block. This field <strong>cannot</strong> contain <acronym title="HyperText Markup Language">HTML</acronym>.'); ?></span></p>
			
		</fieldset>
		
		<p><?php echo
		form::hidden('form_sent', '1')."\n".
		form::hidden('id', 'modules_list') ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	</form>
		
<?php
		adminPage::close();
	}
		
	#--------------------------------------------------
	
	/**
	top_posters<br/>
	
	<strong>FR</strong> Gestion du bloc top des posteurs<br/>
	<strong>EN</strong> Management of the bloc of the top posters
	*/		
	function top_posters()
	{
		global $puntal, $pt_settings;
		
		$p_num = pt_bloc_top_posters_num;
		$p_posts = pt_bloc_top_posters_posts;
		$bloc_active = pt_bloc_top_posters;
		
		if (!empty($_POST['form_sent']))
		{
			$p_posts = intval(trim($_POST['p_posts']));
			$bloc_active = intval(trim($_POST['bloc_top_posters']));
			
			$p_num = intval(trim($_POST['p_num']));
			if ($p_num < 1 || $p_num > 50)
				$p_num = 5;
		
			$pt_settings->setNamespace('mod_blocks');
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_top_posters_num', $p_num);
			$res &= $pt_settings->put('pt_bloc_top_posters_posts', $p_posts);
			$res &= $pt_settings->put('pt_bloc_top_posters', $bloc_active);
			
			$pt_settings->setNamespace('');
			if ( file_exists(PT_CACHE_PATH.'blocks/top_posters.html') ) 
				@unlink(PT_CACHE_PATH.'blocks/top_posters.html');
				
			if ($res)
			{
				logIt("Config top_posters block", 1);
				header('Location: bloc.php?id=top_posters&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
				
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_top_posters')));
?>
	<h2 class="first"><img src="style/img/ico_poster.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_top_posters')) ?></span></h2>
	
	<form method="post" action="bloc.php">
		<fieldset>
			<legend><?php echo __('bloc_top_posters') ?></legend>

			<p class="field"><label for="bloc_top_posters"><?php echo __('Activate ?') ?></label>
				<label><?php echo form::radio(array('bloc_top_posters'),1,$bloc_active, 'radio').__('Yes') ?></label>
				<label><?php echo form::radio(array('bloc_top_posters'),0,!$bloc_active, 'radio').__('No') ?></label>
			</p>			
		
			<p class="field"><label for="p_num"><?php echo __('Number of posters'); ?></label>
			<?php echo form::field('p_num', 5, 25, html::escapeHTML($p_num)) ?>
			<span class="desc"><?php echo __('The number of posters to display on the block (between 1 to 50)'); ?></span></p>
			
			<p><span class="fakelabel"><?php echo __('Show number of posts'); ?></span>
			<label><?php echo form::radio(array('p_posts'), 1, $p_posts, 'radio').__('Yes'); ?></label>
			<label><?php echo form::radio(array('p_posts'), 0, !$p_posts, 'radio').__('No'); ?></label>
			<span class="desc"><?php echo __('Enable this option to display the number of posts written by each poster.'); ?></span></p>
		</fieldset>
		<p><?php echo 
		form::hidden('form_sent', '1')."\n".
		form::hidden('id', 'top_posters') ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	</form>
<?php
		adminPage::close();
	}
	
}

?>