<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
@function install_blocks

La fonction charge de l'installation du module blocks.
*/
function install_blocks()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
		
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	# actives topics
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_active_topics_num',
		'type' 		=> 'integer',
		'init'		=> 15
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_active_topics_fid',
		'type' 		=> 'string',
		'init'		=> ''
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_active_topics_max_len',
		'type' 		=> 'integer',
		'init'		=> 10
	);
		
	# custom block
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_bloc_title',
		'type' 		=> 'string',
		'init'		=> __('Title')
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_bloc_content',
		'type' 		=> 'string',
		'init'		=> __('Content')
	);
	
	# custom block 2
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_bloc_bis_title',
		'type' 		=> 'string',
		'init'		=> __('Title')
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_bloc_bis_content',
		'type' 		=> 'string',
		'init'		=> __('Content')
	);
		
	# custom menu
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_menu_title',
		'type' 		=> 'string',
		'init'		=> 'Puntal'
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_menu_content',
		'type' 		=> 'string',
		'init'		=> 'a:4:{i:0;s:42:"<a href="http://www.puntal.fr/">Puntal</a>";i:1;s:46:"<span style="font-weight: bold">Auteurs</span>";i:2;s:67:"<a href="http://www.foxmask.info/" title="FoxMaSk blog">FoxMaSk</a>";i:3;s:60:"<a href="http://www.forx.fr/" title="vin100 blog">vin100</a>";}'
	);
	
	# custom menu 2
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_menu_bis_content',
		'type' 		=> 'string',
		'init'		=> 'a:2:{i:0;s:86:"<a href="http://www.punbb.org/" hreflang="en" title="Official PunBB website">PunBB</a>";i:1;s:121:"<a href="http://www.punbb.fr/" hreflang="fr" title="Le site des utilisateurs francophones de PunBB">PunBB en franais</a>";}'
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_menu_bis_title',
		'type' 		=> 'string',
		'init'		=> __('Links')
	);
	
	# edito
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_edito_titre',
		'type' 		=> 'string',
		'init'		=> __('Title')
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_edito_message',
		'type' 		=> 'string',
		'init'		=> __('Content')
	);
	
	# modules list
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_modules_list_title',
		'type' 		=> 'string',
		'init'		=> __('Modules')
	);
	
	# recent topics
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_recent_topics_num',
		'type' 		=> 'integer',
		'init'		=> 15
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_recent_topics_fid',
		'type' 		=> 'string',
		'init'		=> ''
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_recent_topics_max_len',
		'type' 		=> 'integer',
		'init'		=> 0
	);
		
	# top posters
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_top_posters_num',
		'type' 		=> 'integer',
		'init'		=> 5
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_top_posters_posts',
		'type' 		=> 'boolean',
		'init'		=> false
	);
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_active_topics',
		'type'		=> 'integer',
		'init'		=> 1
	);

	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_bloc',
		'type'		=> 'integer',
		'init'		=> 1
	);
		
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_bloc_bis',
		'type'		=> 'integer',
		'init'		=> 1
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_menu',
		'type'		=> 'integer',
		'init'		=> 1
	);	
		
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_menu_bis',
		'type'		=> 'integer',
		'init'		=> 1
	);	
	
	# ... edito		
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_edito',
		'type'		=> 'integer',
		'init'		=> 1
	);
		
	# ... recent topics		
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_recent_topics',
		'type'		=> 'integer',
		'init'		=> 1
	);
		
	# ... module list
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_modules_list',
		'type'		=> 'integer',
		'init'		=> 1
	);

	# ... tops posters
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_top_posters',
		'type'		=> 'integer',
		'init'		=> 1
	);	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->install($db_scheme,$params);
}


?>