<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

function update_blocks()
{
	global $puntal;
	
	$res = true;
	
	# mise  jour 1.0
	if (compare_version(pt_mod_blocks_version,'0.6') == '-1')
		$res &= blocks_up_to_to_0_6();
	if (compare_version(pt_mod_blocks_version,'0.7') == '-1')
		$res &= blocks_up_to_to_0_7();
			
	return $res;
}

/**
@function blocks_up_to_to_0_6

Mise  jour du module  la version 0.6
*/
function blocks_up_to_to_0_6()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();

	# calendar
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_bloc_calendar_events_number'
	);
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_bloc_calendar_events_days'
	);
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_bloc_calendar_date_format'
	);
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
}

/**
@function blocks_up_to_to_0_7

Mise  jour du module  la version 0.7
*/
function blocks_up_to_to_0_7() {
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	# bloc ...
	# ... active topic
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_active_topics',
		'type'		=> 'integer',
		'init'		=> 1
	);

	# ... custom
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_bloc',
		'type'		=> 'integer',
		'init'		=> 1
	);
	# ... custom bis
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_bloc_bis',
		'type'		=> 'integer',
		'init'		=> 1
	);
	# ... menu 
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_menu',
		'type'		=> 'integer',
		'init'		=> 1
	);	
	# ... menu bis		
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_custom_menu_bis',
		'type'		=> 'integer',
		'init'		=> 1
	);	
	
	# ... edito		
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_edito',
		'type'		=> 'integer',
		'init'		=> 1
	);
		
	# ... recent topics		
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_recent_topics',
		'type'		=> 'integer',
		'init'		=> 1
	);
		
	# ... module list
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_modules_list',
		'type'		=> 'integer',
		'init'		=> 1
	);

	# ... tops posters
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_top_posters',
		'type'		=> 'integer',
		'init'		=> 1
	);
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
	
}


?>