<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

# URLs configuration
define('BLOG_URL', 'blog');
define('BLOG_TRACKBACK', 'trackback');
define('BLOG_RSS', 'rss');
define('BLOG_ATOM', 'atom');
define('BLOG_CAT', 'category');
define('BLOG_ENTRY', 'entry');
define('BLOG_COMMENTS', 'comments');

# Par exemple en franais :
// define('BLOG_URL', 'weblogue');
// define('BLOG_TRACKBACK', 'retrolien');
// define('BLOG_RSS', 'rss');
// define('BLOG_ATOM', 'atom');
// define('BLOG_CAT', 'categorie');
// define('BLOG_ENTRY', 'billet');
// define('BLOG_COMMENTS', 'commentaires');


#########################################################################

if (!defined('PUNTAL')) exit;


define('dc_format_post_url','%04d/%02d/%02d/%d-%s');
define('dc_format_cat_url','%s');
define('dc_format_archive_url','%s/%02d');
define('dc_format_day_url','%s/%02d/%02d');


# Enregistrement des modles d'URLs du module
$GLOBALS['puntal']->registerURL('blog', pt_portal_url.BLOG_URL.'/');
$GLOBALS['puntal']->registerURL('blog_trackback', pt_portal_url.BLOG_URL.'/'.BLOG_TRACKBACK.'/');
$GLOBALS['puntal']->registerURL('blog_rss', pt_portal_url.BLOG_URL.'/'.BLOG_RSS.'/');
$GLOBALS['puntal']->registerURL('blog_atom', pt_portal_url.BLOG_URL.'/'.BLOG_ATOM.'/');


# enregistrement des blocs
$GLOBALS['puntal']->blocks->registerBlock('blog_calendar',
	array('blogPublicBlocks','calendar'));

$GLOBALS['puntal']->blocks->registerBlock('blog_selection',
	array('blogPublicBlocks','selection'));

$GLOBALS['puntal']->blocks->registerBlock('blog_categories',
	array('blogPublicBlocks','categories'));

$GLOBALS['puntal']->blocks->registerBlock('blog_archives',
	array('blogPublicBlocks','archives'));


# Recherche sur le blog
$GLOBALS['puntal']->addBehavior('searchPerform', array('blogBehavior','performSearch'));
	
# Rsultats de recherche
$GLOBALS['puntal']->addBehavior('searchResults', array('blogBehavior','searchResults'));

# Affiche le nombre de Rsultats de recherche
$GLOBALS['puntal']->addBehavior('searchResultsTtl', array('blogBehavior','searchResultsTtl'));


class blogBehavior
{
	function performSearch()
	{
		global $puntal;
		
		# required files
		require dirname(__FILE__).'/inc/classes/class.blog.php';
		require dirname(__FILE__).'/inc/classes/class.xblog.php';
		require dirname(__FILE__).'/inc/classes/class.xblogpost.php';
		require dirname(__FILE__).'/inc/classes/class.xblogcomment.php';
		
		# blog
		$GLOBALS['blog'] = new xblog($puntal,1,__('lang_iso_code'));
		$GLOBALS['blog']->rs_blogpost = 'xblogpost';
		$GLOBALS['blog']->rs_blogcomment = 'xblogcomment';
		
		$GLOBALS['blog']->setURL('post',$puntal->url('blog').dc_format_post_url);
		$GLOBALS['blog']->setURL('cat',$puntal->url('blog').dc_format_cat_url);
		$GLOBALS['blog']->setURL('archive',$puntal->url('blog').dc_format_archive_url);
		$GLOBALS['blog']->setURL('day',$puntal->url('blog').dc_format_day_url);
		
		if (file_exists(PT_THEMES_PATH.pt_theme.'/blog/blog.css'))
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.pt_theme.'/blog/blog.css'.'" />';
		else
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.PT_DEFAULT_THEME.'/blog/blog.css'.'" />';
		#la recherche est-elle vide ?
		if (strlen(trim($_GET['q'])) > 2 )	  				
			$GLOBALS['blog_entries'] = $GLOBALS['blog']->searchPost($_GET['q']);
	}
	
	
	function searchResults()
	{
		global $blog_entries;
		
		if ($blog_entries and !$blog_entries->isEmpty())
		{
			require dirname(__FILE__).'/inc/tpl_functions.php';
			
			if (file_exists(PT_THEMES_PATH.pt_theme.'/blog/search_results.php'))
				require PT_THEMES_PATH.pt_theme.'/blog/search_results.php';
			else
				require PT_THEMES_PATH.PT_DEFAULT_THEME.'/blog/search_results.php';
		}
	}
	
	function searchResultsTtl() {
		global $blog_entries;
		
		if ($blog_entries and !$blog_entries->isEmpty()) {		
			$GLOBALS['search_ttl'] += $blog_entries->nbRow();
			return $GLOBALS['search_ttl'];			
		}		
	}
}

?>