<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


class blogPublicBlocks
{
	function calendar()
	{
		if (pt_mod_blog) {
			if ($GLOBALS['pt_current_module'] == 'blog')
			{
				global $year,$month,$day,$cat_id,$lang;
				
				startBloc(__('bloc_blog_calendar'), 'blog_calendar');
				echo $GLOBALS['blog']->xCalendar($year,$month,$day,$cat_id,$lang,
				'<div class="cal"><table summary="calendrier">%s</table></div>');
				endBloc();
			}
		}
	}
	
	function selection()
	{
		if (pt_mod_blog) {
			if ($GLOBALS['pt_current_module'] == 'blog')
			{
				global $blog;
				
				$rs = $blog->getLastNews(NULL,'','post_dt DESC',true);
				
				if (!$rs->isEmpty())
				{
					startBloc(__('bloc_blog_selection'), 'blog_selection');
					$res = '';
					while (!$rs->EOF())
					{
						$res .= sprintf('<li><a href="%2$s">%1$s</a></li>',$rs->f('post_titre'),$rs->getPermURL());
						$rs->moveNext();
					}
					printf('<ul>%s</ul>',$res);
					endBloc();
				}
			}
		}
	}
	
	function categories()
	{
		if (pt_mod_blog) {
			if ($GLOBALS['pt_current_module'] == 'blog')
			{
				global $rs_cat, $cat_id, $lang, $blog;
				
				$comp_url = '';
				
				if ($lang)
					$comp_url = $lang.'/';
				
				if (!$rs_cat->isEmpty())
				{
					startBloc(__('bloc_blog_categories'), 'blog_categories');
					$res = '';
					
					while (!$rs_cat->EOF())
					{
						if ($rs_cat->f('nb_post') > 0)
						{
							$id = $rs_cat->f('cat_libelle_url');
							$libelle = $rs_cat->f('cat_libelle');
							
							$lien = '<a href="'.
							sprintf($blog->front_url['cat'],$comp_url.$id).
							'">'.$libelle.'</a>';
							
							if ($cat_id == $id)
								$lien = '<strong>'.$lien.'</strong>';
							
							$res .= sprintf('<li>%s</li>',$lien);
						}
						$rs_cat->moveNext();
					}
					$rs_cat->moveStart();
					
					printf('<ul>%s</ul>',$res);
					endBloc();
				}
			}
		}
	}

	function archives()
	{
		if (pt_mod_blog) {
			if ($GLOBALS['pt_current_module'] == 'blog')
			{
				global $arry_months, $month, $year, $cat_id, $lang, $blog;
				
				$comp_url = '';
				
				if ($lang)
					$comp_url .= $lang.'/';
				
				if ($cat_id)
					$comp_url .= $cat_id.'/';
				
				$res = '';
				
				foreach($arry_months as $ts => $d)
				{
					$titre = dt::str('%B %Y',$ts);
					
					$url = sprintf($blog->front_url['archive'],$comp_url.date('Y',$ts),date('m',$ts));
					$lien = '<a href="'.$url.'">%s</a>';
					
					$liClass = '';
					
					if ($year == date('Y',$ts) && $month == date('m',$ts))
						$lien = '<strong>'.$lien.'</strong>';
					
					$res .= sprintf('<li>%s</li>',sprintf($lien,$titre));
				}
				
				if (count($arry_months) > 0)
				{
					startBloc(__('bloc_blog_archives'), 'blog_archives');
					printf('<ul>%s</ul>',$res);
					endBloc();
				}
			}
		}
	}
}

?>