<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

if (!defined('PUNTAL')) exit;

$do = !empty($_REQUEST['do']) ? $_REQUEST['do'] : null;

# Ajout d'une catgorie
if ($do == 'add_cat' && !empty($_POST['cat_name']) && $puntal->checkToken())
{
	if ($blog->addCat($_POST['cat_name']) !== false)
	{
		header('Location: module.php?id=blog&action=4&added=1');
		exit;
	}
}

# Supprimer catgories
if (!empty($_POST['removeaction']) && !empty($_POST['remove']) && is_array($_POST['remove']) && $puntal->checkToken())
{
	foreach ($_POST['remove'] as $v)
		$blog->delCat($v);
	
	if (!$puntal->err->hasError())
	{
		header('Location: module.php?id=blog&action=4&deleted=1');
		exit;
	}
}

# Ordonner les catgories
$order = array();
if (empty($_POST['categories_order']) && !empty($_POST['order']))
{
	$order = $_POST['order'];
	asort($order);
	$order = array_keys($order);
}
elseif (!empty($_POST['categories_order']))
	$order = explode(',',$_POST['categories_order']);

if (!empty($_POST['saveorder']) && !empty($order) && $puntal->checkToken())
{
	if ($blog->ordCats($order))
	{
		header('Location: module.php?id=blog&action=4&ordered=1');
		exit;
	}
}

# Reord
if (!empty($_GET['reord']))
{
	if ($blog->reordCats(false,true) !== false)
	{
		header('Location: module.php?id=blog&action=4');
		exit;
	}
}

# Messages de confirmation
if (!empty($_GET['edited']))
	$common_message = __('Category edited');

if (!empty($_GET['added']))
	$common_message = __('Category added');

if (!empty($_GET['deleted']))
	$common_message = __('Categories deleted');

if (!empty($_GET['ordered']))
	$common_message =__('Categories ordered');

# Liste des catgories
$rsCat = $blog->getCat('','cat_ord');

# Set token
$puntal->setToken();

/* Affichage
-------------------------------------------------------- */
if (!$rsCat->isEmpty())
{
	$head = 
	adminPage::jsToolMan().
	'<script type="text/javascript">'."\n".
	"//<![CDATA[\n".
	adminPage::jsVar('puntal.msg.confirm_delete_categories',
		__('Are you sure you want to remove the selected categories?')).
	"//]]>\n".
	"</script>"."\n".
	'<script type="text/javascript" src="index.php?pf=blog/js/cats.js"></script>';
}
else
	$head = '';

adminPage::open(__('Manage categories').' - '.__('Blog'),$head);

?>
<h2 class="first"><img src="index.php?pf=blog/img/ico_entries_cats.png" alt="" class="icon" /> <?php echo __('Manage categories') ?></h2>

<h3><img src="style/img/ico_cat_new.png" alt="" class="icon" /> <?php echo __('New category') ?></h3>

<form action="module.php" method="post">
	<p class="field"><label for="cat_name"><?php echo __('Category title') ?></label>
	<?php echo form::field('cat_name', 40, 255) ?>
	
	<?php echo 
	form::hidden(array('id'),'blog')."\n".
	form::hidden(array('action'),4)."\n".
	form::hidden(array('do'),'add_cat')."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Add') ?>" /></p>
</form>

<h3><img src="style/img/ico_cats_list.png" alt="" class="icon" /> <?php echo __('Categories list') ?></h3>

<?php
if ($rsCat->isEmpty()) :
	echo '<p>'.__('No category').'</p>';
else : ?>

<form action="module.php" method="post" id="form-categories">
	<table class="dragable">
	<thead>
		<tr>
			<th colspan="3" class="left"><?php echo __('Category title') ?></th>
			<th class="nowrap"><?php echo __('Number of entries') ?></th>
		</tr>
	</thead>
	<tbody id="categories-list">
	
<?php
$position = 1;
while($rsCat->fetch())
{
	$cat_id = $rsCat->f('cat_id');
	$cat_libelle = $rsCat->f('cat_libelle');
	$cat_nb_post = (integer) $rsCat->f('nb_post');
	
	$deletable = false;
	
	if ($cat_nb_post > 0)
	{
		$nb_post = '<a href="index.php?cat_id='.$cat_id.'">'.
		(($cat_nb_post>1) ? sprintf(__('%d entries'),$cat_nb_post) : sprintf(__('%d entry'),$cat_nb_post)).
		'</a>';
	}
	else {
		$deletable = true;
		$nb_post = __('No entry');
	}
		
	echo
	"\t\t".'<tr class="line" id="c_'.$cat_id.'">'."\n".
	"\t\t\t".'<td class="handle">'.form::field(array('order['.$cat_id.']'), 2, 5, $position++).'</td>'."\n".
	"\t\t\t".'<td>'.form::checkbox(array('remove[]'), $cat_id, 0, 'checkbox', !$deletable).'</td>'."\n".
	"\t\t\t".'<td class="maximal"><a href="module.php?id=blog&amp;action=3&amp;cid='.$cat_id.'">'.html::escapeHTML($cat_libelle).'</a></td>'."\n".
	"\t\t\t".'<td class="nowrap">'.$nb_post.'</td>'."\n\n".
	"\t\t".'</tr>'."\n\n";
}
?>
	</tbody>
	</table>
	
	<div class="two-cols">
		<p class="col">
		<?php echo 
		form::hidden(array('id'),'blog')."\n".
		form::hidden(array('action'),4)."\n".
		form::hidden(array('ptkn'),$puntal->getToken()); ?>
		<input type="hidden" id="categories_order" name="categories_order" value="" />
		<input class="submit" type="submit" name="saveorder" value="<?php echo __('Save order') ?>" />
		</p>
		
		<p class="col right">
		<input class="submit" type="submit" name="removeaction" value="<?php echo __('Delete selected categories') ?>" />
		</p>
	</div>
</form>
	
<?php endif;

adminPage::close() ?>