<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/*
	Original file by Olivier Meunier and contributors from 
	DotClear project. http://www.dotclear.net/
*/

if (!defined('PUNTAL')) exit;

$err 			= '';
$is_editable 	= false;
$comment_id 	= '';
$comment_dt 	= '';
$comment_auteur = '';
$comment_email 	= '';
$comment_site 	= '';
$comment_content = '';
$comment_pub 	= '';
$comment_ip 	= '';
$post_titre		= '';
$post_id 		= '';
$user_id 		= '';

if (!empty($_REQUEST['comment_id']))
{
	require_once PT_INC_PATH."libs/punbb_parser.php";	
	$hide_smilies = 1;
	if (pt_blog_use_smilies) $hide_smilies = 0;
	
	
	$comment = $blog->getComment($_REQUEST['comment_id']);
	
	if ($comment->isEmpty())
		$common_error = __('No comment yet.');
	else
	{
		$comment_id 		= $comment->f('comment_id');
		$comment_ldate 		= dt::str(pt_date_format.' '.pt_time_format,$comment->getTS());
		$comment_auteur 	= $comment->f('comment_auteur');
		$comment_email 		= $comment->f('comment_email');
		$comment_site 		= $comment->f('comment_site');
		$comment_content 	= parse_message($comment->f('comment_content'),$hide_smilies);
		$comment_pub 		= (integer) $comment->f('comment_pub');
		$comment_ip			= $comment->f('comment_ip');
		$post_titre			= $comment->f('post_titre');
		$post_id 			= $comment->f('post_id');
		
		if ($comment->f('user_id') == $puntal->user['id'] || $puntal->user['is_admod'])
			$is_editable = true;
	}
}

# On arrte tout si le commentaire est pas ditable
if (!$is_editable)
	$common_error = __('You are not allowed to edit a comment');

# Modification du commentaire
if (!empty($_POST['update']) && $is_editable)
{
	require_once PT_INC_PATH."libs/punbb_parser.php";
	$comment_auteur 	= $_POST['c_auteur'];
	$comment_email 		= $_POST['c_email'];
	$comment_site 		= preg_replace('|^http://|','',$_POST['c_site']);
	$comment_content 	= $puntal->linebreaks($_POST['c_content']);
	$comment_content 	= preparse_bbcode($comment_content);
	$comment_pub 		= $_POST['c_pub'];
	
	if ($blog->updComment($comment_id,$comment_auteur,$comment_email,
	$comment_site,$comment_content,$comment_pub) !== false)
	{
		header('Location: module.php?id=blog&action=2&post_id='.$post_id.'#c'.$comment_id);
		exit;
	}
}

# Suppression du commentaire
if (!empty($_POST['delete']) && $is_editable)
{
	if ($blog->delComment($comment_id) !== false)
	{
		header('module.php?id=blog&action=2&post_id='.$post_id.'#comments');
		exit;
	}
}


adminPage::open(__('Comment').' - '.__('Blog'));

if ($is_editable)
{
?>

<h2 class="first"><?php echo __('Edit a comment'); ?></h2>

<p><strong><?php echo __('Entry'); ?> :</strong>
<a href="module.php?id=blog&amp;action=2&amp;post_id=<?php echo $post_id; ?>"><?php echo $post_titre; ?></a></p>

<form action="module.php" method="post">

	<div class="two-cols">
		<p class="field col"><label for="c_auteur"><?php echo __('Name'); ?></label>
		<?php echo form::field('c_auteur',30,255,html::escapeHTML($comment_auteur)); ?></p>
		
		<p class="field col"><label for="c_email"><?php echo __('Email'); ?></label>
		<?php echo form::field('c_email',30,255,html::escapeHTML($comment_email)); ?></p>
		<div class="clearer"></div>
	</div>
	
	<div class="two-cols">
		<p class="field col"><label for="c_site"><?php echo __('Site'); ?></label>
		<?php echo form::field('c_site',30,255,'http://'.html::escapeHTML($comment_site)); ?></p>
		
		<p class="field col"><label for="c_pub"><?php echo __('Status'); ?></label>
		<?php echo form::combo('c_pub',array(__('Online')=>'1',__('Offline')=>'0'),$comment_pub); ?>
		<div class="clearer"></div>
	</div>
	
	<div class="two-cols">
		<p class="field col"><span class="fakelabel">@IP&nbsp;:</span>
		<span><?php echo $comment_ip; ?></span></p>
		
		<p class="field col"><span class="fakelabel"><?php echo __('Date'); ?></span>
		<span><?php echo $comment_ldate; ?></span></p>
		<div class="clearer"></div>
	</div>
	
	<p class="field"><label for="c_content"><?php echo __('Comment'); ?></label>
	<?php echo form::textArea('c_content',55,10,html::escapeHTML($comment_content)); ?>	
	</p>
	<?php 
	require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
	$ptb = new puntoolbarSmilies($puntal);
	echo $ptb->generatePtb('c_content',false);
	?>	
	<p>
	<?php echo 
	form::hidden('id','blog')."\n".
	form::hidden('action',7)."\n".
	form::hidden('comment_id',$comment_id)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()) ?>
	<input type="submit" class="submit" name="update" value="<?php echo __('Save'); ?>" />
	<input type="submit" class="submit" name="delete" value="<?php echo __('Delete'); ?>"
	onclick="return window.confirm('<?php echo __('Are you sure you want to delete this comment?'); ?>')" /></p>

</form>

<p><strong><?php echo __('Notice'); ?></strong>&nbsp;: 
<?php echo __('This comment has to be in BBCode format'); ?></p>

<?php } ?>

<?php adminPage::close(); ?>