<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$p_nb_post_per_page = pt_mod_blog_nb_post_per_page;
$p_allow_comments 	= pt_mod_blog_allow_comments;
$p_allow_trackbacks = pt_mod_blog_allow_trackbacks;
$p_comments_pub 	= pt_mod_blog_comments_pub;
$p_comments_ttl 	= pt_mod_blog_comments_ttl;
$p_short_feeds 		= pt_mod_blog_short_feeds;
$p_blog_use_smilies = pt_blog_use_smilies;
 
# Formulaire envoy
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	$p_nb_post_per_page = trim($_POST['p_nb_post_per_page']);
	$p_allow_comments 	= trim($_POST['p_allow_comments']);
	$p_allow_trackbacks = trim($_POST['p_allow_trackbacks']);
	$p_comments_pub 	= trim($_POST['p_comments_pub']);
	$p_comments_ttl 	= trim($_POST['p_comments_ttl']);
	$p_short_feeds 		= trim($_POST['p_short_feeds']);
	$p_blog_use_smilies = trim($_POST['p_blog_use_smilies']);		
	
	# Mise  jour de la configuration
	$pt_settings->setNamespace('mod_blog');    
	
	$res = true;
	$res &= $pt_settings->put('pt_mod_blog_nb_post_per_page', (integer) $p_nb_post_per_page);
	$res &= $pt_settings->put('pt_mod_blog_allow_comments'	, (boolean) $p_allow_comments);
	$res &= $pt_settings->put('pt_mod_blog_allow_trackbacks', (boolean) $p_allow_trackbacks);
	$res &= $pt_settings->put('pt_mod_blog_comments_pub'	, (boolean) $p_comments_pub);
	$res &= $pt_settings->put('pt_mod_blog_comments_ttl'	, (integer) $p_comments_ttl);
	$res &= $pt_settings->put('pt_mod_blog_short_feeds'		, (integer) $p_short_feeds);
	$res &= $pt_settings->put('pt_blog_use_smilies'			, (integer) $p_blog_use_smilies);

	$pt_settings->setNamespace('');
	
	if ($res)
	{
		logIt('Blog module : edit config', 1);
		header('Location: module.php?id=blog&action=5&updated=1');
		exit;
	}
}

# Message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# Set token
$puntal->setToken();

# Affichage
adminPage::open(__('Configuration').' - '.__('Blog'));
?>

<h2 class="first"><img src="index.php?pf=blog/img/ico_blog_config.png" alt="" class="icon" /> <?php echo __('Blog configuration') ?></h2>
<form method="post" action="module.php">	

	<p class="field"><label for="p_nb_post_per_page"><?php echo __('Number of entries per page') ?></label>
	<?php echo form::field('p_nb_post_per_page',3,'',$p_nb_post_per_page) ?></p>
			
	<p><span class="fakelabel"><?php echo __('Allow comments') ?></span>
	<label><?php echo form::radio(array('p_allow_comments'), 1, $p_allow_comments, 'radio').__('Yes') ?></label>
	<label><?php echo form::radio(array('p_allow_comments'), 0, !$p_allow_comments, 'radio').__('No') ?></label>
	</p>
			
	<p><span class="fakelabel"><?php echo __('Allow trackbacks') ?></span>
	<label><?php echo form::radio(array('p_allow_trackbacks'), 1, $p_allow_trackbacks, 'radio').__('Yes') ?></label>
	<label><?php echo form::radio(array('p_allow_trackbacks'), 0, !$p_allow_trackbacks, 'radio').__('No') ?></label>
	</p>
			
	<p><span class="fakelabel"><?php echo __('Publish comments immediately') ?></span>
	<label><?php echo form::radio(array('p_comments_pub'), 1, $p_comments_pub, 'radio').__('Yes') ?></label>
	<label><?php echo form::radio(array('p_comments_pub'), 0, !$p_comments_pub, 'radio').__('No') ?></label>
	</p>
		
	<p class="field"><label for="p_comments_ttl"><?php echo __('Time to live of comments and trackbacks') ?></label>
	<?php echo form::field('p_comments_ttl',3,'',$p_comments_ttl) ?></p>
			
	<p><span class="fakelabel"><?php echo __('Short RSS and Atom feeds') ?></span>
	<label><?php echo form::radio(array('p_short_feeds'), 1, $p_short_feeds, 'radio').__('Yes') ?></label>
	<label><?php echo form::radio(array('p_short_feeds'), 0, !$p_short_feeds, 'radio').__('No') ?></label>
	</p>
	
	<p><span class="fakelabel"><?php echo __('Allow smilies') ?></span>
	<label><?php echo form::radio(array('p_blog_use_smilies'), 1, $p_blog_use_smilies, 'radio').__('Yes') ?></label>
	<label><?php echo form::radio(array('p_blog_use_smilies'), 0, !$p_blog_use_smilies, 'radio').__('No') ?></label>
	</p>
			
	<p><?php echo 
	form::hidden(array('form_sent'),'1')."\n".
	form::hidden(array('id'),'blog')."\n".
	form::hidden(array('action'),5)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
</form>
<?php adminPage::close() ?>