<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/*
	Original file by Olivier Meunier and contributors from 
	DotClear project. http://www.dotclear.net/
*/

# Valeurs par dfaut
$post_id = '';
$titre = '';
$titre_url = '';
$cat_id = '';
$p_date = '';
$chapo = '';
$content = '';
$notes = '';
$is_editable = true;
$etat = 0;
$open_comment = 1;
$open_tb = 1;
$lang = '';
$selected = 0;
$return_link = 'module.php?id=blog&action=1';
$do_trackbacks = false;

# Billet existant
if (!empty($_REQUEST['post_id']))
{
	$post = $blog->getPostById($_REQUEST['post_id']);
	if (!$post->isEmpty())
	{
		$post_id 		= $post->f('post_id');
		$titre 			= $post->f('post_titre');
		$titre_url 		= $post->f('post_titre_url');
		$cat_id 		= $post->f('cat_id');
		$etat 			= (integer) $post->f('post_pub');
		$open_comment 	= (integer) $post->f('post_open_comment');
		$open_tb 		= (integer) $post->f('post_open_tb');
		$lang 			= $post->f('post_lang');
		$selected 		= $post->f('post_selected');
		$chapo 			= $post->f('post_chapo');
		$content 		= $post->f('post_content');
		$notes 			= $post->f('post_notes');
		$return_link 	= 'module.php?id=blog&action=1&m='.$post->f('postyear').$post->f('postmonth').'#p'.$post_id;
		$post_perm_url	=  $post->getPermURL();
		$p_date 		= date('Y-m-d H:i', $post->getTS());
		
		$comments = $blog->getComments($post_id);
		
		# Le post n'est ditable que par un admin, un modrateur ou son rdacteur
		if ($post->f('user_id') != $puntal->user['id'] && !$puntal->user['is_admod'])
			$is_editable = false;
		
		# Changement du status ou suppression d'un commentaire
		if (!empty($_GET['comment_id']))
		{
			if ($is_editable)
			{
				if (!empty($_GET['comment_del']))
				{
					if ($blog->delComment($_GET['comment_id']) !== false)
					{
						header('Location: module.php?id=blog&action=2&post_id='.$post_id.'#comments');
						exit;
					}
				}
				else {				
					if ($blog->statusComment($_GET['comment_id']) !== false)
					{
						header('Location: module.php?id=blog&action=2&post_id='.$post_id.'#c'.$_GET['comment_id']);
						exit;
					}
				}
			}
			else
				$err = '<ul><li>'.__('You are not allowed to edit a comment').'</li></ul>';
		}
		
		# Ajout d'un commentaire
		if (!empty($_POST['add_comment']) && $puntal->checkToken())
		{
			require_once PT_INC_PATH.'libs/punbb_parser.php';
			$comment = $puntal->linebreaks($_POST['com_content']);
			$comment = preparse_bbcode($comment);
			
			if ($blog->addComment($post_id,$_POST['com_nom'],$_POST['com_email'],
				$_POST['com_web'],$comment) !== false)
			{
				header('Location: module.php?id=blog&action=2&post_id='.$post_id.'#comments');
				exit;
			}
		}
		
		# Changement du status d'un billet
		if (!empty($_GET['cancel']) && $is_editable)
		{
			if ($blog->statusPost($post_id) !== false)
			{
				header('Location: '.$return_link);
				exit;
			}
		}
		
		# Suppression d'un billet
		if (!empty($_POST['delete']) && $is_editable)
		{
			if ($blog->delPost($post_id) !== false)
			{
				header('Location: module.php?id=blog&action=1&deleted=1');
				exit;
			}
		}
	}
}

# Valeurs pour la prvisualisation, la cration ou la modification d'un billet
if (!empty($_POST['preview']) || !empty($_POST['publish']))
{
	$titre 			= $_POST['p_titre'];
	$titre_url 		= !empty($_POST['p_titre_url']) ? $_POST['p_titre_url'] : '';
	$cat_id 		= $_POST['p_cat'];
	$etat 			= $_POST['p_etat'];
	$open_comment 	= $_POST['p_open_comment'];
	$open_tb 		= $_POST['p_open_tb'];
	$lang 			= $_POST['p_lang'];
	$selected 		= $_POST['p_selected'];
	$content 		= $_POST['p_content'];	
	$notes 			= $_POST['p_notes'];
	$chapo 			= $_POST['p_chapo'];
	$do_trackbacks 	= !empty($_POST['p_do_trackbacks']) ? true : false;
	$p_date 		= !empty($_POST['p_date']) ? $_POST['p_date'] : '';
	if (empty($p_date))
		$p_date = date('Y-m-d H:i:s');
}

# Insertion ou modification d'un billet
if (!empty($_POST['publish']) && $puntal->checkToken())
{
	# Insertion
	if (empty($post_id))
	{
		require_once PT_INC_PATH.'libs/punbb_parser.php';
		$content = $puntal->linebreaks($content);
		$content = preparse_bbcode($content);
		if (($post_id = $blog->addPost($puntal->user['id'],$titre,$titre_url,$chapo,$content,$notes,
		$cat_id,$etat,$open_comment,$open_tb,$lang,$selected,$puntal->user['timezone'])) !== false)
		{
			if ($do_trackbacks)
				$return_link = 'trackback.php?post_id='.$post_id.'&auto=1';
			else
				$return_link = 'module.php?id=blog&action=2&post_id='.$post_id;
			
			header('Location: '.$return_link);
			exit;
		}
	}
	# Edition
	else {
		if ($is_editable)
		{
			require_once PT_INC_PATH.'libs/punbb_parser.php';
			$content = $puntal->linebreaks($content);
			$content = preparse_bbcode($content);
			if ($blog->updPost($post_id,$titre,$titre_url,$chapo,$content,$notes,$cat_id,$etat,
			$open_comment,$open_tb,$p_date,$lang,$selected,$puntal->user['timezone']) !== false)
			{
				if ($do_trackbacks)
					$return_link = 'trackback.php?post_id='.$post_id.'&auto=1';
				else
					$return_link = 'module.php?id=blog&action=2&post_id='.$post_id;
				
				header('Location: '.$return_link);
				exit;
			}
		}
	}
}


# Set token
$puntal->setToken();

# Les catgories du blog
$rsCat = $blog->getCat();

if ($is_editable && !$rsCat->isEmpty())
{
	$cats_array = array();
	while ($rsCat->fetch())
		$arry_cat[$rsCat->f('cat_libelle')] = $rsCat->f('cat_id');

	$head =	adminPage::jsDatePicker();
	
	if (!empty($post_id)) {
		$head .= 
		'<script type="text/javascript">'."\n".
		"//<![CDATA[\n".
		"chainHandler(window,'onload',function() {".
		"		var post_dtPick = new datePicker(document.getElementById('p_date'));".
		"		post_dtPick.img_top = '1.8em';".
		"		post_dtPick.draw();".
		"});
		//]]>
		</script>";
	}
}
else
	$head = '';

adminPage::open(__('Entry').' - '.__('Blog'),$head); ?>

<h2 class="first"><img src="index.php?pf=blog/img/ico_entry.png" alt="" class="icon" /> <?php echo __('Entry') ?></h2>

<?php # Nous voulons au moins une catgorie
if ($rsCat->isEmpty()) :
	echo '<p><a href="module.php?id=blog&amp;action=4">'.__('No category').'</a></p>';
else : ?>


<?php # Prvisualisation
if (!empty($titre) && !empty($content))
{
	require_once PT_INC_PATH .'libs/punbb_parser.php';
	$hide_smilies = 1;
	if (pt_blog_use_smilies) $hide_smilies = 0;	
	echo 
	'<div id="previewbox">'.
	'<h3>'.html::escapeHTML($titre).'</h3>'.
	((trim($chapo) != '') ? parse_message($chapo,false).'<hr class="thin" />' : '').
	parse_message($content,$hide_smilies).'</div>';
	
	if (!empty($post_perm_url))
	{
		echo '<p class="clear"><strong>'.
		__('Permanent link').'</strong>&nbsp;: '.
		puntal::getPageURL($post_perm_url).'</p>';
	}
}

?>

<?php
require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
$ptb = new puntoolbarSmilies($puntal);

/* Entry form
-------------------------------------------------------- */
if ($is_editable) : ?>
	
<form action="module.php" method="post" id="formPost">
	<div class="lockable">
		<p class="field"><label for="p_titre"><strong><?php echo __('Title') ?></strong></label>
		<?php echo form::field('p_titre',50,255,html::escapeHTML($titre),'lockable-from') ?></p>
		
		<p class="field"><label for="p_titre_url"><?php echo __('URLed title') ?></label>
		<?php echo form::field('p_titre_url',50,255,html::escapeHTML($titre_url),'lockable-in') ?></p>
	</div>
	
	<div class="two-cols">
		<p class="field col"><label for="p_cat"><?php echo __('Category') ?></label>
		<?php echo form::combo('p_cat',$arry_cat,$cat_id) ?></p>
		
		<p class="field col"><label for="p_etat"><?php echo __('Status') ?></label>
		<?php echo form::combo('p_etat',array(__('Online')=>'1',__('Offline')=>'0'),$etat) ?></p>
	</div>
	
	<p class="field clearb"><label for="p_chapo"><?php echo __('Abstract').' ('.__('optional').')' ?></label></p>
	<p class="area"><?php echo form::textarea('p_chapo', 55, 5, html::escapeHTML($chapo)) ?></p>
	<?php // Generate the PunToolBar
	echo $ptb->generatePtb('p_chapo',false);
	?>	
	<p class="field"><label for="p_content"><?php echo __('Entry') ?></label></p>
	<p class="area"><?php echo form::textarea('p_content', 55, 15, html::escapeHTML($content)) ?></p>	 
	<?php // Generate the PunToolBar
	echo $ptb->generatePtb('p_content',false);
	?>	
	<h3 class="moreOptions"><?php echo __('More options') ?></h3>
	<div id="moreOptions" class="moreOptions">
		<p class="field"><label for="p_notes"><?php echo __('Notepad') ?></label></p>
		<p><?php echo form::textArea('p_notes',55,5,html::escapeHTML($notes)) ?></p>
		<?php // Generate the PunToolBar
		echo $ptb->generatePtb('p_notes',false);
		?>
		<?php if (!empty($post_id)) : ?>
		<p class="field"><label for="p_date"><?php echo __('Date') ?></label>
		<?php echo form::field('p_date', 18, 18, html::escapeHTML($p_date)) ?></p>
		<?php endif; ?>
			
		<div class="two-cols">
			<p class="field col"><label for="p_lang"><?php echo __('Language') ?></label>
			<?php echo form::field('p_lang',5,5) ?></p>
			
			<p class="field col"><label for="p_selected"><?php echo __('Selection') ?></label>
			<?php echo form::combo('p_selected',array(__('Yes')=>1,__('No')=>0),$selected) ?></p>
			<div class="clearer"></div>
		</div>
		
		<div class="two-cols">
			<p class="field col"><label for="p_open_comment"><?php echo __('Comments') ?></label>
			<?php echo form::combo('p_open_comment',array(__('Open')=>'1',__('Closed')=>'0'),$open_comment) ?></p>
			
			<p class="field col"><label for="p_open_tb"><?php echo __('Trackbacks') ?></label>
			<?php echo form::combo('p_open_tb',array(__('Open')=>'1',__('Closed')=>'0'),$open_tb) ?></p>
			<div class="clearer"></div>
		</div>
	</div>
		
	<p class="clearb"><label><input type="checkbox" name="p_do_trackbacks" id="p_do_trackbacks"<?php echo ($do_trackbacks ? ' checked="checked"' : ''); ?> /> <?php echo __('Ping URLs') ?></label></p>
	
	<p><?php echo
	form::hidden('id','blog')."\n". 
	form::hidden('action',2)."\n".
	form::hidden('post_id',$post_id)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()) ?>
	<input name="publish" type="submit" class="submit" value="<?php echo __('Save') ?>" /> 
	<input name="preview" type="submit" class="submit" value="<?php echo __('Preview') ?>" /></p>
	
</form>

<?php endif;

/* Comments
-------------------------------------------------------- */
if (!empty($post_id)) :

	echo '<h2><img src="style/img/ico_comments.png" alt="" class="icon" /> '.__('Comments').'</h2>';
	
	if (isset($comments))
		$trackbacks = $comments->extractTrackbacks();
	
	if (isset($trackbacks))
	{
		echo '<h3 id="trackbacks">'.__('Trackbacks list').'</h3>';
		if (!$trackbacks->isEmpty())
			showComments($trackbacks);
		else
			echo __('No trackback');
	}
	
	if (isset($comments))
	{
		echo '<h3 id="comments">'.__('Comments').'</h3>';
		if (!$comments->isEmpty())
			showComments($comments);
		else
			echo __('No comment');
	}
	
?>
	<h3><?php echo __('Write a comment') ?></h3>
	<form action="module.php" method="post">
	
	<p class="field"><label for="com_nom"><?php echo __('Name') ?></label>
	<?php echo form::field('com_nom',30,255,html::escapeHTML($puntal->user['username'])) ?></p>
	
	<div class="two-cols">
		<p class="field col"><label for="com_email"><?php echo __('Email').' ('.__('optional').')'; ?></label>
		<?php echo form::field('com_email',30,255,html::escapeHTML($puntal->user['email'])) ?></p>
			
		<p class="field col"><label for="com_web"><?php echo __('Site').' ('.__('optional').')'; ?></label>
		<?php echo form::field('com_web',30,255,html::escapeHTML($puntal->user['url'])) ?></p>
		<div class="clearer"></div>
	</div>

	<p class="field"><label for="com_content"><?php echo __('Comment') ?></label>
	<?php echo form::textArea('com_content',55,10,' ') ?></p>
	<?php 
	echo $ptb->generatePtb('com_content',false);
	?>	
	<p><?php echo 
	form::hidden('id','blog')."\n".
	form::hidden('action',2)."\n".
	form::hidden('post_id',$post_id)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()) ?>
	<input type="submit" class="submit" name="add_comment" value="<?php echo __('Save') ?>" /></p>
	
	</form>
	
	<p><strong><?php echo __('Notice') ?></strong> : <?php echo __('This comment has to be in BBCode format') ?></p>

<?php
endif;

endif;
adminPage::close();

# Affichage de commentaires ou trackbacks
function showComments(&$rs)
{
	global $is_editable, $post_id;
	require_once PT_INC_PATH."libs/punbb_parser.php";
	$hide_smilies = 1;
	if (pt_blog_use_smilies) $hide_smilies = 0;
	
	while(!$rs->EOF())
	{
		if ($rs->f('comment_pub'))
		{
			$com_style 	= '';
			$com_cancel = __('set offline');
		}
		else {
			$com_style 	= 'style="color:#999;"';
			$com_cancel = __('set online');
		}
		
		echo '<div class="comment" '.$com_style.' id="c'.$rs->f('comment_id').'">';
		
		echo
		'<p>'.(($rs->f('comment_trackback')==1) ? '<strong>'.__('Trackback').'</strong><br />' : '').
		__('By').'&nbsp;: '.$rs->f('comment_auteur').'<br />'.
		dt::str(pt_date_format.' '.pt_time_format,$rs->getTS()).'<br />'.
		__('Email').'&nbsp;: '.$rs->f('comment_email').'<br />'.
		__('Site').'&nbsp;: '.(($rs->f('comment_site')) ? 'http://'.$rs->f('comment_site') : '').'<br />'.
		'@IP : '.$rs->f('comment_ip').'</p>'.
		'<div>'.preparse_bbcode($rs->getContent(),$hide_smilies).'</div>';
		
		if ($is_editable)
		{
			echo
			'<p style="text-align:right">'.
			'<a href="module.php?id=blog&amp;action=2&amp;post_id='.$post_id.
			'&amp;comment_id='.$rs->f('comment_id').'">'.$com_cancel.'</a>'.
			' - <a href="module.php?id=blog&amp;action=7&amp;comment_id='.$rs->f('comment_id').'">'.__('Edit').'</a>'.
			' - <a href="module.php?id=blog&amp;action=2&amp;post_id='.$post_id.
			'&amp;comment_id='.$rs->f('comment_id').'&amp;comment_del=1" '.
			'onclick="return window.confirm(\''.__('Are you sure you want to delete this comment?').'\');">'.__('Delete').'</a></p>';
		}
		
		echo '</div>';
		
		$rs->moveNext();
	}
}

?>