<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
@function uninstall_blog

La fonction charge de la dsinstallation du module bugtracker.
*/
function uninstall_blog()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	# Supression de la table 'pt_blog_categorie'
	$db_scheme[] = array(
		'action' 	=> 'delete',
		'table' 	=> DB_PREFIX.'pt_blog_categorie',
		'query' 	=> 'DROP TABLE '.DB_PREFIX.'pt_blog_categorie'
	);
	
	# Supression de la table 'pt_blog_post'
	$db_scheme[] = array(
		'action' 	=> 'delete',
		'table' 	=> DB_PREFIX.'pt_blog_post',
		'query' 	=> 'DROP TABLE '.DB_PREFIX.'pt_blog_post'
	);
	
	# Supression de la table 'pt_blog_comment'
	$db_scheme[] = array(
		'action' 	=> 'delete',
		'table' 	=> DB_PREFIX.'pt_blog_comment',
		'query' 	=> 'DROP TABLE '.DB_PREFIX.'pt_blog_comment'
	);
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_blog_nb_post_per_page'
	);
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_blog_allow_comments',
	);	
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_blog_allow_trackbacks',
	);	
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_blog_comments_pub',
	);	
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_blog_comments_ttl',
	);	
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_blog_short_feeds',
	);	

	
	/* Dsinstallation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->uninstall($db_scheme,$params);
}


?>