<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$p_num_per_page = pt_mod_bugtracker_num_per_page;
$p_groups = unserialize(pt_mod_bugtracker_groups);
$p_forum = pt_mod_bugtracker_forum_id;
$p_versions = unserialize(pt_mod_bugtracker_versions);
$p_neo_version = '';

/* Config sent */
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	$p_num_per_page = intval(trim($_POST['p_num_per_page']));
	$p_groups = (!empty($_POST['p_groups']) ? array_map('intval',array_map('trim',$_POST['p_groups'])) : array());
	$p_forum = intval(trim($_POST['p_forum']));
	$p_versions = (!empty($_POST['p_versions']) ? array_map('trim',$_POST['p_versions']) : array());
	$p_neo_version = trim($_POST['p_neo_version']);

	$p_versions[] = $p_neo_version;
	foreach ($p_versions as $k=>$v)
		if (empty($v)) unset($p_versions[$k]);

	// Mise  jour de la configuration
	$pt_settings->setNamespace('mod_bugtracker');    
	
	$res = true;
	$res &= $pt_settings->put('pt_mod_bugtracker_num_per_page', $p_num_per_page);
	$res &= $pt_settings->put('pt_mod_bugtracker_groups', serialize($p_groups));
	$res &= $pt_settings->put('pt_mod_bugtracker_forum_id', $p_forum);
	$res &= $pt_settings->put('pt_mod_bugtracker_versions', serialize($p_versions));

	$pt_settings->setNamespace('');
	
	if ($res)
	{
		logIt('Bugtracker module : edit config', 1);
		header('Location: module.php?id=bugtracker&action=4&updated=1');
		exit;
	}
}

# Message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# Set token
$puntal->setToken();

# Liste des groupes
$groups = punbb::getGroups();

# Liste des forums
$forums_array = array();
$forums_array['&nbsp;'] = 0;

$forums = punbb::getForums();

while ($forums->fetch())
	$forums_array[html::escapeHTML($forums->f('cat_name'))][html::escapeHTML($forums->f('forum_name'))] = $forums->f('fid');

# Affichage
adminPage::open(__('Configuration').' - '.__('Bugtracker'),	
'<script type="text/javascript">'."\n".
"//<![CDATA[\n".
"$(function() {
	$('.checkboxes-helpers').each(function() {
		puntal.checkboxesHelpers(this);
	});
});".
"//]]>\n".
"</script>"."\n");
?>

<h2 class="first"><img src="index.php?pf=bugtracker/img/ico_bugtracker_config.png" alt="" class="icon" /> <?php echo __('Bugtracker configuration') ?></h2>

<form method="post" action="module.php" id="form-bugtracker-config">
	<fieldset>
	<legend><?php echo __('Bugtracker configuration'); ?></legend>
	
	<p class="field"><label for="p_num_per_page"><?php echo __('Number of bugs'); ?></label>
	<?php echo form::field('p_num_per_page', 2, 3, html::escapeHTML($p_num_per_page)) ?>
	<span class="desc"><?php echo __('The number of bugs to display on pages') ?></span></p>

	<p><span class="fakelabel"><?php echo __('Allowed groups') ?></span>
	<span class="desc"><?php echo __('The groups which can add bugs reports.') ?></span></p>
	<ul class="checklist">
<?php
while ($groups->fetch()) 
{
	if ($groups->f('g_id') != PUN_ADMIN)
		echo '<li><label>'.form::checkbox(array('p_groups[]'),$groups->f('g_id'),in_array($groups->f('g_id'),$p_groups),'checkbox').html::escapeHTML($groups->f('g_title')).'</label></li>';
}
?>
	</ul>
	<p><span class="desc checkboxes-helpers"></span></p>
	
	<p class="field"><label for="p_forum"><?php echo __('Forum') ?></label>
	<?php echo form::combo('p_forum', $forums_array, $p_forum) ?>
	<span class="desc"><?php echo __('The forum in which a new topic will be started for each new bug. Leave it blank to not start topic, the comments will then not be possible.') ?></span></p>
	
	<p><span class="fakelabel"><?php echo __('Manage versions'); ?></span></p>
	<?php foreach($p_versions as $v)
		echo '<p class="field">'.form::field(array('p_versions[]'), 50, 255, $v).'</p>';
	?>
	
	<p class="field"><label for="p_neo_version"><?php echo __('Add a version'); ?></label>
	<?php echo form::field('p_neo_version', 50, 255, html::escapeHTML($p_neo_version)) ?></p>

	</fieldset>
	
	<p><?php echo 
	form::hidden('form_sent','1')."\n".
	form::hidden('id','bugtracker')."\n".
	form::hidden('action',4)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Save'); ?>" /></p>

</form>

<?php adminPage::close() ?>