<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
@function install_bugtracker

La fonction charge de l'installation du module bugtracker.
*/
function install_bugtracker()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	# Structure de la table 'pt_bugs'
	$db_scheme[] = array(
		'action' 	=> 'add',
		'table' 	=> DB_PREFIX.'pt_bugs',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX.'pt_bugs (
		bug_id 			INT(10) 		NOT NULL auto_increment,
		bug_title 		VARCHAR(255) 	NOT NULL DEFAULT \'\',
		bug_desc 		TEXT,
		bug_severity 	INT(1) 			NOT NULL DEFAULT 0,
		bug_status 		INT(1) 			NOT NULL DEFAULT 0,
		bug_percent 	INT(2) 			NOT NULL DEFAULT 0,
		bug_reporter 	INT(10) 		NOT NULL DEFAULT 1,
		bug_version 	VARCHAR(255) 	NOT NULL DEFAULT \'\',
		bug_tid 		INT(10),
		bug_pid 		INT(10),
		bug_component 	VARCHAR( 80 ) NOT NULL,			
		UNIQUE KEY bug_id (bug_id)
		) TYPE=MyISAM;'
	);
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_bugtracker_num_per_page',
		'type' 		=> 'integer',
		'init'		=> 10
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name'	 	=> 'pt_mod_bugtracker_groups',
		'type' 		=> 'string',
		'init' 		=> 'a:2:{i:0;i:2;i:1;i:4;}'
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_bugtracker_forum_id',
		'type' 		=> 'integer',
		'init' 		=> 0
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_bugtracker_versions',
		'type' 		=> 'string',
		'init' 		=> 'a:0:{}'
	);
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->install($db_scheme,$params);
}


?>