<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/**
 * 
	@brief bugtracker template class
	
*/
class bugtracker
{
	/**
	url<br/>
	
	<strong>FR</strong> Affiche l'URL en fonction du param�tre pass�.<br/>
	<strong>EN</strong> Display the URL regarding the given parameter

	@param type <strong>string</strong>	url type to determine which url to display	
	*/	
	function url($type='')
	{
		switch ($type)
		{
			case 'add':
				echo $GLOBALS['puntal']->url('bugtracker_add');
				break;
			
			case 'forums' :
				echo pt_forum_url;
				break;
				
			case 'bugtracker':
			default :
				echo $GLOBALS['puntal']->url('bugtracker');
				break;
		}
	}
	
	/**
	homeLink<br/>
	
	<strong>FR</strong> Affiche le lien "Accueil".<br/>
	<strong>EN</strong> Display the link "Home"

	@param normal <strong>string</strong>	Formatting mask of the 'normal' link
	@param active <strong>string</strong>	Formatting mask of the 'active' link	
	*/
	function homeLink($normal=' - <a href="%s">%s</a>', $active=' - <a href="%s"><strong>%s</strong></a>')
	{
		printf((($GLOBALS['bt_mode'] == 'default') ? $active : $normal), $GLOBALS['puntal']->url('bugtracker'), __('Bugs list'));
	}
	
	/**
	addLink<br/>
	
	<strong>FR</strong> Affiche le lien "Ajouter un bug".<br/>
	<strong>EN</strong> Display the link "Add a bug"

	@param normal <strong>string</strong>	Formatting mask of the 'normal' link
	@param active <strong>string</strong>	Formatting mask of the 'active' link	
	*/	
	function addLink($normal=' - <a href="%s">%s</a>', $active=' - <a href="%s"><strong>%s</strong></a>')
	{
		global $puntal;
		
		if ($puntal->user['is_admin'] || in_array($puntal->user['g_id'], $GLOBALS['allowed_groups']))
			printf((($GLOBALS['bt_mode'] == 'ajouter') ? $active : $normal), $puntal->url('bugtracker_add'), __('New bug'));
	}
		
	/**
	filterBoxStatus<br/>
	
	<strong>FR</strong> Affiche une liste d'erreurs.<br/>
	<strong>EN</strong> Display a list of errors
	*/
	function filterBoxStatus()
	{
		echo $GLOBALS['filter_box'];
	}
	
	/**
	onPreview<br/>
	
	<strong>FR</strong> Indique si nous devons prvisualiser.<br/>
	<strong>EN</strong> Tell us if we have to preview
	*/
	function onPreview()
	{
		if (isset($_POST['preview']))
			return true;
		
		return false;
	}

	/**
	hasErrors<br/>
	
	<strong>FR</strong> Indique si il y a des erreurs.<br/>
	<strong>EN</strong> Tell us if we have errors
	*/
	function hasErrors()
	{
		if (!empty($GLOBALS['errors']))
			return true;
		
		return false;
	}
	
	/**
	errors<br/>
	
	<strong>FR</strong> Affiche la liste des erreurs.<br/>
	<strong>EN</strong> Display the list of errors
	
	@param block <strong>string</strong> list
	@param item <strong>string</strong> item 
	*/
	function errors($block='<ul>%s</ul>',$item='<li>%s</li>')
	{
		$items = '';
		foreach ($GLOBALS['errors'] as $err)
			$items .= sprintf($item,$err);
		
		printf($block, $items);
	}
	

	/**
	formValue<br/>
	
	<strong>FR</strong> Affiche un des champs du formulaire.<br/>
	<strong>EN</strong> Display one of the field of the form.

	@param	var <strong>string</strong> name of the var to be displayed
	*/	
	function formValue($var='')
	{
		if ($var == '')
			return;
		
		echo html::escapeHTML($GLOBALS[$var]);
	}
	
	/**
	previewValue<br/>
	
	
	<strong>FR</strong> Affiche les �l�ments de la pr�visualisation.<br/>
	<strong>EN</strong> Display the items of the preview
	
	@param	var <strong>string</strong> name of the var to be displayed
	*/
	function previewValue($var='')
	{
		switch ($var)
		{
			case 'severity':
				echo __('sev_'.$GLOBALS['neo_severity']);
				break;
			
			case 'title' :
				echo html::escapeHTML($GLOBALS['neo_bug']);
				break;
			
			case 'desc' :
				echo parse_message($GLOBALS['neo_desc'],0);
				break;
		}
	}

	/**
	severityOptions<br/>
	
	
	<strong>FR</strong> Affiche les lments  du menu droulant  "Svrit"<br/>
	<strong>EN</strong> Display the items of the dropdown menu "Severity"
	
	@param	s <strong>string</strong> formatting mask of the dropwon list
	@param	with_none <strong>boolean</strong> do we add an "empty" item to the dropdown ?
	*/	
	function severityOptions($s='<option value="%s"%s>%s</option>', $with_none=false)
	{
		$current = $GLOBALS['bt_mode'] == 'ajouter' ? $GLOBALS['neo_severity'] : $GLOBALS['severity'];
		
		if ($with_none)
			printf($s, '', ($current == '' ? ' selected="selected"' : ''), '&nbsp;');
		
		for ($i=1; $i<6; $i++)
			printf($s, $i, ($current == $i ? ' selected="selected"' : ''), __('sev_'.$i));
	}
	
	/**
	statusOptions<br/>
	
	
	<strong>FR</strong> Affiche les lments du menu droulant "Statut"<br/>
	<strong>EN</strong> Display the items of the dropdown menu "Status"
	
	@param	s <strong>string</strong> formatting mask of the dropwon list
	@param	with_none <strong>boolean</strong> do we add an "empty" item to the dropdown ?
	*/	
	function statusOptions($s='<option value="%s"%s>%s</option>', $with_none=true)
	{
		global $status;
				
		if ($with_none)
			printf($s, '', ($status == '' ? ' selected="selected"' : ''), '&nbsp;');
		
		for ($i=1; $i<9; $i++)
			printf($s, $i, ($status == $i ? ' selected="selected"' : ''), __('stat_'.$i));
	}
	
	/**
	versionsOptions<br/>
	
	
	<strong>FR</strong> Affiche les lments du menu droulant "Version"<br/>
	<strong>EN</strong> Display the items of the dropdown menu "Version"
	
	@param	s <strong>string</strong> formatting mask of the dropwon list
	@param	with_none <strong>boolean</strong> do we add an "empty" item to the dropdown ?
	*/
	function versionsOptions($s='<option value="%s"%s>%s</option>')
	{
		global $neo_version;
		
		printf($s, '', ($neo_version == '' ? ' selected="selected"' : ''), '&nbsp;');
		foreach (unserialize(pt_mod_bugtracker_versions) as $v)
			printf($s, $v, ($v == $neo_version ? ' selected="selected"' : ''), $v);
	}
	
	/**
	getPagesLinks<br/>
	
	<strong>FR</strong> Affiche les liens des pages sur la liste des bugs<br/>
	<strong>EN</strong> Display the items of the pages on the list of the bugs
	*/	
	function getPagesLinks()
	{
		echo $GLOBALS['lum']->getLinks();
	}
	
	/**
	getBugsTable<br/>
	
	<strong>FR</strong> Affiche le tableau de la liste des bugs<br/>
	<strong>EN</strong> Display the table of the list of the bugs
	*/	
	function getBugsTable()
	{
		echo $GLOBALS['lum']->getPage();
	}
	
	/**
	bugTitle<br/>
	
	<strong>FR</strong> Affiche le titre d'un bug sur la vue d'un bug<br/>
	<strong>EN</strong> Display the bug title on the page that displays the bug
	*/		
	function bugTitle()
	{
		echo html::escapeHTML($GLOBALS['bug']->f('bug_title'));
	}
	
	/**
	bugReporterId<br/>
	
	<strong>FR</strong> Affiche l'ID du rapporteur d'un bug sur la vue d'un bug<br/>
	<strong>EN</strong> Display the reporter ID of the bug on the page that displays the bug
	*/	
	function bugReporterId()
	{
		echo html::escapeHTML($GLOBALS['bug']->f('bug_reporter'));
	}
	
	/**
	bugReporter<br/>
	
	<strong>FR</strong> Affiche le nom de l'utilisateur ayant lev� le bug sur la vue d'un bug<br/>
	<strong>EN</strong> Display the reporter's username who raises the bug on the page that displays the bug
	*/
	function bugReporter()
	{
		echo html::escapeHTML($GLOBALS['bug']->f('bug_username'));
	}
	

	/**
	bugPerCent<br/>
	
	<strong>FR</strong> Affiche le pourcentage d'avancement d'un bug sur la vue d'un bug<br/>
	<strong>EN</strong> Display the purcent progress to the bug on the page that displays the bug
	*/	
	function bugPerCent()
	{
		echo $GLOBALS['bug']->f('bug_percent');
	}
	

	/**
	bugVersion<br/>
	
	<strong>FR</strong> Affiche la version d'un bug sur la vue d'un bug<br/>
	<strong>EN</strong> Display the version of the bug on the page that displays the bug
	*/		
	function bugVersion()
	{
		$version = $GLOBALS['bug']->f('bug_version');
		
		if (!empty($version))
			echo $version;
		else
			echo __('not specified');
	}
	
	
	/**
	bugSeverity<br/>
	
	<strong>FR</strong> Affiche la s�v�rit� d'un bug sur la vue d'un bug<br/>
	<strong>EN</strong> Display the severity of the bug on the page that displays the bug
	*/	
	function bugSeverity()
	{
		echo __('sev_'.$GLOBALS['bug']->f('bug_severity'));
	}
	
	/**
	bugStatus<br/>
	
	<strong>FR</strong> Affiche la statut d'un bug sur la vue d'un bug<br/>
	<strong>EN</strong> Display the status of the bug on the page that displays the bug
	*/	
	function bugStatus()
	{
		echo __('stat_'.$GLOBALS['bug']->f('bug_status'));
	}
	
	/**
	bugDesc<br/>
	
	<strong>FR</strong> Affiche la description d'un bug sur la vue d'un bug<br/>
	<strong>EN</strong> Display the description of the bug on the page that displays the bug
	*/		
	function bugDesc()
	{
		echo parse_message($GLOBALS['bug']->f('bug_desc'),false);
	}
	
	/**
	bugTid<br/>
	
	<strong>FR</strong> Affiche l'identifiant du topic du bug<br/>
	<strong>EN</strong> Display the Topic id of the bug
	*/	
	function bugTid()
	{
		echo $GLOBALS['bug']->f('bug_tid');
	}
	
	/**
	numComment<br/>
	
	<strong>FR</strong> Affiche le nombre de commentaires d'un bug sur la vue d'un bug<br/>
	<strong>EN</strong> Display the number of comments of the bug on the page that displays the bug
	*/		
	function numComment()
	{
		$numComment = $GLOBALS['bug']->f('num_replies');
		
		if ($numComment == 0)
			echo __('No comment');
		elseif ($numComment == 1)
			echo __('One comment');
		else
			printf(__('%s comments'), $numComment);
	}
	
	
	/**
	openComments<br/>
	
	<strong>FR</strong> Indique si il les commentaires pour un bug sont ouvert (i.e. si il y a un topic)<br/>
	<strong>EN</strong> Tell if the comments are available for a given bug
	*/	
	function openComments()
	{
		if ($GLOBALS['bug']->f('bug_tid') > 0)
			return true;
		
		return false;
	}
	

	/**
	hasComments<br/>
	
	<strong>FR</strong> Indique si il y a ou non des commentaires pour un bug<br/>
	<strong>EN</strong> Tell if there are comments for a given bug
	*/	
	function hasComments()
	{
		if ($GLOBALS['comments']->isEmpty())
			return false;
		
		return true;
	}
	

	/**
	commentMessage<br/>
	
	<strong>FR</strong> Message d'un commentaire dans la boucle de commentaires<br/>
	<strong>EN</strong> Message in the comments loop
	*/		
	function commentMessage()
	{
		echo parse_message($GLOBALS['comments']->f('message'), $GLOBALS['comments']->f('hide_smilies'));
	}
	

	/**
	uid<br/>
	
	<strong>FR</strong> Affiche l'identifiant de l'auteur du commentaire<br/>
	<strong>EN</strong> Display the author id of the comment
	*/		
	function commentUid()
	{
		echo $GLOBALS['comments']->f('poster_id');
	}
	

	/**
	commentDate<br/>
	
	<strong>FR</strong> Affiche la date du commentaire<br/>
	<strong>EN</strong> Display date of the comment
	*/	
	function commentDate()
	{
		echo $GLOBALS['puntal']->format_time($GLOBALS['comments']->f('posted'));
	}
	
	/**
	commentAuthor<br/>
	
	<strong>FR</strong> Affiche le nom de l'auteur du commentaire<br/>
	<strong>EN</strong> Display username of the author of the comment
	*/
	function commentAuthor()
	{
		echo html::escapeHTML($GLOBALS['comments']->f('username'));
	}
    
    
	/**
	listUrl<br/>
	
	<strong>FR</strong> Affiche l'URL du bug<br/>
	<strong>EN</strong> Display bug URL
	*/	
	function listUrl()
	{
		echo sprintf($GLOBALS['puntal']->url('bugtracker_bug'),$GLOBALS['bugtracker_list']->f('bug_id'));
	}	

	/**
	listTitle<br/>
	
	<strong>FR</strong> Affiche le titre du bug<br/>
	<strong>EN</strong> Display the title of the bug 
	*/		
	function listTitle()
	{
		echo html::escapeHTML($GLOBALS['bugtracker_list']->f('bug_title'));
	}
		    
	/**
	listContent<br/>
	
	<strong>FR</strong> Affiche la description du bug<br/>
	<strong>EN</strong> Display the description of the bug 
	*/	
	function listContent()
	{
		require_once PT_INC_PATH."libs/punbb_parser.php";
		echo parse_message($GLOBALS['bugtracker_list']->f('bug_desc'),false);
	}


	/**
	componentLabel<br/>
	
	<strong>FR</strong> Affiche le libell<br/>
	<strong>EN</strong> Display the label 
	*/    
    function componentLabel() {
    	echo __('Component');
	}   


	/**
	componentOptions<br/>
	
	<strong>FR</strong> Affiche la liste des composants  partir de la liste des modules installs dans puntal<br/>
	<strong>EN</strong> Display the component list from the installed modules in puntal 
	*/	 
    function componentOptions($s='<option value="%s"%s>%s</option>' ,$with_none=true)
 	{
 		global $puntal;
 		
 		$current = $GLOBALS['bt_mode'] == 'ajouter' ? $GLOBALS['neo_component'] : $GLOBALS['component'];

		if ($with_none)
			printf($s, '', ($current == '' ? ' selected="selected"' : ''), '&nbsp;');
			
 		if ($current == __('all'))
			printf($s,__('all'),' selected="selected"',__('all'));
		else
			printf($s,__('all'),'',__('all'));
			
		foreach ($puntal->modules->getInstalledModules() as $module) {
			$selected = '';
			if ($current == $module['name'] ) 
				$selected = ' selected="selected"';
			if (constant('pt_mod_'.$module['id']) && $module['page_module'])
			{				
			printf($s,$module['name'],$selected,$module['name']);
			}
		}
		
		if ($current == __('other'))
			printf($s,__('other'),' selected="selected"',__('other'));
		else 		
			printf($s,__('other'),'',__('other'));
 	}
    
} # end class


/**
bugsListBlock<br/>

<strong>FR</strong> Modle du bloc pour la liste de bugs <br/>- Important : N'est pas utilis directement dans les templates mais par la classe multipage<br/><br/>
<strong>EN</strong> Template of the bloc to display the list of bugs<br/>- Important : Is not used directly in the template but by the multipage class 
*/	
function bugsListBlock()
{
	return
	'<table class="bugs" cellpadding="0" cellspacing="0">
		<thead>
			<tr>
				<th class="tcl" scope="col">'.__('Bug').'</th>
				<th class="tc2" scope="col">'.__('Component').'</th>
				<th class="tc2" scope="col">'.__('Severity').'</th>
				<th class="tc3" scope="col">'.__('Status').'</th>
				<th class="tc3" scope="col">'.__('Version').'</th>
				<th class="tcr" scope="col">'.__('Progress').'</th>
			</tr>
		</thead>
		<tbody>%s</tbody>
	</table>';
}

/**
bugsListLine<br/>

<strong>FR</strong> Modle des lignes de bugs <br/>- Important : N'est pas utilis directement dans les templates mais par la classe multipage<br/><br/>
<strong>EN</strong> Template of the lines of the bugs<br/>- Important : Is not used directly in the template but by the multipage class 
*/	
function bugsListLine($data,$i)
{
	$class = 'sev_'.$data['bug_severity'];
	
	return
	'<td class="tcl '.$class.'"><h3 class="bugTitle"><a href="'.sprintf($GLOBALS['puntal']->url('bugtracker_bug'),$data['bug_id']).'">'.$data['bug_title'].'</a></h3></td>'.
	'<td class="tc2 '.$class.'">'.$data['bug_component'].'</td>'.
	'<td class="tc2 '.$class.'">'.__('sev_'.$data['bug_severity']).'</td>'.	
	'<td class="tc3 '.$class.'">'.__('stat_'.$data['bug_status']).'</td>'.
	'<td class="tc3 '.$class.'">'.$data['bug_version'].'</td>'.
	'<td class="tcr '.$class.'"><div class="av_bar_ext"><div class="av_bar_int" style="width:'.$data['bug_percent'].'px;"><!-- --></div></div> <p class="percent_txt">'.$data['bug_percent'].'%</p></td>';

}

?>