<?php
/***********************************************************************

  Copyright (C) 2005-2006 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


# enregistrement du bloc
$GLOBALS['puntal']->blocks->registerBlock('calendar',
	array('calendarPublicBlocks','calendar'),
	array('calendarAdminBlocks','calendar'));

# Recherche dans les venements du calendrier
$GLOBALS['puntal']->addBehavior('searchPerform', array('calendarBehavior','performSearch'));
	
# Rsultats de recherche
$GLOBALS['puntal']->addBehavior('searchResults', array('calendarBehavior','searchResults'));

# Affiche le nombre de Rsultats de recherche
$GLOBALS['puntal']->addBehavior('searchResultsTtl', array('calendarBehavior','searchResultsTtl'));

class calendarBehavior
{
	function performSearch()
	{
		global $puntal;
		
		if (file_exists(PT_THEMES_PATH.pt_theme.'/calendar/calendar.css'))
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.pt_theme.'/calendar/calendar.css'.'" />';
		else
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.PT_DEFAULT_THEME.'/calendar/calendar.css'.'" />';

        require_once dirname(__FILE__).'/inc/calendar.class.php';
		$calendar = new calendarManager($puntal);
		
		#la recherche est-elle vide ?
		if (strlen(trim($_GET['q'])) > 2 )             
			$GLOBALS['calendar_list'] = $calendar->searchEntry($_GET['q'], pt_mod_search_num_per_page );
	}
	
	
	function searchResults()
	{
		global $calendar_list;

		#on teste que $calendar_list existe ET qu'il n'est pas vide 
		if ($calendar_list and !$calendar_list->isEmpty())
		{
			require dirname(__FILE__).'/inc/tpl_functions.php';
			
			if (file_exists(PT_THEMES_PATH.pt_theme.'/calendar/search_results.php'))
				require PT_THEMES_PATH.pt_theme.'/calendar/search_results.php';
			else
				require PT_THEMES_PATH.PT_DEFAULT_THEME.'/calendar/search_results.php';
		}
	}
	
	function searchResultsTtl() {
		global $calendar_list;
		
		if ($calendar_list and !$calendar_list->isEmpty()) {		
			$GLOBALS['search_ttl'] += $calendar_list->nbRow();
			return $GLOBALS['search_ttl'];			
		}		
	}	
}

?>