<?php
/***********************************************************************

  Copyright (C) 2005 Vincent Garnier (vin100@forx.fr)
  
  This file is part of Puntal.

  Puntal is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

// Soyons sr que personne ne lance ce script "directement"
if (!defined('PUNTAL')) exit;

// est-ce que l'utilisateur est autoris ?
if ($calendar->getPermission($allowed_groups)) {

$req_subject = '';
$req_message = '';
$can_edit_subject = false;
$event_id 	= $pt_args[2];
$sqlQuery 	= 'SELECT id,date,title,content,C.cat_id,cat_name,pid,tid FROM '.DB_PREFIX.'pt_calendar AS C LEFT JOIN '.DB_PREFIX.'pt_calendar_cat AS CC on  C.cat_id=CC.cat_id WHERE id = \''.$event_id.'\'';
$result 	= $puntal->con->select($sqlQuery) or $puntal->err->fatalError($puntal->con->error());

$event 		= $result->getData('0');

$event_id 	 = isset($_POST['event_id']) ? $_POST['event_id'] : $event['id'];	
$pt_annee 	 = isset($_POST['event_annee']) ? $_POST['event_annee'] : date('Y', $event['date']);
$pt_mois	 = isset($_POST['event_mois']) ? $_POST['event_mois'] : date('n', $event['date']);
$pt_jour 	 = isset($_POST['event_jour']) ? $_POST['event_jour'] : date('d', $event['date']);
$req_subject = isset($_POST['req_subject']) ? $_POST['req_subject'] : $event['title'];
$req_message = isset($_POST['req_message']) ? $_POST['req_message'] : $event['content'];
$calendar_cat_id = isset($_POST['req_cal_category']) ? $_POST['req_cal_category'] : $event['cat_id'];

$calendar_cat_name = isset( $event['cat_name'] ) ? $event['cat_name'] : ''; 
$calendar_subject = $req_subject;

$id = $event['pid'];

if ($id > 0 and  pt_mod_calendar_forum_id > 0) { 
		// Fetch some info about the post, the topic and the forum
		$result = $puntal->con->select('SELECT f.id AS fid, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, t.id AS tid, t.subject, t.posted, t.closed, p.poster, p.poster_id, p.message, p.hide_smilies FROM '
		.DB_PREFIX.'posts AS p INNER JOIN '
		.DB_PREFIX.'topics AS t ON t.id=p.topic_id INNER JOIN '
		.DB_PREFIX.'forums AS f ON f.id=t.forum_id LEFT JOIN '
		.DB_PREFIX.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='
		.$puntal->user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND p.id='.$id) 
		or  $puntal->err->fatalError($puntal->con->error());
		
		if ($result->isEmpty()) 
			//$puntal->message($lang_common['Bad request']);
			$puntal->redirect(pt_portal_url.CAL_URL, $lang_common['Bad request']);
		
		$cur_post = $result->getData('0');
		
		// Sort out who the moderators are and if we are currently a moderator (or an admin)
		$mods_array = ($cur_post['moderators'] != '') ? unserialize($cur_post['moderators']) : array();
		$is_admmod = ($puntal->user['g_id'] == PUN_ADMIN || ($puntal->user['g_id'] == PUN_MOD && array_key_exists($puntal->user['username'], $mods_array))) ? true : false;
		
		// Determine whether this post is the "topic post" or not
		$result = $puntal->con->select('SELECT id FROM '.DB_PREFIX.'posts WHERE topic_id='.$cur_post['tid'].' ORDER BY posted LIMIT 1')  
		or  $puntal->err->fatalError($puntal->con->error());
		
		$topic_post_id = $result->getData('0');
		
		$can_edit_subject = ($id == $topic_post_id && (($puntal->user['g_edit_subjects_interval'] == '0' || (time() - $cur_post['posted']) < $puntal->user['g_edit_subjects_interval']) || $is_admmod)) ? true : false;
		
		// Do we have permission to edit this post?
		if (($puntal->user['g_edit_posts'] == '0' ||
			$cur_post['poster_id'] != $puntal->user['id'] ||
			$cur_post['closed'] == '1') &&
			!$is_admmod)
			message(__('No permission'));
}
else {
}

// Load the post.php language file
require PUN_ROOT.'lang/'.$puntal->user['language'].'/post.php';

// Start with a clean state
$errors = array();


if (isset($_POST['form_sent']) && $puntal->checkToken())
{
	$hide_smilies = isset($_POST['hide_smilies']) ? intval($_POST['hide_smilies']) : 0;
	if ($hide_smilies != '1') $hide_smilies = '0';
	
	// vrification de la date		
	if (!checkdate($pt_mois, $pt_jour, $pt_annee))
		$puntal->err->fatalError(__('Wrong date'));

	$calendar_cat = '';
	if ($calendar->existingCats() > 0 ) {

		$calendar_cat_id = '';
		$calendar_cat_id = intval($_POST['req_cal_category']);
			
		$calendar_my_cat = $calendar->getCat($calendar_cat_id);
		if ($calendar_cat_id != '') 
			$calendar_cat = "[".$calendar_my_cat->f('cat_name')."] ";
	}	
	
	$calendar_subject = $calendar_cat . pun_trim($_POST['req_subject']);
	
	if ($id > 0)
	{	
		// If it is a topic it must contain a subject
		if ($can_edit_subject)
		{
			
			$req_subject = $calendar_cat . pun_trim($_POST['req_subject']);
	
			if ($req_subject == '')
				$errors[] = $lang_post['No subject'];
			else if (pun_strlen($req_subject) > 50)
				$errors[] = $lang_post['Too long subject'];
			else if ($puntal->pun_config['p_subject_all_caps'] == '0' && strtoupper($req_subject) == $req_subject && $puntal->user['g_id'] > PUN_MOD)
				$req_subject = ucwords(strtolower($req_subject));
		}
	
		// Clean up message from POST
		$req_message = $puntal->linebreaks(pun_trim($_POST['req_message']));
	
		if ($req_message == '')
			$errors[] = $lang_post['No message'];
		else if (strlen($req_message) > 65535)
			$errors[] = $lang_post['Too long message'];
		else if ($puntal->pun_config['p_message_all_caps'] == '0' && strtoupper($req_message) == $req_message && $puntal->user['g_id'] > PUN_MOD)
			$req_message = ucwords(strtolower($req_message));
	
		// Validate BBCode syntax
		if ($puntal->pun_config['p_message_bbcode'] == '1' && strpos($req_message, '[') !== false && strpos($req_message, ']') !== false)
		{
			$req_message = preparse_bbcode($req_message, $errors);
		}
	}
		
	// Did everything go according to plan?
	if (empty($errors) && !isset($_POST['preview']))
	{
		if ($id > 0)
		{
			$edited_sql = (!isset($_POST['silent']) || !$is_admmod) ? $edited_sql = ', edited='.time().', edited_by=\''.$puntal->con->escapeStr($puntal->user['username']).'\'' : '';
	
			if ($can_edit_subject)
			{
				// Update the topic and any redirect topics
				$puntal->con->execute('UPDATE '.DB_PREFIX.'topics SET subject=\''.$puntal->con->escapeStr($req_subject).'\' WHERE id='.$cur_post['tid'].' OR moved_to='.$cur_post['tid']) or $puntal->err->fatalError($puntal->con->error());
	
				// We changed the subject, so we need to take that into account when we update the search words
				punbb::updateSearchIndex('edit', $id, $req_message, $req_subject);
			}
			else
				punbb::updateSearchIndex('edit', $id, $req_message);
	
			// Update the post
			$puntal->con->execute('UPDATE '.DB_PREFIX.'posts SET message=\''.$puntal->con->escapeStr($req_message).'\', hide_smilies=\''.$hide_smilies.'\''.$edited_sql.' WHERE id='.$id) or $puntal->err->fatalError($puntal->con->error());
		}

		$result = $puntal->con->execute('UPDATE '.DB_PREFIX.'pt_calendar SET date=\''.strtotime($pt_annee.'-'.$pt_mois.'-'.$pt_jour).'\', title=\''.$puntal->con->escapeStr($calendar_subject).'\', content=\''.$puntal->con->escapeStr($req_message).'\', cat_id = \''.$calendar_cat_id.'\' WHERE id =\''.$event_id.'\'') or $puntal->err->fatalError($puntal->con->error());
	
		$puntal->redirect(pt_portal_url.CAL_URL, __('Event Modified'));
	}
} else $puntal->setToken();


} //  if ($calendar->getPermission($allowed_groups)) 

?>