<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$do = !empty($_REQUEST['do']) ? $_REQUEST['do'] : null;

# FR - Ajout d'une catgorie
# EN - Add a category
if ($do == 'add_cat' && !empty($_POST['cat_name']) && $puntal->checkToken())
{
	if ($calendar->setCat($_POST['cat_name']))
	{
		header('Location: module.php?id=calendar&action=4&added=1');
		exit;
	}
}

# FR - Supprimer catgories
# EN - Delete categories
if (!empty($_POST['removeaction']) && !empty($_POST['remove']) && is_array($_POST['remove']) && $puntal->checkToken())
{
	foreach ($_POST['remove'] as $v)
		$calendar->delCat($v);
	
	if (!$puntal->err->hasError())
	{
		header('Location: module.php?id=calendar&action=4&deleted=1');
		exit;
	}
}

# FR - Ordonner les catgories
# EN - Sort the categories
$order = array();
if (empty($_POST['categories_order']) && !empty($_POST['order']))
{
	$order = $_POST['order'];
	asort($order);
	$order = array_keys($order);
}
elseif (!empty($_POST['categories_order']))
	$order = explode(',',$_POST['categories_order']);

if (!empty($_POST['saveorder']) && !empty($order) && $puntal->checkToken())
{
	if ($calendar->ordCats($order))
	{
		header('Location: module.php?id=calendar&action=4&ordered=1');
		exit;
	}
}

# FR - Messages de confirmation
# EN - Confirmation Messages
if (!empty($_GET['edited']))
	$common_message = __('Category edited');

if (!empty($_GET['added']))
	$common_message = __('Category added');

if (!empty($_GET['deleted']))
	$common_message = __('Categories deleted');

if (!empty($_GET['ordered']))
	$common_message =__('Categories ordered');

# FR - Liste des catgories
# EN - List of categories
$rs = $calendar->getCat();

# Set token
$puntal->setToken();

# FR - Affichage
# EN - Display

if (!$rs->isEmpty())
{
	$head = 
	adminPage::jsToolMan().
	'<script type="text/javascript">'."\n".
	"//<![CDATA[\n".
	adminPage::jsVar('puntal.msg.confirm_delete_categories',
		__('Are you sure you want to remove the selected categories?')).
	"//]]>\n".
	"</script>"."\n".
	'<script type="text/javascript" src="index.php?pf=calendar/js/cats.js"></script>';
}
else
	$head = '';

adminPage::open(__('Manage categories').' - '.__('calendar'),$head);

?>
<h2 class="first"><img src="index.php?pf=calendar/img/ico_calendar_cats.png" alt="" class="icon" /> <?php echo __('Manage categories') ?></h2>

<h3><img src="style/img/ico_cat_new.png" alt="" class="icon" /> <?php echo __('New category') ?></h3>

<form action="module.php" method="post">
	<p class="field"><label for="cat_name"><?php echo __('Category title') ?></label>
	<?php echo form::field('cat_name', 40, 255) ?>
	
	<?php echo 
	form::hidden(array('id'),'calendar')."\n".
	form::hidden(array('action'),4)."\n".
	form::hidden(array('do'),'add_cat')."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Add') ?>" /></p>
</form>

<h3><img src="style/img/ico_cats_list.png" alt="" class="icon" /> <?php echo __('Categories list') ?></h3>

<?php
if ($rs->isEmpty()) :
	echo '<p>'.__('No category').'</p>';
else : ?>

<form action="module.php" method="post" id="form-categories">
	<table class="dragable">
	<thead>
		<tr>
			<th colspan="3" class="left"><?php echo __('Category title') ?></th>
			<th class="nowrap"><?php echo __('Number of calendar') ?></th>
		</tr>
	</thead>
	<tbody id="categories-list">
	
<?php
$position = 1;
while ($rs->fetch())
{
	$deletable = false;
	$calendar_link = '<a href="module.php?&amp;id=calendar&amp;action=1&amp;cat_id=%s">%s</a>';
	
	switch ($rs->f('nb_calendar'))
	{
		case 0:
			$nb_post = __('No article');
			$deletable = true;
			break;
		case 1:
			$nb_post = sprintf($calendar_link,$rs->f('cat_id'),__(' One calendar'));
			break;
		default:
			$nb_post = sprintf($calendar_link,$rs->f('cat_id'),
			sprintf(__('%s calendar'),$rs->f('nb_calendar')));
			break;
	}
	
	echo
	"\t\t".'<tr class="line" id="c_'.$rs->f('cat_id').'">'."\n".
	"\t\t\t".'<td class="handle">'.form::field(array('order['.$rs->f('cat_id').']'), 2, 5, $position++).'</td>'."\n".
	"\t\t\t".'<td>'.form::checkbox(array('remove[]'), $rs->f('cat_id'), 0, 'checkbox', !$deletable).'</td>'."\n".
	"\t\t\t".'<td class="maximal"><a href="module.php?id=calendar&amp;action=3&amp;cid='.$rs->f('cat_id').'">'.html::escapeHTML($rs->f('cat_name')).'</a></td>'."\n".
	"\t\t\t".'<td class="nowrap">'.$nb_post.'</td>'."\n\n".
	"\t\t".'</tr>'."\n\n";
}
?>
	</tbody>
	</table>
	
	<div class="two-cols">
		<p class="col">
		<?php echo 
		form::hidden(array('id'),'calendar')."\n".
		form::hidden(array('action'),4)."\n".
		form::hidden(array('ptkn'),$puntal->getToken()); ?>
		<input type="hidden" id="categories_order" name="categories_order" value="" />
		<input class="submit" type="submit" name="saveorder" value="<?php echo __('Save order') ?>" />
		</p>
		
		<p class="col right">
		<input class="submit" type="submit" name="removeaction" value="<?php echo __('Delete selected categories') ?>"/>
		</p>
	</div>
</form>
	
<?php endif;

adminPage::close() ?>