<?php
/***********************************************************************

  Copyright (C) 2005-2006 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


/**
install_calendar<br/>

<strong>FR</strong> La fonction charge de l'installation du module calendrier<br/>
<strong>EN</strong> the function in charge of the installation of the calendar module.
*/

function install_calendar()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	$db_scheme[] = array(
		'action' 	=> 'add', 
		'table' 	=> DB_PREFIX.'pt_calendar',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_calendar (
					id INT(10) NOT NULL AUTO_INCREMENT ,
					date INT(10) NOT NULL ,
					title VARCHAR(255) NOT NULL ,
					content TEXT NOT NULL ,
					user_id INT(10) NOT NULL ,
					user_name VARCHAR(200) NOT NULL ,
					tid INT(10) ,
					pid INT(10) ,
					cat_id INT(10),
					INDEX (cat_id),
					PRIMARY KEY (id)
					) TYPE = MYISAM;"
	);
	$db_scheme[] = array(
		'action' 	=> 'add', 
		'table' 	=> DB_PREFIX.'pt_calendar_cat',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_calendar_cat (
					`cat_id` int( 10 ) unsigned NOT NULL AUTO_INCREMENT ,
					`cat_name` varchar( 255 )  NOT NULL default '',
					`cat_url` varchar( 255 ) NOT NULL default '',
					`cat_desc` text ,
					`cat_ord` int( 10 ) NOT NULL default '0',
					PRIMARY KEY ( `cat_id` ) ,
					UNIQUE KEY `cat_name` ( `cat_name` ) ,
					UNIQUE KEY `cat_url` ( `cat_url` )
					) TYPE = MYISAM;"
	);	
 	

	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();

	$params[] = array(
		'action'	=> 'add',
		'name'		=> 'pt_mod_calendar_forum_id',
		'type' 		=> 'string',
		'init' 		=> ''
	);

	$params[] = array(
		'action'	=> 'add',
		'name'		=> 'pt_mod_calendar_groups',
		'type'		=> 'string',
		'init' 		=> 'a:2:{i:0;i:2;i:1;i:4;}'
	);

	# calendar block
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_calendar_events_number',
		'type' 		=> 'integer',
		'init'		=> 10
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_calendar_events_days',
		'type' 		=> 'integer',
		'init'		=> 30
	);

	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_calendar_cat_forum',
		'type' 		=> 'string',
		'init'		=> ''
	);
	
	

	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->install($db_scheme,$params);
}


?>