<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
update_calendar<br/>

<strong>FR</strong> La fonction charge de la mise  jour du module calendrier.<br/>
<strong>EN</strong> the function in charge of the update of the calendar module.
*/
function update_calendar()
{
	global $puntal;
	
	$res = true;
	
	# mise  jour 0.6
	if (compare_version(pt_mod_calendar_version,'0.6') == '-1')
		$res &= calendar_up_to_0_6();
	# mise  jour 1.0
	if (compare_version(pt_mod_calendar_version,'1.0') == '-1')
		$res &= calendar_up_to_1_0();
	# mise  jour 1.1.0
	if (compare_version(pt_mod_calendar_version,'1.1.0') == '-1')
		$res &= calendar_up_to_1_1_0();
	# mise  jour 1.1.1
	if (compare_version(pt_mod_calendar_version,'1.1.1') == '-1')
		$res &= calendar_up_to_1_1_1();
	# mise  jour 2.0.0
	if (compare_version(pt_mod_calendar_version,'2.0.0') == '-1')
		$res &= calendar_up_to_2_0_0();
			
	return $res;
}


/**
calendar_up_to_0_6<br/>

<strong>FR</strong> Mise  jour du module  la version 0.6<br/>
<strong>EN</strong> Update to the version 0.6 of the module
*/

function calendar_up_to_0_6()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();

	# calendar
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_calendar_events_number',
		'type' 		=> 'integer',
		'init'		=> 10
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_calendar_events_days',
		'type' 		=> 'integer',
		'init'		=> 30
	);
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
}

/**
calendar_up_to_1_0<br/>

<strong>FR</strong> Mise  jour du module  la version 1.0<br/>
<strong>EN</strong> Update to the version 1.0 of the module
*/

function calendar_up_to_1_0() 
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
		

	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_calendar_cat_forum',
		'type' 		=> 'string',
		'init'		=> ''
	);	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
	
}

/**
calendar_up_to_1_1_0<br/>

<strong>FR</strong> Mise  jour du module  la version 1.1.0<br/>
<strong>EN</strong> Update to the version 1.1.0 of the module
*/

function calendar_up_to_1_1_0() 
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
		

	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
	
}
/**
calendar_up_to_1_1_1<br/>

<strong>FR</strong> Mise  jour du module  la version 1.1.1<br/>
<strong>EN</strong> Update to the version 1.1.1 of the module
*/

function calendar_up_to_1_1_1() 
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
		

	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
	
}
/**
calendar_up_to_2_0_0<br/>

<strong>FR</strong> Mise  jour du module  la version 2.0.0<br/>
<strong>EN</strong> Update to the version 2.0.0 of the module
*/

function calendar_up_to_2_0_0() 
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();

	$db_scheme[] = array(
		'action' 	=> 'add', 
		'table' 	=> DB_PREFIX.'pt_calendar_cat',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_calendar_cat (
					`cat_id` int( 10 ) unsigned NOT NULL AUTO_INCREMENT ,
					`cat_name` varchar( 255 )  NOT NULL default '',
					`cat_url` varchar( 255 ) NOT NULL default '',
					`cat_desc` text ,
					`cat_ord` int( 10 ) NOT NULL default '0',
					PRIMARY KEY ( `cat_id` ) ,
					UNIQUE KEY `cat_name` ( `cat_name` ) ,
					UNIQUE KEY `cat_url` ( `cat_url` )
					) TYPE = MYISAM;"
	);	
		

	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
	
}

?>