<?php
/***********************************************************************

  Copyright (C) 2005-2006 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/**
	@brief calendar template class
*/
class calendar
{
	/**
	url<br/>
	
	<strong>FR</strong> Affiche l'URL en fonction du paramtre pass<br/>
	<strong>EN</strong> Display the URL regarding the given parameter

	@param type <strong>string</strong>	url type to determine which url to display	
	*/
	function url($type='')
	{
		switch ($type)
		{
			case 'add':
				echo $GLOBALS['puntal']->url('calendar_add');
				break;
			
			case 'edit' :
				printf( $GLOBALS['puntal']->url('calendar_edit') , $GLOBALS['event_id']);
				break;
				
			case 'delete':
				echo $GLOBALS['puntal']->url('calendar_delete');
				break;
				
			case 'display':
			default :
				echo $GLOBALS['puntal']->url('calendar');
				break;
		}
	}	
	
	/**
	display<br/>
	
	<strong>FR</strong> Affiche la celendrier entier<br/>
	<strong>EN</strong> Display the complet calendar
	
	*/	
	function display () {
		global $calendar, $pt_mois, $pt_jour, $pt_annee, $pt_mois_av,  $pt_annee_av, $pt_mois_ap, $pt_annee_ap;
		
		echo calendar::pt_calendar($pt_annee, $pt_mois, $pt_jour, pt_portal_url.CAL_URL, true);
		echo calendar::pt_calendar($pt_annee_av, $pt_mois_av, '1',pt_portal_url.CAL_URL, false);
		echo calendar::pt_calendar($pt_annee_ap, $pt_mois_ap, '1',pt_portal_url.CAL_URL, false);
	}
	
	
	/**
	pt_calendar<br/>
	
	<strong>FR</strong> Affiche le contenu de chaque cellule du calendrier<br/>
	<strong>EN</strong> Display the content of each cell of the calendar
		
	@param annee	<strong>integer</strong> 	 the year
	@param mois	<strong>integer</strong>	 the month
	@param jour	<strong>integer</strong>	 the day
	@param url	<strong>string</strong>		url of the event
	@param big 	<strong>boolean</strong>	display the calendar in big or not
	*/
	function pt_calendar ($annee,$mois,$jour,$url,$big) {
		global $calendar;
		
		if ($big)
			{
				// si mois de janvier
				if ($mois == 1)
				{
					$mois_av = 12;
					$annee_av = $annee-1;
				}
				else {
					$mois_av = $mois-1;
					$annee_av = $annee;
				}
				
				// si mois de dcembre
				if ($mois == 12)
				{
					$mois_ap = 1;
					$annee_ap = $annee+1;
				}
				else {
					$mois_ap = $mois+1;
					$annee_ap = $annee;
				}

				// dbut sortie
				$output = '';
				
				$output .= '<table class="calendar" summary="'.$calendar->pt_cal_text['name'].'">'."\n";
				
				// "navigation"
				$output .= "\t".'<caption><a href="'.$url.'/'.$annee_av.'/'.$mois_av.'/'.$jour.'">&laquo;</a> '.
							$calendar->pt_cal_text['month'][$mois-1].' '.$annee.
							' <a href="'.$url.'/'.$annee_ap.'/'.$mois_ap.'/'.$jour.'">&raquo;</a></caption>'."\n";
			}
			else {
				// dbut sortie
				$output = '';
				
				$output .= '<table class="minicalendar" summary="'.$calendar->pt_cal_text['name'].'">'."\n";
				
				// "navigation"
				$output .= "\t".'<caption>'.$calendar->pt_cal_text['month'][$mois-1].' '.$annee.'</caption>'."\n";
			}
		
		#liste des evenements
		$month_events = array();
		$event = $calendar->getCalEventMonth($annee, $mois);
		while ($event->fetch()) 
			$month_events[] = $event->f('date');
		
		// entte
		$output .= "\t".'<thead>'."\n";
		$output .= "\t".'<tr>'."\n";
		
		foreach ($calendar->pt_cal_text['day'] as $d)
			$output .= "\t\t".'<th scope="col"><abbr title="'.$d.'">'.substr($d, 0, 3).'</abbr></th>'."\n";
		
		$output .= "\t".'</tr>'."\n";
		$output .= "\t".'</thead>'."\n";
		$output .= "\t".'<tbody>'."\n";
		
		// corps du tableau
		$ts = strtotime($annee.'-'.$mois.'-01');
		
		$d = 1;
		$i = 0;
		$dstart = false;
		
		$first = date('w',$ts);
		$first = ($first == 0) ? 6 : ($first-1);
		
		$nbre_jours = date('t',$ts);
		
		while ($i<42)
		{
			if ($i%7 == 0)
				$output .= "\t".'<tr>'."\n";
			
			if ($i == $first)
				$dstart = true;
			
			if ($dstart && !checkdate($mois,$d,$annee))
				$dstart = false;
				
			$ad_class = array();
			
			// date passe ?
			if ($dstart && (($annee < date('Y')) || ($annee == date('Y') && $mois < date('n')) || ($annee == date('Y') && $mois == date('n') && $d < date('d'))))
				$ad_class[] = 'past';
			
			// date du jour ?
			if ( ($annee == date('Y')) && ($mois == date('n')) && ($d == date('d')) && $dstart )
				$ad_class[] = 'today';
			
			// date active ? (i.e. date affiche)
			if ($d == $jour && $dstart)
				$ad_class[] = 'active';
			
			// case sans dates ?
			if (!$dstart)
				$ad_class[] = 'inactive';
			
			if (!empty($ad_class))
				$class = ' class="'.implode(" ", $ad_class).'"';
			else
				$class = '';
			
			$output .= "\t\t".'<td'.$class.'>';
			
			$ts_day = strtotime($annee.'-'.$mois.'-'.$d);
			
			if (!$dstart)
				$output .= '';
			
			elseif (in_array($ts_day, $month_events))
			{
				$output .= '<p class="daynumber"><a href="'.$url.'/'.$annee.'/'.$mois.'/'.$d.'">'.$d.'</a></p>';
				if ($big)
				{
					$output .= '<ul class="eventlist">';
					
					$rs_event = $calendar->getDayEvent($ts_day);
					while ($rs_event->fetch())
						$output .= '<li>'.$rs_event->f('title').'</li>';
						
					$output .= '</ul>';
				}
			}
			else
			$output .= ($dstart) ? '<p class="daynumber">'.$d.'</p>' : ' ';
			
			$output .= '</td>'."\n";
			
			if (($i+1)%7 == 0)
			{
				$output .= "\t".'</tr>'."\n";
				
				if ($d>=$nbre_jours)
					$i=42;
			}
			
			$i++;
			if ($dstart)
				$d++;
		}
		
		// fin tableau
		$output .= "\t".'</tbody>'."\n";
		$output .= '</table>'."\n";
		
		echo $output;
	}
	

	/**
	addEvent<br/>
	
	<strong>FR</strong> Ajoute un evenement au calendrier<br/>
	<strong>EN</strong> Add an event to the calendar
	*/
	function addEvent () {
		global $puntal;	
		if ($puntal->user['is_admin'] || in_array($puntal->user['g_id'], $GLOBALS['allowed_groups'])) {
			$rs = ' - <a href="'.pt_portal_url.CAL_URL.'/'.CAL_URL_ADD.'">'.__('Add Event').'</a>';
			echo $rs;
		}
	}
	
	/**
	errors<br/>
	
	<strong>FR</strong> Affiche la liste des erreurs.<br/>
	<strong>EN</strong> Display the list of errors
	
	@param block <strong>string</strong> list
	@param item <strong>string</strong> item 
	*/		
	function error($block='<ul>%s</ul>', $item='<li>%s </li>') {
		$items = '';
		foreach ($GLOBALS['errors'] as $err)
			$items .= sprintf($item,$err);
		
		printf($block, $items);
		
	}
	
	/**
	curIndex<br/>
	
	<strong>FR</strong> retourne l'index dans le formulaire.<br/>
	<strong>EN</strong> return the index in the form
	
	@param block <strong>string</strong> list
	@param item <strong>string</strong> item 
	*/
	function curIndex () {
		global $cur_index;
		return ++$cur_index;
	}
	
	/**
	selectOption<br/>

	<strong>FR</strong> cr une liste droulante.<br/>
	<strong>EN</strong> build a dropdawn list
		
	@param 	selected <strong>string</strong>	display the selected value
	@param 	normal <strong>string</strong>	display the other value
	@param	flag <strong>string</strong>	determine which list we build		
	*/	
	function selectOption($selected = '<option value="%s" selected="selected">%s</option>',$normal='<option value="%s">%s</option>',$flag='')  {
		global $calendar, $pt_mois, $pt_jour, $pt_annee;
		
		$year_str = '';
		$month_str  ='';
		$day_str = '';
		
		if ($flag == 'year') {
			for ($i = $pt_annee; $i<($pt_annee+4); $i++) {
				if ($i == $pt_annee)
					$year_str .=  sprintf($selected,$i,$i);
				else
					$year_str .=  sprintf($normal,$i,$i);
			}
			echo  $year_str;
		}
		elseif ($flag == 'month') {

			for ($i=1; $i<13; $i++)	{
				if ($i == $pt_mois)
					$month_str .= sprintf($selected,$i, $calendar->pt_cal_text['month'][$i-1]);
				else
					$month_str .= sprintf($normal,$i, $calendar->pt_cal_text['month'][$i-1]);
			}
			echo  $month_str;

		}
		elseif ($flag == 'day') {
			for ($i=1; $i<32; $i++) {
				if ($i == $pt_jour)
					$day_str .=  sprintf($selected,$i,$i);
				else
					$day_str .=  sprintf($normal,$i,$i);
			}
			echo $day_str;
		
		
		}
	}

	/**
	onPreview<br/>

	<strong>FR</strong> Indique si nous devons prvisualiser.<br/>
	<strong>EN</strong> Tell if we have to preview
	*/		
	function onPreview()
	{
		if (isset($_POST['preview']))
			return true;
		
		return false;
	}
	
	/**
	hasErrors<br/>

	<strong>FR</strong> Indique si il y a des erreurs.<br/>
	<strong>EN</strong> Tell if there are errors
	*/	
	function hasErrors()
	{
		if (!empty($GLOBALS['errors']))
			return true;
		
		return false;
	}

	/**
	previewValue<br/>
	
	
	<strong>FR</strong> Affiche les �l�ments de la pr�visualisation.<br/>
	<strong>EN</strong> Display the items of the preview
	
	@param	var <strong>string</strong> name of the var to be displayed
	*/
	function previewValue($var='')
	{
		
		if ( $var == 'req_message') {
			$bool = 0;
			if (isset($_POST['hide_smilies'])) 
				$bool =  (pt_mod_calendar_forum_id > 0 and $_POST['hide_smilies'] ) ? $_POST['hide_smilies'] : 0;
			$preview_message = parse_message($_POST['req_message'], $bool);
			echo $preview_message;
		}
		elseif ($var == 'req_subject') 
			echo html::escapeHTML($_POST['req_subject']);
		
	}
	
	/**
	formValue<br/>
	
	<strong>FR</strong> Affiche un des champs du formulaire.<br/>
	<strong>EN</strong> Display one of the field of the form.

	@param	var <strong>string</strong> name of the var to be displayed
	*/	
	function formValue($var='')
	{
		if ($var == '')
			return;
		
		echo html::escapeHTML($GLOBALS[$var]);
		
	}

	/**
	isGuest<br/>

	<strong>FR</strong> Indique si l'utilisateur est un invit�.<br/>
	<strong>EN</strong> Tell if the user is a guest
	*/		
	function isGuest() {
	
		if ($GLOBALS['puntal']->user['is_guest']) { 
			return true; 
		}
		else return false;
	}
	
	/**
	guestEmailLabel<b/>

	<strong>FR</strong> affiche l'adresse de messagerie  quand l'utilisateur est un visiteur.<br/>
	<strong>EN</strong> display the email when the user is a gust
	*/	
	function guestEmailName() {
		$email_form_name = ($GLOBALS['puntal']->pun_config['p_force_guest_email'] == '1') ? 'req_email' : 'email';
		return $email_form_name;
	}

	/**
	viewEventTitle<b/>

	<strong>FR</strong> affiche le titre de l'evenement lors de sa consultation.<br/>
	<strong>EN</strong> display the title of the event when viewing
	*/
	function viewEventTitle() {
		echo  $GLOBALS['calendar_event']->f('title');
	}

	/**
	viewEvent<b/>

	<strong>FR</strong> affiche l'eventment<br/> 
	<strong>EN</strong> display the event
	*/	
	function viewEvent() {
	
		echo parse_message($GLOBALS['calendar_event']->f('content'), false);
	}
	
	/**
	viewEventLinks<br/>
	
	<strong>FR</strong> affiche les liens si le calendrier utilise le forum pour stocker les evenements.<br/>
	<strong>EN</strong> Display link if the calendar use a forum to store the event
	
	@param block <strong>string</strong> list
	@param item <strong>string</strong> item 
	*/					
	function viewEventLinks($block = '<div class="conr">%s</div><div class="clearer"></div>') {
	
		if (intval($GLOBALS['calendar_event']->f('tid')) > 0)
			$options_links[] = '<a href="'.pt_forum_url.'viewtopic.php?id='.$GLOBALS['calendar_event']->f('tid').'">'.__('comments').'</a>';
				
		// lien modifier (admins/modos/auteur si pas invit)
		if (!$GLOBALS['puntal']->user['is_guest'] && ($GLOBALS['puntal']->user['g_id'] <= PUN_MOD || $GLOBALS['puntal']->user['id'] == $GLOBALS['calendar_event']->f('user_id')))
			$options_links[] = '<a href="'.pt_portal_url.CAL_URL.'/edit/'.$GLOBALS['calendar_event']->f('id').'">'.__('Edit Event').'</a>';
				
		// lien supprimer (seulement admins/modos)
		if ($GLOBALS['puntal']->user['g_id'] <= PUN_MOD )
			$options_links[] = '<a href="'.pt_portal_url.CAL_URL.'/delete/'.$GLOBALS['calendar_event']->f('id').'" onclick="return window.confirm(\''.__('Do you confirm that you want to delete this event ?').'\')">'.__('Delete Event').'</a>';
			
		if (!empty($options_links))  
			printf($block, implode(' | ' , $options_links));
		
	}
	
	/**
	eventId<br/>
	
	<strong>FR</strong> retourne l'id de levent courant.<br/>
	<strong>EN</strong> return the current event id 
	*/				
	function eventId() {
		return $GLOBALS['event_id'];
	}
	
	/**
	formUser<br/>
	
	<strong>FR</strong> affiche dans le formulaire le nom de l'utilisateur si c'est un membre.<br/>
	<strong>EN</strong> display in the form of the username if it's a member 
	*/	
	function formUser () {
		$str = (!$GLOBALS['puntal']->user['is_guest']) ? html::escapeHTML($GLOBALS['puntal']->user['username']) : __('Guest');
		return $str;
	}

			
	/**
	formSubject<br/>
	
	<strong>FR</strong> affiche dans le formulaire le sujet<br/>
	<strong>EN</strong> display in the form of the subject 
	*/		
	function formSubject() {
	
		echo (isset($_POST['req_subject'])) ? html::escapeHTML($_POST['req_subject']) : (isset($GLOBALS['req_subject']) ? $GLOBALS['req_subject'] : '');
	}
	

	/**
	formMessage<br/>
	
	<strong>FR</strong> affiche dans le formulaire message<br/>
	<strong>EN</strong> display in the form of the message 
	*/					
	function formMessage() {
		echo isset($_POST['req_message']) ? html::escapeHTML($_POST['req_message']) : (isset($GLOBALS['req_message']) ? $GLOBALS['req_message'] : '');
	}
			
	/**
	smilies<br/>
	
	<strong>FR</strong> gere-t-on les �motic�nes ?<br/>
	<strong>EN</strong> do we use the smilies
	*/			
	function smilies() {
		return  ($GLOBALS['puntal']->pun_config['o_smilies'] == '1') ? true : false;
	}

	/**
	subscriptions<br/>
	
	<strong>FR</strong> gere-t-on les abonnements � cet evenement ?<br/>
	<strong>EN</strong> do we use subscriptions on this event ?
	*/					
	function subscriptions () {
		return  ($GLOBALS['puntal']->pun_config['o_subscriptions'] == '1') ? true : false;
	}

	/**
	checked<br/>
	
	<strong>FR</strong> case  cocher coch ?<br/>
	<strong>EN</strong> checbkox checked ?
	*/	
	function checked($var='') {
		if ($var = '' ) return;
		return (isset($_POST[$var]))? ' checked="checked"' : '';
	}
    
    /**
	listUrl<br/>
	
	<strong>FR</strong> Affiche le titre d'un evenement dans le contexte d'une boucle sur une liste d'evenements<br/>
	<strong>EN</strong> Display the title of an event in the context of a loop on the event list
	*/	
	function listUrl()
	{
        $d = date('j',$GLOBALS['calendar_list']->f('date'));
        $m = date('m',$GLOBALS['calendar_list']->f('date'));
        $y = date('Y',$GLOBALS['calendar_list']->f('date'));
		echo $GLOBALS['puntal']->url('calendar').$y.'/'.$m.'/'.$d;
	}
	
	/**
	listTitle<br/>
	
	<strong>FR</strong> Affiche le titre d'un evenement dans le contexte d'une boucle sur une liste d'articles.<br/>
	<strong>EN</strong> Display the title of an event in a loop of the event list
	*/	
	function listTitle()
	{
		echo html::escapeHTML($GLOBALS['calendar_list']->f('title'));
	}

	/**
	listContent<br/>
	
	<strong>FR</strong> Affiche le contenu d'un evenement dans le contexte d'une boucle sur une liste d'articles.<br/>
	<strong>EN</strong> Display the content of an event in a loop of the event list	
	*/
	function listContent()
	{
		echo parse_message( $GLOBALS['calendar_list']->f('content') , false);		

		
	}
    
    /**
	getEventsTable<br/>
	
	<strong>FR</strong> Affiche le tableau de la liste des evenements<br/>
	<strong>EN</strong> Display the table of the events list
	*/
	function getEventsTable()
	{
		echo $GLOBALS['lum']->getPage();
	}
    

    /**
	getEventsTable<br/>
	
	<strong>FR</strong> Affiche les liens de pages sur la liste des evenements<br/>
	<strong>EN</strong> Display the links of the page of the events list
	*/	
	function getPagesLinks()
	{
		echo $GLOBALS['lum']->getLinks();
	}

	/**
	isCategory<br/>
	
	<strong>FR</strong> Test si le calendrier a des catgories de dfinies<br/>
	<strong>EN</strong> Test if the calendar has defined categories
	
	@return <strong>boolean</strong>
	*/	
	function isCategory() {
		if (pt_mod_calendar_cat_forum != '' ) return true; else return false;		 
	}
	

	/**
	selectCategoryOption<br/>
	
	<strong>FR</strong> Liste d�roulante des categories<br/>
	<strong>EN</strong> Dropdown list of the categories

	@param 	selected <strong>string</strong> display the selected value
	@param 	normal <strong>string</strong>	display all others values	
	@return <strong>boolean</strong>
	*/			
	function selectCategoryOption($selected = '<option value="%s" selected="selected">%s</option>',$normal='<option value="%s">%s</option>')  {
		global $puntal;
		$forum_name='';
		$cat_value='';			
		$p_cat_forum_array = unserialize(pt_mod_calendar_cat_forum);
		
		for ($i=0; $i<count($p_cat_forum_array); ++$i)
		{		 						
			
			$strQuery = "SELECT f.id AS fid, f.forum_name FROM ".DB_PREFIX."forums AS f WHERE id='".$p_cat_forum_array[$i]."' ";
			$rs = $puntal->con->select($strQuery);
			$forum_name = $rs->f('forum_name');
			
			$cat_value.= sprintf($normal,$p_cat_forum_array[$i],$forum_name);				
		}
		
		echo $cat_value;				
	}
	    
	    
	/**
	calCategory<br/>
	
	<strong>FR</strong> Affiche le libell <br/>
	<strong>EN</strong> Display the label
	*/		    
	function calCategory() {
		echo __('Category of Calendar');
	}	  

	/**
	isCalendarCategory<br/>
	
	<strong>FR</strong> Test si des categories de calendrier sont dfinies<br/>
	<strong>EN</strong> Test if the calendar has defined categories
	
	@return <strong>boolean</strong>
	*/		  
	function isCalendarCategory() {
		global $calendar_cat;
		if ($calendar_cat->nbRow() > 0 ) return true; else return false; 		 
	}
		
	/**
	selectCategoryOption<br/>
	
	<strong>FR</strong> Liste droulante des categories de calendrier<br/>
	<strong>EN</strong> Dropdown list of the categories of calendar

	@param 	selected <strong>string</strong> display the selected value
	@param 	normal <strong>string</strong>	display all others values	
	@return <strong>boolean</strong>
	*/			
	function selectCalendarCategoryOption($selected = '<option value="%s" selected="selected">%s</option>',$normal='<option value="%s">%s</option>')  {
		global $puntal, $calendar_cat;
		
		$cat_value='';
		while ($calendar_cat->fetch()) { 
			if ($GLOBALS['cal_mode'] == 'edit' and $GLOBALS['event_id'] == $calendar_cat->f('cat_id'))		
				$cat_value.= sprintf($normal,$calendar_cat->f('cat_id'),$calendar_cat->f('cat_name'));
			else 				
				$cat_value.= sprintf($selected,$calendar_cat->f('cat_id'),$calendar_cat->f('cat_name'));
		}
		
		echo $cat_value;				
	}    
	    
	    
}
?>