<?php
/***********************************************************************

  Copyright (C) 2005-2006 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

# FR - utiliss pour le BBCode et parsing des messages 
# EN - used for the BBCode and messages parsing 

require_once PT_INC_PATH.'libs/punbb_parser.php';
require_once PT_INC_PATH.'libs/punbb.php';

# FR - calendarManager 
# EN - calendarManager
require dirname(__FILE__).'/inc/calendar.class.php';
$calendar = new calendarManager($puntal);

# FR - Template
# EN - Template
require dirname(__FILE__).'/inc/tpl_functions.php';
$pt_template_file = '/calendar/main.php';

# Initialisations
$allowed_groups = unserialize(pt_mod_calendar_groups);

$cal_mode = 'home';
$pt_custom_title_page[] = __('Calendar');
$calendar_cat 	= $calendar->getCat();

# FR - date active
# EN - active date
if (isset($pt_args[1]) && isset($pt_args[2]) && isset($pt_args[3]) && is_numeric($pt_args[1]) && is_numeric($pt_args[2]) && is_numeric($pt_args[3]) )
{

	$cal_mode 	= 'view_date';	
	
	$pt_annee 	= $pt_args[1];
	$pt_mois 	= $pt_args[2];
	$pt_jour 	= $pt_args[3];
	
	$calendar_event = $calendar->getCalEvent($pt_annee,$pt_mois,$pt_jour);
	
}
else {
	$pt_annee 	= date('Y');
	$pt_mois 	= date('n');
	$pt_jour 	= date('d');
}



if (!empty($pt_args[1]))
{

	# FR - page : ajout d'un evenement
	# EN - page : add an event

	if ($pt_args[1] == CAL_URL_ADD && ($puntal->user['is_admin'] || in_array($puntal->user['g_id'], $allowed_groups))) {
		$cal_mode = "add";
		require dirname(__FILE__).'/add_event.php';
	}
	
	# FR - page : editer un evenement
	# EN - page : edit an event

	elseif ($pt_args[1] == CAL_URL_EDIT && is_numeric($pt_args[2]) && ($puntal->user['is_admin'] || in_array($puntal->user['g_id'], $allowed_groups))) {
		$cal_mode = "edit";
		require dirname(__FILE__).'/edit_event.php';
	}

	# FR - page : supprimer un evenement
	# EN - page : delete an event

	elseif ($pt_args[1] == CAL_URL_DEL && is_numeric($pt_args[2]) && ($puntal->user['is_admin'] || in_array($puntal->user['g_id'], $allowed_groups)))
	{
		$cal_mode = 'delete';
		require dirname(__FILE__).'/del_event.php';	
	}
}	

# FR - si janvier
# EN - if january

if ($pt_mois == 1)
{
	$pt_mois_av 	= 12;
	$pt_annee_av 	= $pt_annee-1;
}
else {
	$pt_mois_av 	= $pt_mois-1;
	$pt_annee_av 	= $pt_annee;
}

# FR - si decembre
# EN - if decembre

if ($pt_mois == 12)
{
	$pt_mois_ap 	= 1;
	$pt_annee_ap 	= $pt_annee+1;
}
else {
	$pt_mois_ap 	= $pt_mois+1;
	$pt_annee_ap 	= $pt_annee;
}

?>