<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$cat_id = !empty($_REQUEST['cat_id']) ? intval($_REQUEST['cat_id']) : '0';
$cat_name_url = '';
$cat_root = '';

# Infos de la rubrique courante
if ($cat_id != '0')
{
	$rsCurCat = $dir->getCat($cat_id,'cat_ord',false);
	
	$cat_name = $rsCurCat->f('cat_name');
	$cat_name_url = $rsCurCat->f('cat_name_url');
	$cat_desc = $rsCurCat->f('cat_desc');
	$cat_root = $rsCurCat->f('cat_root');
}

$c_titre = '';

# Ajout d'une catgorie
if (!empty($_POST['add_cat']) && $puntal->checkToken())
{
	$c_titre = trim($_POST['c_titre']);

	if ($dir->setCat($c_titre,$cat_name_url) !== false)
	{
		header('Location: module.php?id=directory&action=3&cat_id='.$cat_id.'&added=1');
		exit;
	}
}

# Modification
if (!empty($_POST['edit_cat']) && $puntal->checkToken())
{
	$cat_name = trim($_POST['c_edit_titre']);
	$cat_name_url = !empty($_POST['c_edit_titre_url']) ? trim($_POST['c_edit_titre_url']) : $cat_name_url;
	$cat_desc = trim($_POST['c_edit_desc']);
	
	if ($dir->setCat($cat_name,$cat_root,$cat_name_url,$cat_desc,$cat_id) !== false)
	{
		header('Location: module.php?id=directory&action=3&cat_id='.$cat_id.'&edited=1');
		exit;
	}
}

# Supprimer catgories
if (!empty($_POST['removeaction']) && !empty($_POST['remove']) && is_array($_POST['remove']) && $puntal->checkToken())
{
	foreach ($_POST['remove'] as $v)
		$dir->delCat($v);
	
	if (!$puntal->err->hasError())
	{
		header('Location: module.php?id=directory&action=3&cat_id='.$cat_id.'&deleted=1');
		exit;
	}
}

# Ordonner les catgories
$order = array();
if (empty($_POST['categories_order']) && !empty($_POST['order']))
{
	$order = $_POST['order'];
	asort($order);
	$order = array_keys($order);
}
elseif (!empty($_POST['categories_order']))
	$order = explode(',',$_POST['categories_order']);

if (!empty($_POST['saveorder']) && !empty($order) && $puntal->checkToken())
{
	if ($dir->ordCats($order))
	{
		header('Location: module.php?id=directory&action=3&cat_id='.$cat_id.'&ordered=1');
		exit;
	}
}

# Message de confirmation
if (!empty($_GET['added']))
	$common_message = __('Category added');
	
if (!empty($_GET['edited']))
	$common_message = __('Category edited');
	
if (!empty($_GET['deleted']))
	$common_message = __('Categories deleted');
	
if (!empty($_GET['ordered']))
	$common_message = __('Categories ordered');


/* Affichage
------------------------------------------------------------*/

# Set token
$puntal->setToken();

# Liste des catgories
$rsCat = $dir->getCat('','cat_ord',$cat_name_url);

# Javascript
$head = '';
if (!$rsCat->isEmpty())
{
	$head .= 
	adminPage::jsToolMan().
	'<script type="text/javascript">'."\n".
	"//<![CDATA[\n".
	adminPage::jsVar('puntal.msg.confirm_delete_categories',
		__('Are you sure you want to remove the selected categories?')).
	"var dragsort = ToolMan.dragsort();
	$(function() {
		dragsort.makeTableSortable(document.getElementById(\"categories-list\"),
		puntal.sortable.setHandle, puntal.sortable.saveOrder);
		
		$('#form-categories input[@name=\"removeaction\"]').click(function() {
			return window.confirm(puntal.msg.confirm_delete_categories);
		});
	});
	
	puntal.sortable = {
		setHandle: function(item) {
			var handle = $(item).find('td.handle').get(0);
			while (handle.firstChild) {
				handle.removeChild(handle.firstChild);
			}
			
			item.toolManDragGroup.setHandle(handle);
			$(handle).addClass('handler');
		},
		
		saveOrder: function(item) {
			var group = item.toolManDragGroup;
			var order = $('#categories_order').get(0);
			group.register('dragend', function() {
				order.value = '';
				items = item.parentNode.getElementsByTagName('tr');
				
				for (var i=0; i<items.length; i++) {
					order.value += items[i].id.substr(2)+',';
				}
			});
		}
	};
	//]]>
	</script>";
}

# Affichage
adminPage::open(__('Manage categories').' - '.__('Directory'),$head);
?>
<h2 class="first"><img src="index.php?pf=directory/img/ico_link_cats.png" alt="" class="icon" /> <?php echo __('Manage categories') ?></h2>

<p> &rarr; <a href="module.php?id=directory&amp;action=3"><?php echo __('Categories') ?></a><?php 
if ($cat_id != '0')
{
	if ($cat_root != '')
		echo ' &rarr; <a href="module.php?id=directory&amp;action=3&amp;name='.$cat_root.'">...</a> &rarr; '.html::escapeHTML($cat_name);
	else
		echo ' &rarr; '.html::escapeHTML($cat_name);
}
?></p>

<h3><img src="style/img/ico_cat_new.png" alt="" class="icon" /> <?php echo __('Add').' '.($cat_id != '0' ? __('sub-category') : __('category'));?></h3>

<form action="module.php" method="post">
		<p class="field"><label for="c_titre"><?php echo __('Category title') ?></label>
		<?php echo form::field('c_titre',40,255,html::escapeHTML($c_titre)); ?>
			
		<?php echo 
		form::hidden(array('id'),'directory')."\n".
		form::hidden(array('action'),3)."\n".
		form::hidden(array('add_cat'),1)."\n".
		form::hidden(array('cat_id'),$cat_id)."\n".
		form::hidden(array('ptkn'),$puntal->getToken()); ?>
		<input type="submit" class="submit" value="<?php echo __('Add') ?>" /></p>
</form>


<h3><img src="style/img/ico_cats_list.png" alt="" class="icon" /> <?php echo ($cat_id != '0' ? __('Sub-categories') : __('Categories'));?></h3>

<?php
if ($rsCat->isEmpty()) :

	if ($cat_id != '0')
		echo '<p>'.__('No sub-category').'</p>';
	else
		echo '<p>'.__('No category').'</p>';

else : ?>
<form action="module.php" method="post" id="form-categories">
	<table class="dragable">
	<thead>
		<tr>
			<th colspan="3" class="left"><?php echo __('Category title') ?></th>
			<th class="nowrap"><?php echo __('Number of websites') ?></th>
		</tr>
	</thead>
	<tbody id="categories-list">
	
<?php
$position = 1;
while ($rsCat->fetch())
{
	$deletable = false;
	$cur_cat_nb_link = (integer) $rsCat->f('nb_lien');
	
	$rsSubCat = $dir->getCat('','cat_ord',$rsCat->f('cat_name_url'));
	$websites_link = '<a href="module.php?&amp;id=directory&amp;action=1&amp;cat_id=%s">%s</a>';
	
	switch ($cur_cat_nb_link)
	{
		case 0:
			$nb_link = __('No websites');
			break;
		case 1:
			$nb_link = sprintf($websites_link, $rsCat->f('cat_id'), __('One website'));
			break;
		default:
			$nb_link = sprintf($websites_link, $rsCat->f('cat_id'),
			sprintf(__('%s websites'),$cur_cat_nb_link));
			break;
	}
	
	if ($cur_cat_nb_link < 1 && $rsSubCat->isEmpty())
		$deletable = true;
	
	echo
	"\t\t".'<tr class="line" id="c_'.$rsCat->f('cat_id').'">'."\n".
	"\t\t\t".'<td class="handle">'.form::field(array('order['.$rsCat->f('cat_id').']'), 2, 5, $position++).'</td>'."\n".
	"\t\t\t".'<td>'.form::checkbox(array('remove[]'), $rsCat->f('cat_id'), 0, 'checkbox', !$deletable).'</td>'."\n".
	"\t\t\t".'<td class="maximal"><a href="module.php?id=directory&amp;action=3&amp;cat_id='.$rsCat->f('cat_id').'">'.html::escapeHTML($rsCat->f('cat_name')).'</a>';
	
	if (!$rsSubCat->isEmpty())
	{
		$sub_cats = array();
		echo '<br />';
		while($rsSubCat->fetch())
		{
			switch ($rsSubCat->f('nb_lien'))
			{
				case 0:
					$nb_sub_link = __('No websites');
					break;
				case 1:
					$nb_sub_link = __('One website');
					break;
				default:
					$nb_sub_link = sprintf(__('%s websites'),$rsSubCat->f('nb_lien'));
					break;
			}

			$sub_cats[] = '<a href="module.php?id=directory&amp;action=3&amp;cat_id='.$rsSubCat->f('cat_id').'">'.html::escapeHTML($rsSubCat->f('cat_name')).'</a> ('.$nb_sub_link.') ';
		}
		echo implode(" - \n", $sub_cats);
	}
	
	echo
	'</td>'."\n".
	"\t\t\t".'<td class="nowrap">'.$nb_link.'</td>'."\n\n".
	"\t\t".'</tr>'."\n\n";
	
	unset($rsSubCat);
}
?>
	</tbody>
	</table>
	
	<div class="two-cols">
		<p class="col">
		<?php echo 
		form::hidden(array('id'),'directory')."\n".
		form::hidden(array('action'),3)."\n".
		form::hidden(array('cat_id'),$cat_id)."\n".
		form::hidden(array('ptkn'),$puntal->getToken()); ?>
		<input type="hidden" id="categories_order" name="categories_order" value="" />
		<input class="submit" type="submit" name="saveorder" value="<?php echo __('Save order') ?>" />
		</p>
		
		<p class="col right">
		<input class="submit" type="submit" name="removeaction" value="<?php echo __('Delete selected categories') ?>" />
		</p>
	</div>
</form>

<?php
endif;

if ($cat_id != '0')
{
?>	
<form action="module.php" method="post" class="clearb">
	<fieldset>
		<legend><?php echo __('Edit category') ?></legend>
				
		<div class="lockable">
			<p class="field"><label for="c_edit_titre" class="float"><?php echo __('Category title') ?></label>
			<?php echo form::field('c_edit_titre',40,255,html::escapeHTML($cat_name),'lockable-from'); ?></p>
			
			<p class="field"><label for="c_edit_titre_url"><?php echo __('Category URL title') ?></label>
			<?php echo form::field('c_edit_titre_url', 40, 255, html::escapeHTML($cat_name_url),'lockable-in') ?></p>
		</div>
		
		<p class="field"><label for="c_edit_desc"><?php echo __('Category description') ?></label></p>
		<p class="area"><?php echo form::textarea('c_edit_desc', 55, 5, html::escapeHTML($cat_desc)) ?></p>
		<?php 
		require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
		$ptb = new puntoolbarSmilies($puntal);
		echo$ptb->generatePtb('c_edit_desc',false);
		?>			
		<p><?php echo 
		form::hidden(array('id'),'directory')."\n".
		form::hidden(array('action'),3)."\n".
		form::hidden(array('edit_cat'),1)."\n".
		form::hidden(array('cat_id'),$cat_id)."\n".
		form::hidden(array('ptkn'),$puntal->getToken()); ?>
		<input type="submit" class="submit" value="<?php echo __('Edit') ?>" /></p>
	</fieldset>
</form>
<?php
}

adminPage::close() ?>