<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$p_nb_entry_new = pt_mod_directory_nb_entry_new;
$p_groups = unserialize(pt_mod_directory_groups);
$p_google_pr = pt_mod_directory_google_pr;
$p_google_pr_method = pt_mod_directory_google_pr_method;
$p_google_pr_ttl = pt_mod_directory_google_pr_ttl;
$p_nb_entry_pr = pt_mod_directory_nb_entry_pr;
$p_top_cliques = pt_mod_directory_tc;
$p_nb_entry_tc = pt_mod_directory_nb_entry_tc;

/* Form sent */
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	$p_nb_entry_new = intval(trim($_POST['p_nb_entry_new']));
	$p_groups = (!empty($_POST['p_groups']) ? array_map('intval',array_map('trim',$_POST['p_groups'])) : array());
	$p_google_pr = intval(trim($_POST['p_google_pr']));
	$p_google_pr_method = intval(trim($_POST['p_google_pr_method']));
	$p_google_pr_ttl = intval(trim($_POST['p_google_pr_ttl']));
	$p_nb_entry_pr = intval(trim($_POST['p_nb_entry_pr']));
	$p_top_cliques = intval(trim($_POST['p_top_cliques']));
	$p_nb_entry_tc = intval(trim($_POST['p_nb_entry_tc']));
	
	// Mise  jour de la configuration
	$pt_settings->setNamespace('mod_directory');    
	
	$res = true;
	$res &= $pt_settings->put('pt_mod_directory_nb_entry_new', $p_nb_entry_new);
	$res &= $pt_settings->put('pt_mod_directory_groups', serialize($p_groups));
	$res &= $pt_settings->put('pt_mod_directory_google_pr', $p_google_pr);
	$res &= $pt_settings->put('pt_mod_directory_google_pr_method', $p_google_pr_method);
	$res &= $pt_settings->put('pt_mod_directory_google_pr_ttl', $p_google_pr_ttl);
	$res &= $pt_settings->put('pt_mod_directory_nb_entry_pr', $p_nb_entry_pr);
	$res &= $pt_settings->put('pt_mod_directory_tc', $p_top_cliques);
	$res &= $pt_settings->put('pt_mod_directory_nb_entry_tc', $p_nb_entry_tc);

	$pt_settings->setNamespace('');
	
	if ($res)
	{
		logIt('Directory module : edit config', 1);
		header('Location: module.php?id=directory&action=4&updated=1');
		exit;
	}
}

# Message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# Liste des groupes
$groups = punbb::getGroups();

# TTL liste
$ttl_array = array(
	__('every hour') => 1,
	__('every 6 hours') => 6, 
	__('every 12 hours') => 12, 
	__('1 time per day') => 24, 
	__('1 time every 2 days') => 48, 
	__('1 time every 3 days') => 72, 
	__('1 time per week') => 168
);

# Set token
$puntal->setToken();

# Affichage
adminPage::open(__('Configuration').' - '.__('Directory'),	
'<script type="text/javascript">'."\n".
"//<![CDATA[\n".
"$(function() {
	$('.checkboxes-helpers').each(function() {
		puntal.checkboxesHelpers(this);
	});
});".
"//]]>\n".
"</script>"."\n");
?>

<h2 class="first"><img src="index.php?pf=directory/img/ico_link_config.png" alt="" class="icon" /> <?php echo __('Directory configuration') ?></h2>
<form method="post" action="module.php" id="form-directory-config">
	<fieldset>
		<legend><?php echo __('Directory configuration') ?></legend>
		
		<p class="field"><label for="p_nb_entry_new"><?php echo __('Number of websites on the novelties') ?></label>
		<?php echo form::field('p_nb_entry_new', 2, 5, $p_nb_entry_new) ?>
		<span class="desc"><?php echo __('The number of websites to display on the novelties page (the last websites added to the directory).') ?></span></p>

		<p><span class="fakelabel"><?php echo __('Allowed groups') ?></span>
		<span class="desc"><?php echo __('The groups which can submit websites.') ?></span></p>
		<ul class="checklist">
	<?php
	while ($groups->fetch()) 
	{
		if ($groups->f('g_id') != PUN_ADMIN)
			echo '<li><label>'.form::checkbox(array('p_groups[]'),$groups->f('g_id'),in_array($groups->f('g_id'),$p_groups),'checkbox').html::escapeHTML($groups->f('g_title')).'</label></li>';
	}
	?>
		</ul>
		<p><span class="desc checkboxes-helpers"></span></p>
			
		<p><span class="fakelabel"><?php echo __('Enable Google Page Rank') ?></span>
		<label><?php echo form::radio(array('p_google_pr'), 1, $p_google_pr, 'radio').__('Yes') ?></label>
		<label><?php echo form::radio(array('p_google_pr'), 0, !$p_google_pr, 'radio').__('No') ?></label>
		<span class="desc"><?php echo __('Allows to calculate and post or not information of PageRank Google. This feature does not function on all host.') ?></span></p>
			
		<p><span class="fakelabel"><?php echo __('Google Page Rank calcul method') ?></span>
		<label><?php echo form::radio(array('p_google_pr_method'), 0, !$p_google_pr_method, 'radio').__('Method 1') ?></label>
		<label><?php echo form::radio(array('p_google_pr_method'), 1, $p_google_pr_method, 'radio').__('Method 2') ?></label>
		<span class="desc"><?php echo __('Choose the first method, if Google Page rank doesn\'t work try the second method, if still doesn\'t work your server have not the support for this so disable this feature.') ?></span></p>
	
		<p class="field"><label for="p_google_pr_ttl"><?php echo __('Check PageRank of the websites') ?></label>
		<?php echo form::combo('p_google_pr_ttl', $ttl_array, $p_google_pr_ttl) ?>
		<span class="desc"><?php echo __('Allows to define the frequency of update of PageRank of the websites.') ?></span></p>
		
		<p class="field"><label for="p_nb_entry_pr"><?php echo __('Number of websites on the Top Page Rank') ?></label>
		<?php echo form::field('p_nb_entry_pr', 2, 5, $p_nb_entry_pr) ?>
		<span class="desc"><?php echo __('The number of websites to display on the Top Page Rank page (the best PageRank of the directory).') ?></span></p>
			
		<p><span class="fakelabel"><?php echo __('Enable Top Clicks') ?></span>
		<label><?php echo form::radio(array('p_top_cliques'), 1, $p_top_cliques, 'radio').__('Yes') ?></label>
		<label><?php echo form::radio(array('p_top_cliques'), 0, !$p_top_cliques, 'radio').__('No') ?></label>
		<span class="desc"><?php echo __('Allows to enable or not the Top Click page (websites the most visited from the directory).') ?></span></p>
		
		<p class="field"><label for="p_nb_entry_tc"><?php echo __('Number of websites on the Top Clicks') ?></label>
		<?php echo form::field('p_nb_entry_tc', 2, 5, $p_nb_entry_tc) ?>
		<span class="desc"><?php echo __('The number of websites to display on the Top Click page.') ?></span></p>
	
	</fieldset>
	<p><?php echo 
	form::hidden('form_sent','1')."\n".
	form::hidden('id','directory')."\n".
	form::hidden('action',4)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Save'); ?>" /></p>
</form>
<?php adminPage::close() ?>