<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$cat_id = '0';
$status = '';
$show_filters = false;

if (!empty($_GET['cat_id']))
{
	$cat_id = $_GET['cat_id'];
	$show_filters = true;
}

if (isset($_GET['status']))
{
	$status = $_GET['status'];
	$show_filters = true;
}

function local_trim($str)
{
	$str =  str_replace('&nbsp;', '', $str);
	$str = trim($str);
	return $str;
}

$ico_bell = 'style/img/ico_bell.png';
$ico_break = 'index.php?pf=directory/img/ico_link_break.png';
$ico_off = 'style/img/off.png';
$ico_on = 'style/img/on.png';

# Tester tous les liens d'une rubrique
if (!empty($_GET['test_all']) && $cat_id != '0')
{
	if (($links = $dir->getLink('',$cat_id)) !== false && !$links->isEmpty())
	{
		$no_dead_links = true;
		
		while ($links->fetch())
		{
			if (!$dir->test_url($links->f('entry_url')))
			{
				if ($links->f('entry_state') != 1)
					$dir->setLinkStatut($links->f('entry_id'),'1');
				
				$no_dead_links &= false;
			}
			else {
				if ($links->f('entry_state') == 1)
					$dir->setLinkStatut($links->f('entry_id'),'2');
			}
		}
		
		if (!$puntal->err->hasError())
		{			
			header('Location: module.php?id=directory&action=1&cat_id='.$cat_id.'&status='.$status.'&'.($no_dead_links ? 'nodeadlinks' : 'deadlinks').'=1');
			exit;
		}
	}
}

# Modifications d'un lot
if (!empty($_POST['lot']) && !empty($_POST['sellinks']) && is_array($_POST['sellinks']))
{
	# Mise en ligne
	if ($_POST['lot'] == 'online' && $puntal->checkToken())
	{
		foreach ($_POST['sellinks'] as $v)
			$dir->setLinkStatut($v,3);
		
		if (!$puntal->err->hasError())
		{
			logIt('Directory module : put online websites '.implode(', ', $_POST['sellinks']), 2);
			header('Location: module.php?id=directory&action=1&cat_id='.$cat_id.'&status='.$status.'&onlined=1');
			exit;
		}
	}
	
	# Mise hors ligne
	if ($_POST['lot'] == 'offline' && $puntal->checkToken())
	{
		foreach ($_POST['sellinks'] as $v)
			$dir->setLinkStatut($v,2);
		
		if (!$puntal->err->hasError())
		{
			logIt('Directory module : put offline websites '.implode(', ', $_POST['sellinks']), 2);
			header('Location: module.php?id=directory&action=1&cat_id='.$cat_id.'&status='.$status.'&offlined=1');
			exit;
		}
	}
	
	# Suppression
	if ($_POST['lot'] == 'delete' && $puntal->checkToken())
	{
		foreach ($_POST['sellinks'] as $v)
			$dir->delLink($v);
		
		if (!$puntal->err->hasError())
		{
			logIt('Directory module : delete websites '.implode(', ', $_POST['sellinks']), 3);
			header('Location: module.php?id=directory&action=1&cat_id='.$cat_id.'&status='.$status.'&deleted=1');
			exit;
		}
	}
}


# Messages de confirmation
if (!empty($_GET['nodeadlinks']))
	$common_message = __('No deads links');

if (!empty($_GET['deadlinks']))
	$common_warning = __('There are deads links');

if (!empty($_GET['onlined']))
	$common_message = __('Websites put online');

if (!empty($_GET['offlined']))
	$common_message = __('Websites put offline');

if (!empty($_GET['deleted']))
	$common_message = __('Websites deleted');


/* Affichage
----------------------------------------------------------*/

# Set token
$puntal->setToken();

# Rubriques
$rsCat = $dir->getCat('','cat_ord', false);
	
# Sites en attente de validation
$waiting = $dir->getValidateLiens();
if ($waiting > 0)
{
	$common_warning = 
	'<a href="module.php?id=directory&amp;action=1&amp;status=0">'.
	sprintf(__('There are %s website(s) on standby of validation.'), $waiting).'</a>';
}

# Sites
if ($cat_id == '0')
	$links = $dir->getLink('','',$status,'entry_dt','DESC','15');
else
	$links = $dir->getLink('',$cat_id,$status,'entry_dt','DESC');

# JS
$head =
'<script type="text/javascript">'."\n".
"//<![CDATA[\n".
"function submitLinksForm(F,msg)
{
	var inputs = F.elements;
	var links_ids = new Array();
	var action;
	
	var i = 0;
	for (i=0; i<inputs.length; i++)
	{
		if (inputs[i].name == 'sellinks[]') {
			links_ids.push(inputs[i]);
		}
		
		if (inputs[i].name == 'lot') {
			action = inputs[i].value;
		}
	}
	
	var selectfields = 0;
	for (i=0; i<links_ids.length; i++) {
		selectfields += links_ids[i].checked;
	}
	
	if (selectfields == 0) {
		return false;
	}
	
	if (action == 'delete') {
		return window.confirm(msg);
	}
	
	return true;
}

$(function() {
	$('.checkboxes-helpers').each(function() {
		puntal.checkboxesHelpers(this);
	});
});

//]]>
</script>";

if (!$show_filters)
	$head .= adminPage::jsLoad('js/filter-controls.js');

# Start page
adminPage::open(__('List of websites').' - '.__('Directory'),$head);

?>
<h2 class="first"><img src="index.php?pf=directory/img/ico_link.png" alt="" class="icon" /> <?php echo __('List of websites') ?></h2>

<?php
if ($rsCat->isEmpty())
	echo '<p><a href="module.php?id=directory&amp;action=3">'.__('No category').'</a></p>'."\n";
	
else {
	$arryCat['&nbsp;'] = NULL;
	$dir->getListCat($rsCat,$arryCat,'',$rsCat->int_index);
	
	$arryState['&nbsp;'] = NULL;
	$arryState[__('Standby of validation')] = '0';
	$arryState[__('Deads links')] = '1';
	$arryState[__('Offline')] = '2';
	$arryState[__('Online')] = '3';

# Filtres
if (!$show_filters)
	echo '<p><a id="filter-control" class="form-control" href="#">'.__('Filters').'</a></p>';
?>	

<form action="module.php" method="get" id="filters-form">
	<fieldset>
		<legend><?php echo __('Filters') ?></legend>
		<div class="three-cols">
			<p class="col"><label for="cat_id"><?php echo __('Category') ?>
			<?php echo form::combo('cat_id',$arryCat,$cat_id); ?></label></p>
			<p class="col"><label for="status"><?php echo __('Status') ?>
			<?php echo form::combo('status',$arryState,$status); ?></label></p>
			<p class="col"><?php echo 
			form::hidden(array('id'),'directory')."\n".
			form::hidden(array('action'),1)."\n"; ?>
			<input class="submit" value="<?php echo __('Display') ?>" type="submit" /></p>
		</div>
	</fieldset>
</form>

<hr class="clearer" />

<?php
	if ($links->isEmpty())
	{
		echo '<p class="clearb">'.__('There is no websites.').'</p>'."\n";
	}
	else {
		unset($arryCat['&nbsp;']);
		$arryCat = array_flip($arryCat);
		$arryCat = array_map('local_trim', $arryCat);
		
		unset($arryState['&nbsp;']);
		$arryState = array_flip($arryState);
		
		if ($cat_id == '0' && $status == '')
			echo '<p class="clearb">'.__('Last websites added').'</p>';
		
		else {
			if ($cat_id != '0')
				echo '<p class="clearb">'.__('Category').' <em>'.$arryCat[$cat_id].'</em> - <a href="module.php?id=directory&amp;action=1&amp;cat_id='.$cat_id.'&amp;test_all=1">'.__('Check links in this category').'</a></p>';
				
			if ($status != '')
				echo '<p class="clearb">'.__('Status').' <em>'.$arryState[$status].'</em></p>';
		}
?>
<form class="clearb" action="module.php" method="post" id="form-links-list" onsubmit="return submitLinksForm(this,'<?php echo html::escapeJS(__('Are you sure you want to delete the selected websites?')) ?>');">
	<table>
		<thead>
			<tr>
				<th colspan="2" class="nowrap left" scope="col"><?php echo __('Title') ?></th>
				<th class="nowrap center" scope="col"><?php echo __('Status') ?></th>
			</tr>
		</thead>
		<tbody>
<?php	# Boucle sur la liste des sites
		while ($links->fetch())
		{
			$link_img = '';
			$link_selected = '';
			
			$cur_link_state = $links->f('entry_state');
			
			if ($cur_link_state == 0)
				$link_img = '<img src="'.$ico_bell.'" alt="'.__('Standby of validation').'" class="icon" />';				
			
			elseif ($cur_link_state == 1)
				$link_img = '<img src="'.$ico_break.'" alt="'.__('Dead link').'" class="icon" />';
			
			elseif ($cur_link_state == 2)
				$link_img = '<img src="'.$ico_off.'" alt="'.__('This website is offline').'" class="icon" />';
			
			elseif ($cur_link_state == 3)
				$link_img = '<img src="'.$ico_on.'" alt="'.__('This website is online').'" class="icon" />';
			
			if ($links->f('entry_selected') == 1)
				$link_selected = '<img src="style/img/ico_rosette.png" alt="'.__('This website is selected').'" class="icon" />';
						
			echo
			'<tr class="line" id="c_'.$links->f('entry_id').'">'.
			'<td scope="row">'.form::checkbox(array('sellinks[]'),$links->f('entry_id'),0,'checkbox').'</td>'.
			'<td class="maximal"><a href="module.php?id=directory&amp;action=2&amp;wid='.$links->f('entry_id').'">'.html::escapeHTML($links->f('entry_name')).'</a></td>'.
			'<td class="center">'.$link_selected.$link_img.'</td>'.
			'</tr>';
		}
?>
		</tbody>
	</table>
	<div class="two-cols">
		<p class="col checkboxes-helpers"></p>
		<p class="col right">
		<?php echo 
			form::hidden(array('id'),'directory')."\n".
			form::hidden(array('action'),1)."\n".
			form::hidden(array('cat_id'),$cat_id)."\n".
			form::hidden(array('status'),$status)."\n".
			form::hidden(array('ptkn'),$puntal->getToken());  ?>
			<label for="lot"><?php echo __('For the selected websites:') ?></label>
			<?php echo form::combo('lot', array(__('Online')=>'online',__('Offline')=>'offline',__('Delete')=>'delete')) ?>
			<input class="submit" type="submit" value="<?php echo __('ok') ?>" />
		</p>
	</div>
</form>
<p><?php echo __('Icons legend:') ?></p>
<ul>
	<li><img src="<?php echo $ico_on ?>" alt="" class="icon" /> <?php echo __('Online') ?></li>
	<li><img src="<?php echo $ico_off ?>" alt="" class="icon" /> <?php echo __('Offline') ?></li>
	<li><img src="<?php echo $ico_bell ?>" alt="" class="icon" /> <?php echo __('Standby of validation') ?></li>
	<li><img src="<?php echo $ico_break ?>" alt="" class="icon" /> <?php echo __('Deads links') ?></li>
</ul>
<?php
	}
}
adminPage::close() ?>