<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


$wid = (!empty($_REQUEST['wid']) && intval($_REQUEST['wid']) > 0) ? intval($_REQUEST['wid']) : null;
$titre_page = $wid ? __('Edit website') : __('Add website');

# initialisations
if ($wid)
{
	$link = $dir->getLink($wid);
	
	$l_titre = $link->f('entry_name');
	$l_cat = $link->f('entry_category');
	$l_href = $link->f('entry_url');
	$l_desc = $link->f('entry_description');
	$l_date = $link->f('entry_dt');
	$l_lang = $link->f('entry_lang');
	$l_statut = $link->f('entry_state');
	$l_selected = $link->f('entry_selected');
}
else {
	$l_titre = '';
	$l_cat = '';
	$l_href = 'http://';
	$l_desc = '';
	$l_date = '';
	$l_lang = '';
	$l_statut = 2;
	$l_selected = 0;
}

# Ajout/modification d'un site
if (!empty($_POST['sended']) && $puntal->checkToken())
{
	$l_titre = trim($_POST['l_titre']);
	$l_href = trim($_POST['l_href']);
	$l_cat = trim($_POST['l_cat']);
	$l_desc = trim($_POST['l_desc']);
	$l_date = trim($_POST['l_date']);
	$l_lang = trim($_POST['l_lang']);
	$l_statut = trim($_POST['l_statut']);
	$l_selected = trim($_POST['l_selected']);
	
	// Modification
	if ($wid)
	{
		if ($dir->setLink($l_titre,$l_href,$l_date,$l_statut,$l_cat,$l_desc,$l_lang,$l_selected,$wid) !== false)
		{
			header('Location: module.php?id=directory&action=2&wid='.$wid.'&added=1');
			exit;
		}
	}
	// Ajout
	else {
		if (($entry_id = $dir->setLink($l_titre,$l_href,$l_date,$l_statut,$l_cat,$l_desc,$l_lang,$l_selected)) !== false)
		{
			header('Location: module.php?id=directory&action=2&wid='.$entry_id.'&edited=1');
			exit;
		}
	}
}

# Messages de confirmation
if (!empty($_GET['added']))
	$common_message = __('Website edited');

if (!empty($_GET['edited']))
	$common_message = __('Website added');


/* Affichage
------------------------------------------------------------*/

# Set token
$puntal->setToken();

# Rubriques
$rsCat = $dir->getCat('','cat_ord', false);
if (!$rsCat->isEmpty())
{
	$arryCat = array();
	$dir->getListCat($rsCat,$arryCat,'',$rsCat->int_index);
	
	$head =
	'<script type="text/javascript">'."\n".
	"//<![CDATA[\n".
	"chainHandler(window,'onload',function() {
		if (!document.getElementById) { return; }
					
		var post_dtPick = new datePicker(document.getElementById('l_date'));
		post_dtPick.img_top = '1.8em';
		post_dtPick.draw();
	});
	//]]>
	</script>\n".
	adminPage::jsDatePicker();
}
else
	$head = '';

$arryState = array();
$arryState[__('Standby of validation')] = '0';
$arryState[__('Deads links')] = '1';
$arryState[__('Offline')] = '2';
$arryState[__('Online')] = '3';

adminPage::open($titre_page.' - '.__('Directory'), $head);
?>

<h2 class="first"><img src="index.php?pf=directory/img/ico_link_cats.png" alt="" class="icon" /> <?php echo $titre_page ?></h2>

<?php # Est-ce qu'il y a des rubriques ?
if ($rsCat->isEmpty())
	echo '<p><a href="module.php?id=directory&amp;action=3">'.__('No category').'</a></p>'."\n";

else {
?>
<form action="module.php" method="post">

	<p class="field"><label for="l_titre"><?php echo __('Website name') ?></label>
	<?php echo form::field('l_titre', 50, 255, html::escapeHTML($l_titre)); ?></p>
	
	<p class="field"><label for="l_href"><?php echo __('<acronym title="Uniform Resource Locator">URL</acronym>') ?></label>
	<?php echo form::field('l_href', 50, 255, html::escapeHTML($l_href)); ?></p>

	<div class="two-cols">	
		<p class="field col"><label for="l_cat">Rubrique : </label>
		<?php echo form::combo('l_cat', $arryCat, $l_cat); ?></p>
	
		<p class="field col"><label for="l_statut">Statut</label>
		<?php echo form::combo('l_statut',$arryState,$l_statut); ?></p>
	</div>

	<p class="field clearb"><label for="l_desc"><?php echo __('Description') ?></label></p>
	<p class="area"><?php echo form::textarea('l_desc', 55, 10, html::escapeHTML($l_desc)) ?></p>
	<?php 
	require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
	$ptb = new puntoolbarSmilies($puntal);
	echo $ptb->generatePtb('l_desc',false);
	?>	
	<div class="two-cols">	
		<p class="field col"><label for="l_date"><?php echo __('Date') ?></label>
		<?php echo form::field('l_date', 10, 10, html::escapeHTML($l_date)) ?></p>
		
		<p class="field col"><label for="l_lang"><?php echo __('Website language') ?></label>
		<?php echo form::field('l_lang', 5, 5, html::escapeHTML($l_lang)); ?></p>
	</div>
	
	<p><span class="fakelabel"><?php echo __('Put this website on selected ones') ?></span>
	<label><?php echo form::radio(array('l_selected'), 1, $l_selected, 'radio').__('Yes'); ?></label>
	<label><?php echo form::radio(array('l_selected'), 0, !$l_selected, 'radio').__('No') ?></label></p>
	
	<p><?php echo 
	form::hidden(array('id'),'directory')."\n".
	form::hidden(array('action'),2)."\n".
	form::hidden(array('sended'),1)."\n".
	form::hidden(array('wid'),$wid)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input type="submit" class="submit" value="<?php echo __('Save') ?>" /></p>

</form>

<?php
}

adminPage::close(); ?>