<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
@function uninstall_directory

La fonction charge de la dsinstallation du module directory.
*/
function uninstall_directory()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	# Supression de la table 'pt_dir_categorie'
	$db_scheme[] = array(
		'action' 	=> 'delete',
		'table' 	=> DB_PREFIX.'pt_dir_categorie',
		'query' 	=> 'DROP TABLE '.DB_PREFIX.'pt_dir_categorie'
	);
	
	# Supression de la table 'pt_dir_entrie'
	$db_scheme[] = array(
		'action' 	=> 'delete',
		'table' 	=> DB_PREFIX.'pt_dir_entrie',
		'query' 	=> 'DROP TABLE '.DB_PREFIX.'pt_dir_entrie'
	);	
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'delete',
		'name'	 	=> 'pt_mod_directory_groups'
	);
		
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_directory_google_pr'
	);
		
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_directory_google_pr_method'
	);
	
	$params[] = array(
		'action'	=> 'delete',
		'name'	 	=> 'pt_mod_directory_google_pr_ttl'
	);
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_directory_nb_entry_pr'
	);
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_directory_tc'
	);
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_directory_nb_entry_tc'
	);
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_directory_nb_entry_new'
	);
	
	/* Rpertoire cache pour le page rank google
	----------------------------------------------------------*/
	$dirs = array();
	$dirs[] = PT_CACHE_PATH.'directory_google_pr';
	
	
	/* Dsinstallation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->uninstall($db_scheme,$params,$dirs);
}


?>