<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/*
 1 : list
 2 : post
 3 : cat
 4 : cats
 5 : config
*/

# Menu downloads
if (pt_mod_downloads && checkPerm('mod_downloads'))
{
	$on_downloads = ($module_id == 'downloads') ? true : false;
	
	$menu->newMenu('downloads',__('Downloads'));
	
	$menu->addItem('downloads',
				__('Downloads list'),
				'module.php?id=downloads&amp;action=1',
				($on_downloads && $action == 1)
	);
	
	$menu->addItem('downloads',
				__('Add'),
				'module.php?id=downloads&amp;action=2',
				($on_downloads && $action == 2)
	);
	
	$menu->addItem('downloads',
				__('Categories'),
				'module.php?id=downloads&amp;action=4',
				($on_downloads && ($action == 3 || $action == 4))
	);
	
	$menu->addItem('downloads',
				__('Configuration'),
				'module.php?id=downloads&amp;action=5',
				($on_downloads && $action == 5)
	);
}


class downloadsAdminBlocks
{
	/**
	@function topDownloads
	
	Gestion du bloc top tlchargements
	*/
	function topDownloads()
	{
		global $puntal, $pt_settings;
		
		$p_num = pt_bloc_downloads_top_num;
		
		if (!empty($_POST['form_sent']))
		{
			$p_num = intval(trim($_POST['p_num']));
			if ($p_num < 1 || $p_num > 50)
				$p_num = 5;
		
			$pt_settings->setNamespace('mod_downloads');
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_downloads_top_num', $p_num);
			
			$pt_settings->setNamespace('');
		
			if ($res)
			{
				logIt("Config top_downloads block", 1);
				header('Location: bloc.php?id=top_downloads&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
						
		# Affichage
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_top_downloads')));
?>
	<h2 class="first"><img src="style/img/ico_disk_multiple.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_top_downloads')) ?></span></h2>
	
	<form method="post" action="bloc.php">
		<fieldset>
			<legend><?php echo __('bloc_top_downloads') ?></legend>
		
			<p class="field"><label for="p_num"><?php echo __('Number of downloads in the top'); ?></label>
			<?php echo form::field('p_num', 5, 25, $p_num) ?>
			<span class="desc"><?php echo __('The number of downloads to display on the block (between 1 to 50)'); ?></span></p>
		</fieldset>
		<p><?php echo 
		form::hidden('form_sent', '1')."\n".
		form::hidden('id', 'top_downloads') ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	</form>
<?php
		adminPage::close();
	}


	/**
	@function listDownloads
	
	Gestion du bloc liste des tlchargements
	*/
	function listDownloads()
	{
		global $puntal, $pt_settings;
		
		$p_num = pt_bloc_downloads_num;
		
		if (!empty($_POST['form_sent']))
		{
			$p_num = intval(trim($_POST['p_num']));
			if ($p_num < 1 || $p_num > 50)
				$p_num = 5;
		
			$pt_settings->setNamespace('mod_downloads');
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_downloads_num', $p_num);
			
			$pt_settings->setNamespace('');
		
			if ($res)
			{
				logIt("Config downloads block", 1);
				header('Location: bloc.php?id=downloads&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
						
		# Affichage
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_downloads_list')));
?>
	<h2 class="first"><img src="style/img/ico_disk_multiple.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_downloads_list')) ?></span></h2>
	
	<form method="post" action="bloc.php">
		<fieldset>
			<legend><?php echo __('bloc_downloads_list') ?></legend>
		
			<p class="field"><label for="p_num"><?php echo __('Number of downloads displayed in the bloc'); ?></label>
			<?php echo form::field('p_num', 5, 25, $p_num) ?>
			<span class="desc"><?php echo __('The number of downloads to display on the block (between 1 to 50)'); ?></span></p>
		</fieldset>
		<p><?php echo 
		form::hidden('form_sent', '1')."\n".
		form::hidden('id', 'downloads') ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	</form>
<?php
		adminPage::close();
	}
}


?>