<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

# URLs configuration
define('DOWNLOAD_URL', 'downloads');
define('DOWNLOAD_URL_DL', 'download');
define('DOWNLOAD_URL_RSS', 'rss');
define('DOWNLOAD_URL_POPULAR', 'populars');
define('DOWNLOAD_URL_LATEST', 'latest');

# Par exemple en franais :
// define('DOWNLOAD_URL', 'telechargements');
// define('DOWNLOAD_URL_DL', 'telecharge');
// define('DOWNLOAD_URL_RSS', 'rss');
// define('DOWNLOAD_URL_POPULAR', 'populaires');
// define('DOWNLOAD_URL_LATEST', 'derniers');


#########################################################################

# Enregistrement des modles d'URLs du module
$GLOBALS['puntal']->registerURL('downloads', pt_portal_url.DOWNLOAD_URL.'/');
$GLOBALS['puntal']->registerURL('downloads_file', pt_portal_url.DOWNLOAD_URL.'/%s/'.DOWNLOAD_URL_DL.'/');
$GLOBALS['puntal']->registerURL('downloads_rss', pt_portal_url.DOWNLOAD_URL.'/'.DOWNLOAD_URL_RSS.'/');
$GLOBALS['puntal']->registerURL('downloads_rss_popular', pt_portal_url.DOWNLOAD_URL.'/'.DOWNLOAD_URL_RSS.'/'.DOWNLOAD_URL_POPULAR.'/');
$GLOBALS['puntal']->registerURL('downloads_rss_latest', pt_portal_url.DOWNLOAD_URL.'/'.DOWNLOAD_URL_RSS.'/'.DOWNLOAD_URL_LATEST.'/');


$GLOBALS['puntal']->blocks->registerBlock('downloads',
	array('downloadsPublicBlocks','listDownloads'),
	array('downloadsAdminBlocks','listDownloads'));

$GLOBALS['puntal']->blocks->registerBlock('top_downloads',
	array('downloadsPublicBlocks','topDownloads'),
	array('downloadsAdminBlocks','topDownloads'));
    

# Recherche sur les downloads
$GLOBALS['puntal']->addBehavior('searchPerform', array('downloadsBehavior','performSearch'));
	
# Rsultats de recherche
$GLOBALS['puntal']->addBehavior('searchResults', array('downloadsBehavior','searchResults'));

# Affiche le nombre de Rsultats de recherche
$GLOBALS['puntal']->addBehavior('searchResultsTtl', array('downloadsBehavior','searchResultsTtl'));


class downloadsBehavior
{

	function performSearch()
	{
		global $puntal;
		
		if (file_exists(PT_THEMES_PATH.pt_theme.'/downloads/downloads.css'))
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.pt_theme.'/downloads/downloads.css'.'" />';
		else
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.PT_DEFAULT_THEME.'/downloads/downloads.css'.'" />';
				
		require dirname(__FILE__).'/inc/download.class.php';
		$downloads = new downloadManager($puntal);
		
		#la recherche est-elle vide ?
		if (strlen(trim($_GET['q'])) > 2 )	  				
			$GLOBALS['downloads_list'] = $downloads->searchEntry($_GET['q'], pt_mod_search_num_per_page );
	}
	
	
	function searchResults()
	{
		global $downloads_list;
		
		#on teste que $downloads_list existe ET qu'il n'est pas vide 
		if ($downloads_list and !$downloads_list->isEmpty())
		{
			require dirname(__FILE__).'/inc/tpl_functions.php';
			
			if (file_exists(PT_THEMES_PATH.pt_theme.'/downloads/search_results.php'))
				require PT_THEMES_PATH.pt_theme.'/downloads/search_results.php';
			else
				require PT_THEMES_PATH.PT_DEFAULT_THEME.'/downloads/search_results.php';
		}
	}
	
	function searchResultsTtl() {
		global $downloads_list;
		
		if ($downloads_list and !$downloads_list->isEmpty()) {		
			$GLOBALS['search_ttl'] += $downloads_list->nbRow();
			return $GLOBALS['search_ttl'];			
		}		
	}	
}

?>