<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/




if (!defined('PUNTAL')) exit;

#all the define constantes are in _prepend.php file

class downloadsPublicBlocks
{
	/**
	@function topDownloads
	
	Affiche le bloc top tlchargemens
	*/
	function topDownloads()
	{
		global $puntal;
		if (pt_mod_downloads) {	
			$cur_file = $puntal->con->select("SELECT id, dl_name, dl_filename, dl_count, cat_id FROM ".DB_PREFIX."pt_downloads WHERE dl_enable = '2' AND dl_home = '1' ORDER BY dl_count DESC LIMIT ".pt_bloc_downloads_top_num) or $puntal->err->fatalError('Impossible de rcuprer la liste des fichiers', $puntal->con->error());
			
			if (!$cur_file->isEmpty())
			{
				startBloc(sprintf(__('Top %s downloads'), pt_bloc_downloads_top_num), 'top_downloads');
				echo "\t\t\t\t".'<ul>'."\n";
				
				while ($cur_file->fetch())
				{ 
					$file_links = '';
					
					if (file_exists(PUNTAL_ROOT . pt_mod_downloads_path .'/'. $cur_file->f('dl_filename')))
						$file_links .= '<a href="'.pt_portal_url.'downloads/'.$cur_file->f('id').'" title="'.sprintf(__('Download %s file'), $cur_file->f('dl_name')).'">'. $cur_file->f('dl_name').'</a> ';
		
						
					if ((pt_mod_downloads_guest == 0 && $puntal->user['is_guest']) || ($file_links == ''))
						echo "\t\t\t".'<li>'.$cur_file->f('dl_name').' ('.$cur_file->f('dl_count').')</li>'."\n";
					else
						echo "\t\t\t".'<li>'.$file_links.' ('.$cur_file->f('dl_count').') </li>'."\n";
				}
				
				echo "\t\t\t\t".'</ul>'."\n";
				endBloc();
			}
		}
	}

	/**
	@function listDownloads
	
	Affiche le bloc liste des tlchargemens
	*/
	function listDownloads()
	{
		global $puntal;
		if (pt_mod_downloads) {
			$cur_file = $puntal->con->select("SELECT id, dl_name, dl_filename, dl_count, cat_id FROM ".DB_PREFIX."pt_downloads WHERE dl_enable = '2' AND dl_home = '1' ORDER BY dl_date DESC LIMIT ".pt_bloc_downloads_num) or $puntal->err->fatalError('Impossible de rcuprer la liste des fichiers', $puntal->con->error());
			
			if (!$cur_file->isEmpty())
			{
				startBloc(sprintf(__('Downloads'), pt_bloc_downloads_num), 'downloads_list');
				echo "\t\t\t\t".'<ul>'."\n";
				
				while ($cur_file->fetch())
				{ 
					$file_links = '';
					
					if (file_exists(PUNTAL_ROOT . pt_mod_downloads_path .'/'. $cur_file->f('dl_filename')))
						$file_links .= '<a href="'.pt_portal_url.'downloads/'.$cur_file->f('id').'" title="'.sprintf(__('Download %s file'), $cur_file->f('dl_name')).'">'. $cur_file->f('dl_name').'</a> ';
		
						
					if ((pt_mod_downloads_guest == 0 && $puntal->user['is_guest']) || ($file_links == ''))
						echo "\t\t\t".'<li>'.$cur_file->f('dl_name').' ('.$cur_file->f('dl_count').')</li>'."\n";
					else
						echo "\t\t\t".'<li>'.$file_links.' ('.$cur_file->f('dl_count').') </li>'."\n";
				}
				
				echo "\t\t\t\t".'</ul>'."\n";
				endBloc();
			}
		}
	}



}

?>