<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$p_id = (!empty($_REQUEST['pid']) && intval($_REQUEST['pid']) > 0) ? intval($_REQUEST['pid']) : '';

# Nouveau download
if ($p_id == '')
{
	$p_name 	= '';
	$p_filename = '';
	$p_cat_id 	= '';
	$p_enable 	= 1;
	$p_desc 	= '';
	$p_count 	= 0;
	$p_disp 	= 0;
	$p_date 	= '';
	$p_home 	= 0;
	$p_welcome 	= 0;
	#id pour le forum.
	$p_post_id 	= 0;
	$p_topic_id = 0;
	
	$title = __('Add a download');
	$buton = __('Add');
	
	// get the files (in the directory) where the downloads are stored ...
	$filenames = $downloads->getDir();
	$filename_array = array();
	
	// ... and get the downloads that are already defined in the database
	$downloads_files = $downloads->getDownloads();
	$downloads_files_array = array();
	while ($downloads_files->fetch()) {
		$downloads_files_array[] = $downloads_files->f('dl_filename'); 
	} 

	// then compare them and get the filename of the file that are not yet in the database
	$new_filenames = array_diff($filenames,$downloads_files_array);
	
	if (empty($new_filenames) ) 
		$filename_array[__('All files have a defined download')]= '';
	else {
		$filename_array[__('&lt; Select a file &gt;')]= ''; 
		foreach ($new_filenames as $file => $filename)
			$filename_array[$filename] = $filename;
	}
	$filename_array[__('Fake file')]= 'fake';
}
# Modification d'un download
else {
	$download = $downloads->getDownload($p_id);
	
	$p_name 	= $download->f('dl_name');
	$p_filename = $download->f('dl_filename');
	$p_cat_id 	= $download->f('cat_id');
	$p_enable 	= $download->f('dl_enable');
	$p_desc 	= $download->f('dl_desc');
	$p_count 	= $download->f('dl_count');
	$p_date 	= $download->f('dl_date');
	$p_disp 	= $download->f('dl_disp');	
	$p_home 	= $download->f('dl_home');
	$p_welcome 	= $download->f('dl_welcome');
	
	$p_topic_id = $download->f('dl_tid');
	$p_post_id 	= $download->f('dl_pid');
	
	$title = __('Edit a download');
	$buton = __('Edit');
	
	// recuperation du nom du fichier pour comparer avec la liste des fichiers
	$filename_selected = $downloads->getFileName($p_id);

	# Liste des fichiers du repertoire de tlchargement
	$filenames = $downloads->getDir();
	
	$filename_array		= array();
	// premiere ligne des options vide 
	$filename_array[''] = '';
	$selected 			= '';
	
	for ($i=0;$i<count($filenames);$i++)
	{
		if ($selected == '') 
			$filename_selected->f('dl_filename') == $filenames[$i] ? $selected = 'selected' : $selected = '';
			
		$filename_array[$filenames[$i]] = $filenames[$i];
	}
	$filename_array[__('Fake file')]= 'fake';
}

# Formulaire envoy
if (!empty($_POST['publish']) || !empty($_POST['preview']) && $puntal->checkToken())
{
	$p_name 	= trim($_POST['p_name']);
	$p_filename = trim($_POST['p_filename']);
	$p_cat_id 	= intval($_POST['p_cat_id']);
	$p_enable 	= intval($_POST['p_enable']);
	$p_desc 	= trim($_POST['p_desc']);
	$p_count	= trim($_POST['p_count']);
	#fix a IE bug which put the date and time in the field 
    #so we cut the date at 10 char and work with it
    $p_date 	= substr($_POST['p_date'],0,10);	
	$p_home 	= intval($_POST['p_home']);
	$p_welcome 	= intval($_POST['p_welcome']);
	
	$p_topic_id = intval($_POST['dl_tid']);
	$p_post_id 	= intval($_POST['dl_pid']);	
			
	if (empty($p_name))
		$puntal->err->setError(__('You must give a name for the download.'));
	
	if (empty($p_filename))
		$puntal->err->setError(__('You must choose a filename for the download.'));
	
	if (empty($p_desc))
		$puntal->err->setError(__('You must give a description for the download.'));
	
	if ($p_date == '')
		$puntal->err->setError(__('You must give a date for the download.'));		
	else {
		list($d_y,$d_m,$d_d) = split("[/.-]",$p_date);
		if (checkdate($d_m,$d_d,$d_y) == false)
			$puntal->err->setError(__('Invalid date - the date must be in YYYY-MM-DD form (Year-Month-Day).'));
}

/***********************************************************************
Description 

[fr]
ajout d'un tlchargement dans puntal :

on va crer un post dans le forum (si dcid par l'utilisateur) 
 partir de la description donne dans le formulaire et creation 
d'un lien pour acceder  la page de tlchargement concerne, 
ceci se fait comme suit :

	1) ajout du download dans la base 
	2) recuperation de l'id du telechargement ajout
	3) constitution de la string du href vers le telechargement ajout
	4) creation du topic dans le forum avec le sujet du tlchargement 
	+ la string "href" constitu au point 3 + description.

[en]
adding a download in puntal :

we're going to create a post in the forum (if the user decides it) 
from the description we gave in the form and then creation of a link 
to be able to acces to the download page which is concerned,
this is done like that :

	1) add a downlod to the database
	2) get the id of the added download 
	3) creation of the string of the href to the added download
	4) creation of the topic in the forum with the subject of the 
	download + the building "href" string + description

************************************************************************/

	# pas d'erreur et publication
	if (!$puntal->err->hasError() && !empty($_POST['publish']))
	{
		/* 1) 
			[fr]ajout du download dans la base 		
			[en]add a downlod to the database
		*/
		
		/* 2)
			[fr]recuperation de l'id du telechargement ajout
			[en]get the id of the added download 
		*/
		if (($ret_id = $downloads->setDownload($p_id,$p_name,$p_filename,$p_desc,$p_count,$p_date,$p_cat_id,$p_disp,$p_home,$p_enable,$p_welcome,$p_topic_id,$p_post_id )) !== false)
		{
			
			if ($p_enable == '2') {
				$t_infos = array('tid' => 0, 'pid' => 0);
	
				if (!$puntal->err->hasError() && pt_mod_downloads_forum_id > 0)
				{
					/* 3) 
						[fr]constitution de la string du href vers le telechargement ajout
						[en]creation of the string of the href to the added download
					*/
					$str = "\n".'[url='.puntal::getHost().$puntal->url('downloads') . $ret_id . ']'.__('Download').'[/url]'."\n\n";
				                                                   
					/* 4)
						[fr]creation du topic dans le forum avec le sujet du tlchargement
						 + la string "href" constitu au point 3 + description.
						[en]creation of the topic in the forum with the subject of the download
						 + the building "href" string + description
					*/
					
					if ($p_id == 0) {
						$t_infos = punbb::newTopic(pt_mod_downloads_forum_id,$p_name,$p_desc.$str,true,false,false,'','',true);
						$downloads->setDownload($ret_id,$p_name,$p_filename,$p_desc,$p_count,$p_date,$p_cat_id,$p_disp,$p_home,$p_enable,$p_welcome, $t_infos['tid'], $t_infos['pid']  );
					}
	
					/**
					 * modification d'un Download
					 */
					else {
					/* 5)
					  [fr] on verifie que le topic existe dj, si par mgarde le post avait t supprim entre temps ...
					  [en] if the topic already exists, if we have removed the post in the forum in the same time
					*/
	
						if ( punbb::checkPostTopic($p_post_id,$p_topic_id) === true) {
							/**
							 * [fr] on le met  jour
							 * [en] we update it
							 */
							punbb::editPost($p_post_id,$p_desc.$str,$p_name);
							$downloads->setDownload($ret_id,$p_name,$p_filename,$p_desc,$p_count,$p_date,$p_cat_id,$p_disp,$p_home,$p_enable,$p_welcome, $p_topic_id, $p_post_id  );
						} else {
							/**
							 * [fr] on recree le post disparu
							 * [en] we rebuild the removed post
							*/
							$t_infos = punbb::newTopic(pt_mod_downloads_forum_id,$p_name,$p_desc.$str,true,false,false,'','',true);
							$downloads->setDownload($ret_id,$p_name,$p_filename,$p_desc,$p_count,$p_date,$p_cat_id,$p_disp,$p_home,$p_enable,$p_welcome, $t_infos['tid'], $t_infos['pid']  );
							
						}
					}
				}
			}
			header('Location: module.php?id=downloads&action=2&pid='.$ret_id.'&'.($p_id==''?'added':'edited').'=1');
			exit;
		}
	}
}

	
# Messages de confirmation
if (!empty($_GET['added']))
	$common_message = __('Download added.');

if (!empty($_GET['edited']))
	$common_message = __('Download edited.');


# Set token
$puntal->setToken();

# Liste des catgories
$cats = $downloads->getCat();

if (!$cats->isEmpty())
{
	$cats_array = array();
	while ($cats->fetch())
		$cats_array[$cats->f('dl_cat_name')] = $cats->f('id');

	$head =
	'<script type="text/javascript">'."\n".
	"//<![CDATA[\n".
	"chainHandler(window,'onload',function() {
		if (!document.getElementById) { return; }
		
		
		var post_dtPick = new datePicker(document.getElementById('p_date'));
		post_dtPick.img_top = '1.8em';
		post_dtPick.draw();
		
	});
	//]]>
	</script>\n".
	adminPage::jsDatePicker();
}
else
	$head = '';

adminPage::open($title.' - '.__('Downloads'),$head);
?>
<h2 class="first"><img src="index.php?pf=downloads/img/ico_downloads_edit.png" alt="" class="icon" /> <?php echo $title ?></h2>

<?php # Nous voulons au moins une catgorie
if ($cats->isEmpty()) :
	echo '<p><a href="module.php?id=downloads&amp;action=4">'.__('No category').'</a></p>';
else : ?>

<?php # Prvisualisation
if (!empty($p_name) && !empty($p_desc))
{
	$filesize = '';
	# on ne calcul pas la taille de fichiers "distants"
	if ($p_filename != 'fake' ){	
		// calculate the size of the file to download and display it
		$size = @filesize($_SERVER['DOCUMENT_ROOT'].pt_portal_path.pt_mod_downloads_path.'/'.$p_filename);
		$i=0;
		$iec = array("B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB");
		while (($size/1024)>1)
		{
			$size=$size/1024;
			$i++;
		}
		$filesize = substr($size,0,strpos($size,'.')+4).$iec[$i];
	}
	
	require_once PT_INC_PATH."libs/punbb_parser.php";
	echo 
	
	'<div id="previewbox">'.
	
	'<h3>'.html::escapeHTML($p_name).'</h3>'.

	parse_message($p_desc,false).'<br />'."\n".	
	'.: '.__('Last release').' <strong>'.dt::str(pt_date_format, strtotime($p_date)).'</strong>'.
	' - '.$filesize.' - '.
	'<em>'.sprintf(__('Downloaded %s times'),'<strong>'.$p_count.'</strong>').'</em> :. '.
	'</div>'."\n";
}
?>
<form action="module.php" id="downloads" method="post">
	
	<p class="field"><label for="p_name"><?php echo __('Download name') ?></label>
	<?php echo form::field('p_name', 50, 255, html::escapeHTML($p_name)) ?></p>
	
	<p class="field"><label for="p_filename"><?php echo __('Download filename') ?></label>
	<?php echo form::combo('p_filename', $filename_array, $p_filename, 'p_filename'); ?>
	<span class="desc"><?php echo __('If you want to add \'external\' files that are hosting somewhere else select here \'Fake file\' and, <br/> then add yourselves the URL in the description on the downloads by using the BBCode [url=http://my_non_local_files]Downloads my file[/url],<br/> then no control will be done by this way.<br/><strong>WARNING:</strong><br/> Be sure you have the autorisation of the owner of the file !') ?></span>	
	</p>

	<div class="two-cols">
		<p class="field col"><label for="p_cat_id"><?php echo __('Category') ?></label>
		<?php echo form::combo('p_cat_id', $cats_array, $p_cat_id) ?></p>
		
		<p class="field col"><label for="p_enable"><?php echo __('Status') ?></label>
		<?php echo form::combo('p_enable', array(__('Offline')=>1,__('Online')=>2), $p_enable) ?></p>
	</div>

	<p class="field clearb"><label for="p_desc"><?php echo __('Description') ?></label></p>
	<p class="area"><?php echo form::textarea('p_desc', 55, 10, html::escapeHTML($p_desc)) ?></p>
	<?php 
	require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
	$ptb = new puntoolbarSmilies($puntal);
	echo $ptb->generatePtb('p_desc',false);
	?>
	<div class="two-cols">
		<p class="field col"><label for="p_date"><?php echo __('Download date') ?></label>
		<?php echo form::field('p_date', 10, 10, html::escapeHTML($p_date)) ?> <br/>
		<span class="desc"><?php echo __('Please give the date in AAAA-MM-JJ form, its displaying will be then made according to the  date format of your portal.') ?></span></p>
		
		<p class="field col"><label for="p_count"><?php echo __('Download count') ?></label>
		<?php echo form::field('p_count', 3, 10, $p_count) ?></p>
	</div>
	
	<p class="clearb"><span class="fakelabel"><?php echo __('Display this download on the home page of the module?') ?></span>
	<label><?php echo form::radio(array('p_welcome'), 1, $p_welcome, 'radio').__('Yes'); ?></label>
	<label><?php echo form::radio(array('p_welcome'), 0, !$p_welcome, 'radio').__('No') ?></label></p>
	
	<p><span class="fakelabel"><?php echo __('Display this download on the Download block?') ?></span>
	<label><?php echo form::radio(array('p_home'), 1, $p_home, 'radio').__('Yes'); ?></label>
	<label><?php echo form::radio(array('p_home'), 0, !$p_home, 'radio').__('No') ?></label></p>
	
	<p><?php echo 
	form::hidden('id','downloads')."\n".
	form::hidden('action',2)."\n".
	form::hidden('pid',$p_id)."\n".
	form::hidden('dl_tid',$p_topic_id)."\n".
	form::hidden('dl_pid',$p_post_id)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" id="publish" name="publish" value="<?php echo $buton ?>" />
	<input class="submit" type="submit" id="preview" name="preview" value="<?php echo __('Preview') ?>" /></p>
</form>
<?php 
endif;
adminPage::close() ?>