<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
@function install_downloads

La fonction charge de l'installation du module downloads.
*/
function install_downloads()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	# Structure de la table 'pt_downloads'
	$db_scheme[] = array(
		'action' 	=> 'add',
		'table' 	=> DB_PREFIX.'pt_downloads',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_downloads (
		id 					INT(10) 		UNSIGNED NOT NULL AUTO_INCREMENT,
		dl_name 			VARCHAR(200) 	NOT NULL DEFAULT 'Nouveau fichier',
		dl_url 				VARCHAR(200) 	NOT NULL DEFAULT 'nouveau-fichier',
		dl_filename 		VARCHAR(200) 	NOT NULL DEFAULT '',
		dl_desc 			TEXT,
		dl_count 			INT(10) 		UNSIGNED NOT NULL DEFAULT 0,
		dl_date 			DATE 			NOT NULL,
		cat_id 				INT(10) 		UNSIGNED NOT NULL DEFAULT 0,
		dl_disp_position 	INT(10) 		NOT NULL DEFAULT 0,
		dl_home 			TINYINT(1) 		NOT NULL DEFAULT 1,
		dl_enable 			TINYINT(1) 		NOT NULL DEFAULT 0,
		dl_welcome 			TINYINT(1) 		NOT NULL DEFAULT 0,
		dl_tid 		INT(12)		NULL,
		dl_pid 		INT(12)		NULL,
		PRIMARY KEY  (id)
		) TYPE=MyISAM;"
	);
	
	# Structure de la table 'pt_downloads_cat'
	$db_scheme[] = array(
		'action' 	=> 'add',
		'table' 	=> DB_PREFIX.'pt_downloads_cat',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_downloads_cat (
		id 					INT(10) 		UNSIGNED NOT NULL AUTO_INCREMENT,
		dl_cat_name 		VARCHAR(80) 	NOT NULL DEFAULT 'Nouvelle cat',
		dl_cat_url 			VARCHAR(255) 	NOT NULL DEFAULT 'cat-url',
		dl_cat_desc 		TEXT,
		dl_disp_position 	INT(10) 		NOT NULL DEFAULT 0,
		PRIMARY KEY  (id)
		) TYPE=MyISAM;"
	);

	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_downloads_path',
		'type' 		=> 'string',
		'init'		=> 'files'
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name'	 	=> 'pt_mod_downloads_time',
		'type' 		=> 'integer',
		'init' 		=> 2
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_downloads_leech',
		'type' 		=> 'boolean',
		'init' 		=> false
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_downloads_dwl',
		'type' 		=> 'boolean',
		'init' 		=> true
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_downloads_guest',
		'type' 		=> 'boolean',
		'init' 		=> true
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_downloads_last_dl',
		'type' 		=> 'boolean',
		'init' 		=> false
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_downloads_popular_dl',
		'type' 		=> 'boolean',
		'init' 		=> false
	);

	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_downloads_num',
		'type' 		=> 'integer',
		'init' 		=> 5
	);

	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_downloads_num',
		'type' 		=> 'integer',
		'init' 		=> 5
	);

	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_bloc_downloads_top_num',
		'type' 		=> 'integer',
		'init' 		=> 5
	);

	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_downloads_forum_id',
		'type' 		=> 'integer',
		'init' 		=> 0
	);

	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->install($db_scheme,$params);
}


?>