<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/*
	Le fichier _admin.php est charg en mme temps que le module sur la
	partie administration de Puntal.
	
	Ce fichier est utile pour effectuer des traitements ds le chargement
	du module sur la partie admin.
	
	A noter que ce fichier est inclu par une fonction ce qui veut dire que
	les variables dfinies dans ce fichier seront locales  ce fichier 
	moins que vous ne les dclariez explicitement comme globales.
	
	Par contre, grce  un dispositif, les variables globales de puntal 
	sont accessibles dans ce fichier.
*/


/*
	Sur les autres modules nous utilisons par exemple ce fichier 
	pour ajouter un menu propre au module dans le menu administration.
	
	Aussi, c'est l'endroit idal pour ajouter des comportements (behavior).
	
	Voici comment faire :
*/

# Dans un premier temps on vrifie si le module est activ
# et si l'utilisateur a le droit d'administrer ce module, ce
# grce  la constante pt_mod_IDENTIFIANT_MODULE et la fonction
# checkPerm('mod_IDENTIFIANT_MODULE')
if (pt_mod_example && checkPerm('mod_example'))
{
	# On crer un nouveau menu en passant en paramtre
	# l'identifiant de ce menu et le titre de ce menu
	$menu->newMenu('example',__('Example'));
	
	# Ici on test si on se trouve sur ce module et on
	# stocke l'information dans une variable pour aprs
	$on_example = ($module_id == 'example') ? true : false;
	
	# On crer un premier item au menu avec les paramtres ncessaires :
	# 1 - l'identifiant du menu auquel ajouter l'item
	# 2 - l'intitul de l'item
	# 3 - l'URL de l'item
	# 4 - condition d'activation de l'item quand on se trouvent sur cet item
	# 5 - cette dernire condition permet de dterminer si on doit afficher ou non l'item
	$menu->addItem('example', # 1
				__('Add'), # 2
				'module.php?id=example&amp;action=1', # 3
				($on_example && $action == 1), # 4
				($une_contidion_quelconque) # 5
	);
	
	# Un deuxime item...
	$menu->addItem('example',
				__('Config'),
				'module.php?id=example&amp;action=2',
				($on_example && $action == 2)
	);
	
	# Ci-dessous enregistrons un comportement grce  la mthode
	# addBehavior() ; cette mthode prend 2 arguments :
	# 1 - l'identifiant du comportement
	# 2 - une fonction de callback
	#
	# Ainsi la fonction de callback sera appele lorsque le script
	# rencontrera le comportement identifi ici 'adminIndexHTML'
	$puntal->addBehavior('adminIndexHTML', array('exampleBehavior','myBehavior'));
}


/*
	Comme nous venons d'enregistrer un comportement avec une fonction de callback
	il faut crire cette dernire. C'est ce que nous faisons ici.
*/
class exampleBehavior
{
	function myBehavior()
	{
		echo '<p>Je suis affich par un comportement</p>';
	}
}


/*
	Nous utilisons galement ce fichier pour dfinir les pages d'administration
	des blocs que le module ajoute. (voir _prepend.php)
*/

# La classe qui se charge de l'affichage des blocs sur la partie administration
class exampleAdminBlocks
{
	# La mthode de cette classe qui se charge du premier bloc
	function example1()
	{
		# administration bloc exemple1
	}
	
	# La mthode qui se charge du second bloc
	function example2()
	{
		# administration bloc exemple2
	}
}

?>