<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/*
	On peut ajouter un fichier _prepend.php dans les modules qui sera 
	charg avant tous les autres fichiers du module.
	
	Ceci peut tre utile pour effectuer des traitements juste au chargement
	du module que ce soit sur la partie publique ou sur la partie admin.
	
	Si vous souhaitez effectuer des traitements au chargement du module
	seulement sur la partie publique ou seulement sur la partie admin
	utilisez les fichiers _public.php et/ou _admin.php
	
	A noter que ce fichier est inclu par une fonction ce qui veut dire que
	les variables dfinies dans ce fichier seront locales  ce fichier 
	moins que vous ne les dclariez explicitement comme globales.
	
	Contrairement  _admin.php et _public.php vous n'avez pas directement
	accs aux globales de puntal, il faut aller les chercher dans le tableau
	$GLOBALS.
*/

/*
	Vous pouvez utiliser ce fichier par exemple pour enregistrer des blocs.

	Voici comment faire :
*/

# On enregistre un nouveau bloc grce  la fonction registerBlock() de l'objet
# $puntal->blocks ; cette fonction require trois arguments.
$GLOBALS['puntal']->blocks->registerBlock(
	# Le premier argument est l'identifiant du nouveau bloc ; essayez d'tre
	# prcis, voir original pour ne pas entrer en conflit avec un bloc 
	# d'un autre module
	'example1',
	# le second est le nom de la fonction qui se charge de l'affichage 
	# de ce bloc sur la partie publique, si vous placez la fonction dans
	# une classe (ce qui est recommand) il faut alors passer un tableau
	# ayant pour valeurs le nom de la classe et le nom de la mthode
	# de cette classe qui se charge de l'affichage sur la partie publique.
	array('examplePublicBlocks','example1'),
	# le troisime argument est le nom de la fonction qui se charge de
	# l'affichage sur la partie administration du bloc ; comme pour la
	# prcdente fonction vous pouvez (devez ?) passer un tableau si
	# cette fonction est une mthode d'une classe
	array('exampleAdminBlocks','example1'));

# Un deuxime bloc...
$GLOBALS['puntal']->blocks->registerBlock('example2',
	array('examplePublicBlocks','example2'),
	array('exampleAdminBlocks','example2'));

?>