<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
@function uninstall_example

La fonction charge de la dsinstallation du module example. Comme pour 
la fonction d'installation cette fonction doit obligatoirement 
tre nomme sous la forme uninstall_IDENTIFIANT_MODULE()

Egalement, le principe est de prparer ce dont on as besoin et de passer
cela  une fonction qui se charge du reste.
*/
function uninstall_example()
{
	/* Structure de la base de donnes
	
	Comme nous avons cr deux tables lors de la procdure 
	d'installation nous devons donc les supprimer lors de
	la dsinstallation. Pour cela mme principe : on crer
	un tableau associatif dans lequel on place nos instructions.
	----------------------------------------------------------*/
	
	# Initialisation du tableau
	$db_scheme = array();
	
	# Ci-dessous les instructions de supression de la premire table
	$db_scheme[] = array(
		# l'action a effectuer, ici 'delete' puisqu'on veut la supprimer
		'action' 	=> 'delete',
		# le nom de la table avecle prfixe des tables
		'table' 	=> DB_PREFIX.'pt_example',
		# la requte de suppression de la table
		'query' 	=> 'DROP TABLE '.DB_PREFIX.'pt_example'
	);
	
	# Supression de la seconde table
	$db_scheme[] = array(
		'action' 	=> 'delete',
		'table' 	=> DB_PREFIX.'pt_example_2',
		'query' 	=> 'DROP TABLE '.DB_PREFIX.'pt_example_2'
	);	
	
	/* Paramtres de configuration
	
	Idem, comme nous avons cr des paramtres de configuration 
	lors de l'installation, alors nous devons les supprimer
	pendant cette dsinstallation. Toujours au moyen d'un 
	tableau associatif.
	----------------------------------------------------------*/
	
	# Initialisation du tableau
	$params = array();
	
	# Une premire ligne dans le tableau pour supprimer
	# le premier paramtre, on voit ici qu'il faut 
	# simplement indiquer l'action et le nom du paramtre
	$params[] = array(
		# l'action, donc 'delete' puisque nosu supprimons
		'action'	=> 'delete',
		# et le nom du paramtre  supprimer
		'name' 		=> 'pt_mod_example_param_1'
	);
	
	# supression du second paramtre
	$params[] = array(
		'action'	=> 'delete',
		'name'	 	=> 'pt_mod_example_param_2'
	);
	
	/* Dsinstallation du module
	
	Enfin, nous procdons  la dsinstallation grce  la 
	fonction ci-dessous. Comme pour l'installation, nous lui
	passons les deux tableaux associatifs.
	----------------------------------------------------------*/
	$GLOBALS['install_module']->uninstall($db_scheme,$params);
}


?>