<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

# Fonction d'affichage des lignes de mots
function words_line($data,$i)
{
	global $lang_admin, $lang_ad_mod_lexique;
	
	require_once PT_INC_PATH ."libs/punbb_parser.php";
	
	$class = ($i%2 == 0) ? ' even' : ' odd';
	$class .= $data['def_status'] == 0 ? ' inactive' : '';
	
	return '<dt class="word'.$class.'">'.html::escapeHTML($data['def_word']).'</dt>'.
	'<dd class="word_def'.$class.'">'.parse_message($data['def_def'],false).'</dd>'.
	($data['def_ex'] != '' ? '<dd class="word_example">'.parse_message($data['def_ex'],false).'</dd>' : '').
	'<dd class="word_infos'.$class.'">'.__('Added by').' '.
	'<a href="'.pt_forum_url.'profile.php?id='.$data['def_user_id'].'">'.html::escapeHTML($data['def_username']).'</a> | '.
	'<a href="module.php?id=lexicon&amp;action=2&amp;wid='.$data['def_id'].'">'.__('Edit').'</a> | '.
	'<a href="module.php?id=lexicon&amp;action=1&amp;delete='.$data['def_id'].'" onclick="return window.confirm(\''.html::escapeJS(__('Are you sure you want to delete this word?')).'\')">'.__('Delete').'</a>'.
	($data['def_status'] == 0 ? ' | <a href="module.php?id=lexicon&amp;action=1&amp;validate='.$data['def_id'].'">'.__('Validate').'</a>' : '').'</dd>';	
}

# supression d'un mot
if (!empty($_GET['delete']))
{
	$del_id = intval($_GET['delete']);
	
	if ($lexique->delWord($del_id))
	{
		header('Location: module.php?id=lexicon&action=1&deleted=1');
		exit;
	}
}


# validation d'un mots
elseif (!empty($_GET['validate']))
{
	$valide_id = intval($_GET['validate']);
	
	if ($lexique->validWord($valide_id))
	{
		header('Location: module.php?id=lexicon&action=1&validated=1');
		exit;
	}
}

# Multipages
require PT_INC_PATH.'classes/multipage.php';

$nb_per_page = 10;
$nb_words = $lexique->getTotalAllWord();

$max_pages = ceil($nb_words/$nb_per_page);
$env = (!empty($_GET['env']) && $_GET['env'] <= $max_pages) ? $_GET['env'] : 1;

$words = $lexique->getWords('','',null,'D.def_word',(($env-1)*$nb_per_page).','.$nb_per_page);

$lum = new multipage($env, 'words_line', $words->getData(), $nb_words, $nb_per_page);

$lum->setOption('html_block', '<dl>%s</dl>');

$lum->setOption('html_row','%s');
$lum->setOption('html_cell','%s');

$lum->setOption('html_links','<p>'.__('Pages:').' %s</p>');
$lum->setOption('html_cur_page','<strong>%s</strong>');

$lum->setOption('html_prev','&lt; '.__('Previous'));
$lum->setOption('html_next',__('Next').' &gt;');
$lum->setOption('html_prev_grp','...');
$lum->setOption('html_next_grp','...');

$lum->setOption('html_empty','<p><strong>'.__('There is no word.').'</strong></p>');


# Messages de confirmation
if (!empty($_GET['deleted']))
	$common_message = __('Word deleted.');

if (!empty($_GET['validated']))
	$common_message = __('Word validated.');

# Affichage
adminPage::open(__('Words list').' - '.__('Lexicon'),
'<style type="text/css">
<!--
dt.word {
	margin-top: 1em;
	font-weight: bold;
}
dd.word_def {
	margin-top: 1em;
}
dd.word_example {
	font-style: italic;
}
dd.word_example em {
	font-style: normal;
}
dd.word_infos {
	text-align: right;
	border-bottom: 1px solid #ddd;
}

dt.inactive, dd.inactive {
	color: #696969;
}
-->
</style>'
);

echo '<h2 class="first"><img src="index.php?pf=lexicon/img/ico_lexique.png" alt="" class="icon" /> '.__('Words list').'</h2>';
echo $lum->getLinks();
echo $lum->getPage();
echo $lum->getLinks();

adminPage::close();

?>