<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$wid = !empty($_REQUEST['wid']) ? intval($_REQUEST['wid']) : '';

# Ajout d'un mot
if ($wid == '')
{
	$p_mot = '';
	$p_def = '';
	$p_ex = '';
	
	$page_title = __('Add a word');
	$buton_text = __('Add');
}
# Modification d'un mot
else {
	$mot = $lexique->getWord($wid);
	
	$p_mot = $mot->f('def_word');
	$p_def = $mot->f('def_def');
	$p_ex = $mot->f('def_ex');
	
	$page_title = __('Edit a word');
	$buton_text = __('Edit');
}


/* Form sent */
if (isset($_POST['form_sent']) && $puntal->checkToken())
{
	$p_mot = trim($_POST['p_mot']);
	$p_def = trim($_POST['p_def']);
	$p_ex = trim($_POST['p_ex']);
	
	if ($p_mot == '')
		$puntal->err->setError(__('You must give a word.'));
	
	if ($p_def == '')
		$puntal->err->setError(__('You must give a definition.'));
	
	if (!$puntal->err->hasError())
	{
		if ($lexique->setWord($p_mot,$p_def,$p_ex,1,$wid))
		{
			header('Location: module.php?id=lexicon&action=1&'.($wid == ''?'added':'edited').'=1');
			exit;
		}
	}
}

# Messages de confirmation
if (!empty($_GET['added']))
	$common_message = __('Word added.');

if (!empty($_GET['edited']))
	$common_message = __('Word edited.');

# Set token
$puntal->setToken();

# Affichage
adminPage::open($page_title.' - '.__('Lexicon'));

require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
$ptb = new puntoolbarSmilies($puntal);

?>

<h2 class="first"><img src="index.php?pf=lexicon/img/ico_lexique_edit.png" alt="" class="icon" /> <?php echo $page_title ?></h2>

<form action="module.php" method="post">
	<fieldset>
		<legend><?php echo $page_title ?></legend>
		
		<p class="field"><label for="p_mot"><?php echo __('Word') ?></label>
		<?php echo form::field('p_mot', 80, 80, html::escapeHTML($p_mot)) ?></p>
		
		<p class="field"><label for="p_def"><?php echo __('Definition') ?></label></p>
		<p class="area"><?php echo form::textarea('p_def', 55, 5, html::escapeHTML($p_def)) ?></p>
		<?php // Generate the PunToolBar
		echo $ptb->generatePtb('p_def',false);
		?>		
		<p class="field"><label for="p_ex"><?php echo __('Example') ?></label></p>
		<p class="area"><?php echo form::textarea('p_ex', 55, 5, html::escapeHTML($p_ex)) ?></p>
		<?php // Generate the PunToolBar
		echo $ptb->generatePtb('p_ex',false);
		?>	
	</fieldset>
	
	<p><?php echo 
	form::hidden('form_sent','1')."\n".
	form::hidden('id','lexicon')."\n".
	form::hidden('action',2)."\n".
	form::hidden('wid',$wid)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo $buton_text ?>" /></p>
</form>

<?php adminPage::close() ?>