<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
@function install_lexicon

La fonction charge de l'installation du module lexicon.
*/
function install_lexicon()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	# Structure de la table 'pt_lexique'
	$db_scheme[] = array(
		'action' 	=> 'add',
		'table' 	=> DB_PREFIX.'pt_lexique',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX.'pt_lexique (
		def_id 			INT(11) 		NOT NULL AUTO_INCREMENT,
		def_word 		VARCHAR(80) 	NOT NULL,
		def_letter 		VARCHAR(2) 		NOT NULL,
		def_def 		TEXT,
		def_ex 			TEXT,
		def_user_id 	INT(11) 		NOT NULL,
		def_status 		TINYINT(1) 		NOT NULL DEFAULT 0,
		PRIMARY KEY (def_id)
		) TYPE=MyISAM;'
	);
	
	$db_scheme[] = array(
		'action' 	=> 'update',
		'table' 	=> DB_PREFIX.'pt_lexique',
		'query' 	=> 
		'ALTER TABLE '.DB_PREFIX.'pt_lexique ADD INDEX k_word_letter (def_letter)'
	);
		
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_lexique_validate',
		'type' 		=> 'boolean',
		'init'		=> true
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name'	 	=> 'pt_mod_lexique_num_per_page',
		'type' 		=> 'integer',
		'init' 		=> 10
	);
		
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->install($db_scheme,$params);
}


?>