<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

# URLs configuration
define('NEWS_URL', 'news');
define('NEWS_RSS', 'rss');

# Par exemple en franais :
// define('NEWS_URL', 'actualites');
// define('NEWS_RSS', 'rss');

#########################################################################

if (!defined('PUNTAL')) exit;

# Enregistrement des modles d'URLs du module
$puntal->registerURL('news', pt_portal_url.NEWS_URL.'/');
$puntal->registerURL('news_rss', pt_portal_url.NEWS_URL.'/'.NEWS_RSS.'/');


# Bloc
class newsPublicBlocks
{
	/**
	@function archives
	
	Affiche le bloc des archives
	*/
	function archives()
	{
		global $puntal;
		
		// make a static block
		if (pt_mod_news_mode == 0)
		{		
			$pt_archives = array();
			$d = dir(PT_CACHE_PATH.'news/archives');
			while (($entry = $d->read()) !== false)
			{
				if (substr($entry, strlen($entry)-5) == '.html' && $entry != 'index.html')
					$pt_archives[] = substr($entry, 0, strlen($entry)-5);
			}
			$d->close();
			
			if (!empty($pt_archives))
			{
				startBloc(__('Archives'), 'archives');
				echo "\t\t\t\t".'<ul>'."\n";
				
				@natsort($pt_archives);
				$pt_archives = array_reverse($pt_archives);
				
				foreach ($pt_archives as $k=>$v)
					echo "\t\t\t\t\t".'<li><a href="'.pt_portal_url.'news/'.str_replace('-', '/', $v).'">'.$v.'</a></li>'."\n";
				echo "\t\t\t\t".'</ul>'."\n";
				endBloc();
			}
		}
		
		// make a dynamic block
		else {
			// Generate monthly archives
			$pt_year_end = intval(date('Y'));
			$pt_month_end = intval(date('n'));
	
			$pt_year_start = ($pt_month_end != 1) ? $pt_year_end : $pt_year_end-1;
			$pt_month_start = ($pt_month_end != 1) ? $pt_month_end-1 : 12;
			
			// How far back should we go?
			$fids = unserialize(pt_mod_news_forum_id);
			$tmp_news_id = array();
			foreach ($fids as $id)
				$tmp_news_id[] = " forum_id='".$id."'";
				
			$query = 'SELECT MIN(posted) AS history_limit FROM '.DB_PREFIX.'topics WHERE ( '.implode(' OR ', $tmp_news_id).' ) ';
	
			$pt_history_limit = $puntal->con->select($query) or $puntal->err->fatalError($puntal->con->error());
			
			if (!$pt_history_limit->isEmpty())
			{
				$pt_year_limit = intval(date('Y', $pt_history_limit->f('history_limit')));
				$pt_month_limit = intval(date('n', $pt_history_limit->f('history_limit')));
				
				startBloc(__('Archives'), 'archivesBox');
				echo "\t\t\t\t".'<ul>'."\n";
				
				while ($pt_year_end > $pt_year_limit || $pt_month_end > $pt_month_limit)
				{				
					echo "\t\t\t\t\t".'<li><a href="'.pt_portal_url.'news/'.$pt_year_start.'/'.($pt_month_start > 9 ? $pt_month_start : '0'.$pt_month_start).'">'.$pt_year_start.'-'.($pt_month_start > 9 ? $pt_month_start : '0'.$pt_month_start).'</a></li>'."\n";
		
					$pt_year_end = $pt_year_start;
					$pt_month_end = $pt_month_start;
					$pt_year_start = ($pt_month_end != 1) ? $pt_year_end : $pt_year_end-1;
					$pt_month_start = ($pt_month_end != 1) ? $pt_month_end-1 : 12;
				}
				
				echo "\t\t\t\t".'</ul>'."\n";
				endBloc();
			}
		}
	}
	
}
?>