<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$news_forums_array = unserialize(pt_mod_news_forum_id);

$p_title = '';
$p_forum = '';
$p_content = '';
$p_chapo = '';

if (isset($_POST['form_sent']) && $puntal->checkToken())
{
	require_once PT_INC_PATH."libs/punbb_parser.php";
	
	$p_complet_post = '';
	$p_title = trim($_POST['p_title']);
	$p_forum = intval($_POST['p_forum']);
	$p_content = trim($_POST['p_content']);	
	$p_chapo = trim($_POST['p_chapo']);
	
	if (!empty($p_chapo)) {
		
		$p_complet_post  = $p_chapo."\n[---]\n".$p_content;
	}
	else 
		$p_complet_post = $p_content;

	/* 
	 * ce qui suit est trait par la fonction punbb::newTopic 
	 * donc inutile ici 
	 * je la mets  titre d'info car c'est qd meme comme ceci
	 * que ca marche sur tous les modules
	 */
	#$p_complet_post = $puntal->linebreaks($p_complet_post);
	#$p_complet_post = preparse_bbcode($p_complet_post,false);
			
	if (empty($p_title))
		$puntal->err->setError(__('must_title'));
	
	if (empty($p_content))
		$puntal->err->setError(__('must_content'));
		
	if (!$puntal->err->hasError() && 
		punbb::newTopic($p_forum,$p_title,$p_complet_post,true,false,false,$puntal->user['username']))	
	{
		if (pt_mod_news_mode == 0)
		{
			logIt("News module : added news");
			header('Location: module.php?id=news&action=2&gen_news=1&from_post=1');
			exit;
		}
		else {
			logIt("News module : added news");
			header('Location: module.php?id=news&action=1&added=1');
			exit;
		}
	}
}

# Messages de confirmation
if (!empty($_GET['added']))
	$common_message = __('News added');

# Le ncssaire de toilette
$forum_array = array();
$forums = punbb::getForums();
while ($forums->fetch())
{
	if (in_array($forums->f('fid'),$news_forums_array))
		$forum_array[$forums->f('forum_name')] = $forums->f('fid');
}

# Set token
$puntal->setToken();

# Affichage
adminPage::open(__('Add news').' - '.__('News'));

require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
$ptb = new puntoolbarSmilies($puntal);
?>

<h2 class="first"><img src="index.php?pf=news/img/ico_news_add.png" alt="" class="icon" /> <?php echo __('Add news') ?></h2>

<form action="module.php" method="post">
	<fieldset>
		<legend><?php echo __('Add news') ?></legend>
		
		<p class="field"><label for="p_title"><?php echo __('News title') ?></label>
		<?php echo form::field('p_title', 50, 255, html::escapeHTML($p_title)) ?></p>
		
		<p class="field"><label for="p_forum"><?php echo __('Forum') ?></label>
		<?php echo form::combo('p_forum',$forum_array,$p_forum) ?></p>

		<p class="field"><label for="p_chapo"><?php echo __('Abstract').' ('.__('optional').')' ?></label></p>
		<p class="area"><?php echo form::textarea('p_chapo', 55, 5, html::escapeHTML($p_chapo)) ?></p>
		<?php // Generate the PunToolBar		
		echo $ptb->generatePtb('p_chapo',false);
		?>
	
		<p class="field"><label for="p_content"><?php echo __('News content') ?></label></p>
		<p class="area"><?php echo form::textarea('p_content', 55, 10, html::escapeHTML($p_content)) ?></p>
		<?php // Generate the PunToolBar
		echo $ptb->generatePtb('p_content',false);
		?>
				
	</fieldset>
	
	<p><?php echo form::hidden('form_sent','1')."\n".
	form::hidden('id','news')."\n".
	form::hidden('action',1)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Add') ?>" /></p>
	
</form>

<?php adminPage::close() ?>