<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


function update_news()
{
	global $puntal;
	
	$res = true;
	
	# mise  jour 0.6
	if (compare_version(pt_mod_news_version,'0.6') == '-1')
		$res &= news_up_to_to_0_6();

	# mise  jour 0.7
	if (compare_version(pt_mod_news_version,'0.7') == '-1')
		$res &= news_up_to_to_0_7();
		
	# mise  jour 0.8
	if (compare_version(pt_mod_news_version,'0.8') == '-1')
		$res &= news_up_to_to_0_8();
			
	return $res;
}

/**
@function news_up_to_to_0_6

Mise  jour du module  la version 0.6
*/
function news_up_to_to_0_6()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_news_date_format'
	);
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
}


/**
@function news_up_to_to_0_7

Mise  jour du module  la version 0.7
*/
function news_up_to_to_0_7()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	$params[] = array(
		'action'	=> 'delete',
		'name' 		=> 'pt_mod_news_truncat_news'
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_news_display_post_it',
		'type'		=> 'integer',
		'init' 		=> 0		
	);
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
}

/**
@function news_up_to_to_0_8

Mise  jour du module  la version 0.8
*/
function news_up_to_to_0_8()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'add',	
		'name'=>'pt_mod_news_display_avatar',
		'type'=>'integer',
		'init'=>1
	);	

	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
}

?>