<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/**
	Fonctions de template du module news.
*/
class news
{
	/**
	@function isStatic
	
	Cette fonction indique si on est en mode statique ou non
	*/
	function isStatic()
	{
		if (pt_mod_news_mode == 0)
			return true;
		else
			return false;
	}
	
	/**
	@function isStatic
	
	Cette fonction indique si on est en mode dynamique ou non
	*/
	function isDynamic()
	{
		if (pt_mod_news_mode == 1)
			return true;
		else
			return false;
	}
	
	/**
	@function getStaticNews
	
	Inclu les news statiques
	*/
	function getStaticNews($no_news='<p>%s</p>')
	{
		global $puntal, $path_module, $pt_args;
		
		$pt_archives = (isset($pt_args[1]) && isset($pt_args[2])) ? true : false;
		
		if ($pt_archives)
		{
			if (file_exists(PT_CACHE_PATH.'news/archives/'.$pt_args[1].'-'.$pt_args[2].'.html'))
				require (PT_CACHE_PATH.'news/archives/'.$pt_args[1].'-'.$pt_args[2].'.html');
			else
				$pt_archives = false;
		}
		
		if (!$pt_archives)
		{
			if (file_exists(PT_CACHE_PATH.'/news/news.html'))
				require (PT_CACHE_PATH.'/news/news.html');
			else
				printf($no_news, __('Pas d\'actualits  afficher.'));
		}
	}
	
	/**
	@function tid
	
	Affiche l'identifiant du topic de la news
	*/
	function tid()
	{
		echo $GLOBALS['news']->f('id');
	}
	
	/**
	@function uid
	
	Affiche l'identifiant de l'auteur de la news
	*/
	function uid()
	{
		echo $GLOBALS['news']->f('poster_id');
	}
	
	/**
	@function title
	
	Affiche le titre de la news
	*/
	function title()
	{
		global $puntal, $news;
		
		if ($puntal->pun_config['o_censoring'] == '1')
			echo html::escapeHTML($puntal->censor_words($news->f('subject')));
		else
			echo html::escapeHTML($news->f('subject'));
	}
	
	/**
	@function date
	
	Affiche la date de la news
	*/
	function date($format='')
	{
		if ($format != '')
			echo dt::str($format,$GLOBALS['news']->f('posted'));
		else
			echo dt::str(pt_date_format.' '.pt_time_format,$GLOBALS['news']->f('posted'));
	}
	
	/**
	@function author
	
	Affiche le nom d'utilisateur de l'auteur de la news
	*/
	function author()
	{
		echo html::escapeHTML($GLOBALS['news']->f('poster'));
	}
	
	/**
	@function avatar
	
	Affiche l'avatar de l'auteur de la news
	*/
	function avatar($s='<p class="newsAvatar">%s</p>')
	{
		global $puntal, $news;
		
		if ($puntal->pun_config['o_avatars'] == '1' && $news->f('use_avatar') == '1')
		{
			if ($img_size = @getimagesize(PUN_ROOT.$puntal->pun_config['o_avatars_dir'].'/'.$news->f('poster_id').'.gif'))
				printf($s, '<img src="'.pt_forum_url.$puntal->pun_config['o_avatars_dir'].'/'.$news->f('poster_id').'.gif" '.$img_size[3].' alt="" />');
			else if ($img_size = @getimagesize(PUN_ROOT.$puntal->pun_config['o_avatars_dir'].'/'.$news->f('poster_id').'.jpg'))
				printf($s, '<img src="'.pt_forum_url.$puntal->pun_config['o_avatars_dir'].'/'.$news->f('poster_id').'.jpg" '.$img_size[3].' alt="" />');
			else if ($img_size = @getimagesize(PUN_ROOT.$puntal->pun_config['o_avatars_dir'].'/'.$news->f('poster_id').'.png'))
				printf($s, '<img src="'.pt_forum_url.$puntal->pun_config['o_avatars_dir'].'/'.$news->f('poster_id').'.png" '.$img_size[3].' alt="" />');
		}
	}


	
	/**
	@function message
	
	Affiche le contenu de la news
	*/	
	function message()
	{
		global $news, $lang_mod_news;
		
		#on coupe le message avec un chapo pour n'afficher que cette partie sur la page d'acceuil
		#si le chapo n'existe pas on affichera toute la news
		$message = '';
		$pos = strpos($news->f('message'),'[---]');
		if ($pos > 0 ) 
			list($message) = split('\[---\]',$news->f('message'));
		else $message = $news->f('message');

		$port = '';
		if ( $_SERVER['SERVER_PORT'] != '80' ) 
			$port = ":".$_SERVER['SERVER_PORT'];
		if ($pos > 0 )					
			$message .=	"\n".'[url='.$_SERVER['SERVER_NAME'].$port.pt_forum_url.'viewtopic.php?id='.$news->f('id').']'.__('Read more').'[/url]';
		echo parse_message($message, $news->f('hide_smilies'));		

	}
	
	/**
	@function forumId
	
	Affiche l'identifiant du forum de la news
	*/	
	function forumId()
	{
		echo $GLOBALS['news']->f('fid');
	}
	
	/**
	@function forumName
	
	Affiche le nom du forum de la news
	*/	
	function forumName()
	{
		echo html::escapeHTML($GLOBALS['news']->f('forum_name'));
	}
	
	/**
	@function comments
	
	Affiche le nombre de commentaires
	*/	
	function comments()
	{
		global $news, $lang_mod_news;
		
		if ($news->f('num_replies') < 1)
			echo __('No comment');
		elseif($news->f('num_replies') == 1)
			echo __('One comment');
		else
			printf(__('%s comments'), $news->f('num_replies'));
	}
	
	/**
	@function reads
	
	Affiche le nombre de lectures de la news
	*/	
	function reads()
	{
		global $news, $lang_mod_news;
		
		if ($news->f('num_views') < 1)
			echo __('No reading');
		elseif($news->f('num_views') == 1)
			echo __('One reading');
		else
			printf(__('%s readings'), $news->f('num_views'));
	}
	
	/***********************************************************************\
		Des infos pour le fil RSS
	\***********************************************************************/
	
	/**
	@function headRss
	
	Affiche le lien d'entte vers le fil RSS.
	*/
	function headRss()
	{
		echo '<link rel="alternate" type="application/rss+xml" href="'.$GLOBALS['puntal']->url('news_rss').'" title="'.__('RSS feed of news').'" />'."\n";
	}
	
	/**
	@function rssMessage
	
	Affiche le contenu de la news
	*/
	function rssMessage()
	{
		echo $GLOBALS['news']->f('message');
	}
	
	/**
	@function newsUrl
	
	Affiche l'URL des news
	*/
	function newsUrl()
	{
		echo puntal::getHost().$GLOBALS['puntal']->url('news');
	}
	
	/**
	@function tid
	
	Affiche l'URL du topic de la news
	*/
	function topicUrl()
	{
		echo puntal::getHost().pt_forum_url.'viewtopic.php?id='.$GLOBALS['news']->f('id');
	}	
	
	/**
	@function rssDate
	
	Affiche la date de la news pour le fil RSS
	*/
	function rssDate()
	{
		echo date('r', $GLOBALS['news']->f('posted'));
	}

}
?>