<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

# Template
require dirname(__FILE__).'/inc/tpl_functions.php';
$pt_template_file = '/news/main.php';

$pt_archives = (isset($pt_args[1]) && isset($pt_args[2])) ? true : false;

$fids = unserialize(pt_mod_news_forum_id);

# Affichage du flux RSS
if (!empty($pt_args[1]) && $pt_args[1] == NEWS_RSS)
{

	if (!defined('PUN_QUIET_VISIT'))  defined('PUN_QUIET_VISIT');
	$pt_template_file = '/news/rss.php';
	
	require_once PT_INC_PATH.'libs/punbb_parser.php';
	
	// Fetch $show topics
	$tmp_news_id = array(); 
	foreach ($fids as $id)
		$tmp_news_id[] = " t.forum_id='".$id."'";

	$sticky='';
	if (pt_mod_news_display_post_it) 
		$sticky = ' OR t.sticky=1 ';
		
	//Get news		
	if (pt_mod_news_display_avatar) 
		$query = 'SELECT u.use_avatar,p.message,p.hide_smilies,p.poster_id, t.id, p.poster, t.subject, t.posted, t.last_post,t.num_replies,t.num_views, f.id AS fid, f.forum_name 
		FROM '.DB_PREFIX.'posts AS p
		INNER JOIN '.DB_PREFIX.'users AS u ON u.id=p.poster_id,			
	 	'.DB_PREFIX.'topics AS t 
		INNER JOIN '.DB_PREFIX.'forums AS f ON f.id=t.forum_id 			
		LEFT JOIN '.DB_PREFIX.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id=3) 
		WHERE p.posted=t.posted 
		AND (fp.read_forum IS NULL OR fp.read_forum=1) 
		AND t.moved_to IS NULL
		AND  t.sticky=0 '.$sticky. '
		AND ('.implode(' OR ', $tmp_news_id).') 
		ORDER BY t.posted DESC LIMIT '.pt_mod_news_num_posts;
	
	else 
		$query = 'SELECT p.message,p.hide_smilies,p.poster_id, t.id, p.poster, t.subject, t.posted, t.last_post,t.num_replies,t.num_views, f.id AS fid, f.forum_name 
		FROM '.DB_PREFIX.'posts AS p, '.DB_PREFIX.'topics AS t 
		INNER JOIN '.DB_PREFIX.'forums AS f ON f.id=t.forum_id 			
		LEFT JOIN '.DB_PREFIX.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id=3) 
		WHERE p.posted=t.posted 
		AND (fp.read_forum IS NULL OR fp.read_forum=1) 
		AND t.moved_to IS NULL 
		AND  t.sticky=0 '.$sticky. '
		AND ('.implode(' OR ', $tmp_news_id).') 
		ORDER BY t.posted DESC LIMIT '.pt_mod_news_num_posts;
		
	
	$news = $con->select($query) or $puntal->err->fatalError($con->error());
	
	// avons-nous des news ?
	if (!$news->isEmpty())
	{
		// boucle sur les sujets
		while ($news->fetch())
		{
			// set post infos
			$news->setField('posted',$news->f('posted'));
			$news->setField('poster',html::escapeHTML($news->f('poster')));
			$news->setField('message',parse_message($news->f('message'),true));
		}
	}
}
else {

	# Get news to make a dynamic page
	if (pt_mod_news_mode == 1)
	{
		require_once PT_INC_PATH.'libs/punbb_parser.php';
		
		# archives ?
		if ($pt_archives)
		{
			$pt_year_start = $pt_args[1];
			$pt_month_start = ($pt_args[2]{0} == '0') ? substr($pt_args[2], 1, 2) : $pt_args[2];
			
			if ($pt_month_start == '12')
			{
				$pt_year_end = $pt_year_start + 1;
				$pt_month_end = '1';
			}
			else {
				$pt_year_end = $pt_year_start;
				$pt_month_end = $pt_month_start + 1;
			}
	
			$tmp_news_id = array(); 
			foreach ($fids as $id)
				$tmp_news_id[] = " t.forum_id='".$id."'";
			
			$query = 'SELECT t.id, t.subject, t.num_views, t.num_replies, f.id AS fid, f.forum_name FROM '.DB_PREFIX.'topics t LEFT JOIN '.DB_PREFIX.'forums f ON t.forum_id=f.id WHERE ( '.implode(' OR ', $tmp_news_id).' ) AND t.moved_to IS NULL AND  t.sticky=0 AND t.posted>=UNIX_TIMESTAMP(\''.$pt_year_start.'-'.$pt_month_start.'-01\') AND t.posted<UNIX_TIMESTAMP(\''.$pt_year_end.'-'.$pt_month_end.'-01\') ORDER BY posted DESC';
			
			$news = $con->select($query);        
	
			if ($news->isEmpty())
				$pt_archives = false;
			else
				$pt_custom_title_page[] = $pt_args[1].'-'.$pt_args[2];
		}
		
		if (!$pt_archives)
		{
			// Fetch $show topics
			$tmp_news_id = array(); 
			foreach ($fids as $id)
				$tmp_news_id[] = " t.forum_id='".$id."'";
				
			//Get news		
			$sticky=' AND t.sticky=0 ';
			if (pt_mod_news_display_post_it) 
				$sticky = 'AND ( t.sticky=0 OR t.sticky=1 )';
				
			if (pt_mod_news_display_avatar) 
				$query = 'SELECT u.use_avatar,p.message,p.hide_smilies,p.poster_id, t.id, p.poster, t.subject, t.posted, t.last_post,t.num_replies,t.num_views, f.id AS fid, f.forum_name 
				FROM '.DB_PREFIX.'posts AS p
				INNER JOIN '.DB_PREFIX.'users AS u ON u.id=p.poster_id,			
			 	'.DB_PREFIX.'topics AS t 
				INNER JOIN '.DB_PREFIX.'forums AS f ON f.id=t.forum_id 			
				LEFT JOIN '.DB_PREFIX.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id=3) 
				WHERE p.posted=t.posted 
				AND (fp.read_forum IS NULL OR fp.read_forum=1) 
				AND t.moved_to IS NULL
				 '.$sticky. '
				AND ('.implode(' OR ', $tmp_news_id).') 
				ORDER BY t.posted DESC LIMIT '.pt_mod_news_num_posts;
			
			else 
				$query = 'SELECT p.message,p.hide_smilies,p.poster_id, t.id, p.poster, t.subject, t.posted, t.last_post,t.num_replies,t.num_views, f.id AS fid, f.forum_name 
				FROM '.DB_PREFIX.'posts AS p, '.DB_PREFIX.'topics AS t 
				INNER JOIN '.DB_PREFIX.'forums AS f ON f.id=t.forum_id 			
				LEFT JOIN '.DB_PREFIX.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id=3) 
				WHERE p.posted=t.posted 
				AND (fp.read_forum IS NULL OR fp.read_forum=1) 
				AND t.moved_to IS NULL 
				 '.$sticky. '
				AND ('.implode(' OR ', $tmp_news_id).') 
				ORDER BY t.posted DESC LIMIT '.pt_mod_news_num_posts;
		
			
			$news = $con->select($query) or $puntal->err->fatalError($con->error());
		}
		
		// avons-nous des news ?
		if (!$news->isEmpty())
		{
			// boucle sur les sujets
			while ($news->fetch())
			{
					
				// set post infos
				$news->setField('posted',$news->f('posted'));
				$news->setField('poster',$news->f('poster'));
				$news->setField('poster_id',$news->f('poster_id'));
				
				if (pt_mod_news_display_avatar) 
					$news->setField('use_avatar',$news->f('use_avatar'));
					
				$news->setField('hide_smilies',$news->f('hide_smilies'));
				$news->setField('message',$news->f('message'));
			}
		}
	}
}

?>