<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

# menu
if (pt_mod_planet && checkPerm('mod_planet'))
{
	$menu->newMenu('planet',__('Planet'));
	
	$on_planet = ($module_id == 'planet') ? true : false;
	
	$menu->addItem('planet',
				__('Manage'),
				'module.php?id=planet&amp;action=1',
				($on_planet && $action == 1)
	);
	
	$menu->addItem('planet',
				__('Add'),
				'module.php?id=planet&amp;action=2',
				($on_planet && $action == 2 && empty($_REQUEST['fid']))
	);
	
	$menu->addItem('planet',
				__('Configuration'),
				'module.php?id=planet&amp;action=3',
				($on_planet && $action == 3)
	);
}

# gestion du bloc
class planetAdminBlocks
{
	function rssreader()
	{
		global $puntal, $pt_settings;
		
		$p_num = pt_bloc_rssreader_num;
		$p_desc = pt_bloc_rssreader_desc;
		
		# Formulaire envoy
		if (!empty($_POST['form_sent']))
		{
			$p_num = intval(trim($_POST['p_num']));
			if ($p_num < 0 || $p_num > 50)
				$p_num = 0;	
			
			$p_desc = intval(trim($_POST['p_desc']));
			
			$pt_settings->setNamespace('mod_planet');
			
			$res = true;
			$res &= $pt_settings->put('pt_bloc_rssreader_num', $p_num);
			$res &= $pt_settings->put('pt_bloc_rssreader_desc', $p_desc);
		
			$pt_settings->setNamespace('');
		
			if ($res)
			{
				logIt("Config RSS reader block", 1);
				header('Location: bloc.php?id=rssreader&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
						
		# Affichage
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_rssreader')));
?>
	<h2 class="first"><img src="style/img/ico_feed.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_rssreader')); ?></h2>
	
	<form method="post" action="bloc.php">
		<fieldset>
			<legend><?php echo __('bloc_rssreader') ?></legend>
									
			<p class="field"><label for="p_num"><?php echo __('Number of item per feed') ?></label>
			<?php echo form::field('p_num', 2, 5, $p_num) ?>
			<span class="desc"><?php echo __('The number of item per feed to display on this block (between 1 and 50). Put 0 (or blank) to display default number provide by the feed.') ?></span></p>
									
			<p class="field"><label for="p_desc"><?php echo __('Size limit of the description of an item') ?></label>
			<?php echo form::field('p_desc', 2, 5, $p_desc) ?>
			<span class="desc"><?php echo __('Allow to limit the size of the description of an item when the mouse goes over him. 0 does not display anything, recommanded 255 if used') ?></span></p>
			
		</fieldset>
		
		<p><?php echo 
		form::hidden('form_sent','1')."\n".
		form::hidden('id','rssreader'); ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	
	</form>
<?php
		adminPage::close();
	}
}

?>