<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$cache_ttl = pt_mod_planet_cache_ttl;

/* Form sent */
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	$cache_ttl = intval(trim($_POST['cache_ttl']));
	$date_format = trim($_POST['date_format']);	

	// Mise  jour de la configuration
	$pt_settings->setNamespace('mod_planet');    
	
	$res = true;
	$res &= $pt_settings->put('pt_mod_planet_cache_ttl', $cache_ttl);

	$pt_settings->setNamespace('');
	
	if ($res)
	{
		logIt('Planet module : edit config', 1);
		header('Location: module.php?id=planet&action=3&updated=1');
		exit;
	}
}

# Message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# Cache ttl array
$cache_ttl_array = array(
	__('30 minutes') => 30,
	__('1 hour') => 60,
	__('2 hours') => 120,
	__('6 hours') => 360,
	__('12 hours') => 720,
	__('1 day') => 1440,
	__('2 days') => 2880,
	__('1 week') => 10080
);

# Set token
$puntal->setToken();

# Affichage
adminPage::open(__('Configuration').' - '.__('Planet'));
?>

<h2 class="first"><img src="index.php?pf=planet/img/ico_feed_config.png" alt="" class="icon" /> <?php echo __('Planet configuration') ?></h2>
<form method="post" action="module.php">
	
	<p class="field"><label for="cache_ttl"><?php echo __('Cache time to live') ?></label>
	<?php echo form::combo('cache_ttl', $cache_ttl_array, $cache_ttl) ?>
	<span class="desc"><?php echo __('Changes the amount of time a feed is cached for before expiring.') ?></span></p>

	<p><?php echo 
	form::hidden(array('form_sent'),'1')."\n".
	form::hidden(array('id'),'planet')."\n".
	form::hidden(array('action'),3)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
</form>
<?php adminPage::close() ?>