<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$fid = (!empty($_REQUEST['fid']) && intval($_REQUEST['fid']) > 0) ? intval($_REQUEST['fid']) : '';

# Nouveau feed
if ($fid == '')
{
	$p_url = '';
	$p_planet = 1;
	$p_block = 0;
	$p_status = 1;
	
	$title = __('New a feed');
	$icon = 'ico_feed_add.png';
	$buton = __('Add');
}

# Modification d'un feed
else {
	$feed = $planet->getFeed($fid,false,false,false);
	
	$p_url = $feed->f('rss_url');
	$p_planet = $feed->f('rss_planet');
	$p_block = $feed->f('rss_bloc');
	$p_status = $feed->f('rss_status');
	
	$title = __('Edit a feed');
	$icon = 'ico_feed_edit.png';
	$buton = __('Edit');
}

# Formulaire envoy
if (!empty($_POST['sended']) && $puntal->checkToken())
{
	$p_url = trim($_POST['p_url']);
	$p_planet = (boolean) trim($_POST['p_planet']);
	$p_block = (boolean) trim($_POST['p_block']);
	$p_status = (boolean) trim($_POST['p_status']);
	
	if (($fid = $planet->setFeed($p_url,$p_status,$p_planet,$p_block,$fid)) !== false)
	{
		header('Location: module.php?id=planet&action=2&fid='.$fid.'&'.($fid == '' ? 'added' : 'edited').'=1');
		exit;
	}
}

# Messages de confirmation
if (!empty($_GET['added']))
	$common_message = __('Feed added');

if (!empty($_GET['edited']))
	$common_message = __('Feed edited');


/* Affichage
----------------------------------------------------------*/

# Set token
$puntal->setToken();

# Dbut de page
adminPage::open($title.' - '.__('Planet'));
?>
<h2 class="first"><img src="index.php?pf=planet/img/<?php echo $icon ?>" alt="" class="icon" /> <?php echo $title ?></h2>

<form action="module.php" method="post">
	
	<p class="field"><label for="p_url"><?php echo __('Feed <acronym title="Uniform Resource Locator">URL</acronym>') ?></label>
	<?php echo form::field('p_url', 50, 255, html::escapeHTML($p_url)) ?></p>
	
	<p><span class="fakelabel"><?php echo __('Planet') ?></span>
	<label><?php echo form::radio(array('p_planet'), 1, $p_planet, 'radio').__('Yes'); ?></label>
	<label><?php echo form::radio(array('p_planet'), 0, !$p_planet, 'radio').__('No') ?></label>
	<span class="desc"><?php echo __('Allow to display or not this feed on the planet.') ?></span></p>
	
	<p><span class="fakelabel"><?php echo __('Block') ?></span>
	<label><?php echo form::radio(array('p_block'), 1, $p_block, 'radio').__('Yes'); ?></label>
	<label><?php echo form::radio(array('p_block'), 0, !$p_block, 'radio').__('No') ?></label>
	<span class="desc"><?php echo __('Allow to display or not this feed on the block.') ?></span></p>
	
	<p><span class="fakelabel"><?php echo __('Enable') ?></span>
	<label><?php echo form::radio(array('p_status'), 1, $p_status, 'radio').__('Yes'); ?></label>
	<label><?php echo form::radio(array('p_status'), 0, !$p_status, 'radio').__('No') ?></label>
	<span class="desc"><?php echo __('Allow to enable or disable the feed.') ?></span></p>	
			
	<p><?php echo 
	form::hidden('id','planet')."\n".
	form::hidden('action',2)."\n".
	form::hidden('fid',$fid)."\n".
	form::hidden('sended',1)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo $buton ?>" /></p>
</form>

<?php adminPage::close() ?>