<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/**
	La classe d'affichage du planet
*/
class planet
{
	/**
	@function titleLink
	
	Affiche le lien (si il y en as un) et le titre d'un item.
	Dans le contexte de la boucle sur les feeds du planet
	*/
	function titleLink($with_link='<a href="%s">%s</a>', $whitout_link='%s')
	{
		global $feeds;
		
		if ($feeds->f('permalink') != '')
			printf($with_link, $feeds->f('permalink'), $feeds->f('title'));
		else
			printf($whitout_link, $feeds->f('title'));
	}
	
	/**
	@function title
	
	Affiche le titre d'un item.
	Dans le contexte de la boucle sur les feeds du planet
	*/
	function title()
	{
		echo $GLOBALS['feeds']->f('title');
	}
	
	/**
	@function permalink
	
	Affiche le lien d'un item.
	Dans le contexte de la boucle sur les feeds du planet
	*/
	function permalink()
	{
		echo $GLOBALS['feeds']->f('permalink');
	}
	
	/**
	@function date
	
	Affiche la date d'un item.
	Dans le contexte de la boucle sur les feeds du planet
	*/
	function date()
	{
		echo $GLOBALS['feeds']->f('date');
	}
	
	/**
	@function description
	
	Affiche la description d'un item.
	Dans le contexte de la boucle sur les feeds du planet
	*/
	function description()
	{
		echo $GLOBALS['feeds']->f('description');
	}
	
	/**
	@function feedTitleLink
	
	Affiche le lien (si il y en as un) et le titre d'un feed.
	Dans le contexte de la boucle sur les feeds du planet
	*/
	function feedTitleLink($with_link='<a href="%s">%s</a>', $whitout_link='%s')
	{
		global $feeds;
		
		if ($feeds->f('feed_link') != '')
			printf($with_link, $feeds->f('feed_link'), $feeds->f('feed_title'));
		else
			printf($whitout_link, $feeds->f('feed_title'));
	}
	
	/**
	@function feedTitle
	
	Affiche le titre d'un feed.
	Dans le contexte de la boucle sur les feeds du planet
	*/
	function feedTitle()
	{
		echo $GLOBALS['feeds']->f('feed_title');
	}
	
	/**
	@function feedLink
	
	Affiche le lien d'un feed.
	Dans le contexte de la boucle sur les feeds du planet
	*/
	function feedLink()
	{
		echo $GLOBALS['feeds']->f('feed_link');
	}
	
	function blinklist()
	{
		echo $GLOBALS['feeds']->f('blinklist');
	}
	
	function delicious()
	{
		echo $GLOBALS['feeds']->f('delicious');
	}
	
	function digg()
	{
		echo $GLOBALS['feeds']->f('digg');
	}
	
	function furl()
	{
		echo $GLOBALS['feeds']->f('furl');
	}
	
	function magnolia()
	{
		echo $GLOBALS['feeds']->f('magnolia');
	}
	
	function newsvine()
	{
		echo $GLOBALS['feeds']->f('newsvine');
	}
	
	function spurl()
	{
		echo $GLOBALS['feeds']->f('spurl');
	}
	
	function technorati()
	{
		echo $GLOBALS['feeds']->f('technorati');
	}
}
?>