<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/


#########################################################################

if (!defined('PUNTAL')) exit;

$GLOBALS['extra_header'] .= "\n\t".'<link rel="stylesheet" type="text/css" href="'. PT_THEMES_URL.pt_theme . '/tribune/tribune.css" />'."\n";


# La classe qui se charge de l'affichage des blocs sur la partie publique
class tribunePublicBlocks
{

    // refrsch function to get the data
	function refresh() {
		global $puntal;
	
		require_once PT_INC_PATH.'libs/punbb_parser.php';
		$lines = "<ul>";
        // Fetch tribune         
		$sqlQuery = 'SELECT id_tribune, tribune_text, tribune_date, tribune_time, username FROM '.DB_PREFIX.'pt_tribune AS t,'
                                .DB_PREFIX.'users AS u WHERE t.id_user=u.id ORDER BY tribune_date DESC, tribune_time DESC LIMIT '.
                                pt_bloc_tribune_num;
                                
		$rs = $puntal->con->select($sqlQuery) or $puntal->err->fatalError($puntal->con->error());
				
        while ($rs->fetch()) {                    
            $message = $rs->f('tribune_text');
            
            if ($puntal->pun_config['p_message_bbcode'] == '1') 
                if ( strpos($message, '[') !== false && strpos($message, ']') !== false ) 
                        $message = parse_message($message, 0);				
                else {
                    $message = parse_message($message, 0);                    
                }
                
	        if ( $puntal->user['g_id'] == PUN_ADMIN )
				$del_tribune = '<input title="'.__('Delete the message').'" alt="x" type="image" src="'.PT_THEMES_URL.pt_theme.'/tribune/img/supprimer.png" name="id_tribune" value="'.$rs->f('id_tribune').'" onclick="submit();"/> ';	
			else
				$del_tribune ='';
	
					
            $lines .= '<li>'.$del_tribune.substr($rs->f('tribune_time'),0,5).' '.$rs->f('username').': '.html_entity_decode($message).'</li>';
        }
	        
		$lines .= '</ul><br/>';
    	        
    	return $lines;
	}	

	function setTribune($id_user,$tribune_text) {
		global $puntal;
       $sqlInsert = '';
       
        if ($tribune_text !='' ) {
        	
			mysql_real_escape_string ($tribune_text);
            $text = wordwrap($tribune_text,20,"\n",1);
            
            $sqlInsert = "INSERT INTO ".DB_PREFIX."pt_tribune (id_tribune, id_user, tribune_text, tribune_date, tribune_time) VALUES('','".$id_user."','".strip_tags(stripslashes(htmlentities($text, ENT_QUOTES)))."',NOW(),NOW())";
			$puntal->con->execute($sqlInsert) or $puntal->err->fatalError($puntal->con->error());                
        }
	}
	

	
    // function that delete datas
	function delTribune($id_tribune) {
		global $puntal;
		$sqlDelete = '';
		$sqlDelete = "DELETE FROM ".DB_PREFIX."pt_tribune WHERE id_tribune = '".$id_tribune."' ";
		$puntal->con->execute($sqlDelete) or $puntal->err->fatalError($puntal->con->error());			
	}
		

	# La mthode de cette classe qui se charge du premier bloc
	function tribune($collapse_feat=true)
	{
		global $puntal;
		if (pt_mod_tribune) {											
	
			if (!empty($_POST['tribune_sent']) and ! $puntal->user['is_guest'] and !empty($_POST['tribune_text']) ) {

				tribunePublicBlocks::setTribune($puntal->user['id'],$_POST['tribune_text'] );
			}
			elseif (!empty($_POST['tribune_sent']) and ! $puntal->user['is_guest'] 
					and empty($_POST['tribune_text']) and  isset($_POST['id_tribune'])
					and is_numeric($_POST['id_tribune'])
					) {
					tribunePublicBlocks::delTribune($_POST['id_tribune'] );						 
					}
			
			startBloc(sprintf(__('Tribune')), 'tribune', $collapse_feat);
			$tribune = tribunePublicBlocks::refresh();
			if (! $puntal->user['is_guest']) {				
?>
				<form method="post" action="index.php">
				<div class="wall"><?php echo $tribune; ?></div>                
                <div class="inform">
					<input type="hidden" name="tribune_sent" id="tribune_sent" value="1" />
					<input type="hidden" name="id_user" id="id_user" value="<?php echo $puntal->user['id']; ?>" />
					<label><strong><?php echo __('Your message'); ?></strong><br />
					<input type="text" name="tribune_text" id="tribune_text" size="27" maxlength="80" /><br /></label>					
					<input type="submit" name="ok" id="ok" value="<?php echo __('Add'); ?>" onclick="add();  return false;" />
				</div>
				</form>	
<?php 	} else { ?>
			<div class="wall"><?php echo $tribune; ?></div>
			
			<?php echo __('guest_message'); ?>
<?php 		}
			endBloc();
		}
	}


}	
?>