<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
@function install_tribune

La fonction charge de l'installation du module tribune. Cette fonction 
doit obligatoirement tre nomme install_IDENTIFIANT_MODULE()

On va d'abord prparer ce qu'il y a  installer, structure de la base
de donnes, paramtres de configuration, puis faire appel  l'objet
d'installation des modules en lui passant ce qu'il faut.
*/
function install_tribune()
{
	/* Structure de la base de donnes
	
	On dfinit ici la structure de la base de donnes. 
	On commencentpar dclarer un tableau associatif dans
	lequel nous allons mettre les diffrentes tables  crer.
	
	Si votre module n'a pas besoin de table dans la base de 
	donnes, utilisez simplement un tableau vide.
	----------------------------------------------------------*/
	
	# Initialisation du tableau
	$db_scheme = array();
	
	# Nous avons ci-dessous les instructions d'ajout de la premire table.
	$db_scheme[] = array(
		# l'action a effectuer, ici 'add' peut aussi tre 'update' ou 'delete
		# suivant ce que l'on veut faire sur la base de donnes
		'action' 	=> 'add', 
		# le nom de la table en utilisant la constante de prfixe des tables
		'table' 	=> DB_PREFIX.'pt_tribune',
		# la requte MySQL en elle-mme
		'query' 	=> 
           'CREATE TABLE '.DB_PREFIX.'pt_tribune (
                  id_tribune int(12) NOT NULL auto_increment,
                  id_user int(12) NOT NULL,
                  tribune_text varchar(255) NOT NULL,
                  tribune_date date NOT NULL,
                  tribune_time time NOT NULL,
                  PRIMARY KEY  (`id_tribune`),
                  KEY id_user (`id_user`)
                )TYPE=MyISAM;'
	);
	
	/* Paramtres de configuration
	
	Dans un deuxime temps on va dfinir les paramtres de
	configuration. Comme pour la base de donnes, nous plaons 
	ces paramtres dans un tableau associatif pour lequel
	chaque ligne correspond  un paramtre.
	
	Si votre module n'a pas besoin de paramtre de configuration, 
	utilisez simplement un tableau vide.
	----------------------------------------------------------*/
	
	# Initialisation du tableau
	$params = array();
	
	# Un premir paramtre grce  une ligne dans le tableau
	# Cette ligne contient diffrentes informations pour 
	# ajouter le paramtre
	$params[] = array(
		# L'action a effectuer, ici 'add' pour ajouter le paramtre,
		# peut aussi tre 'update' ou 'delete'
		'action'	=> 'add',
		# Le nom du paramtre, il doit commencer 
		# par pt_mod_IDENTIFIANT_MODULE_
		'name' 		=> 'pt_bloc_tribune_num',
		# Le type de donnes enregistrs dans ce paramtre
		'type' 		=> 'integer',
		# La valeur initiale
		'init'		=> 15
	);
	$params[] = array(
		# L'action a effectuer, ici 'add' pour ajouter le paramtre,
		# peut aussi tre 'update' ou 'delete'
		'action'	=> 'add',
		# Le nom du paramtre, il doit commencer 
		# par pt_mod_IDENTIFIANT_MODULE_
		'name' 		=> 'pt_bloc_tribune_groups',
		# Le type de donnes enregistrs dans ce paramtre
		'type'		=> 'string',
		# La valeur initiale
		'init' 		=> 'a:2:{i:0;i:2;i:1;i:4;}'		
	);
	
	
	/* Installation du module
	
	Enfin, dans un troisime temps, nous procdons  l'installation
	en invoquant la fonction qui va bien et en passant les tableaux
	 cette dernire.
	----------------------------------------------------------*/
	$GLOBALS['install_module']->install($db_scheme,$params);
}


?>