<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/
 
require_once dirname(__FILE__).'/../../inc/prepend.php'; 
require_once dirname(__FILE__).'/../../inc/public/tpl_functions.php';

$textarea='p_content';
if (!empty($_GET['textarea'])) $textarea = $_GET['textarea'];  

require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
$ptb = new puntoolbarSmilies($puntal);
$rs = $ptb->getSmilies();
 
while ($rs->fetch())
{
	$smiley_text[] = addslashes($rs->f('text'));
	$smiley_img[] = $rs->f('image');
}
// Most of the loop was taken from Rickards mod_easy_bbcode.php
$smiley_dups = array();
$num_smilies = count($smiley_text);
	
for ($i = 0; $i < $num_smilies; ++$i)
{
	// Is there a smiley at the current index?
	if (!isset($smiley_text[$i]))
		continue;

	if (in_array($smiley_img[$i], $smiley_dups))
	{
			// Unset duplicate entries
			unset($smiley_text[$i]);
			unset($smiley_img[$i]);
	}
	else
		$smiley_dups[] = $smiley_img[$i];
}
	
// Re-index the arrays
$smiley_text = array_values($smiley_text);
$smiley_img = array_values($smiley_img);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html dir="<?php echo __('lang_direction'); ?>">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo __('lang_encoding'); ?>" />
<title><?php echo __('Smilies'); ?></title>
<link rel="stylesheet" type="text/css" href="<?php tpl::url('template') ?>style.css" />
<script type="text/javascript">
//<![CDATA[
	var textarea = window.opener.document.getElementById('<?php echo $textarea; ?>');

	var smilies = document.createElement("div");
	smilies.id = "smilies";

	var smiliesTxt = new Array();
	var smiliesImg = new Array();

	<?php
	$stop = count($smiley_text);
	for ($i = 0; $i < $stop; ++$i)
	{
			echo "\t".'smiliesTxt['.$i.'] = "'.stripslashes($smiley_text[$i]).'";'."\n";
			echo "\t".'smiliesImg['.$i.'] = "'.$smiley_img[$i].'";'."\n";
	}
	?>

	function addSmiley(src, txt)
	{
		var i = document.createElement('img');
		var htxt = txt;
		htxt = htxt.replace(new RegExp(/&amp;/g),'&');
		htxt = htxt.replace(new RegExp(/&quot;/g),'"');
		htxt = htxt.replace(new RegExp(/&lt;/g),'<');
		htxt = htxt.replace(new RegExp(/&gt;/g),'>'); 
		i.src = src;
		i.title = htxt;
		i.style.padding = '0.2em';
		i.onclick = function() { try { insertSmiley(htxt) } catch (e) { } return false };
		i.tabIndex = 400;
		smilies.appendChild(i);
	}

	function insertSmiley(txt)
	{
		encloseSelection(txt, '');
		window.close();
	}

	function encloseSelection(prefix, suffix, fn)
	{
		textarea.focus();
		var start, end, sel, scrollPos, subst;

		if (typeof(window.opener.document["selection"]) != "undefined") {
			sel = window.opener.document.selection.createRange().text;
		} else if (typeof(textarea["setSelectionRange"]) != "undefined") {
			start = textarea.selectionStart;
			end = textarea.selectionEnd;
			scrollPos = textarea.scrollTop;
			sel = textarea.value.substring(start, end);
		}

		if (sel.match(/ $/)) { // exclude ending space char, if any
			sel = sel.substring(0, sel.length - 1);
			suffix = suffix + " ";
		}

		if (typeof(fn) == 'function') {
			var res = (sel) ? fn(sel) : fn('');
		} else {
			var res = (sel) ? sel : '';
		}

		subst = prefix + res + suffix;

		if (typeof(window.opener.document["selection"]) != "undefined") {
			var range = window.opener.document.selection.createRange().text = subst;
			textarea.caretPos -= suffix.length;
		} else if (typeof(textarea["setSelectionRange"]) != "undefined") {
			textarea.value = textarea.value.substring(0, start) + subst +
			textarea.value.substring(end);
			if (sel) {
				textarea.setSelectionRange(start + subst.length, start + subst.length);
			} else {
				textarea.setSelectionRange(start + prefix.length, start + prefix.length);
			}
			textarea.scrollTop = scrollPos;
		}
	}
//]]>
</script>
</head>

<body>

<div class="block" style="margin:0.5em">
	<div class="box">
		<div id="smilies_box" class="inbox">

		<script type="text/javascript">
		//<![CDATA[
			for (var i=0; i<smiliesTxt.length; i++)
			{
				addSmiley('/themes/img/smilies/'+smiliesImg[i],smiliesTxt[i]);
			}
			document.getElementById('smilies_box').appendChild(smilies);
		//]]>
		</script>

		</div>
	</div>
</div>

</body>
</html>
