<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php tpl::lang('lang_iso_code') ?>" 
lang="<?php tpl::lang('lang_iso_code') ?>" dir="<?php tpl::lang('lang_direction') ?>">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=<?php tpl::lang('lang_encoding') ?>" />
	<title><?php tpl::headTitlePage() ?></title>
	<link rel="stylesheet" type="text/css" href="<?php tpl::url('template') ?>style.css" />
	<link rel="stylesheet" type="text/css" href="<?php tpl::urlFile('directory/dir.css') ?>" />
	<script type="text/javascript" src="<?php tpl::url('themes') ?>common/js/common.js"></script>
	<?php tpl::headExtra() ?>
	</head>
<body>

<div id="wrapper">

<?php # debut de page commun (fichier _top.php)
tpl::top() ?>

<div id="puntal_main">
	<div id="puntal_content">	
	<?php # Affichage d'une catgorie / sous-catgorie
	if ($dir_mode == 'cat') : ?>
		<?php require dirname(__FILE__).'/cat.php'; ?>
	
	<?php # Affichage rsultats de recherche
	elseif ($dir_mode == 'search') : ?>
		<?php require dirname(__FILE__).'/search.php'; ?>	
	
	<?php # Formulaire pour soumettre un site
	elseif ($dir_mode == 'submit') :  ?>
		<?php require dirname(__FILE__).'/submit.php'; ?>	
		
	<?php # Affichage pages 'top cliques', 'toprank' ou 'nouveautes'
	elseif ($dir_mode == 'topclick' || $dir_mode == 'toprank' || $dir_mode == 'novelties') : ?>
		<?php require dirname(__FILE__).'/list.php'; ?>	
			
	<?php # Affichage de la page d'accueil de l'annuaire
	else : ?>	
		<?php require dirname(__FILE__).'/home.php'; ?>	
	
	<?php endif; ?>
	</div>
</div>

<div id="puntal_sidebar">
<?php tpl::blocsNav() ?>
<?php tpl::blocsExtra() ?>
</div>
<div class="clearer"></div>

<?php # fin de page commun (fichier _bottom.php)
tpl::bottom() ?>

</div>

</body>
</html>
